public domain code
freenico2000@yahoo.fr

this is cde i wrote for the exercice 46 of the pyhonthehardway by Zed Shaw

the purpose of this is to see if i can create a little package that has a script installed too.


usage example : 

   >>> from dungeon import printlist
   >>> printlist("argument")
   
1. from the root directory (dungeon) do the following (after having installed pip, distribute, virtualenv, nose)

python setup.py

2. This create aa dist/ directory with dungeon... tarball directory.

3. copy the tarball to ~/testing/

4. from ~/testing/ directory run

sudo pip install dungeon....(the tarball file)

5. from same directory run 

testprint.py
   

some many thing i do not understand with the python 2.6 it display the following :

a list of things
['milk', 'bread', 'carrot', 'cheese', 'butter', 'yogurt']

with python2.7 :

Traceback (most recent call last):
  File "testprint.py", line 3, in <module>
    from dungeon import printlist
ImportError: No module named dungeon

This is a source file distribution for the game dungeon as implemented
in C.  It is based on the game dungeon as distributed on a DECUS tape,
circa 1980.  It has been converted from the original DEC FORTRAN to
f77 to C.  See the file "History" for some revision history and credit
to those whose efforts have made this possible.

Take a look at the Makefile.  It should be fine for most systems,
although you may want to change BINDIR and LIBDIR.  On SCO UNIX see
the note at the definition of CFLAGS.  Makefile.MSC should work for
MS-DOS using Microsoft C.  It was contributed by Jonathan Mark
(uunet!microsoft!jonm).

To compile and link dungeon, type make.  To install it in BINDIR and
LIBDIR, type make install.

There are two functions in local.c that you may want to write for your
system.  The first controls when the game can be played, and can be
used to disallow play during business hours, for example.  The second
controls who is allowed to invoke the game debugging tool; note that
this will only be available at all if you uncomment the GDTFLAG line
in the Makefile.  The comments in local.c explain what to do.

All files in the distribution kit are ASCII.  The files dtextc.uu1,
dtextc.uu2, dtextc.uu3, dtextc.uu4 are parts of a uuencoded binary
file named dtextc.dat.  The Makefile will create the binary file
automatically on a UNIX system; elsewhere you will have to stick the
four files together in numerical order and run the resulting large
file through uudecode.  I can't help you find uudecode, though.

The binary file dtextc.dat holds the text strings and initialization
information for the game.  The strings are encrypted to prevent easy
cheating; if you want to do further work on the program, or translate
the strings, Ian Taylor (address below) has a program to convert this
file back and forth from a human-readable form.

This has been compiled and tested on a DECstation 3100 running Ultrix
4.0, a VAXstation GPX running Ultrix 3.1, an 80386 box running SCO
Unix 3.2.2, an 8800 running Ultrix, a Sun box running SUN OS 4 release
4, and an 80386 PC running MS-DOS.

I consider my changes to be in the public domain, as did previous
contributors (see the History file for more detail).  The original
source, however, is copyright.

	Ian Lance Taylor
	ian@airs.com or uunet!airs!ian
	11 March 1991

Dungeon consists of the following files:

	dmain.c			-program root
	dgame.c			-main routine
	dsub.c			-resident subroutines
	dinit.c			-initialization routine
	np.c			-parser, part 0
	np1.c			-parser, part 1
	np2.c			-parser, part 2
	np3.c			-parser, part 3
	gdt.c			-game debugging tool
	verbs.c			-principal verbs
	objcts.c		-principal objects
	sverbs.c		-simple verbs
	dverb1.c		-auxiliary verbs, part 1
	dverb2.c		-auxiliary verbs, part 2
	actors.c		-character processors
	demons.c		-demon processors
	clockr.c		-clock event processors
	rooms.c			-room processors
	nrooms.c		-new room processors
	sobjs.c			-simple objects
	nobjs.c			-new objects
	ballop.c		-balloon processor
	lightp.c		-light processors
	villns.c		-villain processors
	dso1.c			-overlaid subroutines, part 1
	dso2.c			-overlaid subroutines, part 2
	dso3.c			-overlaid subroutines, part 3
	dso4.c			-overlaid subroutines, part 4
	dso5.c			-overlaid subroutines, part 5
	dso6.c			-overlaid subroutines, part 6
	dso7.c			-overlaid subroutines, part 7
	funcs.h			-header file with function prototypes
	vars.h			-header file with variable definitions
	parse.h			-header file for parsing routines
	supp.c			-support routines and more processing
	local.c			-hooks for local definition
	dindxc.dat		-data base [binary file]
	dungeon.6		-man page
	Makefile		-Makefile
	Makefile.MSC		-Makefile for MS-DOS and Microsoft C
	History			-Some revision history notes
	README			-This file

------------------------------------------------------------------------------

I supplied a new file Makefile.BCC for Borland C++ (tested with version 3.1).
While working on this, I discovered that I had to change function main in
dmain.c from 'returning void' to 'returning int' - bcc doesn't accept
'void main(...)' in ANSI mode.

Volker Blasius, 11jul93                                <Volker.Blasius@gmd.de>

C Parser for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C RDLINE-	Read input line
C
C Declarations
C
	SUBROUTINE RDLINE(INLINE,INLEN,WHO)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	CHARACTER*(TEXLNT) INLINE
C
	LUCVT=ICHAR('A')-ICHAR('a')		! case conversion factor.
5	GO TO (90,10),WHO+1			! see who to prompt for.
10	WRITE(OUTCH,50)				! prompt for game.
50	FORMAT(' >',$)
C
90	READ(INPCH,100,END=5) INLINE		! get input.
100	FORMAT(A)
C
	INLEN=NBLEN(INLINE)			! len w/o trailing blanks.
	IF(INLEN.LE.0) GO TO 5			! anything left?
	DO 400 I=1,INLEN			! convert to upper case.
	  IF((INLINE(I:I).GE.'a').AND.(INLINE(I:I).LE.'z'))
	1	INLINE(I:I)=CHAR(ICHAR(INLINE(I:I))+LUCVT)
400	CONTINUE
	PRSCON=1				! restart lex scan.
	RETURN
	END

C PARSE-	Top level parse routine
C
C Declarations
C
C This routine details on bit 0 of PRSFLG
C
	LOGICAL FUNCTION PARSE(INLINE,INLEN,VBFLAG)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	CHARACTER*(TEXLNT) INLINE
	CHARACTER*(WRDLNT) OUTBUF(LEXMAX),BAKBUF(LEXMAX)
	LOGICAL LEX,SYNMCH,DFLAG,VBFLAG
	SAVE BAKBUF,BAKLEN
	DATA BAKBUF(1)/'L'/,BAKLEN/1/
C
	DFLAG=(PRSFLG.AND.1).NE.0
	PARSE=.FALSE.				! assume fails.
	PRSA=0					! zero outputs.
	PRSI=0
	PRSO=0
C
	IF(.NOT.LEX(INLINE,INLEN,OUTBUF,OUTLEN,VBFLAG)) GO TO 1000
	IF((OUTLEN.NE.1).OR.(OUTBUF(1).NE.'AGAIN')) GO TO 100
	DO 50 I=1,LEXMAX			! use previous
	  OUTBUF(I)=BAKBUF(I)
50	CONTINUE
	OUTLEN=BAKLEN				! buffer and length.
100	IF(SPARSE(OUTBUF,OUTLEN,VBFLAG)) 1000,200,300	! do syn scan.
C
C Parse requires validation
C
200	IF(.NOT.VBFLAG) GO TO 350		! echo mode, force fail.
	IF(.NOT.SYNMCH(X)) GO TO 1000		! do syn match.
	IF(PRSO.EQ.BUNOBJ) LASTIT=BUNVEC(1)	! record for "it".
	IF((PRSO.GT.0).AND.(PRSO.LT.BUNOBJ)) LASTIT=PRSO
C
C Successful parse or successful validation
C
300	PARSE=.TRUE.
350	CALL ORPHAN(0,0,0,0,0,' ',0,0)		! clear orphans.
	DO 400 I=1,LEXMAX			! save command
	  BAKBUF(I)=OUTBUF(I)
400	CONTINUE
	BAKLEN=OUTLEN				! save length
	IF(DFLAG) TYPE 500,PARSE,PRSA,PRSO,PRSI
500	FORMAT(' PARSE RESULTS- ',L7,3I7)
	RETURN
C
C Parse fails, disallow continuation
C
1000	PRSCON=1
	IF(DFLAG) TYPE 500,PARSE,PRSA,PRSO,PRSI
	RETURN
C
	END

C LEX-	Lexical analyzer
C
C Declarations
C
C This routine details on bit 1 of PRSFLAG
C
	LOGICAL FUNCTION LEX(INLINE,INLEN,OUTBUF,OP,VBFLAG)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	CHARACTER*(TEXLNT) INLINE
	CHARACTER*(WRDLNT) OUTBUF(LEXMAX)
	CHARACTER*1 J
	LOGICAL DFLAG,VBFLAG
C
	DFLAG=(PRSFLG.AND.2).NE.0
	LEX=.FALSE.				! assume lex fails.
	OP=0					! output ptr.
	DO 10 I=1,LEXMAX			! clear output buf.
	  OUTBUF(I)=' '
10	CONTINUE
C
50	OP=OP+1					! adv output ptr.
	CP=0					! char ptr=0.
C
200	IF(PRSCON.GT.INLEN) GO TO 2000		! end of input?
	J=INLINE(PRSCON:PRSCON)			! no, get character,
	IF((J.EQ.'"').OR.(J.EQ.'''')) GO TO 3000! substring?
	PRSCON=PRSCON+1				! advance ptr.
	IF(J.EQ.' ') GO TO 1000			! space?
	IF((J.EQ.'.').OR.(J.EQ.';').OR.
	1  (J.EQ.'!').or.(J.EQ.'?')) GO TO 2000	! end of command?
	IF(J.EQ.',') GO TO 4000			! comma?
	IF(OP.GT.LEXMAX) GO TO 5000		! too many tokens?
	CP=CP+1					! adv char ptr.
	IF(CP.LE.WRDLNT) OUTBUF(OP)(CP:CP)=J	! insert char in word.
	GO TO 200
C
C Space.
C
1000	IF(CP.EQ.0) GO TO 200			! any word yet?
	GO TO 50				! yes, adv op.
C
C End of input, see if partial word available.
C
2000	IF(PRSCON.GT.INLEN) PRSCON=1		! force parse restart.
	IF((CP.EQ.0).AND.(OP.EQ.1)) RETURN	! any results?
	IF(CP.EQ.0) OP=OP-1			! any last word?
	LEX=.TRUE.
	IF(DFLAG) TYPE 2020,CP,OP,PRSCON,(OUTBUF(I),I=1,OP)
2020	FORMAT(' LEX RESULTS- ',3I7/1X,8(A,1X))
	RETURN
C
C Substring, J is delimiter.
C
3000	IF(SUBLNT.NE.0) GO TO 3400		! already got one?
3100	PRSCON=PRSCON+1				! skip initial quote.
	IF(PRSCON.GT.INLEN) GO TO 3500		! any more characters?
	IF(INLINE(PRSCON:PRSCON).EQ.' ') GO TO 3100	! skip blanks.
	K=INDEX(INLINE(PRSCON:INLEN),J)		! find closing quote.
	IF(K.LE.1) GO TO 3500			! none or empty?
	SUBBUF=INLINE(PRSCON:PRSCON+K-2)	! set up substring buffer,
	SUBLNT=K-1				! length.
	PRSCON=PRSCON+K				! skip over string.
	IF(DFLAG) TYPE 3030,SUBLNT,SUBBUF(1:SUBLNT)
3030	FORMAT(' SUBSTRING- ',I7,' "',A,'"')
	GO TO 1000				! treat as end of word.
C
3400	IF(VBFLAG) CALL RSPEAK(1046)		! multiple substrings.
	RETURN
C
3500	IF(VBFLAG) CALL RSPEAK(616)		! bad substring.
	RETURN					! fails.
C
C Comma.
C
4000	IF(CP.NE.0) OP=OP+1			! if partial word, go to next.
	IF(OP.EQ.1) GO TO 4500			! no first word? die.
	IF(OP.GT.LEXMAX) GO TO 5000		! too many tokens?
	OUTBUF(OP)='AND'			! insert 'AND'.
	GO TO 50				! start new word
C
4500	IF(VBFLAG) CALL RSPEAK(1047)		! misplaced comma.
	RETURN
C
C Too many tokens.
C
5000	IF(VBFLAG) CALL RSPEAK(1048)		! too many tokens.
	RETURN
C
	END

C SPARSE-	Start of parse
C
C Declarations
C
C This routine details on bit 2 of PRSFLG
C
	INTEGER FUNCTION SPARSE(LBUF,LLNT,VBFLAG)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	CHARACTER*(WRDLNT) LBUF(LEXMAX),WORD,LCWORD,LCIFY
	CHARACTER*(WRDLNT+2) LCWRD1
	LOGICAL LIT,QHERE,DFLAG,VBFLAG,ANDFLG,BUNFLG
	INTEGER OBJVEC(2),PRPVEC(2)
	EQUIVALENCE (OBJVEC(1),OBJ1),(PRPVEC(1),PREP1)

C SPARSE, PAGE 2
C
C Vocabularies
C
C Buzz words--	ignored in syntactic processing
C
	DATA BWORD/'BY','IS','A','AN','THE',
	1	'TODAY','MY','YOUR','OUR','HIS'/
C
C Prepositions--	maps prepositions to indices
C
	DATA PWORD/'OVER','WITH','USING','AT','TO',
	1	'IN','INSIDE','INTO','DOWN','UP',
	2	'UNDER','OF','ON','OFF','FOR',
	3	'FROM','OUT','THROUGH',' ',' '/
C
	DATA PVOC/1,2,2,3,4,
	1	5,5,5,6,7,
	2	8,9,10,11,12,
	3	13,13,14,0,0/
C
C Directions--	maps directions to indices
C
	DATA DWORD/'N','NORTH','S','SOUTH',
	1 'E','EAST','W','WEST',
	2 'SE','SW','NE','NW',
	4 'U','UP','D','DOWN',
	5 'LAUNCH','LAND','EXIT','OUT',
	6 'TRAVEL','IN','CROSS',' ',' '/
C
	DATA DVOC/XNORTH,XNORTH,XSOUTH,XSOUTH,
	1 XEAST,XEAST,XWEST,XWEST,
	2 XSE,XSW,XNE,XNW,
	4 XUP,XUP,XDOWN,XDOWN,
	5 XLAUN,XLAND,XEXIT,XEXIT,
	6 XCROSS,XENTER,XCROSS,0,0/

C SPARSE, PAGE 3
C
C Adjectives--	maps adjectives to object numbers
C
C Each string entry in aword corresponds to a list of one or more
C object numbers in AVOC.  Object entries are delimited by the first
C object being positive, and all subsequent objects in the same entry
C being negative.
C
	DATA (AWORD(I),I=1,40) /
	1 'BROWN','ELONGATE','HOT','PEPPER',
	1 'VITREOUS','JADE','HUGE','ENORMOUS',
	2 'TROPHY','CLEAR','LARGE','NASTY',
	3 'ELVISH','BRASS','BROKEN','ORIENTAL',
	4 'BLOODY','RUSTY','BURNED-O','DEAD',
	5 'OLD','LEATHER','PLATINUM','PEARL',
	6 'MOBY','CRYSTAL','GOLD','IVORY',
	7 'SAPPHIRE','WOODEN','WOOD','STEEL',
	8 'DENTED','FANCY','ANCIENT','SMALL',
	9 'BLACK','TOUR','VISCOUS','VICIOUS'/
C
	DATA (AVOC(I),I=1,112) /
	1 1,-81,-133,1,3,-190,3,
	1 4,6,8,8,-122,
	2 9,10,12,-26,-47,-95,-96,-123,-133,-135,-144,-145,
	2	-150,-176,-191,13,-19,
	3 14,15,-16,-46,-156,-190,16,-22,-38,-92,-113,-155,-158,17,
	4 20,24,-205,22,22,
	5 25,-41,-44,-45,-208,25,26,27,
	6 31,32,-126,-206,-209,33,-85,-104,-157,-158,-188,34,
	7 37,38,-67,-75,-93,-136,-137,-165,-173,-174,-175,-197,-204,
	7	38,-67,-136,-137,-165,-173,-174,-175,
	7	39,-105,-124,-125,-189,
	8 39,40,41,-44,5,-46,-52,-53,-89,-102,-103,-153,-187,
	9 47,-162,49,55,62/
C
	DATA (AWORD(I),I=41,80) /
	1 'GLASS','TRAP','FRONT','STONE',
	1 'MANGLED','RED','YELLOW','BLUE',
	2 'VAMPIRE','MAGIC','SEAWORTH','TAN',
	3 'SHARP','WICKER','CLOTH','BRAIDED',
	4 'GAUDY','SQUARE','CLAY','SHINY',
	5 'THIN','GREEN','PURPLE','WHITE',
	6 'MARBLE','COKE','EMPTY','ROUND',
	7 'TRIANGUL','RARE','OBLONG','EAT-ME',
	8 'EATME','ORANGE','ECCH','ROCKY',
	9 'SHEER','200','NEAT','SHIMMERI'/
C
	DATA (AVOC(I),I=113,179) /
	1 10,-126,-132,-206,-209,66,68,69,-150,-278,
	1 	72,-124,79,-94,-140,-161,-170,-171,-190,-209,
	1	80,-159,82,-112,-114,-141,-206,
	2 83,90,-281,90,91,
	3 92,98,100,101,
	4 108,109,-127,109,110,
	5 110,77,-115,-143,116,117,-126,-147,-160,-266,
	6 119,121,121,128,
	7 129,134,135,138,
	8 138,139,141,146,
	9 146,148,148,151/
C
	DATA (AWORD(I),I=81,120) /
	1 'ZURICH','BIRDS','ENCRUSTE','BEAUTIFU',
	1 'CLOCKWOR','MECHANIC','MAHOGANY','PINE',
	2 'LONG','CENTER','SHORT','T',
	3 'COMPASS','BRONZE','CELL','LOCKED',
	4 'SUN','BARE','SONG','NORTH',
	5 'NORTHERN','SOUTH','SOUTHERN','EAST',
	6 'EASTERN','WEST','WESTERN','DUNGEON',
	7 'FREE','GRANITE','LOWERED','VOLCANO',
	8 'MAN-SIZE','METAL','PLASTIC','SILVER',
	9 'USED','USELESS','SEEING','ONE-EYED'/
C
	DATA (AVOC(I),I=180,236) /
	1 152,153,-154,-155,154,-155,86,-156,
	1 157,-158,157,-158,163,164,
	2 166,166,167,168,
	3 169,-275,172,174,-175,174,
	4 177,259,267,269,
	5 269,270,270,271,
	6 271,272,272,279,
	7 195,-262,265,36,111,
	8 93,64,-99,-200,-201,77,-87,-88,-90,59,
	9 22,22,126,-206,-209,58/
C
	DATA (AWORD(I),I=121,160) /
	1 'HOLY','HAND-HEL','UNRUSTY','PLAIN',
	1 'PRICELES','SANDY','GIGANTIC','LINE-PRI',
	2 'FLATHEAD','FINE','SHADY','SUSPICIO',
	3 'CROSS','TOOL','CONTROL','DON',
	4 'WOODS','GOLDEN','OAK','BARRED',
	5 'DUSTY','NARROW','IRON','WELCOME',
	6 'RUBBER','SKELETON','ALL',13*' '/
C
	DATA (AVOC(I),I=237,279) /
	1 43,89,13,13,
	1 104,192,122,122,
	2 118,91,61,61,
	3 165,193,194,196,
	4 196,157,-158,197,198,-210,
	5 204,199,205,207,
	6 207,23,253,-254,13*0/


C SPARSE, PAGE 4
C
C OBJECTS--	Maps objects to object indices,
C 		same format as AVOC.
C
	DATA (OWORD(I),I=1,40) /
	1 'BAG','SACK','GARLIC','CLOVE',
	1 'FOOD','SANDWICH','LUNCH','DINNER',
	2 'GUNK','PIECE','SLAG','COAL',
	3 'PILE','HEAP','FIGURINE','MACHINE',
	4 'PDP10','VAX','DRYER','LID',
	5 'DIAMOND','CASE','BOTTLE','CONTAINE',
	6 'WATER','QUANTITY','LIQUID','H2O',
	7 'ROPE','HEMP','COIL','KNIFE',
	8 'BLADE','SWORD','ORCHRIST','GLAMDRIN',
	9 'LAMP','LANTERN','RUG','CARPET'/
C
	DATA (OVOC(I),I=1,71) /
	1 1,-25,-100,1,2,2,
	1 3,3,3,3,
	2 4,-55,4,-143,-186,-282,4,5,
	3 5,-18,-38,-72,-73,-87,-88,-122,-148,5,6,7,
	4 7,7,7,7,-200,-201,
	5 8,9,-123,10,-121,10,
	6 11,-273,11,-273,11,-273,11,-273,
	7 12,-101,-282,12,12,-110,13,-24,
	8 13,-14,14,14,14,
	9 15,-16,-22,15,-16,-22,17,17/
C
	DATA (OWORD(I),I=41,80) /
	1 'LEAVES','LEAF','TROLL','AXE',
	1 'PRAYER','KEYS','KEY','SET',
	2 'BONES','SKELETON','BODY','COINS',
	3 'BAR','NECKLACE','PEARLS','MIRROR',
	4 'ICE','MASS','GLACIER','RUBY',
	5 'TRIDENT','FORK','COFFIN','CASKET',
	6 'TORCH','CAGE','DUMBWAIT','BASKET',
	7 'BRACELET','JEWEL','TIMBER','BOX',
	8 'STRADIVA','VIOLIN','ENGRAVIN','INSCRIPT',
	9 'GHOST','SPIRIT','FIEND','GRAIL'/
C
	DATA (OVOC(I),I=72,129) /
	1 18,18,19,-111,20,
	1 44,-47,23,23,-205,23,
	2 21,21,21,-73,25,
	3 26,-165,-168,27,27,28,-29,-276,
	4 30,30,30,31,
	5 32,32,33,33,
	6 34,35,-36,-124,-125,35,-36,35,-36,-98,-113,
	7 37,37,38,39,-53,-105,
	8 40,40,41,41,-44,
	9 42,42,42,43/
C
	DATA (OWORD(I),I=81,120) /
	1 'TRUNK','CHEST','BELL','BOOK',
	1 'BIBLE','GOODBOOK','CANDLES','PAIR',
	2 'GUIDEBOO','GUIDE','PAPER','NEWSPAPE',
	3 'ISSUE','REPORT','MAGAZINE','NEWS',
	4 'MATCHBOO','MATCH','MATCHES','ADVERTIS',
	5 'PAMPHLET','LEAFLET','BOOKLET','MAILBOX',
	6 'TUBE','TOOTHPAS','PUTTY','MATERIAL',
	7 'GLUE','WRENCH','SCREWDRI','CYCLOPS',
	8 'MONSTER','CHALICE','CUP','GOBLET',
	9 'PAINTING','ART','CANVAS','PICTURE'/
C
	DATA (OVOC(I),I=130,181) /
	1 45,45,-193,46,-190,47,-49,-114,-115,-116,-117,
	1 47,47,48,48,
	2 49,49,50,-122,-143,-186,50,
	3 50,50,50,50,
	4 51,51,51,52,
	5 52,52,52,53,
	6 54,54,55,55,
	7 55,56,57,58,
	8 58,59,59,59,
	9 60,-149,60,-149,60,60/
C
	DATA (OWORD(I),I=121,160) /
	1 'WORK','MASTERPI','THIEF','ROBBER',
	1 'CRIMINAL','BANDIT','CROOK','GENT',
	2 'GENTLEMA','MAN','INDIVIDU','BAGMAN',
	3 'STILETTO','WINDOW','BOLT','NUT',
	4 'GRATE','GRATING','DOOR','TRAP-DOO',
	5 'SWITCH','HEAD','CORPSE','BODIES',
	6 'DAM','GATES','GATE','FCD',
	7 'RAIL','RAILING','BUTTON','BUBBLE',
	8 'LEAK','DRIP','HOLE','BAT',
	9 'RAINBOW','POT','STATUE','SCULPTUR'/
C
	DATA (OVOC(I),I=182,255) /
	1 60,60,61,61,
	1 61,61,61,61,
	2 61,61,61,61,
	3 62,63,-198,-210,64,64,
	4 65,65,66,-67,-68,-69,-119,-164,
	4	-172,-173,-174,-175,-189,-197,66,
	5 70,-76,-79,-80,-81,-82,-170,71,-120,72,-73,73,
	6 74,74,-76,74,-76,74,
	7 75,75,76,-79,-80,-81,-82,-127,-128,-129,-170,-176,77,
	8 78,-191,78,78,-107,83,
	9 84,85,86,86/
C
	DATA (OWORD(I),I=161,200) /
	1 'ROCK','BOAT','PLASTIC','PUMP',
	1 'AIRPUMP','AIR-PUMP','LABEL','FINEPRIN',
	2 'STICK','BARREL','BUOY','EMERALD',
	3 'SHOVEL','GUANO','CRAP','SHIT',
	4 'HUNK','BALLOON','RECEPTAC','WIRE',
	5 'HOOK','ZORKMID','COIN','SAFE',
	6 'CARD','NOTE','SLOT','CROWN',
	7 'BRICK','FUSE','GNOME','STAMP',
	8 'TOMB','CRYPT','GRAVE','HEADS',
	9 'POLES','IMPLEMEN','LOSERS','COKES'/
C
	DATA (OVOC(I),I=256,309) /
	1 60,87,-88,-90,87,-88,-90,89,
	1 89,89,91,-112,91,
	2 92,93,94,95,
	3 96,97,97,97,
	4 97,98,-113,99,101,-110,
	5 102,-103,104,-148,104,105,
	6 106,-188,106,-186,107,-187,108,
	7 109,110,111,-152,118,-196,
	8 119,119,119,120,
	9 120,120,120,121/
C
	DATA (OWORD(I),I=201,240) /
	1 'LISTINGS','STACK','PRINTOUT','SPHERE',
	1 'BALL','ETCHING','WALLS','WALL',
	2 'FLASK','POOL','SEWAGE','TIN',
	3 'SAFFRON','SPICES','TABLE','POST',
	4 'POSTS','BUCKET','CAKE','ICING',
	5 'ROBOT','ROBBY','C3PO','R2D2',
	6 'PANEL','POLE','TBAR','T-BAR',
	7 'ARROW','POINT','BEAM','DIAL',
	8 'SUNDIAL','1','ONE','2',
	9 'TWO','3','THREE','4'/
C
	DATA (OVOC(I),I=310,384) /
	1 122,122,122,126,-206,-209,
	1 126,130,-131,130,-131,-257,130,-131,-159,
	1	-160,-161,-162,-163,-164,-257,-265,-269,-270,-271,-272,
	2 132,133,133,134,
	3 134,134,135,-204,136,-166,-167,
	4 136,137,138,-139,-140,-141,139,-140,-141,
	5 142,142,142,142,
	6 159,-160,-161,-162,-163,-164,-194,-277,120,-166,-167,168,168,
	7 169,169,171,177,
	8 177,178,178,179,
	9 179,180,180,181/
C
	DATA (OWORD(I),I=241,280) /
	1 'FOUR','5','FIVE','6',
	1 'SIX','7','SEVEN','8',
	2 'EIGHT','WARNING','SLIT','IT',
	3 'THAT','THIS','ME','MYSELF',
	4 'CRETIN','ALL','EVERYTHI','TREASURE',
	5 'VALUABLE','SAILOR','TEETH','GRUE',
	6 'HAND','HANDS','LUNGS','AIR',
	7 'AVIATOR','FLYER','TREE','CLIFF',
	8 'LEDGE','PORTRAIT','STACK','BILLS',
	9 'VAULT','CUBE','LETTERIN','CURTAIN'/
C
	DATA (OVOC(I),I=385,428) /
	1 181,182,182,183,
	1 183,184,184,185,
	2 185,186,187,250,
	3 250,250,251,251,
	4 251,252,252,253,
	5 253,255,256,258,
	6 259,259,260,260,
	7 261,261,144,-145,-268,146,-147,
	8 146,149,148,148,
	9 150,150,67,-150,151/
C
	DATA (OWORD(I),I=281,320) /
	1 'LIGHT','NEST','EGG','BAUBLE',
	1 'CANARY','BIRD','SONGBIRD','GUARD',
	2 'GUARDIAN','ROSE','STRUCTUR','CHANNEL',
	3 'KEEPER','LADDER','BROCHURE','WISH',
	4 'GROUND','EARTH','SAND','WELL',
	5 'SLIDE','CHUTE','HOUSE','BOTTLES',
	6 'BUNCH','PALANTIR','STONE','FLINT',
	7 'POSSESSI','GOOP','BEACH','GRIP',
	8 'HANDGRIP','PRINT','ETCHINGS','CRACK',
	9 'KEYHOLE','MAT','STOVE','PLATINUM'/
C
	DATA (OVOC(I),I=429,481) /
	1 15,-151,-174,153,154,-155,156,
	1 157,-158,267,267,274,
	2 274,275,276,278,
	3 279,280,195,-262,263,
	4 264,264,192,-264,281,
	5 283,283,266,121,
	6 121,126,-206,-209,126,-206,-209,51,
	7 254,133,192,167,
	8 167,91,-122,130,-131,199,
	9 202,-203,207,208,26/
C
	DATA (OWORD(I),I=321,360) /
	1 'HIM','SELF','GOLD','SAPPHIRE',
	1 'IVORY','MASTER','CANDLE','JADE',
	2 'SCREEN',31*' '/
C
	DATA (OVOC(I),I=482,522) /
	1 250,251,85,-104,37,
	1 34,279,48,6,
	2 151,31*0/

C SPARSE, PAGE 5
C
C VERBS--	Maps verbs to syntax slots
C
C Vocabulary entries are variable length and consist of one
C or more words.  If an entry contains more than one word,
C all but the last are prefaced with an '*'.  The preferred
C string for error messages should be first.
C
C Syntax entries consist of a flag word followed by 0, 1, or 2
C Object descriptions.  The flag word has the following format--
C
C bit <14>	if 1, syntax includes direct object
C bit <13>	if 1, syntax includes indirect object
C bit <12>	if 1, direct object is implicit (standard form)
C bit <11>	if 1, direct and indirect object must be swapped
C			after syntax processing
C bit <10>	if 1, this is default syntax for orphanery
C bits <8:0>	verb number for VAPPLI
C
C Object descriptions consist of a flag word and two FWIM words.
C The flag word has the following format--
C
C bit <14>	if 1, search adventurer for object
C bit <13>	if 1, search room for object
C bit <12>	if 1, parser will try to take object
C bit <11>	if 1, adventurer must have object
C bit <10>	if 1, qualifying bits (normally -1,-1) are same
C			as FWIM bits
C bit <9>	if 1, object must be reachable
C bits <8:0>	preposition number for SYNMCH
C
C The FWIM words have the same format as the two object flag words.
C
C Note that bits 12 and 11 of object descriptions actually have
C four distinct states--
C
C	bit 12	bit 11	mdldesc		interpretation
C	------	------	-------		---------------
C
C	  0	  0	 --		no parser action
C	  0	  1	 HAVE		adventurer must have object
C	  1	  0	 TRY		try to take, dont care if fail
C	  1	  1	 TAKE		try to take, care if fail
C

C SPARSE, PAGE 6
C
	DATA (VWORD(I),I=1,43) /
	1 'BRIEF','VERBOSE','SUPERBRI','STAY',
	1 'VERSION','*SWIM','*BATHE','WADE',
	2 'GERONIMO','*ULYSSES','ODYSSEUS','*PLUGH','XYZZY',
	3 'PRAY','TREASURE','TEMPLE','BLAST',
	4 'SCORE','*QUIT','*GOODBYE','*Q','BYE','HELP',
	5 'INFO','*HISTORY','UPDATE','BACK',
	6 '*MUMBLE','SIGH','*CHOMP','*LOSE',
	7 'BARF','DUNGEON','FROBOZZ','*FOO',
	8 '*BLETCH','BAR','REPENT','*HOURS',
	9 'SCHEDULE','WIN','*YELL','*SCREAM'/
C
	DATA (VVOC(I),I=1,54) /
	1 1,70,1,71,1,72,1,73,
	1 1,74,1,75,
	2 1,76,1,77,1,56,
	3 1,79,1,80,1,81,1,82,
	4 1,83,1,84,1,40,
	5 1,41,1,42,1,43,
	6 1,44,
	7 1,45,1,46,1,47,
	8 1,48,1,49,
	9 1,50,1,51/
C
	DATA (VWORD(I),I=44,86) /
	1 'SHOUT','*HOP','SKIP','*CURSE',
	1 '*SHIT','*DAMN','FUCK','ZORK',
	2 'WISH','SAVE','RESTORE','TIME',
	3 'DIAGNOSE','EXORCISE','*LIST','*I','INVENTOR',
	4 'WAIT','INCANT','*ANSWER','RESPOND','AGAIN',
	5 'NOOBJ','*BUG','*GRIPE','COMPLAIN',
	6 '*FEATURE','*COMMENT','*IDEA','SUGGESTI',
	7 'ROOM','*OBJECTS','OBJ','RNAME','DEFLATE',
	8 '*EXAMINE','*WHAT','DESCRIBE','FILL',
	9 '*FIND','*SEEK','*WHERE','SEE'/
C
	DATA (VVOC(I),I=55,120) /
	1 1,52,1,53,
	1 1,54,1,55,
	2 1,169,1,149,1,150,1,90,
	3 1,94,1,105,1,133,
	4 1,128,1,95,1,96,1,57,
	5 1,58,1,59,
	6 1,60,
	7 1,65,1,66,1,67,1,'50147'O,
	8 4,'40170'O,'60000'O,-1,-1,
	8 11,'60206'O,'61000'O,'200'O,0,'61002'O,-1,-1,
	8	'40206'O,'61000'O,'200'O,0,
	9 4,'40177'O,'60000'O,-1,-1/
C
	DATA (VWORD(I),I=87,131) /
	1 'FOLLOW','*KICK','*BITE','TAUNT',
	1 'LOWER','*PUSH','PRESS','*RING',
	2 'PEAL','*RUB','*FEEL','*CARESS','*TOUCH',
	3 'FONDLE','SHAKE','SPIN','*UNTIE',
	4 'FREE','*WALK','*RUN','*PROCEED','GO','*ATTACK','*FIGHT',
	5 '*INJURE','*HIT','HURT','BOARD',
	6 '*BRUSH','CLEAN','*BURN','*IGNITE',
	7 'INCINERA','CLIMB','CLOSE','DIG',
	8 'DISEMBAR','*DRINK','*IMBIBE','SWALLOW',
	9 '*DROP','RELEASE','*EAT','*GOBBLE','*CONSUME'/
C
	DATA (VVOC(I),I=121,278) /
	1 2,'125'O,'50125'O,1,'50153'O,
	1 1,'50156'O,9,'50160'O,'40160'O,'61012'O,-1,-1,
	1	'40241'O,'61010'O,-1,-1,
	2 5,'52127'O,'70127'O,'61002'O,-1,-1,
	3 1,'50157'O,1,'50171'O,1,'50201'O,
	4 11,'42161'O,'61000'O,0,'10000'O,
	4	'60242'O,'61000'O,0,'10000'O,'61015'O,-1,-1,
	4 9,'50216'O,'40126'O,'61016'O,-1,-1,'40126'O,'61005'O,-1,-1,
	5 7,'60215'O,'21000'O,0,'200'O,'44002'O,0,'1000'O,
	5 4,'40202'O,'21000'O,0,2,
	6 5,'52130'O,'70130'O,'61002'O,-1,-1,
	7 7,'60211'O,'61000'O,'20'O,0,'64002'O,'10'O,0,
	7 12,'40235'O,'20007'O,0,'4000'O,'40236'O,'20006'O,0,'4000'O,
	7	'40234'O,'20000'O,0,'4000'O,
	7 4,'40176'O,'61000'O,'10200'O,0,
	7 21,'60131'O,'20005'O,-1,-1,'44002'O,4,0,
	7 	'60131'O,'20016'O,-1,-1,'44002'O,4,0,
	7 	'60131'O,'20000'O,-1,-1,'44002'O,4,0,
	8 8,'40203'O,'20000'O,0,2,'40203'O,'20015'O,0,2,
	8 4,'40210'O,'61000'O,'400'O,0,
	9 25,'42221'O,'41000'O,-1,-1,
	9	'60220'O,'41000'O,-1,-1,'61005'O,-1,-1,
	9	'60220'O,'41000'O,-1,-1,'61006'O,-1,-1,
	9	'60220'O,'41000'O,-1,-1,'61016'O,-1,-1/
C
	DATA (VWORD(I),I=132,172) /
	1 '*MUNCH','TASTE','*DOUSE','EXTINGUI',
	1 '*GIVE','*HAND','DONATE','*HELLO',
	2 'HI','BLOW','INFLATE','*JUMP',
	3 'LEAP','*KILL','*MURDER','*SLAY',
	4 '*STAB','DISPATCH','*KNOCK','RAP',
	5 'LIGHT','LOCK','*LOOK','*L','*STARE',
	6 'GAZE','*MELT','LIQUIFY','MOVE',
	7 '*PULL','TUG','*DESTROY','*MUNG',
	8 '*BREAK','DAMAGE','OPEN','PICK',
	9 '*PLUG','*GLUE','PATCH','*POKE'/
C
	DATA (VVOC(I),I=279,450) /
	1 4,'40207'O,'75000'O,'2000'O,0,
	1 4,'40174'O,'75000'O,'100'O,0,
	1 11,'72222'O,'21004'O,'40'O,0,'64222'O,'21000'O,'40'O,0,
	1	'61000'O,-1,-1,
	2 2,'2227'O,'50227'O,
	2 15,'62146'O,'61007'O,-1,-1,'61002'O,4,0,
	2	'40122'O,'61007'O,-1,-1,'40165'O,'61005'O,-1,-1,
	2 4,'70146'O,'61002'O,4,0,
	3 5,'133'O,'40133'O,'61001'O,-1,-1,
	4 7,'60213'O,'21000'O,0,'200'O,'44002'O,0,'1000'O,
	4 12,'42166'O,'61003'O,-1,-1,'40166'O,'61012'O,-1,-1,
	4	'40215'O,'23006'O,'40'O,0,
	5 11,'42173'O,'75000'O,'100'O,0,'60211'O,'61000'O,'100'O,0,
	5	'54002'O,'10'O,0,
	5 7,'60134'O,'20000'O,-1,-1,'74002'O,4,0,
	6 31,'167'O,'40170'O,'60003'O,-1,-1,'40231'O,'61010'O,-1,-1,
	6	'40230'O,'60005'O,-1,-1,'40230'O,'60016'O,-1,-1,
	6	'60144'O,'60003'O,-1,-1,'61002'O,-1,-1,
	6	'60144'O,'60003'O,-1,-1,'61016'O,-1,-1,
	6 4,'70145'O,'61002'O,'10'O,0,
	6 4,'40172'O,'20000'O,-1,-1,
	7 8,'42172'O,'21000'O,-1,-1,'40172'O,'21012'O,-1,-1,
	8 5,'52212'O,'70212'O,'44002'O,-1,-1,
	8 11,'42175'O,'61000'O,'10200'O,0,'60175'O,'61000'O,'10200'O,0,
	8	'54002'O,4,'1000'O,
	8 4,'40204'O,'61007'O,'20000'O,'40'O,
	9 4,'70152'O,'61002'O,-1,-1/
C
	DATA (VWORD(I),I=173,212) /
	1 '*BREAK','JAB','*POUR','SPILL',
	1 'PUMP','*PUT','*INSERT','*STUFF',
	2 'PLACE','*RAISE','LIFT','*READ',
	3 'SKIM','*STRIKE','BLIND','*SWING',
	4 'THRUST','*TAKE','*HOLD','*CARRY',
	5 'REMOVE','*TELL','*COMMAND','REQUEST',
	6 '*THROW','*HURL','CHUCK','*TIE',
	7 'FASTEN','*TURN','SET','UNLOCK',
	8 '*WAKE','*ALARM','*STARTLE','SURPRISE',
	9 '*WAVE','*FLAUNT','BRANDISH','WIND'/
C
	DATA (VVOC(I),I=451,654) /
	1 7,'60212'O,'21000'O,0,'200'O,'44002'O,0,'1000'O,
	1 25,'42223'O,'41000'O,-1,-1,
	1	'60223'O,'41000'O,-1,-1,'61005'O,-1,-1,
	1	'60223'O,'41000'O,-1,-1,'61016'O,-1,-1,
	1	'60240'O,'41000'O,-1,-1,'61012'O,-1,-1,
	1 4,'60232'O,'60007'O,-1,-1,
	2 16,'72220'O,'61005'O,-1,-1,'70220'O,'61016'O,-1,-1,
	2	'40221'O,'61006'O,-1,-1,'70241'O,'61010'O,-1,-1,
	2 5,'52155'O,'40155'O,'61007'O,-1,-1,
	3 18,'42144'O,'71000'O,'40000'O,0,
	3	'60144'O,'71000'O,'40000'O,0,'61002'O,-1,-1,
	3	'60144'O,'71000'O,'40000'O,0,'61016'O,-1,-1,
	3 12,'60215'O,'23000'O,'40'O,0,'44002'O,0,'1000'O,
	3	'42215'O,'23000'O,'40'O,0,'50173'O,
	3 7,'60214'O,'44000'O,0,'1000'O,'21003'O,0,'200'O,
	5 11,'42204'O,'61000'O,'20000'O,'40'O,
	5	'60204'O,'61000'O,'20000'O,0,'61015'O,-1,-1,
	5 4,'40217'O,'20000'O,0,'2000'O,
	6 21,'62224'O,'44000'O,-1,-1,'21003'O,'40'O,0,
	6	'60224'O,'44000'O,-1,-1,'21016'O,'40'O,0,
	6	'60220'O,'44000'O,-1,-1,'61005'O,-1,-1,
	7 11,'70162'O,'61004'O,-1,-1,'60163'O,'21007'O,'40'O,0,
	7	'65002'O,4,0,
	7 22,'62164'O,'61000'O,2,0,'64002'O,4,0,
	7	'40173'O,'75012'O,'100'O,0,'40174'O,'75013'O,'100'O,0,
	7	'60237'O,'61000'O,2,0,'20004'O,-1,-1,
	7 7,'60135'O,'21000'O,-1,-1,'74002'O,4,0,
	8 8,'42150'O,'20000'O,'40'O,0,'40150'O,'20007'O,'40'O,0,
	9 4,'40154'O,'40000'O,-1,-1,
	9 5,'50233'O,'40233'O,'61007'O,-1,-1/
C
	DATA (VWORD(I),I=213,240)/
	1 'ENTER','LEAVE','*MAKE','BUILD',
	1 '*OIL','*GREASE','LUBRICAT','PLAY',
	2 'SEND','SLIDE','*SMELL','SNIFF',
	3 'SQUEEZE','GET',14*' '/
C
	DATA (VVOC(I),I=655,721) /
	1 2,167,'50126'O,2,168,'50220'O,1,'50243'O,
	1 4,'70244'O,'41002'O,-1,-1,
	1 5,'50245'O,'70245'O,'75000'O,4,0,
	2 4,'40246'O,'61014'O,-1,-1,
	2 4,'70241'O,'61010'O,-1,-1,1,'50105'O,
	3 1,'50104'O,19,'42204'O,'61000'O,'20000'O,'40'O,
	3	'40202'O,'21005'O,0,2,'40203'O,'21015'O,0,2,
	3	'60204'O,'61000'O,'20000'O,'40'O,'61015'O,-1,-1,
	3 14*0/

C SPARSE, PAGE 7
C
C Set up for parsing
C
	SPARSE=-1				! assume parse fails.
	ADJ=0					! clear parts holders.
	ACT=0
	PREP=0
	PPTR=0
	OBJ1=0
	OBJ2=0
	PREP1=0
	PREP2=0
	LOBJ=0
	ANDFLG=.FALSE.
	BUNFLG=.FALSE.
	DFLAG=(PRSFLG.AND.4).NE.0

C SPARSE, PAGE 8
C
C Now loop over input buffer of lexical tokens.
C
	I=0
10	I=I+1					! do 1000 i=1,llnt
	  WORD=LBUF(I)				! get current token.
	  ERRVOC=0				! assume won't find
	  IF(WORD.EQ.' ') GO TO 1000		! blank? ignore.
	  IF(WORD.EQ.'AND') GO TO 1500		! 'AND'?
	  IF((WORD.EQ.'EXCEPT').OR.(WORD.EQ.'BUT')) GO TO 2500
C
C Check for buzz word
C
	  DO 50 J=1,BWMAX
	    IF(WORD.EQ.BWORD(J)) GO TO 1000	! if match, ignore.
50	  CONTINUE
C
C Check for action or direction
C
	  J=1					! check for action.
	  DO 70 K=1,VWMAX
	    IF(VWORD(K)(1:1).EQ.'*') GO TO 65	! synonym?
	    IF(WORD.EQ.VWORD(K)) GO TO 2000	! match to base word?
	    J=J+VVOC(J)+1			! skip over syntax.
	    GO TO 70
65	    IF(WORD.EQ.VWORD(K)(2:WRDLNT)) GO TO 2000 ! synonym match?
70	  CONTINUE
C
75	  IF((ADJ.NE.0).OR.(PREP.NE.0).OR.(OBJ1.NE.0)) GO TO 200
	  IF(ACT.EQ.0) GO TO 80			! any verb yet?
	  IF((VVOC(ACT+1).AND.SVMASK).NE.WALKW) GO TO 200	! walk?
80	  DO 100 J=1,DWMAX			! then chk for dir.
	    IF(WORD.EQ.DWORD(J)) GO TO 3000	! match to direction?
100	  CONTINUE
C
C Not an action, check for preposition, adjective, or object.
C
200	  DO 250 J=1,PWMAX			! look for preposition.
	    IF(WORD.EQ.PWORD(J)) GO TO 4000	! match to preposition?
250	  CONTINUE
C
	  J=1					! look for adjective.
	  DO 350 K=1,AWMAX
	    IF(WORD.EQ.AWORD(K)) GO TO 5000	! match to adjective?
300	    J=J+1				! advance to next entry.
	    IF(AVOC(J).LT.0) GO TO 300		! found next entry yet?
350	  CONTINUE
C
400	  J=1					! look for object.
	  DO 550 K=1,OWMAX
	    IF(WORD.EQ.OWORD(K)) GO TO 6000	! match to object?
500	    J=J+1				! advance to next entry.
	    IF(OVOC(J).LT.0) GO TO 500		! found next entry yet?
550	  CONTINUE
C
C Not recognizable
C
	  IF(.NOT.VBFLAG) RETURN		! if mute, return
	  LCWORD=LCIFY(WORD,1)			! convert to lower case
	  WRITE(OUTCH,600) LCWORD(1:NBLEN(LCWORD)) ! don't recognize
600	  FORMAT(' I don''t understand "',A,'".')
	  CALL RSPEAK(ERRVOC)			! if extra verb, say so
800	  TELFLG=.TRUE.				! something said.
	  BUNSUB=0				! no valid EXCEPT clause.
	  RETURN

C SPARSE, PAGE 9
C
1000	IF(I.LT.LLNT) GO TO 10			! end of do loop
C
C At end of parse, check for:
C	1. dangling adjective
C	2. bunched object
C	3. simple directions
C	4. orphan preposition
C	5. dangling preposition
C
	IF(ADJ.NE.0) GO TO 4500			! dangling adjective?
	IF(BUNFLG) OBJ1=BUNOBJ			! bunched object?
	IF(BUNFLG.AND.(BUNSUB.NE.0).AND.(BUNLNT.EQ.0))
	1	GO TO 13200			! except for nothing?
	IF(ACT.EQ.0) ACT=OFLAG.AND.OACT		! if no action, take orphan.
	IF(ACT.EQ.0) GO TO 10000		! no action, punt.
	IF(((VVOC(ACT+1).AND.SVMASK).NE.WALKW).OR.(OBJ1.LT.XMIN))
	1	GO TO 1100			! simple direction?
	IF ((OBJ2.NE.0).OR.(PREP1.NE.0).OR.(PREP2.NE.0))
	1	GO TO 1050			! no extra junk?
	PRSA=WALKW				! yes, win totally.
	PRSO=OBJ1
	SPARSE=1				! special return value.
	RETURN
C
1050	IF(VBFLAG) CALL RSPEAK(618)		! direction+junk, fail.
	GO TO 800				! clean up state.
C
1100	IF((OFLAG.NE.0).AND.(OPREP.NE.0).AND.(PREP.EQ.0).AND.
	1	(OBJ1.NE.0).AND.(OBJ2.EQ.0).AND.(ACT.EQ.OACT))
	2	GO TO 11000
C
	IF(PREP.EQ.0) GO TO 1200		! if dangling prep,
	IF(PPTR.EQ.0) GO TO 12000		! and no object, die;
	IF(PRPVEC(PPTR).NE.0) GO TO 12000	! and prep already, die;
	PRPVEC(PPTR)=PREP			! cvt to 'pick up frob'.
1200	SPARSE=0				! parse succeeds.
	IF(DFLAG) TYPE 1310,ACT,OBJ1,OBJ2,PREP1,PREP2
1310	FORMAT(' SPARSE RESULTS- ',5I7)
	RETURN

C SPARSE, PAGE 10
C
C 1500--	AND
C
1500	IF(ADJ.NE.0) GO TO 4100			! dangling adj? treat as obj.
	IF((PREP.NE.0).OR.(PPTR.NE.1)) GO TO 8000	! prep or not dir obj?
	ANDFLG=.TRUE.				! flag 'AND'.
	GO TO 1000				! done.
C
C 2000--	Action
C
2000	IF(ACT.EQ.0) GO TO 2100			! got one already?
	ERRVOC=624				! flag for error report.
	GO TO 75				! try to construe differently.
C
2100	ACT=J					! save index to verb.
	OACT=0					! no orphan.
	ANDFLG=.FALSE.				! clear 'AND' flag.
	IF(DFLAG) TYPE 2020,J
2020	FORMAT(' SPARSE- ACT AT ',I6)
	GO TO 1000				! done.
C
C 2500--	EXCEPT/BUT
C
2500	IF(ANDFLG.OR.BUNFLG.OR.(PPTR.NE.1).OR.(ADJ.NE.0).OR.
	1	(I.GE.LLNT)) GO TO 13000	! not in right place?
	IF(LBUF(I+1).NE.'FOR') GO TO 2600	! except for?
	I=I+1					! skip over.
	IF(I.GE.LLNT) GO TO 13000		! out of text?
2600	IF((OBJ1.NE.EVERY).AND.(OBJ1.NE.VALUA).AND.
	1  (OBJ1.NE.POSSE)) GO TO 13100		! "collective" EXCEPT?
	ANDFLG=.TRUE.				! force next object
	BUNFLG=.TRUE.				! into bunch vector.
	BUNLNT=0				! start at top.
	BUNSUB=OBJ1				! remember collective.
	GO TO 1000				! on to next word.
C
C 3000--	Direction
C 		Don't need to check for ambiguous use as adjective;
C		only possible overlap is north/south/east/west wall;
C		and global wall takes is found if no adjective given.
C
3000	OBJ=DVOC(J)				! save direction.
	ACT=1					! find value for action.
3600	IF(VVOC(ACT).EQ.0) CALL BUG(310,ACT)	! can't find walk.
	IF((VVOC(ACT+1).AND.SVMASK).EQ.WALKW) GO TO 6300 ! treat as obj.
	ACT=ACT+VVOC(ACT)+1			! to next syntax entry.
	GO TO 3600
C
C 4000--	Preposition (or dangling adjective at end of parse)
C
4000	IF(ADJ.EQ.0) GO TO 4600			! dangling adjective?
4100	I=I-1					! back up parse stream.
4500	WORD=AWORD(ADJPTR)			! get adjective string.
	ADJ=0					! now an object.
	GO TO 400				! go search object words.
C
4600	IF(ANDFLG) GO TO 8000			! 'AND' pending?
	IF(PREP.NE.0) GO TO 1000		! already have one? ignore.
	PREP=PVOC(J)				! no, get index.
	IF(DFLAG) TYPE 4030,J
4030	FORMAT(' SPARSE- PREP AT ',I6)
	GO TO 1000
C
C 5000--	Adjective
C
5000	ADJ=J					! save adjective.
	ADJPTR=K				! save string pointer.
	IF((I.LT.LLNT).OR.(OFLAG.EQ.0).OR.(ONAME.EQ.' '))
	1	GO TO 1000			! last word + orphan string?
	IF(DFLAG) TYPE 5040,ADJ,ONAME		! have orphan.
5040	FORMAT(' SPARSE- ADJ AT ',I6,' ORPHAN= ',A)
	WORD=ONAME				! get object string.
	GO TO 400				! go search object names.
C
C 6000--	Object
C
6000	OBJ=GETOBJ(J,ADJ,0)			! identify object.
	IF(DFLAG) TYPE 6010,J,OBJ
6010	FORMAT(' SPARSE- OBJ AT ',I6,'  OBJ= ',I6)
	IF(OBJ.LE.0) GO TO 7000			! if le, couldnt.
	IF(OBJ.NE.ITOBJ) GO TO 6100		! "it"?
	OBJ=GETOBJ(0,0,LASTIT)			! find last.
	IF(OBJ.LE.0) GO TO 7000			! if le, couldnt.
C
6100	IF(PREP.NE.9) GO TO 6200		! "of" obj?
	IF((LOBJ.EQ.OBJ).OR.(LOBJ.EQ.OCAN(OBJ))) GO TO 6500	! same as prev?
	IF((LOBJ.EQ.EVERY).AND.((OBJ.EQ.VALUA).OR.(OBJ.EQ.POSSE)))
	1	GO TO 6350			! all of "collective"?
6150	IF(VBFLAG) CALL RSPEAK(601)		! doesn't work
	GO TO 800				! clean up state.
C
6200	IF(.NOT.ANDFLG) GO TO 6300		! 'AND' pending?
	IF(BUNFLG) GO TO 6250			! first object?
	BUNVEC(1)=OBJVEC(PPTR)			! put preceding obj in vector.
	BUNLNT=1
	BUNFLG=.TRUE.				! flag bunch of objects.
	BUNSUB=0				! no EXCEPT/BUT clause.
6250	BUNLNT=BUNLNT+1				! advance bunch pointer.
	IF(BUNLNT.GT.BUNMAX) GO TO 9000		! too many objects?
	BUNVEC(BUNLNT)=OBJ			! add to bunch vector.
	GO TO 6500
C
6300	IF(PPTR.EQ.2) GO TO 9000		! too many objs?
	PPTR=PPTR+1
	PRPVEC(PPTR)=PREP
6350	OBJVEC(PPTR)=OBJ			! stuff into vector.
6500	PREP=0
	ADJ=0
	ANDFLG=.FALSE.				! no pending 'AND'.
	LOBJ=OBJ				! record last object.
	GO TO 1000

C SPARSE, PAGE 11
C
C 7000--	Unidentifiable object (index into OVOC is J)
C
7000	LCWORD=LCIFY(WORD,1)			! convert obj to lower case.
	LCWRD1=' '				! assume no adjective
	IF(ADJ.NE.0) LCWRD1=' '//LCIFY(AWORD(ADJPTR),1)//' '
	IF(OBJ.LT.0) GO TO 7200			! if lt, ambiguous.
	IF(LIT(HERE)) GO TO 7100		! lit?
	IF(VBFLAG) CALL RSPEAK(579)		! not lit, report.
	GO TO 800				! go clean up state.
C
7100	IF(VBFLAG) WRITE(OUTCH,7110)
	1	LCWRD1(1:NBLEN(LCWRD1)+1),LCWORD(1:NBLEN(LCWORD))
7110	FORMAT(' I can''t see any',A,A,' here.')
	GO TO 800				! go clean up state.
C
7200	IF(OBJ.NE.-10000) GO TO 7300		! inside vehicle?
	IF(VBFLAG) CALL RSPSUB(620,ODESC2(AVEHIC(WINNER)))
	GO TO 800				! go clean up state.
C
7300	IF(ACT.EQ.0) ACT=OFLAG.AND.OACT		! if no act, get orphan.
	CALL ORPHAN(-1,ACT,PREP1,OBJ1,PREP,WORD,0,0)	! orphan the world.
	IF(VBFLAG) WRITE(OUTCH,7310)
	1	LCWRD1(1:NBLEN(LCWRD1)+1),LCWORD(1:NBLEN(LCWORD))
7310	FORMAT(' Which',A,A,' do you mean?')
	GO TO 800				! go clean up state.
C
C 8000--	Misplaced 'AND'.
C
8000	IF(VBFLAG) CALL RSPEAK(1049)
	GO TO 800				! go clean up state.
C
C 9000--	Too many objects.
C
9000	IF(VBFLAG) CALL RSPEAK(617)
	GO TO 800				! go clean up state.
C
C 10000--	No action, punt.
C
10000	IF(OBJ1.EQ.0) GO TO 10100		! any direct object?
	IF(VBFLAG) CALL RSPSUB(621,ODESC2(OBJ1))	! what to do?
	CALL ORPHAN(-1,0,PREP1,OBJ1,0,' ',0,0)
	RETURN
C
10100	IF(VBFLAG) CALL RSPEAK(622)		! huh?
	GO TO 800				! go clean up state.
C
C 11000--	Orphan preposition.  Conditions are
C		OBJ1.NE.0, OBJ2=0, PREP=0, ACT=OACT
C
11000	IF(OOBJ1.NE.0) GO TO 11500		! orphan object?
	PREP1=OPREP				! no, just use prep.
	GO TO 1200
C
11500	OBJ2=OBJ1				! yes, use as direct obj.
	PREP2=OPREP
	OBJ1=OOBJ1
	PREP1=OPREP1
	GO TO 1200
C
C 12000--	True hanging preposition, no objects yet.
C
12000	CALL ORPHAN(-1,ACT,0,0,PREP,' ',0,0)	! orphan prep.
	GO TO 1200
C
C 13000--	EXCEPT/BUT errors.
C
13000	LCWORD=LCIFY(WORD,1)
	IF(VBFLAG) WRITE(OUTCH,13010) LCWORD(1:NBLEN(LCWORD))	! wrong place.
13010	FORMAT(' Misplaced "',A,'".')
	GO TO 800				! go clean up state.
C
13100	LCWORD=LCIFY(WORD,2)				! wrong case.
	IF(VBFLAG) WRITE(OUTCH,13110) LCWORD(1:NBLEN(LCWORD))	! not coll.
13110	FORMAT(' "',A,'" can only be used with "everything", "valuables",
	1or "possessions".')
	GO TO 800				! go clean up state.
C
13200	IF(VBFLAG) CALL RSPEAK(619)		! no objects.
	GO TO 800				! go clean up state.
C
	END

C GETOBJ--	Find obj described by adj, name pair
C
C Declarations
C
C This routine details on bit 3 of PRSFLG
C
	INTEGER FUNCTION GETOBJ(OIDX,AIDX,SPCOBJ)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL THISIT,GHERE,LIT,CHOMP,DFLAG,NOADJS
C
	DFLAG=(PRSFLG.AND.8).NE.0
	CHOMP=.FALSE.
	AV=AVEHIC(WINNER)
	OBJ=0					! assume dark.
	IF(.NOT.LIT(HERE)) GO TO 200		! lit?
C
	OBJ=SCHLST(OIDX,AIDX,HERE,0,0,SPCOBJ)	! search room.
	IF(DFLAG) TYPE 10,OBJ
10	FORMAT(' SCHLST- ROOM SCH ',I6)
	IF(OBJ) 1000,200,100			! test result.
100	IF((AV.EQ.0).OR.(AV.EQ.OBJ).OR.(OCAN(OBJ).EQ.AV).OR.
	1	((OFLAG2(OBJ).AND.FINDBT).NE.0)) GO TO 200
	CHOMP=.TRUE.				! not reachable.
C
200	IF(AV.EQ.0) GO TO 400			! in vehicle?
	NOBJ=SCHLST(OIDX,AIDX,0,AV,0,SPCOBJ)	! search vehicle.
	IF(DFLAG) TYPE 220,NOBJ
220	FORMAT(' SCHLST- VEH SCH  ',I6)
	IF(NOBJ) 800,400,300			! test result.
300	CHOMP=.FALSE.				! reachable.
	IF(OBJ.EQ.NOBJ) GO TO 400		! same as before?
	IF(OBJ.NE.0) NOBJ=-NOBJ			! amb result?
	OBJ=NOBJ
C
400	NOBJ=SCHLST(OIDX,AIDX,0,0,WINNER,SPCOBJ)	! search adventurer.
	IF(DFLAG) TYPE 430,NOBJ
430	FORMAT(' SCHLST- ADV SCH  ',I6)
	IF(NOBJ) 800,900,500			! test result
500	IF(OBJ.EQ.0) GO TO 800			! any previous? no, use nobj.
	IF(AIDX.NE.0) GO TO 600			! yes, amb, any adj?
	IF(NOADJS(OBJ).NEQV.NOADJS(NOBJ)) GO TO 700 ! both adj or no adj?
600	OBJ=-NOBJ				! ambiguous result.
	GO TO 900
700	IF(NOADJS(OBJ)) GO TO 900		! if old no adj, use old.
800	OBJ=NOBJ				! return new object.
900	IF(CHOMP) OBJ=-10000			! unreachable.
1000	GETOBJ=OBJ
C
	IF(GETOBJ.NE.0) GO TO 1500		! got something?
	DO 1200 I=STRBIT+1,OLNT			! no, search globals.
	  IF(.NOT.THISIT(OIDX,AIDX,I,SPCOBJ)) GO TO 1200
	  IF(.NOT.GHERE(I,HERE)) GO TO 1200	! can it be here?
	  IF(GETOBJ.EQ.0) GO TO 1150		! got one yet?
	  IF(AIDX.NE.0) GO TO 1050		! yes, no adj?
	  IF(NOADJS(GETOBJ).NEQV.NOADJS(I)) GO TO 1100	! only one with no adj?
1050	  GETOBJ=-I				! ambiguous
	  GO TO 1200
1100	  IF(NOADJS(GETOBJ)) GO TO 1200		! if old no adj, retain.
1150	  GETOBJ=I				! new is target.
1200	CONTINUE
C
1500	CONTINUE				! end of search.
	IF(DFLAG) TYPE 1540,GETOBJ
1540	FORMAT(' SCHLST- RESULT   ',I6)
	RETURN
	END

C SCHLST--	Search for object
C
C Declarations
C
	INTEGER FUNCTION SCHLST(OIDX,AIDX,RM,CN,AD,SPCOBJ)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL THISIT,QHERE,NOTRAN,NOVIS,AEMPTY,NOADJS
C
C Functions and data
C
	NOTRAN(O)=((OFLAG1(O).AND.TRANBT).EQ.0).AND.
	1	((OFLAG2(O).AND.OPENBT).EQ.0)
	NOVIS(O)=((OFLAG1(O).AND.VISIBT).EQ.0)
C
	SCHLST=0				! no result.
	AEMPTY=.FALSE.				! no ambiguous empty.
	DO 1000 I=1,OLNT			! search objects.
	  IF(NOVIS(I).OR.
	1	(((RM.EQ.0).OR.(.NOT.QHERE(I,RM))).AND.
	2	 ((CN.EQ.0).OR.(OCAN(I).NE.CN)).AND.
	3	 ((AD.EQ.0).OR.(OADV(I).NE.AD)))) GO TO 1000
	  IF(.NOT.THISIT(OIDX,AIDX,I,SPCOBJ)) GO TO 200
	  IF(SCHLST.EQ.0) GO TO 150		! got one already?
	  IF(AIDX.NE.0) GO TO 2000		! adj? then ambiguous
	  IF(NOADJS(I)) GO TO 100		! new have no adj?
	  AEMPTY=.TRUE.				! no, old might, flag.
	  GO TO 200
100	  IF(NOADJS(SCHLST)) GO TO 2000		! old have no adj?
150	  SCHLST=I				! new is unique, or
						! new has no adj, old does.
C
C If open or transparent, search the object itself.
C
200	  IF(NOTRAN(I)) GO TO 1000
C
C Search is conducted in reverse.  All objects are checked to
C See if they are at some level of containment inside object 'I'.
C If they are at level 1, or if all links in the containment
C chain are open, visible, and have SEARCHME set, they can qualify
C as a potential match.
C
	  DO 500 J=1,OLNT			! search objects.
	    IF(NOVIS(J).OR. (.NOT.THISIT(OIDX,AIDX,J,SPCOBJ)))
	1	GO TO 500			! visible & match?
	    X=OCAN(J)				! get container.
300	    IF(X.EQ.I) GO TO 400		! inside target?
	    IF(X.EQ.0) GO TO 500		! inside anything?
	    IF(NOVIS(X).OR.NOTRAN(X).OR.
	1	((OFLAG2(X).AND.SCHBT).EQ.0)) GO TO 500
	    X=OCAN(X)				! go another level.
	    GO TO 300
C
400	    IF(SCHLST.EQ.0) GO TO 450		! already got one?
	    IF(AIDX.NE.0) GO TO 2000		! adj? then ambiguous.
	    IF(NOADJS(J)) GO TO 425		! new have no adj?
	    AEMPTY=.TRUE.			! no, ambiguous empty.
	    GO TO 500
425	    IF(NOADJS(SCHLST)) GO TO 2000	! old have no adj? then amb.
450	    SCHLST=J				! new is unique, or
						! new has no adj, and old does.
500	  CONTINUE
C
1000	CONTINUE
	IF(.NOT.AEMPTY.OR.(SCHLST.EQ.0)) RETURN	! if none or not amb, done.
	IF(NOADJS(SCHLST)) RETURN		! if amb, and no adj, done.
2000	SCHLST=-SCHLST				! amb return.
	RETURN
C
	END

C THISIT--	Validate object vs description
C
C Declarations
C
	LOGICAL FUNCTION THISIT(OIDX,AIDX,OBJ,SPCOBJ)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	THISIT=.FALSE.				! assume no match.
	IF((SPCOBJ.NE.0).AND.(OBJ.EQ.SPCOBJ)) GO TO 500
C
C Check for object names
C
	I=OIDX
100	IF(IABS(OVOC(I)).EQ.OBJ) GO TO 200	! found it?
	I=I+1					! adv to next.
	IF(OVOC(I).LT.0) GO TO 100		! still part of list?
	RETURN					! if done, lose.
C
200	IF(AIDX.EQ.0) GO TO 500			! any adj?
	I=AIDX
300	IF(IABS(AVOC(I)).EQ.OBJ) GO TO 500	! found it?
	I=I+1					! adv to next.
	IF(AVOC(I).LT.0) GO TO 300		! still part of list?
	RETURN					! if done, lose.
C
500	THISIT=.TRUE.
	RETURN
	END

C SYNMCH--	Syntax matcher
C
C Declarations
C
C This routine details on bit 4 of PRSFLG
C
	LOGICAL FUNCTION SYNMCH
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL SYNEQL,TAKEIT,DFLAG
	CHARACTER*(TEXLNT) STR
	CHARACTER*(WRDLNT) FINDVB,FINDPR,LCIFY,LCWORD
	CHARACTER*(WRDLNT+2) LCPRP1,LCPRP2
C
	SYNMCH=.FALSE.
	DFLAG=(PRSFLG.AND.16).NE.0
	J=ACT					! set up ptr to syntax.
	DRIVE=0					! no default.
	DFORCE=0				! no forced default.
	QPREP=OFLAG.AND.OPREP			! valid orphan prep flag.
	LIMIT=J+VVOC(J)+1			! compute limit.
	J=J+1					! advance to next.
C
200	CALL UNPACK(J,NEWJ)			! unpack syntax.
	IF(DFLAG) TYPE 260,OBJ1,PREP1,DOBJ,DFL1,DFL2
260	FORMAT(' SYNMCH INPUTS TO SYNEQL- ',5I7)
	SPREP=DOBJ.AND.VPMASK			! save expected prep.
	IF(SYNEQL(PREP1,OBJ1,DOBJ,DFL1,DFL2)) GO TO 1000
C
C Direct syntax match fails.
C
	IF((OBJ2.NE.0).OR.(.NOT.SYNEQL(PREP1,OBJ1,IOBJ,IFL1,IFL2)))
	1	GO TO 500			! try direct as indirect.
	OBJ2=OBJ1				! move direct to indirect.
	PREP2=PREP1
	OBJ1=0					! no direct.
	PREP1=0
500	IF(OBJ1.NE.0) GO TO 3000		! if direct obj, on to next.
	GO TO 2500				! go do defaults.
C
1000	IF(DFLAG) TYPE 260,OBJ2,PREP2,IOBJ,IFL1,IFL2
	SPREP=IOBJ.AND.VPMASK			! save expected prep.
	IF(SYNEQL(PREP2,OBJ2,IOBJ,IFL1,IFL2)) GO TO 6000
C
C Indirect syntax match fails.
C
	IF(OBJ2.NE.0) GO TO 3000		! if ind object, on to next.
2500	IF((QPREP.EQ.0).OR.(QPREP.EQ.SPREP)) DFORCE=J	 ! if prep mch.
	IF((VFLAG.AND.SDRIV).NE.0) DRIVE=J	! if driver, record.
3000	J=NEWJ
	IF(J.LT.LIMIT) GO TO 200		! more to do?

C SYNMCH, PAGE 2
C
C Match has failed.  If default syntax exists, try to snarf
C orphans or GWIMs, or make new orphans.
C
	IF(DFLAG) TYPE 3020,DRIVE,DFORCE,OBJ1,OBJ2
3020	FORMAT(' SYNMCH, DRIVE=',2I6,'  OBJECTS =',2I6)
	IF(DRIVE.EQ.0) DRIVE=DFORCE		! no driver? use force.
	IF(DRIVE.EQ.0) GO TO 10000		! any driver?
	CALL UNPACK(DRIVE,DFORCE)		! unpack dflt syntax.
	LCWORD=LCIFY(FINDVB(DRIVE),2)		! get verb string.
	LCPRP1=' '//LCIFY(FINDPR(DOBJ.AND.VPMASK),1)//' '
	LCPRP2=' '//LCIFY(FINDPR(IOBJ.AND.VPMASK),1)//' '
C
C Try to fill direct object slot if that was the problem.
C
	IF(((VFLAG.AND.SDIR).EQ.0).OR.(OBJ1.NE.0)) GO TO 4000
	OBJ1=OFLAG.AND.OOBJ1
	IF(OBJ1.EQ.0) GO TO 3500		! any orphan?
	IF(SYNEQL(OPREP1,OBJ1,DOBJ,DFL1,DFL2)) GO TO 4000
C
C Orphan fails, try GWIM.
C
3500	OBJ1=GWIM(DOBJ,DFW1,DFW2)		! get gwim.
	IF(DFLAG) TYPE 3530,OBJ1
3530	FORMAT(' SYNMCH- DO GWIM= ',I6)
	IF(OBJ1.GT.0) GO TO 4000		! test result.
	CALL ORPHAN(-1,ACT,0,0,DOBJ.AND.VPMASK,' ',PREP2,OBJ2)	! fails, orphan.
	BUNSUB=0				! no EXCEPT clause.
	IF(OBJ2.GT.0) GO TO 3800		! if iobj, go print.
3700	WRITE(OUTCH,3750)
	1	LCWORD(1:NBLEN(LCWORD)),LCPRP1(1:NBLEN(LCPRP1)+1)
3750	FORMAT(1X,A,A,'what?')
	TELFLG=.TRUE.
	RETURN
C
3800	X=IABS(ODESC2(OBJ2))			! get iobj description.
	READ(DBCH,REC=X) J,STR			! read data base.
	CALL TXCRYP(X,STR)			! decrypt the line.
	WRITE(OUTCH,3880) LCWORD(1:NBLEN(LCWORD)),
	1	LCPRP1(1:NBLEN(LCPRP1)+1),
	2	LCPRP2(1:NBLEN(LCPRP2)+1),STR(1:NBLEN(STR))
3880	FORMAT(1X,A,A,'what',A,'the ',A,'?')
	TELFLG=.TRUE.
	RETURN

C SYNMCH, PAGE 3
C
C Try to fill indirect object slot if that was the problem.
C
4000	IF(((VFLAG.AND.SIND).EQ.0).OR.(OBJ2.NE.0)) GO TO 6000
	OBJ2=OFLAG.AND.OOBJ2
	IF(OBJ2.EQ.0) GO TO 4500		! any orphan?
	IF(SYNEQL(OPREP2,OBJ2,IOBJ,IFL1,IFL2)) GO TO 6000
C
C Orphan fails, try GWIM.
C
4500	OBJ2=GWIM(IOBJ,IFW1,IFW2)		! gwim.
	IF(DFLAG) TYPE 4550,OBJ2
4550	FORMAT(' SYNMCH- IO GWIM= ',I6)
	IF(OBJ2.GT.0) GO TO 6000
	IF(OBJ1.GT.0) GO TO 4600		! if dobj, go print.
	CALL ORPHAN(-1,ACT,OFLAG.AND.OPREP1,
	1	OFLAG.AND.OOBJ1,IOBJ.AND.VPMASK,' ',0,0)
	GO TO 3700
C
C Error with direct object available.
C
4600	CALL ORPHAN(-1,ACT,PREP1,OBJ1,IOBJ.AND.VPMASK,' ',0,0)
	X=IABS(ODESC2(OBJ1))			! get dobj description.
	READ(DBCH,REC=X) J,STR			! read data base.
	CALL TXCRYP(X,STR)			! decrypt the line.
	WRITE(OUTCH,4660) LCWORD(1:NBLEN(LCWORD)),
	1	LCPRP1(1:NBLEN(LCPRP1)+1),
	2	STR(1:NBLEN(STR)),LCPRP2(1:NBLEN(LCPRP2)+1)
4660	FORMAT(1X,A,A,'the ',A,A,'what?')
	TELFLG=.TRUE.
	RETURN
C
C Total chomp.
C
10000	CALL RSPEAK(601)			! cant do anything.
	BUNSUB=0
	RETURN

C SYNMCH, PAGE 3
C
C Now try to take individual objects and
C in general clean up the parse vector.
C
6000	IF((VFLAG.AND.SFLIP).EQ.0) GO TO 7000	! flip?
	J=OBJ1					! yes.
	OBJ1=OBJ2
	OBJ2=J
C
7000	PRSA=VFLAG.AND.SVMASK			! get verb.
	PRSO=OBJ1				! get dir obj.
	PRSI=OBJ2				! get ind obj.
	IF(.NOT.TAKEIT(PRSO,DOBJ)) RETURN	! try take.
	IF(.NOT.TAKEIT(PRSI,IOBJ)) RETURN	! try take.
	SYNMCH=.TRUE.
	IF(DFLAG) TYPE 7050,SYNMCH,PRSA,PRSO,PRSI,ACT,OBJ1,OBJ2
7050	FORMAT(' SYNMCH- RESULTS ',L1,6I7)
	RETURN
C
	END

C UNPACK-	Unpack syntax specification, adv pointer
C
C Declarations
C
	SUBROUTINE UNPACK(OLDJ,J)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	DO 10 I=1,11				! clear syntax.
	  SYN(I)=0
10	CONTINUE
C
	VFLAG=VVOC(OLDJ)
	J=OLDJ+1
	IF((VFLAG.AND.SDIR).EQ.0) RETURN	! dir object?
	DFL1=-1					! assume std.
	DFL2=-1
	IF((VFLAG.AND.SSTD).EQ.0) GO TO 100	! std object?
	DFW1=-1					! yes.
	DFW2=-1
	DOBJ=VABIT+VRBIT+VFBIT
	GO TO 200
C
100	DOBJ=VVOC(J)				! not std.
	DFW1=VVOC(J+1)
	DFW2=VVOC(J+2)
	J=J+3
	IF((DOBJ.AND.VEBIT).EQ.0) GO TO 200	! vbit = vfwim?
	DFL1=DFW1				! yes.
	DFL2=DFW2
C
200	IF((VFLAG.AND.SIND).EQ.0) RETURN	! ind object?
	IFL1=-1					! assume std.
	IFL2=-1
	IOBJ=VVOC(J)
	IFW1=VVOC(J+1)
	IFW2=VVOC(J+2)
	J=J+3
	IF((IOBJ.AND.VEBIT).EQ.0) RETURN	! vbit = vfwim?
	IFL1=IFW1				! yes.
	IFL2=IFW2
	RETURN
C
	END

C SYNEQL-	Test for syntax equality
C
C Declarations
C
	LOGICAL FUNCTION SYNEQL(PREP,OBJ,SPREP,SFL1,SFL2)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	IF(OBJ.EQ.0) GO TO 100			! any object?
	SYNEQL=(PREP.EQ.(SPREP.AND.VPMASK)).AND.
	1	(((SFL1.AND.OFLAG1(OBJ)).OR.
	2	  (SFL2.AND.OFLAG2(OBJ))).NE.0)
	RETURN
C
100	SYNEQL=(PREP.EQ.0).AND.(SFL1.EQ.0).AND.(SFL2.EQ.0)
	RETURN
C
	END

C TAKEIT-	Parser based take of object
C
C Declarations
C
	LOGICAL FUNCTION TAKEIT(OBJ,SFLAG)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL TAKE
C
	TAKEIT=.FALSE.				! assume loses.
	IF((OBJ.EQ.0).OR.(OBJ.GT.STRBIT).OR.DEADF)
	1	GO TO 4000			! null/stars/dead win.
	ODO2=ODESC2(OBJ)			! get desc.
	X=OCAN(OBJ)				! get container.
	IF((X.EQ.0).OR.((SFLAG.AND.VFBIT).EQ.0)) GO TO 500
	IF((OFLAG2(X).AND.OPENBT).NE.0) GO TO 500
	CALL RSPSUB(566,ODO2)			! cant reach.
	RETURN
C
500	IF((SFLAG.AND.VRBIT).EQ.0) GO TO 1000	! shld be in room?
	IF((SFLAG.AND.VTBIT).EQ.0) GO TO 2000	! can be taken?
C
C Should be in room (VRBIT NE 0) and can be taken (VTBIT NE 0)
C
	IF(SCHLST(0,0,HERE,0,0,OBJ).LE.0) GO TO 4000 ! if not, ok.
C
C Its in the room and can be taken.
C
	IF((OFLAG1(OBJ).AND.TAKEBT).NE.0) GO TO 3000
C
C Not takeable.  If we care, fail.
C
	IF((SFLAG.AND.VCBIT).EQ.0) GO TO 4000	! if no care, return.
	CALL RSPSUB(445,ODO2)
	RETURN
C
C 1000--	It should not be in the room.
C 2000--	It cant be taken.
C
2000	IF((SFLAG.AND.VCBIT).EQ.0) GO TO 4000	! if no care, return
1000	IF(SCHLST(0,0,HERE,0,0,OBJ).LE.0) GO TO 4000
	CALL RSPSUB(665,ODO2)
	RETURN
C
C 3000--	Take object.
C
3000	IF(LIT(HERE)) GO TO 3500		! lit?
	CALL RSPEAK(579)			! can't do it.
	RETURN
C
3500	SVA=PRSA				! save parse vector
	SVO=PRSO
	SVI=PRSI
	PRSA=TAKEW				! make 'take obj'
	PRSO=OBJ
	PRSI=0					! no indirect object
	TAKEIT=TAKE(.TRUE.)			! try to take object
	PRSA=SVA				! restore parse vector.
	PRSO=SVO
	PRSI=SVI
	RETURN
C
C 4000--	Win on general principles.
C
4000	TAKEIT=.TRUE.
	RETURN
C
	END

C GWIM- Get what I mean in ambiguous situations
C
C Declarations
C
	INTEGER FUNCTION GWIM(SFLAG,SFW1,SFW2)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL TAKEIT,NOCARE,LIT
C
	IF(DEADF) GO TO 700			! dead? gwim disabled.
	AV=AVEHIC(WINNER)
	NOBJ=0
	NOCARE=(SFLAG.AND.VCBIT).EQ.0
C
C First search adventurer
C
	IF((SFLAG.AND.VABIT).NE.0)
	1	GWIM=FWIM(SFW1,SFW2,0,0,WINNER,NOCARE)
	IF((GWIM.LT.0).OR..NOT.LIT(HERE).OR.
	1  ((SFLAG.AND.VRBIT).EQ.0)) RETURN
C
C Also search room
C
100	ROBJ=FWIM(SFW1,SFW2,HERE,0,0,NOCARE)
	IF(ROBJ) 500,600,200			! test result.
C
C ROBJ > 0
C
200	IF((AV.EQ.0).OR.(ROBJ.EQ.AV).OR.
	1	((OFLAG2(ROBJ).AND.FINDBT).NE.0)) GO TO 300
	IF(OCAN(ROBJ).NE.AV) RETURN		! unreachable? use prev obj.
C
300	IF(GWIM.EQ.0) GO TO 400			! prev obj?
	GWIM=-GWIM				! yes, ambiguous.
	RETURN
C
400	IF(.NOT.TAKEIT(ROBJ,SFLAG)) RETURN	! if untakeable, return prev.
500	GWIM=ROBJ				! return room seach.
600	RETURN
C
700	GWIM=-1					! fails.
	RETURN
C
	END

C NOADJS-	See if any adjectives for object
C
C Declarations
C
	LOGICAL FUNCTION NOADJS(OBJ)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	NOADJS=.FALSE.				! assume false.
	DO 100 I=1,AVMAX			! search adj.
	  IF(IABS(AVOC(I)).EQ.OBJ) RETURN	! found adjective?
	  IF(AVOC(I).EQ.0) GO TO 200		! end of list?
100	CONTINUE
200	NOADJS=.TRUE.				! true.
	RETURN
C
	END

C LCIFY-	"Lower case"-ify a string for printing
C
C Declarations
C
	CHARACTER*(*) FUNCTION LCIFY(STRING,START)
	IMPLICIT INTEGER(A-Z)
	CHARACTER*(*) STRING
C
	LCIFY=STRING				! assume input = output.
	K=LEN(STRING)				! get input length.
	IF(START.GT.K) RETURN			! anything to convert?
C
	ULCVT=ICHAR('a')-ICHAR('A')		! conversion factor
	DO 100 I=START,K			! loop on characters
	  IF((STRING(I:I).GE.'A').AND.(STRING(I:I).LE.'Z'))
	1	LCIFY(I:I)=CHAR(ICHAR(STRING(I:I))+ULCVT)
100	CONTINUE
	RETURN
C
	END

C FINDVB-	Find verb string corresponding to syntax.
C
C Declarations
C
	CHARACTER*(*) FUNCTION FINDVB(SYNTAX)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	J=1
	DO 100 K=1,VWMAX			! loop through verbs
	  NEWJ=J+VVOC(J)+1			! start of next syntax
	  IF((J.LE.SYNTAX).AND.(SYNTAX.LT.NEWJ)) GO TO 200
	  IF(VWORD(K)(1:1).NE.'*') J=NEWJ	! if last synonym, advance.
100	CONTINUE
	FINDVB=' '				! disaster
	RETURN
C
200	FINDVB=VWORD(K)				! return string
	IF(VWORD(K)(1:1).EQ.'*') FINDVB=VWORD(K)(2:WRDLNT)
	RETURN
C
	END

C FINDPR-	Find preposition string corresponding to index.
C
C Declarations
C
	CHARACTER*(*) FUNCTION FINDPR(PREPNO)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	DO 100 I=1,PWMAX			! loop through prepositions.
	  IF(PVOC(I).EQ.PREPNO) GO TO 200
100	CONTINUE
	FINDPR=' '
	RETURN
C
200	FINDPR=PWORD(I)
	RETURN
C
	END

C Subroutines for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C RSPEAK-- Output random message routine
C
C Called by--
C
C	CALL RSPEAK(MSGNUM)
C
	SUBROUTINE RSPEAK(N)
	IMPLICIT INTEGER(A-Z)
C
	CALL RSPSB2(N,0,0)
	RETURN
C
	END
C
C RSPSUB-- Output random message with substitutable argument
C
C Called by--
C
C	CALL RSPSUB(MSGNUM,SUBNUM)
C
	SUBROUTINE RSPSUB(N,S1)
	IMPLICIT INTEGER(A-Z)
C
	CALL RSPSB2(N,S1,0)
	RETURN
C
	END

C RSPSB2-- Output random message with substitutable arguments
C
C Called by--
C
C	CALL RSPSB2(MSGNUM,S1,S2)
C
	SUBROUTINE RSPSB2(A,B,C)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	CHARACTER*(TEXLNT) B1,B2
C
C Convert all arguments from dictionary numbers (if positive)
c to absolute record numbers.
C
	X=A					! set up work variables.
	Y=B
	Z=C
	IF(X.GT.0) X=RTEXT(X)			! if >0, look up in rtext.
	IF(Y.GT.0) Y=RTEXT(Y)
	IF(Z.GT.0) Z=RTEXT(Z)
	X=IABS(X)				! take abs value.
	Y=IABS(Y)
	Z=IABS(Z)
	IF(X.EQ.0) RETURN			! anything to do?
	TELFLG=.TRUE.				! said something.
C
	READ(DBCH,REC=X) OLDREC,B1		! read first line.
100	CALL TXCRYP(X,B1)			! decrypt line.
C
200	IF(Y.EQ.0) GO TO 400			! any substitutable?
	I=INDEX(B1,'#')				! look for #.
	IF(I.GT.0) GO TO 1000			! found?
C
400	WRITE(OUTCH,650) B1(1:MAX0(1,NBLEN(B1)))! output line.
650	FORMAT(1X,A)
	X=X+1					! on to next record.
	READ(DBCH,REC=X) NEWREC,B1		! read next record.
	IF(OLDREC.EQ.NEWREC) GO TO 100		! continuation?
	RETURN					! no, exit.

C RSPSB2, PAGE 2
C
C Substitution with substitutable available.
C I is index of # in B1.
C Y is number of record to substitute.
C
C Procedure:
C   1) Copy rest of B1 to B2
C   2) Read substitutable over B1
C   3) Restore tail of original B1
C
C The implicit assumption here is that the substitutable string
c is very short.
C
1000	B2(1:(TEXLNT-I))=B1(I+1:TEXLNT)		! copy rest of B1.
C
	READ(DBCH,REC=Y) J,B1(I:TEXLNT)		! read sub record.
	CALL TXCRYP(Y,B1(I:TEXLNT))		! decrypt sub record.
	J=NBLEN(B1)				! backscan for blanks.
	B1(J+1:TEXLNT)=B2(1:TEXLNT-J)
C
	Y=Z					! set up for next
	Z=0					! substitution and
	GO TO 200				! recheck line.
C
	END

C OBJACT-- Apply objects from parse vector
C
C Declarations
C
	LOGICAL FUNCTION OBJACT(X)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL OAPPLI
C
	OBJACT=.TRUE.				! assume wins.
	IF(PRSI.EQ.0) GO TO 100			! ind object?
	IF(OAPPLI(OACTIO(PRSI),0)) RETURN	! yes, let it handle.
C
100	IF(PRSO.EQ.0) GO TO 200			! dir object?
	IF(OAPPLI(OACTIO(PRSO),0)) RETURN	! yes, let it handle.
C
200	OBJACT=.FALSE.				! loses.
	RETURN
C
	END

C BUG-- Report fatal system error
C
C Declarations
C
	SUBROUTINE BUG(A,B)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	TYPE 100,A,B				! gonzo
	IF(DBGFLG.NE.0) RETURN
	SUBBUF='CRASH.DAT'			! set up crash save name.
	SUBLNT=NBLEN(SUBBUF)
	CALL SAVEGM				! do final save.
	TYPE 200
	CALL EXIT
C
100	FORMAT(' Program error ',I2,', parameter =',I6)
200	FORMAT(' Game state saved in "CRASH.DAT".')
C
	END

C NEWSTA-- Set new status for object
C
C Called by--
C
C	CALL NEWSTA(OBJECT,STRING,NEWROOM,NEWCON,NEWADV)
C
	SUBROUTINE NEWSTA(O,R,RM,CN,AD)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	CALL RSPEAK(R)
	OROOM(O)=RM
	OCAN(O)=CN
	OADV(O)=AD
	RETURN
C
	END

C QHERE-- Test for object in room
C
C Declarations
C
	LOGICAL FUNCTION QHERE(OBJ,RM)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	QHERE=.TRUE.
	IF(OROOM(OBJ).EQ.RM) RETURN		! in room?
	DO 100 I=1,R2LNT			! no, sch room2.
	  IF((O2(I).EQ.OBJ).AND.(R2(I).EQ.RM)) RETURN
100	CONTINUE
	QHERE=.FALSE.				! not present.
	RETURN
C
	END

C QEMPTY-- Test for object empty
C
C Declarations
C
	LOGICAL FUNCTION QEMPTY(OBJ)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	QEMPTY=.FALSE.				! assume lose.
	DO 100 I=1,OLNT
	  IF(OCAN(I).EQ.OBJ) RETURN		! inside target?
100	CONTINUE
	QEMPTY=.TRUE.
	RETURN
C
	END

C JIGSUP- You are dead
C
C Declarations
C
	SUBROUTINE JIGSUP(DESC)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL MOVETO,QHERE,F
	INTEGER RLIST(8)
C
C Functions and data
C
	DATA RLIST/6,36,35,34,4,34,6,5/
C
	CALL RSPEAK(DESC)			! describe sad state.
	PRSCON=0				! stop parser.
	IF(DBGFLG.NE.0) RETURN			! if dbg, exit.
	AVEHIC(WINNER)=0			! get rid of vehicle.
	IF(WINNER.EQ.PLAYER) GO TO 10		! himself?
	CALL RSPSUB(432,ODESC2(AOBJ(WINNER)))	! no, say who died.
	CALL NEWSTA(AOBJ(WINNER),0,0,0,0)	! send to hyper space.
	RETURN
C
10	CALL SCRUPD(-10)			! charge 10 points.
	IF(ENDGMF) GO TO 900			! no recovery in end game.
	IF(DEATHS.GE.2) GO TO 1000		! dead twice? kick him off.
	DEATHS=DEATHS+1				! record deaths.
	DEADF=.TRUE.				! flag dead player.
	CALL RSPEAK(8)				! tell him bad news
	AACTIO(PLAYER)=PLAYER			! turn on dead player func.
C
	DO 50 J=1,OLNT				! turn off fighting.
	  IF(QHERE(J,HERE)) OFLAG2(J)=OFLAG2(J).AND. .NOT.FITEBT
50	CONTINUE
C
	F=MOVETO(LLD1,WINNER)			! reposition him.
	EGYPTF=.TRUE.				! restore coffin.
	IF(OADV(COFFI).EQ.WINNER) CALL NEWSTA(COFFI,0,EGYPT,0,0)
	OFLAG2(DOOR)=OFLAG2(DOOR).AND. .NOT.TCHBT ! restore door.
	OFLAG1(ROBOT)=(OFLAG1(ROBOT).OR.VISIBT) .AND. .NOT.NDSCBT
	CALL NEWSTA(LAMP,0,LROOM,0,0)		! lamp to living room,
	OFLAG1(LAMP)=OFLAG1(LAMP).OR.VISIBT	! visible
	DO 100 I=1,CLNT				! disable cevnts if needed.
	  IF(CCNCEL(I)) CFLAG(I)=.FALSE.
100	CONTINUE

C JIGSUP, PAGE 2
C
C Now redistribute his valuables and other belongings.
C
C The lamp has been placed in the living room.
C The first 8 non-valuables are placed in locations around the house.
C His valuables are placed start at maze.
C Remaining non-valuables are after that.
C
	I=0
	DO 200 J=1,OLNT				! loop thru objects.
	  IF((OADV(J).NE.WINNER).OR.(OTVAL(J).NE.0))
	1	GO TO 200			! get his non-val objs.
	  I=I+1
	  IF(I.GT.8) GO TO 400			! move to random locations.
	  CALL NEWSTA(J,0,RLIST(I),0,0)
200	CONTINUE
C
400	I=MTROL					! now move valuables.
	NONOFL=RAIR+RWATER+REND			! dont move here.
	DO 300 J=1,OLNT
	  IF((OADV(J).NE.WINNER).OR.(OTVAL(J).EQ.0))
	1	GO TO 300			! on adv and valuable?
250	  I=I+1					! find next room.
	  IF((RFLAG(I).AND.NONOFL).NE.0) GO TO 250	! skip if nono.
	  CALL NEWSTA(J,0,I,0,0)		! yes, move.
300	CONTINUE
C
	DO 500 J=1,OLNT				! now get rid of remainder.
	  IF(OADV(J).NE.WINNER) GO TO 500
450	  I=I+1					! find next room.
	  IF((RFLAG(I).AND.NONOFL).NE.0) GO TO 450	! skip if nono.
	  CALL NEWSTA(J,0,I,0,0)
500	CONTINUE
	RETURN
C
C Cant or wont continue, clean up and exit.
C
900	CALL RSPEAK(625)			! in endgame, lose.
	GO TO 1100
C
1000	CALL RSPEAK(7)				! involuntary exit.
1100	CALL SCORE(.FALSE.)			! tell score.
	CLOSE (UNIT=DBCH)
	CALL EXIT
C
	END

C OACTOR-	Get actor associated with object
C
C Declarations
C
	INTEGER FUNCTION OACTOR(OBJ)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	DO 100 OACTOR=1,ALNT			! loop thru actors.
	  IF(AOBJ(OACTOR).EQ.OBJ) RETURN	! found it?
100	CONTINUE
	CALL BUG(40,OBJ)			! no, die.
	RETURN
C
	END

C PROB-		Compute probability
C
C Declarations
C
	LOGICAL FUNCTION PROB(G,B)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	I=G					! assume good luck.
	IF(BADLKF) I=B				! if bad, too bad.
	PROB=RND(100).LT.I			! compute.
	RETURN
C
	END

C RMDESC-- Print room description
C
C RMDESC prints a description of the current room.
C It is also the processor for verbs 'LOOK' and 'EXAMINE'
C when there is no direct object.
C
	LOGICAL FUNCTION RMDESC(FULL)
C
C FULL=	0/1/2/3=	full/obj/room/full but no applicable
C
C Declarations
C
	IMPLICIT INTEGER (A-Z)
	LOGICAL PROB,LIT,OBJACT
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	RMDESC=.TRUE.				! assume wins.
	RA=RACTIO(HERE)				! get room action.
	IF(PRSO.LT.XMIN) GO TO 50		! if direction,
	FROMDR=PRSO				! save and
	PRSO=0					! clear.
50	IF(FULL.EQ.1) GO TO 600			! objects only?
	IF(HERE.EQ.AROOM(PLAYER)) GO TO 100	! player just move?
	CALL RSPEAK(2)				! no, just say done.
	PRSA=WALKIW				! set up walk in action.
	RETURN
C
100	IF(LIT(HERE)) GO TO 300			! lit?
	CALL RSPEAK(430)			! warn of grue.
	RMDESC=.FALSE.
	RETURN
C
300	I=RDESC2-HERE				! assume short desc.
	IF((FULL.EQ.0)
	1	.AND. (SUPERF.OR.(((RFLAG(HERE).AND.RSEEN).NE.0)
	1	.AND. (BRIEFF.OR.PROB(80,80))))) GO TO 400
	I=RDESC1(HERE)				! use long.
	IF((I.NE.0).OR.(RA.EQ.0)) GO TO 400	! if got desc, skip.
	PRSA=LOOKW				! pretend look around.
	PRSO=0					! no object referenced.
	CALL RAPPLI(RA)				! let room handle.
	PRSA=FOOW				! nop parser.
	GO TO 500
C
400	CALL RSPEAK(I)				! output description.
500	IF(AVEHIC(WINNER).NE.0) CALL RSPSUB(431,ODESC2(AVEHIC(WINNER)))
	RFLAG(HERE)=RFLAG(HERE).OR.RSEEN	! indicate room seen.
C
600	IF(LIT(HERE)) GO TO 700			! if lit, do objects
	CALL RSPEAK(1036)			! can't see anything
	RETURN
C
700	IF(FULL.NE.2) CALL PRINCR(FULL,HERE)	! print room contents
	IF((FULL.NE.0).OR.(RA.EQ.0)) RETURN	! anything more?
	PRSA=WALKIW				! give him a surpise.
	CALL RAPPLI(RA)				! let room handle
	PRSA=FOOW
	RETURN
C
	END

C PRINCR- Print contents of room
C
C Declarations
C
	SUBROUTINE PRINCR(FULL,RM)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QEMPTY,QHERE
C
	J=329					! assume superbrief format.
	DO 500 I=1,OLNT				! loop on objects
	  IF(.NOT.QHERE(I,RM).OR.((OFLAG1(I).AND.VISIBT).EQ.0).OR.
	1	(((OFLAG1(I).AND.NDSCBT).NE.0).AND.(FULL.NE.1)).OR.
	2	(I.EQ.AVEHIC(WINNER))) GO TO 500
	  IF((FULL.EQ.0).AND.(SUPERF.OR.(BRIEFF.AND.
	1	((RFLAG(HERE).AND.RSEEN).NE.0)))) GO TO 200
C
C Do long description of object.
C
	  K=ODESCO(I)				! get untouched.
	  IF((K.EQ.0).OR.((OFLAG2(I).AND.TCHBT).NE.0)) K=ODESC1(I)
	  IF((K.EQ.0).AND.(FULL.EQ.1)) CALL RSPSUB(936,ODESC2(I))
	  CALL RSPEAK(K)			! describe.
	  GO TO 500
C
C Do short description of object.
C
200	  CALL RSPSUB(J,ODESC2(I))		! you can see it.
	  J=502
C
500	CONTINUE
C
C Now loop to print contents of objects in room.
C
	DO 1000 I=1,OLNT			! loop on objects.
	  IF(.NOT.QHERE(I,RM).OR.((OFLAG1(I).AND.VISIBT).EQ.0).OR.
	1	(((OFLAG1(I).AND.NDSCBT).NE.0).AND.(FULL.NE.1)))
	2	GO TO 1000
	  IF((OFLAG2(I).AND.ACTRBT).NE.0) CALL INVENT(OACTOR(I))
	  IF((((OFLAG1(I).AND.TRANBT).EQ.0).AND.((OFLAG2(I).AND.OPENBT)
	1	.EQ.0)).OR.QEMPTY(I)) GO TO 1000
C
C Object is not empty and is open or transparent.
C
	  IF(I.NE.TCASE) GO TO 600		! trophy case?
	  IF((.NOT.(BRIEFF.OR.SUPERF)).OR.(FULL.EQ.1))
	1	CALL PRINCO(I,1053,.FALSE.)	! print contents.
	  GO TO 1000
600	  CALL PRINCO(I,573,.TRUE.)		! print contents
1000	CONTINUE
	RETURN
C
	END

C INVENT- Print contents of adventurer
C
C Declarations
C
	SUBROUTINE INVENT(ADV)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QEMPTY
C
	I=575					! first line.
	IF(ADV.NE.PLAYER) I=576			! if not me.
	DO 10 J=1,OLNT				! loop
	  IF((OADV(J).NE.ADV).OR.((OFLAG1(J).AND.VISIBT).EQ.0))
	1	GO TO 10
	  CALL RSPSUB(I,ODESC2(AOBJ(ADV)))
	  I=0
	  CALL RSPSUB(502,ODESC2(J))
10	CONTINUE
C
	IF(I.EQ.0) GO TO 25			! any objects?
	IF(ADV.EQ.PLAYER) CALL RSPEAK(578)	! no, tell him.
	RETURN
C
25	DO 100 J=1,OLNT				! loop.
	  IF((OADV(J).NE.ADV).OR.((OFLAG1(J).AND.VISIBT).EQ.0).OR.
	1	(((OFLAG1(J).AND.TRANBT).EQ.0).AND.
	2	((OFLAG2(J).AND.OPENBT).EQ.0))) GO TO 100
	  IF(.NOT.QEMPTY(J)) CALL PRINCO(J,573,.TRUE.) ! if not empty, list.
100	CONTINUE
	RETURN
C
	END

C PRINCO-	Print contents of object
C
C Declarations
C
	SUBROUTINE PRINCO(OBJ,DESC,LDESCF)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QEMPTY,LDESCF,MOREF,QSEEIN,QUAL
C
C Functions and data
C
	QSEEIN(X)=((OFLAG1(X).AND.TRANBT).NE.0).OR.
	1	  ((OFLAG2(X).AND.OPENBT).NE.0)
	QUAL(X,Y)=((OFLAG1(X).AND.VISIBT).NE.0).AND.
	1	   (OCAN(X).EQ.Y).AND.(X.NE.AOBJ(WINNER))
C
	MOREF=.FALSE.				! no additional printouts.
	ALSO=0					! no untouched descriptions.
	IF(SUPERF.OR..NOT.LDESCF) GO TO 2000	! skip long descriptions?
	DO 1000 I=1,OLNT			! loop thru objects.
	  IF(.NOT.QUAL(I,OBJ)) GO TO 1000	! inside target?
	  IF((ODESCO(I).EQ.0).OR.
	1   ((OFLAG2(I).AND.TCHBT).NE.0)) GO TO 700
	  CALL RSPEAK(ODESCO(I))		! print untouched descr.
	  ALSO=1				! flag.
	  IF(.NOT.QSEEIN(I).OR.QEMPTY(I)) GO TO 1000
	  CALL RSPSUB(573,ODESC2(I))		! object, which contains:
	  DO 500 J=1,OLNT			! loop thru objects.
	    IF(QUAL(J,I)) CALL RSPSUB(502,ODESC2(J))
500	  CONTINUE
	  GO TO 1000
700	  MOREF=.TRUE.
1000	CONTINUE
	IF(.NOT.MOREF) RETURN			! more to do?
C
2000	CALL RSPSUB(DESC+ALSO,ODESC2(OBJ))	! print header.
	DO 3000 I=1,OLNT			! loop thru objects.
	  IF(.NOT.QUAL(I,OBJ)) GO TO 3000	! inside target?
	  IF((ALSO.NE.0).AND.(ODESCO(I).NE.0).AND.
	1    ((OFLAG2(I).AND.TCHBT).EQ.0)) GO TO 3000
	  IF(.NOT.QSEEIN(I).OR.QEMPTY(I)) GO TO 2700
	  CALL RSPSUB(1050,ODESC2(I))		! object, which contains:
	  DO 2500 J=1,OLNT			! loop thru objects.
	    IF(QUAL(J,I)) CALL RSPSUB(1051,ODESC2(J))
2500	  CONTINUE
	  GO TO 3000
2700	  CALL RSPSUB(502,ODESC2(I))		! object, nothing inside.
3000	CONTINUE
	RETURN
C
	END

C MOVETO- Move player to new room
C
C Declarations
C
	LOGICAL FUNCTION MOVETO(NR,WHO)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL NLV,LHR,LNR
C
	MOVETO=.FALSE.				! assume fails.
	LHR=(RFLAG(HERE).AND.RLAND).NE.0	! land  here flag.
	LNR=(RFLAG(NR).AND.RLAND).NE.0		! land there flag.
	J=AVEHIC(WHO)				! his vehicle
C
	IF(J.NE.0) GO TO 100			! in vehicle?
	IF(LNR) GO TO 500			! no, going to land?
	CALL RSPEAK(427)			! can't go without vehicle.
	RETURN
C
100	BITS=0					! assume nowhere.
	IF(J.EQ.RBOAT) BITS=RWATER		! in boat?
	IF(J.EQ.BALLO) BITS=RAIR		! in balloon?
	IF(J.EQ.BUCKE) BITS=RBUCK		! in bucket?
	NLV=(RFLAG(NR).AND.BITS).EQ.0		! got wrong vehicle flag.
	IF((.NOT.LNR .AND.NLV) .OR.
	1	(LNR.AND.LHR.AND.NLV.AND.(BITS.NE.RLAND)))
	2	GO TO 800			! got wrong vehicle?
C
500	MOVETO=.TRUE.				! move should succeed.
	IF((RFLAG(NR).AND.RMUNG).EQ.0) GO TO 600 ! room munged?
	CALL RSPEAK(RDESC1(NR))			! yes, tell how.
	RETURN
C
600	IF(WHO.NE.PLAYER) CALL NEWSTA(AOBJ(WHO),0,NR,0,0)
	IF(J.NE.0) CALL NEWSTA(J,0,NR,0,0)
	HERE=NR
	AROOM(WHO)=HERE
	CALL SCRUPD(RVAL(NR))			! score room
	RVAL(NR)=0
	RETURN
C
800	CALL RSPSUB(428,ODESC2(J))		! wrong vehicle.
	RETURN
C
	END

C SCORE-- Print out current score
C
C Declarations
C
	SUBROUTINE SCORE(FLG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL FLG
	INTEGER RANK(10),ERANK(5)
C
C Functions and data
C
	DATA RANK/20,19,18,16,12,8,4,2,1,0/
	DATA ERANK/20,15,10,5,0/
C
	AS=ASCORE(WINNER)
	IF(ENDGMF) GO TO 60			! endgame?
	IF(FLG) WRITE(OUTCH,100)
	IF(.NOT.FLG) WRITE(OUTCH,110)
	IF(MOVES.NE.1) WRITE(OUTCH,120) AS,MXSCOR,MOVES
	IF(MOVES.EQ.1) WRITE(OUTCH,130) AS,MXSCOR,MOVES
	DO 10 I=1,10
	  IF((AS*20/MXSCOR).GE.RANK(I)) GO TO 50
10	CONTINUE
	CALL RSPEAK(886)			! negative score.
	RETURN
C
50	CALL RSPEAK(484+I)
	RETURN
C
60	IF(FLG) WRITE(OUTCH,140)
	IF(.NOT.FLG) WRITE(OUTCH,150)
	WRITE(OUTCH,120) EGSCOR,EGMXSC,MOVES
	DO 70 I=1,5
	  IF((EGSCOR*20/EGMXSC).GE.ERANK(I)) GO TO 80
70	CONTINUE
	CALL RSPEAK(886)			! negative score.
	RETURN
C
80	CALL RSPEAK(786+I)
	RETURN
C
100	FORMAT(' Your score would be',$)
110	FORMAT(' Your score is',$)
120	FORMAT('+',I4,' [total of',I4,' points], in',I5,' moves.')
130	FORMAT('+',I4,' [total of',I4,' points], in',I5,' move.')
140	FORMAT(' Your score in the endgame would be',$)
150	FORMAT(' Your score in the endgame is',$)
C
	END

C SCRUPD- Update winner's score
C
C Declarations
C
	SUBROUTINE SCRUPD(N)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	IF(ENDGMF) GO TO 100			! endgame?
	ASCORE(WINNER)=ASCORE(WINNER)+N		! update score
	RWSCOR=RWSCOR+N				! update raw score
	IF(ASCORE(WINNER).LT.(MXSCOR-(10*MIN0(1,DEATHS)))) RETURN
	CFLAG(CEVEGH)=.TRUE.			! turn on end game
	CTICK(CEVEGH)=15
	RETURN
C
100	EGSCOR=EGSCOR+N				! update eg score.
	RETURN
C
	END

C FINDXT- Find exit from room
C
C Declarations
C
	LOGICAL FUNCTION FINDXT(DIR,RM)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	FINDXT=.TRUE.				! assume wins.
	XI=REXIT(RM)				! find first entry.
	IF(XI.EQ.0) GO TO 1000			! no exits?
C
100	I=TRAVEL(XI)				! get entry.
	XROOM1=I.AND.XRMASK			! isolate room.
	XTYPE=(((I.AND..NOT.XLFLAG)/XFSHFT).AND.XFMASK)+1
	GO TO (110,120,130,130),XTYPE		! branch on entry.
	CALL BUG(10,XTYPE)
C
130	XOBJ=TRAVEL(XI+2).AND.XRMASK		! door/cexit- get obj/flag.
	XACTIO=TRAVEL(XI+2)/XASHFT
120	XSTRNG=TRAVEL(XI+1)			! door/cexit/nexit - string.
110	XI=XI+XELNT(XTYPE)			! advance to next entry.
	IF((I.AND.XDMASK).EQ.DIR) RETURN	! match?
	IF((I.AND.XLFLAG).EQ.0) GO TO 100	! last entry?
1000	FINDXT=.FALSE.				! yes, lose.
	RETURN
C
	END

C FWIM- Find what I mean
C
C Declarations
C
	INTEGER FUNCTION FWIM(F1,F2,RM,CON,ADV,NOCARE)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL NOCARE
C
	FWIM=0					! assume nothing.
	DO 1000 I=1,OLNT			! loop
	  IF(((RM.EQ.0).OR.(OROOM(I).NE.RM)) .AND.
	1	((ADV.EQ.0).OR.(OADV(I).NE.ADV)) .AND.
	2	((CON.EQ.0).OR.(OCAN(I).NE.CON)))
	3	GO TO 1000
C
C Object is on list... is it a match?
C
	  IF((OFLAG1(I).AND.VISIBT).EQ.0) GO TO 1000
	  IF((.NOT.NOCARE .AND.((OFLAG1(I).AND.TAKEBT).EQ.0)) .OR.
	1	(((OFLAG1(I).AND.F1).EQ.0).AND.
	2	 ((OFLAG2(I).AND.F2).EQ.0))) GO TO 500
	  IF(FWIM.EQ.0) GO TO 400		! already got something?
	  FWIM=-FWIM				! yes, ambiguous.
	  RETURN
C
400	  FWIM=I				! note match.
C
C Does object contain a match?
C
500	  IF((OFLAG2(I).AND.OPENBT).EQ.0) GO TO 1000 ! closed?
	  DO 700 J=1,OLNT			! no, search contents.
	    IF((OCAN(J).NE.I).OR.((OFLAG1(J).AND.VISIBT).EQ.0) .OR.
	1	(((OFLAG1(J).AND.F1).EQ.0).AND.
	2	 ((OFLAG2(J).AND.F2).EQ.0))) GO TO 700
	    IF(FWIM.EQ.0) GO TO 600
	    FWIM=-FWIM
	    RETURN
C
600	    FWIM=J
700	  CONTINUE
1000	CONTINUE
	RETURN
C
	END

C ORPHAN- Set up orphans for parser
C
C Declarations
C
	SUBROUTINE ORPHAN(OR1,OR2,OR3,OR4,OR5,OR6,OR7,OR8)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	CHARACTER*(*) OR6
C
	OFLAG=OR1
	OACT=OR2
	OPREP1=OR3
	OOBJ1=OR4
	OPREP=OR5
	ONAME=OR6
	OPREP2=OR7
	OOBJ2=OR8
	RETURN
C
	END

C YESNO- Obtain yes/no answer
C
C Called by-
C
C	YES-IS-TRUE=YESNO(QUESTION,YES-STRING,NO-STRING)
C
	LOGICAL FUNCTION YESNO(Q,Y,N)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	CHARACTER*1 ANS
C
100	CALL RSPEAK(Q)				! ask
	READ(INPCH,110,END=120) ANS		! get answer
110	FORMAT(A)
	IF((ANS.EQ.'Y').OR.(ANS.EQ.'y')) GO TO 200
	IF((ANS.EQ.'N').OR.(ANS.EQ.'n')) GO TO 300
120	CALL RSPEAK(6)				! scold.
	GO TO 100
C
200	YESNO=.TRUE.				! yes,
	CALL RSPEAK(Y)				! out with it.
	RETURN
C
300	YESNO=.FALSE.				! no,
	CALL RSPEAK(N)				! likewise.
	RETURN
C
	END

C ROBADV-- Steal winner's valuables
C
C Declarations
C
	INTEGER FUNCTION ROBADV(ADV,NR,NC,NA)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	ROBADV=0				! count objects
	DO 100 I=1,OLNT
	  IF((OADV(I).NE.ADV).OR.(OTVAL(I).LE.0).OR.
	1	((OFLAG2(I).AND.SCRDBT).NE.0)) GO TO 100
	  CALL NEWSTA(I,0,NR,NC,NA)		! steal object
	  ROBADV=ROBADV+1
100	CONTINUE
	RETURN
C
	END

C ROBRM-- Steal room valuables
C
C Declarations
C
	INTEGER FUNCTION ROBRM(RM,PR,NR,NC,NA)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL PROB,QHERE
C
	ROBRM=0					! count objects
	DO 100 I=1,OLNT				! loop on objects.
	  IF(.NOT. QHERE(I,RM)) GO TO 100
	  IF((OTVAL(I).LE.0).OR.((OFLAG2(I).AND.SCRDBT).NE.0).OR.
	1	((OFLAG1(I).AND.VISIBT).EQ.0).OR.(.NOT.PROB(PR,PR)))
	2	GO TO 50
	  CALL NEWSTA(I,0,NR,NC,NA)
	  ROBRM=ROBRM+1
	  OFLAG2(I)=OFLAG2(I).OR.TCHBT
	  GO TO 100
50	  IF((OFLAG2(I).AND.ACTRBT).NE.0)
	1	ROBRM=ROBRM+ROBADV(OACTOR(I),NR,NC,NA)
100	CONTINUE
	RETURN
C
	END

C WINNIN-- See if villain is winning
C
C Declarations
C
	LOGICAL FUNCTION WINNIN(VL,HR)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL PROB
C
	VS=OCAPAC(VL)				! villain strength
	PS=VS-FIGHTS(HR,.TRUE.)			! his margin over hero
	WINNIN=PROB(90,100)
	IF(PS.GT.3) RETURN			! +3... 90% winning
	WINNIN=PROB(75,85)
	IF(PS.GT.0) RETURN			! >0... 75% winning
	WINNIN=PROB(50,30)
	IF(PS.EQ.0) RETURN			! =0... 50% winning
	WINNIN=PROB(25,25)
	IF(VS.GT.1) RETURN			! any villain strength.
	WINNIN=PROB(10,0)
	RETURN
C
	END

C FIGHTS-- Compute fight strength
C
C Declarations
C
	INTEGER FUNCTION FIGHTS(H,FLG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	PARAMETER (STRMAX=7)
	PARAMETER (STRMIN=2)
	LOGICAL FLG
C
	FIGHTS=STRMIN+((((STRMAX-STRMIN)*ASCORE(H))+(MXSCOR/2))/MXSCOR)
	IF(FLG) FIGHTS=FIGHTS+ASTREN(H)
	RETURN
C
	END

C VILSTR-	Compute villain strength
C
C Declarations
C
	INTEGER FUNCTION VILSTR(V)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	VILSTR=OCAPAC(V)
	IF(VILSTR.LE.0) RETURN
	IF((V.NE.THIEF).OR..NOT.THFENF) GO TO 100
	THFENF=.FALSE.				! thief unengrossed.
	VILSTR=MIN0(VILSTR,2)			! no better than 2.
C
100	DO 200 I=1,VLNT				! see if best weapon.
	  IF((VILLNS(I).EQ.V).AND.(PRSI.EQ.VBEST(I)))
	1	VILSTR=MAX0(1,VILSTR-1)
200	CONTINUE
	RETURN
C
	END

C GTTIME-- Get total time played
C
C Declarations
C
	SUBROUTINE GTTIME(T)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	CALL ITIME(H,M,S)
	T=((H*60)+M)-((SHOUR*60)+SMIN)
	IF(T.LT.0) T=T+1440
	T=T+PLTIME
	RETURN
C
	END

C OPNCLS-- Process open/close for doors
C
C Declarations
C
	LOGICAL FUNCTION OPNCLS(OBJ,SO,SC)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QOPEN
C
C Functions and data
C
	QOPEN(O)=(OFLAG2(O).AND.OPENBT).NE.0
C
	OPNCLS=.TRUE.				! assume wins.
	IF(PRSA.EQ.CLOSEW) GO TO 100		! close?
	IF(PRSA.EQ.OPENW) GO TO 50		! open?
	OPNCLS=.FALSE.				! lose
	RETURN
C
50	IF(QOPEN(OBJ)) GO TO 200		! open... is it?
	CALL RSPEAK(SO)
	OFLAG2(OBJ)=OFLAG2(OBJ).OR.OPENBT
	RETURN
C
100	IF(.NOT.QOPEN(OBJ)) GO TO 200		! close... is it?
	CALL RSPEAK(SC)
	OFLAG2(OBJ)=OFLAG2(OBJ).AND..NOT.OPENBT
	RETURN
C
200	CALL RSPEAK(125+RND(3))			! dummy.
	RETURN
C
	END

C LIT-- Is room lit?
C
C Declarations
C
	LOGICAL FUNCTION LIT(RM)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QHERE
C
	LIT=.TRUE.				! assume wins
	IF(DEADF.OR.((RFLAG(RM).AND.RLIGHT).NE.0)) RETURN	! room lit?
C
	DO 1000 I=1,OLNT			! look for lit obj
	  IF(QHERE(I,RM)) GO TO 100		! in room?
	  OA=OADV(I)				! no
	  IF(OA.LE.0) GO TO 1000		! on adv?
	  IF(AROOM(OA).NE.RM) GO TO 1000	! adv in room?
C
C Obj in room or on adv in room
C
100	  IF((OFLAG1(I).AND.ONBT).NE.0) RETURN	! lit?
	  IF(((OFLAG1(I).AND.VISIBT).EQ.0).OR.
	1	(((OFLAG1(I).AND.TRANBT).EQ.0).AND.
	2	((OFLAG2(I).AND.OPENBT).EQ.0))) GO TO 1000
C
C Obj is visible and open or transparent
C
	  DO 500 J=1,OLNT
	    IF((OCAN(J).EQ.I).AND.((OFLAG1(J).AND.ONBT).NE.0))
	1	RETURN
500	  CONTINUE
1000	CONTINUE
	LIT=.FALSE.
	RETURN
C
	END

C WEIGHT- Returns sum of weight of qualifying objects
C
C Declarations
C
	INTEGER FUNCTION WEIGHT(RM,CN,AD)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QHERE
C
	WEIGHT=0
	DO 100 I=1,OLNT				! omit big fixed items.
	  IF(OSIZE(I).GE.10000) GO TO 100	! if fixed, forget it.
	  IF((QHERE(I,RM).AND.(RM.NE.0)).OR.
	1	((OADV(I).EQ.AD).AND.(AD.NE.0))) GO TO 50
	  J=I					! see if contained.
25	  J=OCAN(J)				! get next level up.
	  IF(J.EQ.0) GO TO 100			! end of list?
	  IF(J.NE.CN) GO TO 25
50	  WEIGHT=WEIGHT+OSIZE(I)
100	CONTINUE
	RETURN
C
	END

C GHERE--	Is global actually in this room?
C
C Declarations
C
	LOGICAL FUNCTION GHERE(OBJ,RM)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	GHERE=.TRUE.				! assume wins.
	IF(OBJ.LE.GLOBAL) RETURN		! if untested, return.
	GO TO ( 1000,2000,3000,4000,5000,5000,5000,6000,
	3	7000,8000,9000,9100,8000,10000,11000,
	4	12000,13000,14000,15000),OBJ-GLOBAL
	CALL BUG(60,OBJ)
C
C 1000--	House
C
1000	GHERE=((RM.GE.WHOUS).AND.(RM.LE.EHOUS)).OR.
	1	((RM.GE.FORE1).AND.(RM.LE.CLEAR)).OR.(RM.EQ.MTREE)
	RETURN
C
C 2000--	Bird
C
2000	GHERE=((RM.GE.FORE1).AND.(RM.LT.CLEAR)).OR.(RM.EQ.MTREE)
	RETURN
C
C 3000--	Tree
C
3000	GHERE=((RM.GE.FORE1).AND.(RM.LT.CLEAR)).AND.(RM.NE.FORE3)
	RETURN
C
C 4000--	North wall
C
4000	GHERE=((RM.GE.BKVW).AND.(RM.LE.BKBOX)).OR.(RM.EQ.CPUZZ)
	RETURN
C
C 5000--	East, south, west walls
C
5000	GHERE=((RM.GE.BKVW).AND.(RM.LT.BKBOX)).OR.(RM.EQ.CPUZZ)
	RETURN
C
C 6000--	Global water
C
6000	GHERE=(RFLAG(RM).AND.(RWATER+RFILL)).NE.0
	RETURN
C
C 7000--	Global guardians
C
7000	GHERE=((RM.GE.MRC).AND.(RM.LE.MRD)).OR.
	1	((RM.GE.MRCE).AND.(RM.LE.MRDW)).OR.(RM.EQ.INMIR)
	RETURN
C
C 8000--	Rose/channel
C
8000	GHERE=((RM.GE.MRA).AND.(RM.LE.MRD)).OR.(RM.EQ.INMIR)
	RETURN
C
C 9000--	Mirror
C 9100		Panel
C
9100	IF(RM.EQ.FDOOR) RETURN			! panel at fdoor.
9000	GHERE=((RM.GE.MRA).AND.(RM.LE.MRC)).OR.
	1	((RM.GE.MRAE).AND.(RM.LE.MRCW))
	RETURN
C
C 10000--	Master
C
10000	GHERE=(RM.EQ.FDOOR).OR.(RM.EQ.NCORR).OR.(RM.EQ.PARAP).OR.
	1	(RM.EQ.CELL).OR.(RM.EQ.PCELL).OR.(RM.EQ.NCELL)
	RETURN
C
C 11000--	Ladder
C
11000	GHERE=(RM.EQ.CPUZZ)
	RETURN
C
C 12000--	Well
C
12000	GHERE=(RM.EQ.TWELL).OR.(RM.EQ.BWELL)
	RETURN
C
C 13000--	Rope in slide
C
13000	GHERE=(RM.GE.SLID1).AND.(RM.LE.SLEDG)
	RETURN
C
C 14000--	Slide
C
14000	GHERE=(RM.GE.SLIDE).OR.((RM.GE.SLID1).AND.(RM.LE.SLEDG))
	RETURN
C
C 15000--	Bunch pseudo object
C
15000	GHERE=.FALSE.			! never present
	RETURN
C
	END

C MRHERE--	Is mirror here?
C
C Declarations
C
	INTEGER FUNCTION MRHERE(RM)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	IF((RM.LT.MRAE).OR.(RM.GT.MRDW)) GO TO 100
C
C Room is an e-w room, mirror must be n-s (mdir= 0 or 180)
C
	MRHERE=1				! assume mirror 1 here.
	IF(MOD(RM-MRAE,2).EQ.(MDIR/180)) MRHERE=2
	RETURN
C
C Room is north or south of mirror.  If mirror is n-s or not
c within one room of room, lose.
C
100	MRHERE=0
	IF((IABS(MLOC-RM).NE.1).OR.(MOD(MDIR,180).EQ.0)) RETURN
C
C Room is within one of mloc, and mdir is e-w
C
	MRHERE=1
	IF(((RM.LT.MLOC).AND.(MDIR.LT.180)).OR.
	1  ((RM.GT.MLOC).AND.(MDIR.GT.180))) MRHERE=2
	RETURN
C
	END

C ENCRYP--	Encrypt password
C
C Declarations
C
	SUBROUTINE ENCRYP(INW,OUTW)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	CHARACTER*(WRDLNT) INW,OUTW,KEYW
	INTEGER UINW(8),UKEYW(8)
	DATA KEYW/'ECOVXRMS'/
C
	ICHARA=ICHAR('A')-1			! character base.
	UINWS=0					! unbiased inw sum.
	UKEYWS=0				! unbiased keyw sum.
	J=1					! pointer in keyword.
	DO 100 I=1,WRDLNT			! unbias, compute sums.
	  UKEYW(I)=ICHAR(KEYW(I:I))-ICHARA	! strip ascii.
	  IF(ICHAR(INW(J:J)).LE.ICHARA) J=1	! recycle on bad.
	  UINW(I)=ICHAR(INW(J:J))-ICHARA
	  UKEYWS=UKEYWS+UKEYW(I)
	  UINWS=UINWS+UINW(I)
	  J=J+1
100	CONTINUE
C
	USUM=MOD(UINWS,8)+(8*MOD(UKEYWS,8))	! compute mask.
	DO 200 I=1,8
	  J=(UINW(I).XOR.UKEYW(I).XOR.USUM).AND.31
	  USUM=MOD(USUM+1,32)
	  IF(J.GT.26) J=MOD(J,26)
	  OUTW(I:I)=CHAR(MAX0(1,J)+ICHARA)
200	CONTINUE
	RETURN
C
	END

C CPGOTO--	Move to next state in puzzle room
C
C Declarations
C
	SUBROUTINE CPGOTO(ST)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	RFLAG(CPUZZ)=RFLAG(CPUZZ).AND..NOT.RSEEN
	DO 100 I=1,OLNT				! relocate objects.
	  IF((OROOM(I).EQ.CPUZZ).AND.
	1	((OFLAG2(I).AND.(ACTRBT+VILLBT)).EQ.0))
	2	CALL NEWSTA(I,0,CPHERE*HFACTR,0,0)
	  IF(OROOM(I).EQ.(ST*HFACTR))
	1	CALL NEWSTA(I,0,CPUZZ,0,0)
100	CONTINUE
	CPHERE=ST
	RETURN
C
	END

C CPINFO--	Describe puzzle room
C
C Declarations
C
	SUBROUTINE CPINFO(RMK,ST)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	INTEGER DGMOFT(8)
	CHARACTER*2 DGM(8),PICT(5),QMK
C
C Functions and local data
C
	DATA DGMOFT/-9,-8,-7,-1,1,7,8,9/
	DATA PICT/'SS','SS','SS','  ','MM'/
	DATA QMK/'??'/
C
	CALL RSPEAK(RMK)
	DO 100 I=1,8
	  J=DGMOFT(I)
	  DGM(I)=PICT(CPVEC(ST+J)+4)		! get picture element.
	  IF((IABS(J).EQ.1).OR.(IABS(J).EQ.8)) GO TO 100
	  K=8
	  IF(J.LT.0) K=-8			! get ortho dir.
	  L=J-K
	  IF((CPVEC(ST+K).NE.0).AND.(CPVEC(ST+L).NE.0))
	1	DGM(I)=QMK
100	CONTINUE
	WRITE(OUTCH,10) DGM
C
	IF(ST.EQ.10) CALL RSPEAK(870)		! at hole?
	IF(ST.EQ.37) CALL RSPEAK(871)		! at niche?
	I=872					! door open?
	IF(CPOUTF) I=873
	IF(ST.EQ.52) CALL RSPEAK(I)		! at door?
	IF(CPVEC(ST+1).EQ.-2) CALL RSPEAK(874)	! east ladder?
	IF(CPVEC(ST-1).EQ.-3) CALL RSPEAK(875)	! west ladder?
	RETURN
C
10	FORMAT('       |',A,1X,A,1X,A,'|'/,
	1' West  |',A,' .. ',A,'|  East',/
	2'       |',A,1X,A,1X,A,'|')
C
	END

C NBLEN-	Compute string length without trailing blanks
C
C Declarations
C
	INTEGER FUNCTION NBLEN(STRING)
	IMPLICIT INTEGER(A-Z)
	CHARACTER*(*) STRING
C
	NBLEN=LEN(STRING)			! get nominal length
100	IF(NBLEN.LE.0) RETURN			! any string left?
	IF(STRING(NBLEN:NBLEN).NE.' ') RETURN	! found a non-blank?
	NBLEN=NBLEN-1				! no, trim len by 1
	GO TO 100				! and continue.
C
	END

C Main program for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
	PROGRAM DUNGEO
C
C Declarations
C
	IMPLICIT INTEGER (A-Z)
	LOGICAL INITFL
	INCLUDE 'DPARAM.FOR/NOLIST'
C
C Data statements for constant arrays
C
	DATA VMAJ/3/,VMIN/0/,VEDIT/'A'/
C
	DATA BATDRP/66,67,68,69,70,71,72,65,73/
C
	DATA SCOLDR/XNORTH,BKTWI,XSOUTH,BKVAU,XEAST,BKVE,XWEST,BKVW/
	DATA SCOLWL/BKVW,271,XEAST,BKVE,272,XWEST,
	1	BKTWI,270,XSOUTH,BKVAU,269,XNORTH/
C
	DATA CPDR/XNORTH,-8,XNE,-7,XEAST,1,XSE,9,
	1	XSOUTH,8,XSW,7,XWEST,-1,XNW,-9/
	DATA CPWL/269,-8,270,8,271,1,272,-1/
	DATA CPVEC/1,1,1,1,1,1,1,1,
	1	1,0,-1,0,0,-1,0,1,
	2	1,-1,0,1,0,-2,0,1,
	3	1,0,0,0,0,1,0,1,
	4	1,-3,0,0,-1,-1,0,1,
	5	1,0,0,-1,0,0,0,1,
	6	1,1,1,0,0,0,1,1,
	7	1,1,1,1,1,1,1,1/
C
	DATA XELNT/1,2,3,3/

C DUNGEON, PAGE 2
C
C 1) Initialize data structures
C 2) Initialize files
C 3) Play game
C
	MLNT=0					! init array counters.
	OLNT=0					! array limits are parameters
	RLNT=0
	VLNT=0
	ALNT=0
	CLNT=0
	XLNT=1
	R2LNT=0
C
	LTSHFT=10				! set up state variables.
	MXSCOR=LTSHFT
	EGSCOR=0
	EGMXSC=0
	MXLOAD=100
	RWSCOR=0
	DEATHS=0
	MOVES=0
	PLTIME=0
	MUNGRM=0
	HS=0
	PRSA=0					! clear parse vector.
	PRSI=0
	PRSO=0
	PRSCON=1
	OFLAG=0					! clear orphans.
	OACT=0
	OPREP1=0
	OOBJ1=0
	OPREP=0
	ONAME=' '
	OPREP2=0
	OOBJ2=0
	BUNLNT=0				! clear bunch vector.
	BUNSUB=0
	DO 100 I=1,BUNMAX
	  BUNVEC(I)=0
100	CONTINUE
	THFFLG=.FALSE.				! thief not introduced but
	THFACT=.TRUE.				! is active.
	SWDACT=.FALSE.				! sword is inactive.
	SWDSTA=0				! sword is off.
C
	MBASE=0					! init melee base.
	INPCH=5					! tty input
	OUTCH=5					! tty output.
	DBCH=2					! data base.

C DUNGEON, PAGE 3
C
C Init all arrays.
C
	DO 200 I=1,CMAX				! clear clock events
	  CFLAG(I)=.FALSE.
	  CCNCEL(I)=.FALSE.
	  CTICK(I)=0
	  CACTIO(I)=0
200	CONTINUE
C
	DO 300 I=1,FMAX				! clear flags.
	  FLAGS(I)=.FALSE.
300	CONTINUE
	EGYPTF=.TRUE.				! some start as true.
	CAGETF=.TRUE.
	MR1F=.TRUE.
	MR2F=.TRUE.
	FOLLWF=.TRUE.
	DO 400 I=1,SMAX				! clear switches.
	  SWITCH(I)=0
400	CONTINUE
	ORMTCH=4				! number of matches.
	LCELL=1
	PNUMB=1
	MDIR=270
	MLOC=MRB
	CPHERE=10
C
	DO 500 I=1,R2MAX			! clear room 2 array.
	  R2(I)=0
	  O2(I)=0
500	CONTINUE
C
	DO 600 I=1,XXMAX			! clear travel array.
	  TRAVEL(I)=0
600	CONTINUE
C
	DO 700 I=1,VMAX				! clear villains arrays.
	  VOPPS(I)=0
	  VPROB(I)=0
	  VILLNS(I)=0
	  VBEST(I)=0
	  VMELEE(I)=0
700	CONTINUE

C DUNGEON, PAGE 4
C
	DO 800 I=1,OMAX				! clear object arrays.
	  ODESC1(I)=0
	  ODESC2(I)=0
	  ODESCO(I)=0
	  OREAD(I)=0
	  OACTIO(I)=0
	  OFLAG1(I)=0
	  OFLAG2(I)=0
	  OFVAL(I)=0
	  OTVAL(I)=0
	  OSIZE(I)=0
	  OCAPAC(I)=0
	  OCAN(I)=0
	  OADV(I)=0
	  OROOM(I)=0
800	CONTINUE
C
	RDESC2=0				! clear desc base ptr.
	DO 900 I=1,RMAX				! clear room arrays.
	  RDESC1(I)=0
	  RACTIO(I)=0
	  RFLAG(I)=0
	  RVAL(I)=0
	  REXIT(I)=0
900	CONTINUE
C
	DO 1000 I=1,MMAX			! clear message directory.
	  RTEXT(I)=0
1000	CONTINUE
C
	DO 1100 I=1,AMAX			! clear adventurer's arrays.
	  AROOM(I)=0
	  ASCORE(I)=0
	  AVEHIC(I)=0
	  AOBJ(I)=0
	  AACTIO(I)=0
	  ASTREN(I)=0
	  AFLAG(I)=0
1100	CONTINUE
C
	DBGFLG=0
	PRSFLG=0
	GDTFLG=1
C
	FROMDR=0				! init scol goodies.
	SCOLRM=0
	SCOLAC=0
C
	IF(INITFL(X)) CALL GAME			! if init files, play game.
	CALL EXIT				! done
	END

C TXCRYP - Subroutine to encrypt/decrypt text strings.
C
C This subroutine performs a reversible encryption on a text string.
C The purpose is not to protect the data base but to make it more
C difficult for the casual game user to read the data base file.
C It is located here, rather than in the SUBRoutine module, because
C it is used by both the game and the separate data base compiler.
C
	SUBROUTINE TXCRYP(R,LINE)
	IMPLICIT INTEGER(A-Z)
	CHARACTER*(*) LINE
C
	DO 100 I=1,LEN(LINE)
	  X=(R.AND.31)+I
	  LINE(I:I)=CHAR(ICHAR(LINE(I:I)).XOR.X)
100	CONTINUE
	RETURN
	END

C Verb processors for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C VAPPLI- Main verb processing routine
C
C Declarations
C
	LOGICAL FUNCTION VAPPLI(RI)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL LIT,OBJACT,WASLIT
	LOGICAL QEMPTY,RMDESC,CLOCKD
	LOGICAL MOVETO,YESNO
	LOGICAL QOPEN,EDIBLE,DRKBLE
	LOGICAL TAKE,PUT,DROP,WALK
	LOGICAL QHERE,FINDXT,OAPPLI,F
	INTEGER JOKES(25),ANSWER(28)
	CHARACTER*81 ANSSTR
	CHARACTER*(WRDLNT) PW(2),CH
	PARAMETER (MXNOP=39,MXJOKE=64,MXSMP=99)
C
C Functions and data
C
	QOPEN(R)=(OFLAG2(R).AND.OPENBT).NE.0
	EDIBLE(R)=(OFLAG1(R).AND.FOODBT).NE.0
	DRKBLE(R)=(OFLAG1(R).AND.DRNKBT).NE.0
	DATA JOKES/4,5,3,304,305,306,307,308,309,310,311,312,
	1	313,5314,5319,324,325,883,884,120,120,0,0,0,0/
	DATA ANSWER/0,6,1,6,2,5,3,5,4,3,4,6,4,7,
	1	4,5,5,5,5,4,5,8,6,11,7,4,7,6/
	DATA ANSSTR/'TEMPLEFOREST30003FLASKRUBFONDLECARRESS
	1TOUCHBONESBODYSKELETONRUSTY KNIFENONENOWHERE'/

C VAPPLI, PAGE 2
C
	VAPPLI=.TRUE.				! assume wins.
	IF(PRSO.NE.0) ODO2=ODESC2(PRSO)		! set up descriptors.
	IF(PRSI.NE.0) ODI2=ODESC2(PRSI)
	AV=AVEHIC(WINNER)
	RMK=372+RND(6)				! remark for hack-hacks.
	IF(RI.EQ.0) GO TO 10			! zero is false.
	IF(RI.LE.MXNOP) RETURN			! nop?
	IF(RI.LE.MXJOKE) GO TO 20		! joke?
	IF(RI.LE.MXSMP) GO TO 30		! simple verb?
	WASLIT=LIT(HERE)
	GO TO (
	1   500, 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000,
	2 10000,11000,12000,13000,14000,15000,16000,17000,18000,19000,
	3 20000,21000,22000,23000,24000,25000,26000,27000,28000,29000,
	4 30000,31000,32000,33000,34000,35000,36000,37000,38000,39000,
	5 40000,41000,42000,43000,44000,45000,46000,47000,48000,49000,
	6 50000,51000,52000,53000,54000,55000,56000,57000,58000,59000,
	7 60000,61000,62000,63000,64000,65000,66000,67000,68000,69000),
	9	(RI-MXSMP)
	CALL BUG(7,RI)
C
C All verb processors return here to declare failure.
C
10	VAPPLI=.FALSE.				! lose.
	RETURN
C
C Joke processor.
C Find proper entry in jokes, use it to select string to print.
C
20	I=JOKES(RI-MXNOP)			! get table entry.
	J=I/1000				! isolate # strings.
	IF(J.NE.0) I=MOD(I,1000)+RND(J)		! if random, choose.
	CALL RSPEAK(I)				! print joke.
	RETURN
C
C 'Simple' verbs.
C
30	GO TO (65001,66001,67001,68001,69001,
	1 70000,71000,72000,73000,74000,75000,76000,77000,78000,79000,
	2 80000,81000,82000,83000,84000,85000,86000,87000,88000,89000,
	3 90000,91000,92000,93000,94000,95000,96000),
	9	(RI-MXJOKE)
	CALL BUG(7,RI)
C
C Here to test for change in light.
C
50	IF(WASLIT.AND..NOT.LIT(HERE)) CALL RSPEAK(406)
	RETURN

C VAPPLI, PAGE 3
C
C V100--	Read
C
500	IF(LIT(HERE)) GO TO 600			! room lit?
	CALL RSPEAK(356)			! no, cant read.
	RETURN
C
600	IF(PRSI.EQ.0) GO TO 700			! read through obj?
	IF((OFLAG1(PRSI).AND.TRANBT).NE.0) GO TO 700
	CALL RSPSUB(357,ODI2)			! not transparent.
	RETURN
C
700	IF(OBJACT(X)) RETURN			! object handle?
	IF((OFLAG1(PRSO).AND.READBT).NE.0) GO TO 800
	CALL RSPSUB(358,ODO2)			! not readable.
	RETURN
C
800	CALL RSPEAK(OREAD(PRSO))		! print reading material.
	RETURN
C
C V101--	Melt
C
1000	IF(.NOT.OBJACT(X)) CALL RSPSUB(361,ODO2)
	RETURN
C
C V102--	Inflate
C
2000	IF(.NOT.OBJACT(X)) CALL RSPEAK(368)	! obj handle?
	RETURN
C
C V103--	Deflate.
C
3000	IF(.NOT.OBJACT(X)) CALL RSPEAK(369)	! obj handle?
	RETURN

C VAPPLI, PAGE 4
C
C V104--	Alarm
C
4000	IF((OFLAG2(PRSO).AND.SLEPBT).EQ.0) GO TO 4100
	VAPPLI=OBJACT(X)			! sleeping, let obj do.
	RETURN
C
4100	CALL RSPSUB(370,ODO2)			! joke.
	RETURN
C
C V105--	Exorcise
C
5000	F=OBJACT(X)				! objects handle.
	RETURN
C
C V106--	Plug
C
6000	IF(.NOT.OBJACT(X)) CALL RSPEAK(371)
	RETURN
C
C V107--	Kick
C
7000	IF(.NOT.OBJACT(X)) CALL RSPSB2(378,ODO2,RMK)
	RETURN
C
C V108--	Wave
C
8000	IF(.NOT.OBJACT(X)) CALL RSPSB2(379,ODO2,RMK)
	RETURN
C
C V109,V110--	Raise, lower
C
9000	CONTINUE
10000	IF(.NOT.OBJACT(X)) CALL RSPSB2(380,ODO2,RMK)
	RETURN
C
C V111--	Rub
C
11000	IF(.NOT.OBJACT(X)) CALL RSPSB2(381,ODO2,RMK)
	RETURN
C
C V112--	Push
C
12000	IF(.NOT.OBJACT(X)) CALL RSPSB2(382,ODO2,RMK)
	RETURN

C VAPPLI, PAGE 5
C
C V113--	Untie
C
13000	IF(OBJACT(X)) RETURN			! object handle?
	I=383					! no, not tied.
	IF((OFLAG2(PRSO).AND.TIEBT).EQ.0) I=384	! not tieable.
	CALL RSPEAK(I)
	RETURN
C
C V114--	Tie
C
14000	IF((OFLAG2(PRSO).AND.TIEBT).NE.0) GO TO 14100
	CALL RSPEAK(385)			! not tieable.
	RETURN
C
14100	IF(OBJACT(X)) RETURN			! object handle?
	I=386					! joke 1.
	IF(PRSI.EQ.OPLAY) I=919			! if player, joke 2.
	CALL RSPSUB(386,ODO2)			! print remark.
	RETURN
C
C V115--	Tie up
C
15000	IF((OFLAG2(PRSI).AND.TIEBT).NE.0) GO TO 15100
	CALL RSPSUB(387,ODO2)			! not tieable.
	RETURN
C
15100	I=388					! assume villain.
	IF((OFLAG2(PRSO).AND.VILLBT).EQ.0) I=389
	CALL RSPSUB(I,ODO2)			! joke.
	RETURN
C
C V116--	Turn
C
16000	IF((OFLAG1(PRSO).AND.TURNBT).NE.0) GO TO 16100
	CALL RSPEAK(390)			! not turnable.
	RETURN
C
16100	IF((OFLAG1(PRSI).AND.TOOLBT).NE.0) GO TO 16200
	CALL RSPSUB(391,ODI2)			! not a tool.
	RETURN
C
16200	VAPPLI=OBJACT(X)			! let object handle.
	RETURN
C
C V117--	Breathe
C
17000	PRSA=INFLAW
	PRSI=LUNGS
	GO TO 2000				! handle like inflate.

C VAPPLI, PAGE 5A.
C
C V118--	Knock
C
18000	IF(OBJACT(X)) RETURN			! obj handle?
	I=394					! joke for door.
	IF((OFLAG1(PRSO).AND.DOORBT).EQ.0) I=395
	CALL RSPSUB(I,ODO2)			! joke for nondoors too.
	RETURN
C
C V119--	Look
C
19000	IF(PRSO.NE.0) GO TO 20500		! something to look at?
	VAPPLI=RMDESC(3)			! handled by rmdesc.
	RETURN
C
C V120--	Examine
C
20000	IF(PRSO.NE.0) GO TO 20500		! something to examine?
	VAPPLI=RMDESC(0)			! handled by rmdesc.
	RETURN
C
20500	IF(OBJACT(X)) RETURN			! obj handle?
	I=OREAD(PRSO)				! get reading material.
	IF(I.NE.0) CALL RSPEAK(I)		! output if there,
	IF(I.EQ.0) CALL RSPSUB(429,ODO2)	! otherwise default.
	PRSA=FOOW				! defuse room processors.
	RETURN
C
C V121--	Shake
C
21000	IF(OBJACT(X)) RETURN			! object handle?
	IF((OFLAG2(PRSO).AND.VILLBT).EQ.0) GO TO 21100
	CALL RSPEAK(371)			! joke for villains.
	RETURN
C
21100	IF((OFLAG1(PRSO).AND.TAKEBT).NE.0) GO TO 21200	! takeable?
	CALL RSPEAK(923)			! no, joke.
	RETURN
C
21200	IF(QEMPTY(PRSO)) GO TO 10		! empty?  fails.
	IF(QOPEN(PRSO)) GO TO 21300		! open?  spill.
	CALL RSPSUB(396,ODO2)			! no, describe noise.
	RETURN
C
21300	CALL RSPSUB(397,ODO2)			! spill the works.
	DO 21500 I=1,OLNT			! spill contents.
	  IF(OCAN(I).NE.PRSO) GO TO 21500	! inside?
	  OFLAG2(I)=OFLAG2(I).OR.TCHBT		! touch object.
	  IF(AV.EQ.0) GO TO 21400		! in vehicle?
	  CALL NEWSTA(I,0,0,AV,0)		! yes, spill in there.
	  GO TO 21500
C
21400	  CALL NEWSTA(I,0,HERE,0,0)		! no, spill on floor,
	  IF(I.EQ.WATER) CALL NEWSTA(I,133,0,0,0)	! but water disappears.
21500	CONTINUE
	RETURN

C VAPPLI, PAGE 6
C
C V122--	Move
C
22000	IF(.NOT.QHERE(PRSO,HERE)) GO TO 22100	! is it here?
	IF(OBJACT(X)) RETURN			! obj handle?
	I=399					! assume not takeable.
	IF((OFLAG1(PRSO).AND.TAKEBT).NE.0) I=887
	CALL RSPSUB(I,ODO2)			! joke.
	RETURN
C
22100	CALL RSPEAK(398)			! not here.
	RETURN
C
C V123--	Turn on
C
23000	IF(OBJACT(X)) RETURN			! object handle?
	IF(((OFLAG1(PRSO).AND.LITEBT).NE.0).AND.
	1	(OADV(PRSO).EQ.WINNER)) GO TO 23100
	CALL RSPEAK(400)			! cant do it.
	RETURN
C
23100	IF((OFLAG1(PRSO).AND.ONBT).EQ.0) GO TO 23200
	CALL RSPEAK(401)			! already on.
	RETURN
C
23200	OFLAG1(PRSO)=OFLAG1(PRSO).OR.ONBT	! turn it on.
	CALL RSPSUB(404,ODO2)
	RETURN
C
C V124--	Turn off
C
24000	IF(OBJACT(X)) RETURN			! obj handle?
	IF(((OFLAG1(PRSO).AND.LITEBT).NE.0).AND.
	1	(OADV(PRSO).EQ.WINNER)) GO TO 24100
	CALL RSPEAK(402)			! cant do it.
	RETURN
C
24100	IF((OFLAG1(PRSO).AND.ONBT).NE.0) GO TO 24200
	CALL RSPEAK(403)			! already off.
	RETURN
C
24200	OFLAG1(PRSO)=OFLAG1(PRSO).AND. .NOT.ONBT
	CALL RSPSUB(405,ODO2)
	GO TO 50				! go see if now dark.
C
C V125--	Open
C
25000	IF(OBJACT(X)) RETURN			! obj handle?
	IF((OFLAG1(PRSO).AND.DOORBT).NE.0) GO TO 25150	! door?
	IF((OFLAG1(PRSO).AND.CONTBT).NE.0) GO TO 25100	! container?
25050	CALL RSPSUB(407,ODO2)			! not door or container.
	RETURN
C
25100	IF(OCAPAC(PRSO).NE.0) GO TO 25200	! openable container?
25150	CALL RSPSUB(408,ODO2)			! door or not openable.
	RETURN
C
25200	IF(.NOT.QOPEN(PRSO)) GO TO 25225
	CALL RSPEAK(412)			! already open.
	RETURN
C
25225	OFLAG2(PRSO)=OFLAG2(PRSO).OR.OPENBT	! open it.
	IF(((OFLAG1(PRSO).AND.TRANBT).NE.0).OR.QEMPTY(PRSO))
	1	GO TO 25300
	CALL PRINCO(PRSO,410,.FALSE.)		! print contents.
	RETURN
C
25300	CALL RSPEAK(409)			! done
	RETURN
C
C V126--	Close
C
26000	IF(OBJACT(X)) RETURN			! obj handle?
	IF((OFLAG1(PRSO).AND.DOORBT).NE.0) GO TO 26050	! door?
	IF((OFLAG1(PRSO).AND.CONTBT).EQ.0) GO TO 25050	! container?
	IF(OCAPAC(PRSO).NE.0) GO TO 26100	! closable container?
26050	CALL RSPSUB(411,ODO2)			! door or not closable.
	RETURN
C
26100	IF(QOPEN(PRSO)) GO TO 26200		! open?
	CALL RSPEAK(413)			! no, joke.
	RETURN
C
26200	OFLAG2(PRSO)=OFLAG2(PRSO).AND. .NOT.OPENBT
	CALL RSPEAK(414)			! done.
	GO TO 50				! go see if now dark.

C VAPPLI, PAGE 7
C
C V127--	Find
C
27000	IF(OBJACT(X)) RETURN			! obj handle?
	I=415					! room string.
	IF(QHERE(PRSO,HERE)) GO TO 27200	! in room?
	I=416					! winner string.
	IF(OADV(PRSO).EQ.WINNER) GO TO 27200	! on winner?
	J=OCAN(PRSO)				! down one level.
	IF(J.EQ.0) GO TO 10
	IF((((OFLAG1(J).AND.TRANBT).EQ.0).AND.
	2 (.NOT.QOPEN(J).OR.((OFLAG1(J).AND.(DOORBT+CONTBT)).EQ.0))))
	3	GO TO 10			! if not visible, punt.
	I=417					! assume in room.
	IF(QHERE(J,HERE)) GO TO 27100
	I=418					! assume on winner.
	IF(OADV(J).NE.WINNER) GO TO 10		! not here or on person.
27100	CALL RSPSUB(I,ODESC2(J))		! describe findings.
	RETURN
C
27200	CALL RSPSUB(I,ODO2)			! describe findings.
	RETURN
C
C V128--	Wait
C
28000	CALL RSPEAK(419)			! time passes.
	DO 28100 I=1,3
	  IF(CLOCKD(X)) RETURN
	  IF(.NOT.DEADF) CALL FIGHTD
	  IF(PRSCON.EQ.0) RETURN			! fighting happened.
28100	CONTINUE
	RETURN
C
C V129--	Spin
C V159--	Turn to
C
29000	CONTINUE
59000	IF(.NOT.OBJACT(X)) CALL RSPEAK(663)	! if not obj, joke.
	RETURN
C
C V130--	Board
C
30000	IF((OFLAG2(PRSO).AND.VEHBT).NE.0) GO TO 30100
	CALL RSPSUB(421,ODO2)			! not vehicle, joke.
	PRSCON=0				! kill cmd stream.
	RETURN
C
30100	IF(QHERE(PRSO,HERE)) GO TO 30200	! here?
	CALL RSPSUB(420,ODO2)			! no, joke.
	PRSCON=0				! kill cmd stream.
	RETURN
C
30200	IF(AV.EQ.0) GO TO 30300			! already got one?
	CALL RSPSUB(422,ODO2)			! yes, joke.
	PRSCON=0				! kill cmd stream.
	RETURN
C
30300	IF(OBJACT(X)) RETURN			! obj handle?
	CALL RSPSUB(423,ODO2)			! describe.
	AVEHIC(WINNER)=PRSO
	IF(WINNER.NE.PLAYER) CALL NEWSTA(AOBJ(WINNER),0,0,PRSO,0)
	RETURN
C
C V131--	Disembark
C
31000	IF(AV.EQ.PRSO) GO TO 31100		! from vehicle?
	CALL RSPEAK(424)			! no, joke.
	PRSCON=0				! kill cmd stream.
	RETURN
C
31100	IF(OBJACT(X)) RETURN			! obj handle?
	IF((RFLAG(HERE).AND.RLAND).NE.0) GO TO 31200
	CALL RSPEAK(425)			! not on land.
	PRSCON=0				! kill cmd stream.
	RETURN
C
31200	AVEHIC(WINNER)=0
	CALL RSPEAK(426)
	IF(WINNER.NE.PLAYER) CALL NEWSTA(AOBJ(WINNER),0,HERE,0,0)
	RETURN
C
C V132--	Take
C
32000	VAPPLI=TAKE(.TRUE.)
	RETURN
C
C V133--	Inventory
C
33000	CALL INVENT(WINNER)
	RETURN

C VAPPLI, PAGE 8
C
C V134--	Fill
C
34000	IF(PRSI.NE.0) GO TO 34050		! any obj specified?
	IF((RFLAG(HERE).AND.(RWATER+RFILL)).NE.0) GO TO 34025
	CALL RSPEAK(516)			! nothing to fill with.
	PRSWON=.FALSE.				! you lose.
	CALL ORPHAN(-1,ACT,PREP1,PRSO,2,' ',0,0)! orphan "fill obj with"
	GO TO 10				! return false.
C
34025	PRSI=GWATE				! use global water.
34050	IF(OBJACT(X)) RETURN			! obj handle?
	IF((PRSI.NE.GWATE).AND.(PRSI.NE.WATER))
	1	CALL RSPSB2(444,ODO2,ODI2)	! no, joke.
	RETURN
C
C V135,V136--	Eat/Drink
C
35000	CONTINUE
36000	IF(OBJACT(X)) RETURN			! obj handle?
	IF(PRSO.EQ.GWATE) GO TO 36500		! drink global water?
	IF(.NOT.EDIBLE(PRSO)) GO TO 36400	! edible?
	IF(OADV(PRSO).EQ.WINNER) GO TO 36200	! yes, on winner?
36100	CALL RSPSUB(454,ODO2)			! not accessible.
	RETURN
C
36200	IF(PRSA.EQ.DRINKW) GO TO 36300		! drink food?
	CALL NEWSTA(PRSO,455,0,0,0)		! no, it disappears.
	RETURN
C
36300	CALL RSPEAK(456)			! yes, joke.
	RETURN
C
36400	IF(.NOT.DRKBLE(PRSO)) GO TO 36600	! drinkable?
	IF(OCAN(PRSO).EQ.0) GO TO 36100		! yes, in something?
	IF(OADV(OCAN(PRSO)).NE.WINNER) GO TO 36100
	IF(QOPEN(OCAN(PRSO))) GO TO 36500	! cont open?
	CALL RSPEAK(457)			! no, joke.
	RETURN
C
36500	CALL NEWSTA(PRSO,458,0,0,0)		! gone.
	RETURN
C
36600	CALL RSPSUB(453,ODO2)			! not food or drink.
	RETURN
C
C V137--	Burn
C
37000	IF((OFLAG1(PRSI).AND.(FLAMBT+LITEBT+ONBT)).NE.
	1	(FLAMBT+LITEBT+ONBT)) GO TO 37400
	IF(OBJACT(X)) RETURN			! obj handle?
	IF(OCAN(PRSO).NE.RECEP) GO TO 37050	! balloon?
	VAPPLI=OAPPLI(OACTIO(BALLO),0)		! yes.
	RETURN
37050	IF((OFLAG1(PRSO).AND.BURNBT).EQ.0) GO TO 37300
	IF(OADV(PRSO).NE.WINNER) GO TO 37100	! carrying it?
	CALL RSPSUB(459,ODO2)
	CALL JIGSUP(460)
	RETURN
C
37100	J=OCAN(PRSO)				! get container.
	IF(QHERE(PRSO,HERE).OR. ((AV.NE.0).AND.(J.EQ.AV)))
	1	GO TO 37200			! reachable?
	IF(J.EQ.0) GO TO 37150			! inside?
	IF(.NOT.QOPEN(J)) GO TO 37150		! open?
	IF(QHERE(J,HERE).OR.((AV.NE.0).AND.(OCAN(J).EQ.AV)))
	1	GO TO 37200			! reachable?
37150	CALL RSPEAK(461)			! cant reach it.
	RETURN
C
37200	CALL RSPSUB(462,ODO2)			! burn it.
	CALL NEWSTA(PRSO,0,0,0,0)
	RETURN
C
37300	CALL RSPSUB(463,ODO2)			! cant burn it.
	RETURN
C
37400	CALL RSPSUB(301,ODI2)			! cant burn it with that.
	RETURN

C VAPPLI, PAGE 9
C
C V138--	Mung
C
38000	I=466					! choose phrase.
	IF((OFLAG2(PRSO).AND.VILLBT).NE.0) GO TO 41100
	IF(.NOT.OBJACT(X)) CALL RSPSB2(466,ODO2,RMK)
	RETURN
C
C V139--	Kill
C
39000	I=467					! choose phrase.
	GO TO 41100
C
C V140--	Swing
C
40000	J=PRSO					! invert.
	PRSO=PRSI
	PRSI=J
	J=ODO2
	ODO2=ODI2
	ODI2=J
	PRSA=ATTACW				! for objact.
C
C V141--	Attack
C
41000	I=468
C
C Common mung/attack/swing/kill code.
C
41100	IF(PRSO.NE.0) GO TO 41200		! anything?
	CALL RSPEAK(469)			! no, joke.
	RETURN
C
41200	IF(OBJACT(X)) RETURN			! obj handle?
	IF((OFLAG2(PRSO).AND.VILLBT).NE.0) GO TO 41300
	IF((OFLAG1(PRSO).AND.VICTBT).EQ.0)
	1	CALL RSPSUB(470,ODO2)		! not a villain.
	RETURN
C
41300	J=471					! assume no weapon.
	IF(PRSI.EQ.0) GO TO 41500
	IF((OFLAG2(PRSI).AND.WEAPBT).EQ.0) GO TO 41400
	MELEE=1					! assume sword.
	IF(PRSI.NE.SWORD) MELEE=2		! must be knife.
	I=BLOW(PLAYER,PRSO,MELEE,.TRUE.,0)	! strike blow.
	RETURN
C
41400	J=472					! not a weapon.
41500	CALL RSPSB2(I,ODO2,J)			! joke.
	RETURN

C VAPPLI, PAGE 10
C
C V142--	Walk
C
42000	VAPPLI=WALK(X)
	RETURN
C
C V143--	Tell
C
43000	CALL RSPEAK(603)
	PRSCON=0				! kill cmd stream.
	RETURN
C
C V144--	Put
C
44000	VAPPLI=PUT(.TRUE.)
	RETURN
C
C V145,V146,V147,V148--	Drop/Give/Pour/Throw
C
45000	CONTINUE
46000	CONTINUE
47000	CONTINUE
48000	VAPPLI=DROP(.TRUE.)
	RETURN
C
C V149--	Save
C
49000	IF((RFLAG(TSTRS).AND.RSEEN).EQ.0) GO TO 49100
	CALL RSPEAK(828)			! no saves in endgame.
	RETURN
C
49100	CALL SAVEGM				! save game.
	PRSWON=.FALSE.				! disable rest of move.
	PRSCON=0
	RETURN
C
C V150--	Restore
C
50000	IF((RFLAG(TSTRS).AND.RSEEN).EQ.0) GO TO 50100
	CALL RSPEAK(829)			! no restores in endgame.
	RETURN
C
50100	CALL RSTRGM				! restore game.
	PRSWON=.FALSE.				! disable rest of move.
	PRSCON=0
	RETURN

C VAPPLI, PAGE 11
C
C V151--	Hello
C
51000	IF(PRSO.NE.0) GO TO 51100		! any obj?
	CALL RSPEAK(346+RND(4))			! no, vanilla hello.
	RETURN
C
51100	IF(PRSO.NE.AVIAT) GO TO 51200		! hello aviator?
	CALL RSPEAK(350)			! nothing happens.
	RETURN
C
51200	IF(PRSO.NE.SAILO) GO TO 51300		! hello sailor?
	HS=HS+1					! count.
	I=351					! give normal or
	IF(MOD(HS,10).EQ.0) I=352		! random message.
	IF(MOD(HS,20).EQ.0) I=353
	CALL RSPEAK(I)				! speak up.
	RETURN
C
51300	IF(OBJACT(X)) RETURN			! obj handle?
	I=354					! assume villain.
	IF((OFLAG2(PRSO).AND.(VILLBT+ACTRBT)).EQ.0) I=355
	CALL RSPSUB(I,ODO2)			! hello there!
	RETURN
C
C V152--	Look into
C
52000	IF(OBJACT(X)) RETURN			! obj handle?
	IF((OFLAG1(PRSO).AND.DOORBT).EQ.0) GO TO 52300	! door?
	IF(.NOT.QOPEN(PRSO)) GO TO 52200	! open?
	CALL RSPSUB(628,ODO2)			! open door- uninteresting.
	RETURN
C
52200	CALL RSPSUB(525,ODO2)			! closed door- cant see.
	RETURN
C
52300	IF((OFLAG1(PRSO).AND.CONTBT).NE.0) GO TO 52500	! container?
	IF(QOPEN(PRSO)) GO TO 52400		! open anyway?
	CALL RSPSUB(630,ODO2)			! cant look inside.
	RETURN
C
52400	IF(.NOT.QEMPTY(PRSO)) GO TO 52700	! not empty?
	CALL RSPSUB(1054,ODO2)			! doesn't contain anything.
	RETURN
C
52500	IF(QOPEN(PRSO).OR.((OFLAG1(PRSO).AND.TRANBT).NE.0))
	1	GO TO 52600			! open or see inside?
	CALL RSPSUB(525,ODO2)			! closed.
	RETURN
C
52600	IF(QEMPTY(PRSO)) GO TO 52800		! see in.  empty?
52700	CALL PRINCO(PRSO,573,.TRUE.)		! no, list contents.
	RETURN
C
52800	CALL RSPSUB(629,ODO2)			! empty.
	RETURN

C VAPPLI, PAGE 12
C
C V153--	Look under
C
53000	IF(.NOT.OBJACT(X)) CALL RSPEAK(631)	! object handle?
	RETURN
C
C V154--	Pump
C
54000	IF((OROOM(PUMP).EQ.HERE).OR.(OADV(PUMP).EQ.WINNER))
	1	GO TO 54100			! pump here?
	CALL RSPEAK(632)			! no.
	RETURN
C
54100	PRSI=PUMP				! becomes inflate
	PRSA=INFLAW				! x with pump.
	GO TO 2000				! done.
C
C V155--	Wind
C
55000	IF(.NOT.OBJACT(X)) CALL RSPSUB(634,ODO2)	! obj handle?
	RETURN
C
C V156--	Climb
C V157--	Climb up
C V158--	Climb down
C
56000	CONTINUE
57000	CONTINUE
58000	IF(OBJACT(X)) RETURN			! object handle?
	I=XUP					! assume up.
	IF(PRSA.EQ.CLMBDW) I=XDOWN		! unless climb dn.
	F=(OFLAG2(PRSO).AND.CLMBBT).NE.0
	IF(F.AND.FINDXT(I,HERE)) GO TO 58500	! anything to climb?
	I=657
	IF(F) I=524				! variety of jokes.
	IF(.NOT.F .AND.((PRSO.EQ.WALL).OR.(PRSO.EQ.GRWAL).OR.
	1	((PRSO.GE.WNORT).AND.(PRSO.LE.WNORT+3))))
	2	I=656				! if walls.
	CALL RSPEAK(I)				! joke.
	RETURN
C
58500	PRSA=WALKW				! walk
	PRSO=I					! in specified dir.
	GO TO 42000				! treat as walk.

C VAPPLI, PAGE 13
C
C V160--	Pour on
C
60000	IF(PRSO.NE.WATER) GO TO 60500		! pour water?
	IF(OBJACT(X)) RETURN			! object handle?
	CALL NEWSTA(WATER,0,0,0,0)		! vanish water.
	IF(OCAN(PRSI).NE.RECEP) GO TO 60100	! onto obj in receptacle?
	CALL RSPSUB(977,ODI2)			! doesn't work.
	RETURN
C
60100	IF((OFLAG1(PRSI).AND.(LITEBT+FLAMBT+ONBT)).NE.
	1	(LITEBT+FLAMBT+ONBT)) GO TO 60300	! on flame?
	IF(PRSO.NE.TORCH) GO TO 60200		! on torch?
	CALL RSPEAK(978)			! doesn't work.
	RETURN
C
60200	OFLAG1(PRSI)=OFLAG1(PRSI).AND..NOT.ONBT	! extinguish.
	CALL RSPSUB(979,ODI2)			! describe.
	IF(PRSI.EQ.CANDL) CFLAG(CEVCND)=.FALSE.	! if candle, disable timer.
	IF(PRSI.EQ.MATCH) CTICK(CEVMAT)=0	! if match, gone.
	GO TO 50				! go see if now dark.
C
60300	CALL RSPSUB(980,ODI2)			! doesn't work.
	RETURN
C
60500	CALL RSPEAK(981)			! not water, joke.
	RETURN
C
C V161--	Put under
C
61000	IF(OBJACT(X)) RETURN			! object handle.
	I=1037					! can't do.
	IF((OFLAG1(PRSO).AND.DOORBT).NE.0) I=982	! if door, won't fit.
	CALL RSPEAK(I)
	RETURN
C
C V162--	Untie from
C
62000	IF(((PRSO.EQ.BROPE).AND.(BTIEF.NE.0)).OR.
	1  ((PRSO.EQ.ROPE).AND.(DOMEF.OR.(TTIE.EQ.PRSI))))
	2  GO TO 62100				! untie rope?
	CALL RSPEAK(1006)			! can't do it.
	RETURN
C
62100	PRSA=UNTIEW				! treat as normal untie.
	GO TO 13000

C VAPPLI, PAGE 14
C
C V163--	Make
C V169--	Wish
C
63000	IF(PRSO.NE.GWISH) GO TO 10		! make a wish?
69000	IF(HERE.NE.BWELL) GO TO 63100		! at well?
	IF(OROOM(BAGCO).EQ.HERE) GO TO 63200	! coins here?
	IF(OROOM(ZORKM).EQ.HERE) GO TO 63300	! zorkmid here?
63100	CALL RSPEAK(937)			! doesn't work.
	RETURN
C
63200	CALL NEWSTA(BAGCO,938,0,0,0)		! vanish coins
	RETURN
C
63300	CALL NEWSTA(ZORKM,938,0,0,0)		! vanish zorkmid.
	RETURN
C
C V164--	Oil
C
64000	IF(PRSI.NE.PUTTY) GO TO 64100		! with putty?
	IF(OBJACT(X)) RETURN			! object handle?
	CALL RSPEAK(904)			! doesn't work.
	RETURN
C
64100	CALL RSPEAK(905)			! joke.
	RETURN
C
C V165--	Play
C
65000	IF(PRSO.NE.STRAD) GO TO 65200		! play violin?
	IF((OFLAG2(PRSI).AND.WEAPBT).EQ.0) GO TO 65100
	OTVAL(STRAD)=0				! with weapon, ruined.
	CALL RSPEAK(933)
	RETURN
C
65100	CALL RSPEAK(934)			! offensive noise.
	RETURN
C
65200	IF((OFLAG2(PRSO).AND.VILLBT).EQ.0) GO TO 10	! play villain?
	CALL RSPSUB(935,ODO2)			! you're dead.
	CALL JIGSUP(0)
	RETURN
C
C V166--	Send
C
66000	IF(OBJACT(X)) RETURN			! object handle?
	I=940					! can't do it.
	IF((OFLAG2(PRSO).AND.VILLBT).NE.0) I=941 ! why do it?
	CALL RSPSUB(I,ODO2)
	RETURN

C VAPPLI, PAGE 15
C
C V167--	Enter
C
67000	PRSA=WALKW				! treat as walk.
	PRSO=XENTER
	GO TO 42000
C
C V168--	Leave
C
68000	PRSA=WALKW				! treat as walk.
	PRSO=XEXIT
	GO TO 42000
C
C V65--	Room
C
65001	VAPPLI=RMDESC(2)			! describe room only.
	RETURN
C
C V66--	Objects
C
66001	VAPPLI=RMDESC(1)			! describe obj only.
	IF(.NOT.TELFLG) CALL RSPEAK(138)	! no objects.
	RETURN
C
C V67--	Rname
C
67001	CALL RSPEAK(RDESC2-HERE)		! short room name.
	RETURN
C
C V68--	Squeeze
C
68001	IF(OBJACT(X)) RETURN			! object handle?
	I=901					! can't.
	IF((OFLAG2(PRSO).AND.VILLBT).NE.0) I=902 ! don't understand.
	CALL RSPSUB(I,ODO2)
	RETURN
C
C V69--	Smell
C
69001	CALL RSPSUB(903,ODO2)			! joke.
	RETURN

C VAPPLI, PAGE 16
C
C V70--	Brief
C
70000	BRIEFF=.TRUE.				! brief descriptions.
	SUPERF=.FALSE.
	CALL RSPEAK(326)
	RETURN
C
C V71--	Verbose
C
71000	BRIEFF=.FALSE.				! long descriptions.
	SUPERF=.FALSE.
	CALL RSPEAK(327)
	RETURN
C
C V72--	Superbrief
C
72000	SUPERF=.TRUE.
	CALL RSPEAK(328)
	RETURN
C
C V73-- Stay (used in endgame)
C
73000	IF(WINNER.NE.AMASTR) GO TO 73100	! tell master, stay.
	CALL RSPEAK(781)			! he does.
	CTICK(CEVFOL)=0				! not following.
	RETURN
C
73100	IF(WINNER.EQ.PLAYER) CALL RSPEAK(664)	! joke.
	RETURN
C
C V74--	Version
C
74000	WRITE(OUTCH,74010) VMAJ,VMIN,VEDIT
74010	FORMAT(' V',I1,'.',I2,A)
	TELFLG=.TRUE.
	RETURN
C
C V75--	Swim
C
75000	I=330					! assume water.
	IF((RFLAG(HERE).AND.(RWATER+RFILL)).EQ.0)
	1	I=331+RND(3)			! if no water, joke.
	CALL RSPEAK(I)
	RETURN
C
C V76--	Geronimo
C
76000	IF(AVEHIC(WINNER).EQ.BARRE) GO TO 76100	! in barrel?
	CALL RSPEAK(334)			! no, joke.
	RETURN
C
76100	CALL JIGSUP(335)			! over falls.
	RETURN
C
C V77--	Sinbad et al
C
77000	IF((HERE.EQ.MCYCL).AND.QHERE(CYCLO,HERE)) GO TO 77100
	CALL RSPEAK(336)			! not here, joke.
	RETURN
C
77100	CALL NEWSTA(CYCLO,337,0,0,0)		! cyclops flees.
	CYCLOF=.TRUE.				! set all flags.
	MAGICF=.TRUE.
	OFLAG2(CYCLO)=OFLAG2(CYCLO).AND. .NOT.FITEBT
	RETURN
C
C V78--	unused
C
78000	GO TO 10
C
C V79--	Pray
c
79000	IF(HERE.NE.TEMP2) GO TO 79050		! in temple?
	IF(MOVETO(FORE1,WINNER)) GO TO 79100	! fore1 still there?
79050	CALL RSPEAK(340)			! joke.
	RETURN
C
79100	F=RMDESC(3)				! moved, describe.
	RETURN
C
C V80--	Treasure
c
80000	IF(HERE.NE.TEMP1) GO TO 80050		! in temple?
	IF(MOVETO(TREAS,WINNER)) GO TO 79100	! treasure room there?
80050	CALL RSPEAK(341)			! nothing happens.
	RETURN
C
C V81--	Temple
c
81000	IF(HERE.NE.TREAS) GO TO 81050		! in treasure?
	IF(MOVETO(TEMP1,WINNER)) GO TO 79100	! temp1 still there?
81050	CALL RSPEAK(341)			! nothing happens.
	RETURN
C
C V82--	Blast
C
82000	I=342					! dont understand.
	IF(PRSO.EQ.SAFE) I=252			! joke for safe.
	CALL RSPEAK(I)
	RETURN
C
C V83--	Score
C
83000	CALL SCORE(.FALSE.)
	RETURN
C
C V84--	Quit
C
84000	CALL SCORE(.TRUE.)			! tell score.
	IF(.NOT.YESNO(343,10,0)) RETURN		! ask for y/n decision.
	CLOSE (UNIT=DBCH)			! clean up.
	CALL EXIT				! bye.

C VAPPLI, PAGE 17
C
C V85--	Follow (used in endgame)
C
85000	IF(WINNER.NE.AMASTR) GO TO 85100	! tell master, follow.
	CALL RSPEAK(782)
	CFLAG(CEVFOL)=.TRUE.
	CTICK(CEVFOL)=-1			! starts following.
	RETURN
C
85100	I=10					! assume ok.
	IF(PRSO.EQ.0) GO TO 85200		! any object?
	I=964					! joke 1
	IF((OFLAG2(PRSO).AND.VILLBT).NE.0) I=965 ! joke 2.
85200	CALL RSPEAK(I)
	RETURN
C
C V86--	Walk through
C
86000	IF(OBJACT(X)) RETURN			! object handle?
	IF((SCOLRM.EQ.0).OR.((PRSO.NE.SCOL).AND.
	1	((PRSO.NE.WNORT).OR.(HERE.NE.BKBOX)))) GO TO 86100
	SCOLAC=SCOLRM				! walked thru scol.
	PRSO=0					! fake out fromdr.
	CFLAG(CEVSCL)=.TRUE.
	CTICK(CEVSCL)=6				! start alarm.
	CALL RSPEAK(668)			! disorient him.
	F=MOVETO(SCOLRM,WINNER)			! into room.
	F=RMDESC(0)				! describe.
	RETURN
C
86100	IF(HERE.NE.SCOLAC) GO TO 86300		! on other side of scol?
	DO 86200 I=1,12,3			! walk thru proper wall?
	  IF((SCOLWL(I).EQ.HERE).AND.(SCOLWL(I+1).EQ.PRSO))
	1	GO TO 86500			! in specified room?
86200	CONTINUE
C
86300	IF((OFLAG1(PRSO).AND.TAKEBT).NE.0) GO TO 86400	! tkble?
	I=669					! no, joke.
	IF(PRSO.EQ.SCOL) I=670			! special joke for scol.
	CALL RSPSUB(I,ODO2)
	RETURN
C
86400	I=671					! joke.
	IF(OROOM(PRSO).NE.0) I=552+RND(6)	! special jokes if carry.
	CALL RSPEAK(I)
	RETURN
C
86500	PRSO=SCOLWL(I+2)			! thru scol wall...
	DO 86600 I=1,8,2			! find matching room.
	  IF(PRSO.EQ.SCOLDR(I)) SCOLRM=SCOLDR(I+1)
86600	CONTINUE				! declare new scolrm.
	CTICK(CEVSCL)=0				! cancel alarm.
	CALL RSPEAK(668)			! disorient him.
	F=MOVETO(BKBOX,WINNER)			! back in box room.
	F=RMDESC(0)
	RETURN
C
C V87--	Ring
C
87000	IF(OBJACT(X)) RETURN			! object handle?
	I=359					! cant ring.
	IF(PRSO.EQ.BELL) I=360			! ding, dong.
	CALL RSPEAK(I)				! joke.
	RETURN
C
C V88--	Brush
C
88000	IF(PRSO.EQ.TEETH) GO TO 88100		! brush teeth?
	CALL RSPEAK(362)			! no, joke.
	RETURN
C
88100	IF(PRSI.NE.0) GO TO 88200		! with something?
	CALL RSPEAK(363)			! no, joke.
	RETURN
C
88200	IF((PRSI.EQ.PUTTY).AND.(OADV(PUTTY).EQ.WINNER))
	1	GO TO 88300			! with putty?
	CALL RSPSUB(364,ODI2)			! no, joke.
	RETURN
C
88300	CALL JIGSUP(365)			! yes, dead!!!!!
	RETURN

C VAPPLI, PAGE 18
C
C V89--	Dig
C
89000	IF(PRSI.NE.SHOVE) GO TO 89100		! shovel?
	VAPPLI=OBJACT(X)			! must handle.
	RETURN
C
89100	I=392					! assume tool.
	IF((OFLAG1(PRSO).AND.TOOLBT).EQ.0) I=393
	CALL RSPSUB(I,ODO2)
	RETURN
C
C V90--	Time
C
90000	CALL GTTIME(K)				! get play time.
	I=K/60
	J=MOD(K,60)
	WRITE(OUTCH,90010)
	IF(I.NE.0) WRITE(OUTCH,90011) I
	IF(I.GE.2) WRITE(OUTCH,90012)
	IF(I.EQ.1) WRITE(OUTCH,90013)
	IF(J.EQ.1) WRITE(OUTCH,90014) J
	IF(J.NE.1) WRITE(OUTCH,90015) J
	TELFLG=.TRUE.
	RETURN
C
90010	FORMAT(' You have been playing Dungeon for ',$)
90011	FORMAT('+',I3,' hour',$)
90012	FORMAT('+s and ',$)
90013	FORMAT('+ and ',$)
90014	FORMAT('+',I2,' minute.')
90015	FORMAT('+',I2,' minutes.')
C
C V91--	Leap
C
91000	IF(PRSO.EQ.0) GO TO 91200		! over something?
	IF(QHERE(PRSO,HERE)) GO TO 91100	! here?
	CALL RSPEAK(447)			! no, joke.
	RETURN
C
91100	IF((OFLAG2(PRSO).AND.VILLBT).EQ.0) GO TO 91300
	CALL RSPSUB(448,ODO2)			! cant jump villain.
	RETURN
C
91200	IF(.NOT.FINDXT(XDOWN,HERE)) GO TO 91300	! down exit?
	IF((XTYPE.EQ.XNO).OR.((XTYPE.EQ.XCOND).AND.
	1	.NOT.FLAGS(XFLAG))) GO TO 91400	! blocked off?
91300	CALL RSPEAK(314+RND(5))			! wheeee!
	RETURN
C
91400	CALL JIGSUP(449+RND(4))			! fatal leap.
	RETURN

C VAPPLI, PAGE 19
C
C V92--	Lock
C
92000	IF(OBJACT(X)) RETURN			! object handle?
	IF((PRSO.EQ.GRATE).AND..NOT.QOPEN(GRATE).AND.(HERE.EQ.MGRAT))
	1	GO TO 92200			! lock closed grate?
92100	CALL RSPEAK(464)			! not lock grate.
	RETURN
C
92200	GRUNLF=.FALSE.				! grate now locked.
	CALL RSPEAK(214)
	TRAVEL(REXIT(HERE)+1)=214		! change exit status.
	RETURN
C
C V93--	Unlock
C
93000	IF(OBJACT(X)) RETURN			! object handle?
	IF((PRSO.NE.GRATE).OR.(HERE.NE.MGRAT))
	1	GO TO 92100			! not unlock grate.
	IF(PRSI.EQ.KEYS) GO TO 93200		! got keys?
	CALL RSPSUB(465,ODI2)			! no, joke.
	RETURN
C
93200	GRUNLF=.TRUE.				! unlock grate.
	CALL RSPEAK(217)
	TRAVEL(REXIT(HERE)+1)=1041		! change exit status.
	RETURN
C
C V94--	Diagnose
C
94000	I=FIGHTS(WINNER,.FALSE.)		! get fights strength.
	J=ASTREN(WINNER)			! get health.
	K=MIN0(I+J,4)				! get state.
	IF(.NOT.CFLAG(CEVCUR)) J=0		! if no wounds.
	L=MIN0(4,IABS(J))			! scale.
	CALL RSPEAK(473+L)			! describe health.
	I=(30*(-J-1))+CTICK(CEVCUR)		! compute wait.
	IF(J.NE.0) WRITE(OUTCH,94100) I
94100	FORMAT(' You will be cured after ',I3,' moves.')
	CALL RSPEAK(478+K)			! how much more?
	IF(DEATHS.NE.0) CALL RSPEAK(482+DEATHS)	! how many deaths?
	RETURN

C VAPPLI, PAGE 20
C
C V95--	Incant
C
95000	IF(WINNER.NE.PLAYER) GO TO 10		! must do yourself.
	IF(SUBLNT.EQ.0) GO TO 95350		! any input?
	PW(1)=' '				! set up parse.
	PW(2)=' '
	WP=1
	CP=1
	DO 95200 I=1,SUBLNT			! scan substring
	  IF(SUBBUF(I:I).NE.' ') GO TO 95150	! blank?
	  IF(CP.EQ.1) GO TO 95200		! anything in word yet?
	  WP=MIN0(2,WP+1)			! advance word pointer.
	  CP=1					! reset char pointer.
	  GO TO 95200
95150	  IF(CP.LE.WRDLNT) PW(WP)(CP:CP)=SUBBUF(I:I)	! add char to word.
	  CP=CP+1
95200	CONTINUE
C
	IF(PW(1).NE.' ') GO TO 95400		! any input?
95350	CALL RSPEAK(856)			! no, ho hum.
95375	PRSCON=0				! kill cmd stream.
	RETURN
C
95400	CALL ENCRYP(PW(1),CH)			! compute response.
	IF(PW(2).NE.' ') GO TO 95600		! two phrases?
C
	IF(SPELLF) GO TO 95550			! he's trying to learn.
	IF((RFLAG(TSTRS).AND.RSEEN).EQ.0) GO TO 95575
	SPELLF=.TRUE.				! tell him.
	TELFLG=.TRUE.
	WRITE(OUTCH,95510) PW(1),CH
95510	FORMAT(' A hollow voice replies:  "',A,1X,A,'".')
	RETURN
C
95550	CALL RSPEAK(857)			! he's got one already.
	GO TO 95375
C
95575	CALL RSPEAK(858)			! he's not in endgame.
	GO TO 95375
C
95600	IF((RFLAG(TSTRS).AND.RSEEN).NE.0) GO TO 95800
	IF(PW(2).NE.CH) GO TO 95900		! wrong.
	SPELLF=.TRUE.				! it works.
	CALL RSPEAK(859)
	CFLAG(CEVSTE)=.TRUE.
	CTICK(CEVSTE)=1				! force start.
	RETURN
C
95800	CALL RSPEAK(855)			! too late.
	GO TO 95375
C
95900	CALL RSPEAK(1052)			! got it wrong.
	GO TO 95375

C VAPPLI, PAGE 21
C
C V96--	Answer
C
96000	IF(WINNER.NE.PLAYER) GO TO 10		! must answer for himself.
	IF(SUBLNT.EQ.0) GO TO 96050		! any substring?
	IF((HERE.EQ.RIDDL).AND..NOT.RIDDLF) GO TO 96700
	IF((HERE.EQ.FDOOR).AND.INQSTF) GO TO 96100
96050	CALL RSPEAK(799)			! no one listens.
	PRSCON=0				! kill cmd stream.
	RETURN
C
96100	K=1					! pointer into ansstr.
	DO 96300 J=1,28,2			! check answers.
	  NEWK=K+ANSWER(J+1)			! compute next k.
	  IF(QUESNO.NE.ANSWER(J)) GO TO 96300	! only check proper ans.
	  IF(SUBBUF.EQ.ANSSTR(K:NEWK-1)) GO TO 96500
96300	K=NEWK
C
	PRSCON=0				! kill cmd stream.
	NQATT=NQATT+1				! wrong, cretin.
	IF(NQATT.GE.5) GO TO 96400		! too many wrong?
	CALL RSPEAK(800+NQATT)			! no, try again.
	RETURN
C
96400	CALL RSPEAK(826)			! all over.
	CFLAG(CEVINQ)=.FALSE.			! lose.
	RETURN
C
96500	CORRCT=CORRCT+1				! got it right.
	CALL RSPEAK(800)			! hooray.
	IF(CORRCT.GE.3) GO TO 96600		! won totally?
	CFLAG(CEVINQ)=.TRUE.
	CTICK(CEVINQ)=2				! no, start again.
	QUESNO=MOD(QUESNO+3,8)
	NQATT=0
	CALL RSPEAK(769)			! ask next question.
	CALL RSPEAK(770+QUESNO)
	RETURN
C
96600	CALL RSPEAK(827)			! quiz over,
	CFLAG(CEVINQ)=.FALSE.
	OFLAG2(QDOOR)=OFLAG2(QDOOR).OR.OPENBT	! open door.
	RETURN
C
96700	IF(SUBBUF.NE.'WELL') GO TO 96050	! right answer?
	RIDDLF=.TRUE.				! solved riddle.
	CALL RSPEAK(338)
	RETURN
C
	END

C TAKE-- Basic take sequence
C
C Take an object (for verbs take, put, drop, read, etc.)
C
	LOGICAL FUNCTION TAKE(FLG)
C
C Declarations
C
	IMPLICIT INTEGER (A-Z)
	LOGICAL FLG,OBJACT,OAPPLI,QOPEN,QHERE
	INCLUDE 'DPARAM.FOR/NOLIST'
C
C Functions and data
C
	QOPEN(O)=(OFLAG2(O).AND.OPENBT).NE.0

C TAKE, PAGE 2
C
	IF((PRSO.LE.STRBIT).AND.
	1 ((OFLAG2(PRSO).AND.NOCHBT).EQ.0)) GO TO 100	! star or nocheck?
	TAKE=OBJACT(X)				! yes, let it handle.
	RETURN
C
100	TAKE=.FALSE.				! assume loses.
	X=OCAN(PRSO)				! inside?
	IF((PRSI.EQ.0).OR.(PRSI.EQ.X)) GO TO 200 ! take x from ocan(x)?
	CALL RSPEAK(1038)			! not in that.
	RETURN
C
200	IF(PRSO.NE.AVEHIC(WINNER)) GO TO 400	! his vehicle?
	CALL RSPEAK(672)			! dummy.
	RETURN
C
400	OA=OACTIO(PRSO)				! get object action.
	IF((OFLAG1(PRSO).AND.TAKEBT).NE.0) GO TO 500 ! takeable?
	IF(.NOT.OAPPLI(OA,0)) CALL RSPEAK(552+RND(6))
	RETURN
C
C Object is takeable and in position to be taken.
C
500	IF((X.NE.0).OR. QHERE(PRSO,HERE)) GO TO 600
	IF(OADV(PRSO).EQ.WINNER) CALL RSPEAK(103)	! already got it?
	RETURN
C
600	IF(((X.NE.0).AND.(OADV(X).EQ.WINNER)).OR.
	1	((WEIGHT(0,PRSO,WINNER)+OSIZE(PRSO)).LE.MXLOAD))
	2	GO TO 700
	CALL RSPEAK(558)			! too much weight.
	PRSCON=0				! kill cmd stream.
	RETURN
C
700	TAKE=.TRUE.				! at last.
	IF(OAPPLI(OA,0)) RETURN			! did it handle?
	CALL NEWSTA(PRSO,0,0,0,WINNER)		! take object for winner.
	OFLAG2(PRSO)=OFLAG2(PRSO).OR.TCHBT	! has been touched.
	CALL SCRUPD(OFVAL(PRSO))		! update score.
	OFVAL(PRSO)=0				! cant be scored again.
	IF(FLG) CALL RSPEAK(559)		! tell taken.
	RETURN
C
	END

C DROP- Drop verb processor
C
C Declarations
C
	LOGICAL FUNCTION DROP(FLG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL F,PUT,OBJACT,FLG
C
	IF((OFLAG2(PRSO).AND.NOCHBT).EQ.0) GO TO 100
	DROP=OBJACT(X)				! no check, let obj handle.
	RETURN
C
100	DROP=.TRUE.				! assume wins.
	X=OCAN(PRSO)				! get container.
	IF(X.EQ.0) GO TO 200			! is it inside?
	IF(OADV(X).NE.WINNER) GO TO 1000	! is he carrying con?
	IF((OFLAG2(X).AND.OPENBT).NE.0) GO TO 300 ! is it open?
	CALL RSPSUB(525,ODESC2(X))		! cant reach.
	RETURN
C
200	IF(OADV(PRSO).NE.WINNER) GO TO 1000	! is he carrying obj?
300	IF(AVEHIC(WINNER).EQ.0) GO TO 400	! is he in vehicle?
	PRSI=AVEHIC(WINNER)			! yes,
	F=PUT(.TRUE.)				! drop into vehicle.
	PRSI=0					! disarm parser.
	RETURN					! done.
C
400	CALL NEWSTA(PRSO,0,HERE,0,0)		! drop into room.
	CALL SCRUPD(OFVAL(PRSO))		! score object.
	OFVAL(PRSO)=0				! cant be scored again.
	OFLAG2(PRSO)=OFLAG2(PRSO).OR.TCHBT	! has been touched.
C
	IF(OBJACT(X)) RETURN			! did it handle?
	IF(PRSA.EQ.DROPW) CALL RSPEAK(528)
	IF(PRSA.EQ.THROWW) CALL RSPEAK(529)
	RETURN
C
1000	CALL RSPEAK(527)			! dont have it.
	RETURN
C
	END

C PUT- Put verb processor
C
C Declarations
C
	LOGICAL FUNCTION PUT(FLG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QOPEN,QHERE,OBJACT,FLG
C
C Functions and data
C
	QOPEN(R)=(OFLAG2(R).AND.OPENBT).NE.0

C PUT, PAGE 2
C
	IF((OFLAG2(PRSO).AND.NOCHBT).EQ.0) GO TO 100
	PUT=OBJACT(X)				! no check, let obj handle.
	RETURN
C
100	PUT=.FALSE.
	IF((PRSO.LE.STRBIT).AND.(PRSI.LE.STRBIT)) GO TO 200
	IF(.NOT.OBJACT(X)) CALL RSPEAK(560)	! star
	PUT=.TRUE.
	RETURN
C
200	IF(QOPEN(PRSI).OR.((OFLAG1(PRSI).AND.(DOORBT+CONTBT)).NE.0)
	1	.OR.((OFLAG2(PRSI).AND.VEHBT).NE.0)) GO TO 300
	CALL RSPEAK(561)			! cant put in that.
	RETURN
C
300	IF(QOPEN(PRSI)) GO TO 400		! is it open?
	CALL RSPEAK(562)			! no, joke
	RETURN
C
400	IF(PRSO.NE.PRSI) GO TO 500		! into itself?
	CALL RSPEAK(563)			! yes, joke.
	RETURN
C
500	IF(OCAN(PRSO).NE.PRSI) GO TO 600	! already inside.
	CALL RSPSB2(564,ODESC2(PRSO),ODESC2(PRSI))
	PUT=.TRUE.
	RETURN
C
600	IF((WEIGHT(0,PRSO,0)+WEIGHT(0,PRSI,0)+OSIZE(PRSO))
	1	.LE.OCAPAC(PRSI)) GO TO 700	! not too full?
	IF(PRSI.NE.AVEHIC(WINNER)) GO TO 650	! into vehicle?
	CALL RSPSUB(889,ODESC2(PRSI))		! too full.
	RETURN
C
650	CALL RSPEAK(565)			! then cant do it.
	RETURN
C
C Now see if object (or its container) is in room
C
700	J=PRSO					! start search.
725	IF(QHERE(J,HERE)) GO TO 750		! is it here?
	J=OCAN(J)
	IF(J.NE.0) GO TO 725			! more to do?
	GO TO 800				! no, sch fails.
C
750	IF((PRSO.EQ.WATER).OR.(PRSO.EQ.GWATE)) GO TO 800
	SVO=PRSO				! save parser.
	SVI=PRSI
	PRSA=TAKEW
	PRSI=0
	IF(.NOT.TAKE(.FALSE.)) RETURN		! take object.
	PRSA=PUTW
	PRSO=SVO
	PRSI=SVI
	GO TO 1000
C
C Now see if object is on person.
C
800	IF(OCAN(PRSO).EQ.0) GO TO 1000		! inside?
	IF(QOPEN(OCAN(PRSO))) GO TO 900		! open?
	CALL RSPSUB(566,ODESC2(PRSO))		! lose.
	RETURN
C
900	CALL SCRUPD(OFVAL(PRSO))		! score object.
	OFVAL(PRSO)=0
	OFLAG2(PRSO)=OFLAG2(PRSO).OR.TCHBT	! has been touched.
	CALL NEWSTA(PRSO,0,0,0,WINNER)		! temporarily on winner.
C
1000	IF(OBJACT(X)) RETURN			! no, give object a shot.
	CALL NEWSTA(PRSO,2,0,PRSI,0)		! contained inside.
	PUT=.TRUE.
	RETURN
C
	END

C VALUAC- Handles valuables/everything/possessions/bunch object
C
C Declarations
C
	SUBROUTINE VALUAC(V)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL LIT,F,F1,TAKE,PUT,DROP,NOTHIS,QHERE,QBUNCH
C
C Functions and data
C
	NOTHIS(R)=((SAVEP.EQ.BUNOBJ).AND.QBUNCH(R)) .OR.
	1	  ((OTVAL(R).LE.0).AND.((SAVEP.EQ.VALUA).OR.
	2	   ((SAVEP.EQ.BUNOBJ).AND.(BUNSUB.EQ.VALUA)))) .OR.
	3	  ((OADV(R).NE.WINNER).AND.((SAVEP.EQ.POSSE).OR.
	4	   ((SAVEP.EQ.BUNOBJ).AND.(BUNSUB.EQ.POSSE))))

C VALUAC, PAGE 2
C
	SAVEP=PRSO				! save prso.
	SAVEH=HERE				! save here.
	F=.TRUE.				! assume no actions.
	I=579					! assume not lit.
	IF(.NOT.LIT(HERE)) GO TO 4000		! if not lit, punt.
	I=677					! assume wrong verb.
C
100	IF(PRSA.NE.TAKEW) GO TO 1000		! take?
	IF((PRSO.NE.BUNOBJ).OR.(BUNSUB.NE.0)) GO TO 400	! bunch, no except?
	DO 300 I=1,BUNLNT			! loop through bunch
	  PRSO=BUNVEC(I)			! get next item
	  F=.FALSE.
	  CALL RSPSUB(580,ODESC2(PRSO))
	  F1=TAKE(.TRUE.)
	  IF(SAVEH.NE.HERE) GO TO 4500
300	CONTINUE
	GO TO 3000
C
400	DO 500 PRSO=1,OLNT			! loop thru objects.
	  IF((((OFLAG1(PRSO).AND.TAKEBT).EQ.0).AND.
	1	((OFLAG2(PRSO).AND.TRYBT).EQ.0)).OR.
	2	((OFLAG1(PRSO).AND.VISIBT).EQ.0).OR.
	3	((OFLAG2(PRSO).AND.ACTRBT).NE.0).OR.
	4	NOTHIS(PRSO)) GO TO 500
	  IF(QHERE(PRSO,HERE)) GO TO 450	! is it here?
	  J=OCAN(PRSO)				! get container.
	  IF(J.EQ.0) GO TO 500			! in a container?
	  IF(((OFLAG2(J).AND.OPENBT).EQ.0).OR.
	1    (.NOT.QHERE(J,HERE).AND.(OADV(J).NE.WINNER)))
	2    GO TO 500				! in open cont here?
450	  F=.FALSE.
	  CALL RSPSUB(580,ODESC2(PRSO))
	  F1=TAKE(.TRUE.)
	  IF(SAVEH.NE.HERE) GO TO 4500
500	CONTINUE
	GO TO 3000
C
1000	IF(PRSA.NE.DROPW) GO TO 2000		! drop?
	IF((PRSO.NE.BUNOBJ).OR.(BUNSUB.NE.0)) GO TO 1400 ! bunch, no except?
	DO 1300 I=1,BUNLNT			! loop through bunch
	  PRSO=BUNVEC(I)			! get next item
	  F=.FALSE.
	  CALL RSPSUB(580,ODESC2(PRSO))
	  F1=DROP(.TRUE.)
	  IF(SAVEH.NE.HERE) GO TO 4500
1300	CONTINUE
	GO TO 3000
C
1400	DO 1500 PRSO=1,OLNT
	  IF((OADV(PRSO).NE.WINNER).OR.NOTHIS(PRSO))
	1	GO TO 1500
	  F=.FALSE.
	  CALL RSPSUB(580,ODESC2(PRSO))
	  F1=DROP(.TRUE.)
	  IF(SAVEH.NE.HERE) GO TO 4500
1500	CONTINUE
	GO TO 3000

C VALUAC, PAGE 2
C
2000	IF(PRSA.NE.PUTW) GO TO 4000		! put?
	IF((PRSO.NE.BUNOBJ).OR.(BUNSUB.NE.0)) GO TO 2400 ! bunch, no except?
	DO 2300 I=1,BUNLNT			! loop through bunch
	  PRSO=BUNVEC(I)			! get next item
	  F=.FALSE.
	  CALL RSPSUB(580,ODESC2(PRSO))
	  F1=PUT(.TRUE.)
	  IF(SAVEH.NE.HERE) GO TO 4500
2300	CONTINUE
	GO TO 3000
C
2400	DO 2500 PRSO=1,OLNT			! loop thru objects.
	  IF(((OADV(PRSO).NE.WINNER).AND.
	1	(.NOT.QHERE(PRSO,HERE).OR.
	2	(((OFLAG1(PRSO).AND.TAKEBT).EQ.0).AND.
	3	 ((OFLAG2(PRSO).AND.TRYBT).EQ.0)))).OR.
	4	(PRSO.EQ.PRSI).OR.NOTHIS(PRSO).OR.
	5	((OFLAG1(PRSO).AND.VISIBT).EQ.0)) GO TO 2500
	  F=.FALSE.
	  CALL RSPSUB(580,ODESC2(PRSO))
	  F1=PUT(.TRUE.)
	  IF(SAVEH.NE.HERE) GO TO 4500
2500	CONTINUE
C
3000	I=581					! right verb, choose
	IF(SAVEP.EQ.VALUA) I=582		! nothing happened message.
4000	IF(F) CALL RSPEAK(I)			! nothing or wrong verb?
4500	PRSO=SAVEP				! restore PRSO.
	BUNSUB=0				! cancel EXCEPT/BUT.
	RETURN
	END

C QBUNCH-	Is object in bunch vector?
C
C Declarations
C
	LOGICAL FUNCTION QBUNCH(OBJ)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	IF(BUNLNT.EQ.0) GO TO 200		! bunch vector empty?
	QBUNCH=.TRUE.				! assume found.
	DO 100 I=1,BUNLNT			! search bunch vector.
	  IF(OBJ.EQ.BUNVEC(I)) RETURN		! got one.
100	CONTINUE
200	QBUNCH=.FALSE.				! not found.
	RETURN
C
	END

C SAVE- Save game state
C
C Declarations
C
	SUBROUTINE SAVEGM
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	IF(SUBLNT.EQ.0) SUBBUF='DSAVE.DAT'
	OPEN (UNIT=1,NAME=SUBBUF,ACCESS='SEQUENTIAL',
	1	TYPE='UNKNOWN',FORM='UNFORMATTED',ERR=100)
C
	CALL GTTIME(I)				! get time.
	WRITE(1) VMAJ,VMIN
	WRITE(1) WINNER,HERE,THFPOS,TELFLG,THFFLG,THFACT,
	1	SWDACT,SWDSTA,CPVEC
	WRITE(1) I,MOVES,DEATHS,RWSCOR,EGSCOR,MXLOAD,
	1	LTSHFT,BLOC,MUNGRM,HS,FROMDR,SCOLRM,SCOLAC
	WRITE(1) ODESC1,ODESC2,OFLAG1,OFLAG2,OFVAL,OTVAL,
	1	OSIZE,OCAPAC,OROOM,OADV,OCAN
	WRITE(1) RDESC1,RVAL,RFLAG,TRAVEL
	WRITE(1) AROOM,ASCORE,AVEHIC,ASTREN,AFLAG
	WRITE(1) FLAGS,SWITCH,VPROB,CFLAG,CTICK,CCNCEL
C
	CALL RSPEAK(597)
	CLOSE(UNIT=1)
	RETURN
C
100	CALL RSPEAK(598)			! cant do it.
	RETURN
	END

C RESTORE- Restore game state
C
C Declarations
C
	SUBROUTINE RSTRGM
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	IF(SUBLNT.EQ.0) SUBBUF='DSAVE.DAT'
	OPEN (UNIT=1,NAME=SUBBUF,ACCESS='SEQUENTIAL',
	1	TYPE='OLD',READONLY,FORM='UNFORMATTED',ERR=100)
C
	READ(1) I,J
	IF((I.NE.VMAJ).OR.(J.NE.VMIN)) GO TO 200
C
	READ(1) WINNER,HERE,THFPOS,TELFLG,THFFLG,THFACT,
	1	SWDACT,SWDSTA,CPVEC
	READ(1) PLTIME,MOVES,DEATHS,RWSCOR,EGSCOR,MXLOAD,
	1	LTSHFT,BLOC,MUNGRM,HS,FROMDR,SCOLRM,SCOLAC
	READ(1) ODESC1,ODESC2,OFLAG1,OFLAG2,OFVAL,OTVAL,
	1	OSIZE,OCAPAC,OROOM,OADV,OCAN
	READ(1) RDESC1,RVAL,RFLAG,TRAVEL
	READ(1) AROOM,ASCORE,AVEHIC,ASTREN,AFLAG
	READ(1) FLAGS,SWITCH,VPROB,CFLAG,CTICK,CCNCEL
C
	CALL RSPEAK(599)
	CLOSE(UNIT=1)
	RETURN
C
100	CALL RSPEAK(598)			! cant do it.
	RETURN
C
200	CALL RSPEAK(600)			! obsolete version
	CLOSE (UNIT=1)
	RETURN
	END

C WALK- Move in specified direction
C
C Declarations
C
	LOGICAL FUNCTION WALK(X)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL FINDXT,QOPEN,LIT,PROB,MOVETO,RMDESC
C
C Functions and data
C
	QOPEN(O)=(OFLAG2(O).AND.OPENBT).NE.0

C WALK, PAGE 2
C
	WALK=.TRUE.				! assume wins.
	IF((WINNER.NE.PLAYER).OR.LIT(HERE).OR.PROB(25,25))
	1	GO TO 500
	IF(.NOT.FINDXT(PRSO,HERE)) GO TO 450	! invalid exit? grue!
	GO TO (400,200,100,300),XTYPE		! decode exit type.
	CALL BUG(9,XTYPE)
C
100	IF(CXAPPL(XACTIO).NE.0) GO TO 400	! cexit... returned room?
	IF(FLAGS(XFLAG)) GO TO 400		! no, flag on?
200	CALL JIGSUP(523)			! bad exit, grue!
	RETURN
C
300	IF(CXAPPL(XACTIO).NE.0) GO TO 400	! door... returned room?
	IF(QOPEN(XOBJ)) GO TO 400		! no, door open?
	CALL JIGSUP(523)			! bad exit, grue!
	RETURN
C
400	IF(LIT(XROOM1)) GO TO 900		! valid room, is it lit?
450	CALL JIGSUP(522)			! no, grue!
	RETURN
C
C Room is lit, or winner is not player (no grue).
C
500	IF(FINDXT(PRSO,HERE)) GO TO 550		! exit exist?
525	XSTRNG=678				! assume wall.
	IF(PRSO.EQ.XUP) XSTRNG=679		! if up, cant.
	IF(PRSO.EQ.XDOWN) XSTRNG=680		! if down, cant.
	IF((RFLAG(HERE).AND.RNWALL).NE.0) XSTRNG=524
	CALL RSPEAK(XSTRNG)
	PRSCON=0				! stop cmd stream.
	RETURN
C
550	GO TO (900,600,700,800),XTYPE		! branch on exit type.
	CALL BUG(9,XTYPE)
C
700	IF(CXAPPL(XACTIO).NE.0) GO TO 900	! cexit... returned room?
	IF(FLAGS(XFLAG)) GO TO 900		! no, flag on?
600	IF(XSTRNG.EQ.0) GO TO 525		! if no reason, use std.
	CALL RSPEAK(XSTRNG)			! deny exit.
	PRSCON=0				! stop cmd stream.
	RETURN
C
800	IF(CXAPPL(XACTIO).NE.0) GO TO 900	! door... returned room?
	IF(QOPEN(XOBJ)) GO TO 900		! no, door open?
	IF(XSTRNG.EQ.0) XSTRNG=525		! if no reason, use std.
	CALL RSPSUB(XSTRNG,ODESC2(XOBJ))
	PRSCON=0				! stop cmd stream.
	RETURN
C
900	WALK=MOVETO(XROOM1,WINNER)		! move to room.
	IF(WALK) WALK=RMDESC(0)			! describe room.
	RETURN
	END

C CXAPPL- Conditional exit processors
C
C Declarations
C
	INTEGER FUNCTION CXAPPL(RI)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	CXAPPL=0				! no return.
	IF(RI.EQ.0) RETURN			! if no action, done.
	GO TO (1000,2000,3000,4000,5000,6000,7000,8000,
	1	9000,10000,11000,12000,13000,14000,15000),RI
	CALL BUG(5,RI)

C CXAPPL, PAGE 2
C
C C1-	Coffin-cure
C
1000	EGYPTF=OADV(COFFI).NE.WINNER		! t if no coffin.
	RETURN
C
C C2-	Carousel exit
C C5-	Carousel out
C
2000	IF(CAROFF) RETURN			! if flipped, nothing.
2500	CALL RSPEAK(121)			! can't tell directions.
5000	I=XELNT(XCOND)*RND(8)			! choose random exit.
	XROOM1=(TRAVEL(REXIT(HERE)+I)).AND.XRMASK
	CXAPPL=XROOM1				! return exit.
	RETURN
C
C C3-	Chimney function
C
3000	LITLDF=.FALSE.				! assume heavy load.
	IF(DEADF) GO TO 3300			! if dead, always ok.
	J=0
	DO 3100 I=1,OLNT			! count objects.
	  IF(OADV(I).EQ.WINNER) J=J+1
3100	CONTINUE
C
	IF(J.GT.2) RETURN			! carrying too much?
	IF(J.NE.0) GO TO 3200			! carrying too little?
	XSTRNG=890				! bad idea.
	RETURN
C
3200	IF(OADV(LAMP).NE.WINNER) GO TO 3300	! no lamp?
	XSTRNG=446				! bad idea.
	RETURN
C
3300	LITLDF=.TRUE.				! he can do it.
	IF((OFLAG2(DOOR).AND.OPENBT).EQ.0)
	1	OFLAG2(DOOR)=OFLAG2(DOOR).AND. .NOT.TCHBT
	RETURN
C
C C4-	Frobozz flag (Magnet Room, fake exit)
C C6-	Frobozz flag (Magnet Room, real exit)
C
4000	IF(CAROFF) GO TO 2500			! if flipped, go spin.
	FROBZF=.FALSE.				! otherwise, not an exit.
	RETURN
C
6000	IF(CAROFF) GO TO 2500			! if flipped, go spin.
	FROBZF=.TRUE.				! otherwise, an exit.
	RETURN

C CXAPPL, PAGE 3
C
C C7-	Frobozz flag (bank alarm)
C
7000	FROBZF=.FALSE.				! assume fails.
	J=BILLS					! check for bills.
7100	IF(OADV(J).EQ.WINNER) RETURN		! winner's got it, fail.
	J=OCAN(J)				! get container.
	IF(J.NE.0) GO TO 7100			! if inside, loop
	J=PORTR					! check for portrait.
7200	IF(OADV(J).EQ.WINNER) RETURN		! winner's got it, fail.
	J=OCAN(J)				! get container.
	IF(J.NE.0) GO TO 7200			! if inside, loop
	FROBZF=.TRUE.				! wins.
	RETURN
C
C C8-	Frobozz flag (MRGO)
C
8000	FROBZF=.FALSE.				! assume cant move.
	IF(MLOC.NE.XROOM1) GO TO 8100		! mirror in way?
	IF((PRSO.EQ.XNORTH).OR.(PRSO.EQ.XSOUTH)) GO TO 8200
	IF(MOD(MDIR,180).NE.0) GO TO 8300	! mirror must be n-s.
	XROOM1=((XROOM1-MRA)*2)+MRAE		! calc east room.
	IF(PRSO.GT.XSOUTH) XROOM1=XROOM1+1	! if sw/nw, calc west.
8100	CXAPPL=XROOM1
	RETURN
C
8200	XSTRNG=814				! assume struc blocks.
	IF(MOD(MDIR,180).EQ.0) RETURN		! if mirror n-s, done.
8300	LDIR=MDIR				! see which mirror.
	IF(PRSO.EQ.XSOUTH) LDIR=180
	XSTRNG=815				! mirror blocks.
	IF(((LDIR.GT.180).AND..NOT.MR1F).OR.
	1  ((LDIR.LT.180).AND..NOT.MR2F)) XSTRNG=816 ! mirror broken.
	RETURN
C
C C9-	Frobozz flag (MIRIN)
C
9000	IF(MRHERE(HERE).NE.1) GO TO 9100	! mirror 1 here?
	IF(MR1F) XSTRNG=805			! see if broken.
	FROBZF=MROPNF				! enter if open.
	RETURN
C
9100	FROBZF=.FALSE.				! not here,
	XSTRNG=817				! lose.
	RETURN

C CXAPPL, PAGE 4
C
C C10-	Frobozz flag (mirror exit)
C
10000	FROBZF=.FALSE.				! assume cant.
	LDIR=((PRSO-XNORTH)/XNORTH)*45		! xlate dir to degrees.
	IF(.NOT.MROPNF .OR.
	1	((MOD(MDIR+270,360).NE.LDIR).AND.(PRSO.NE.XEXIT)))
	2	GO TO 10200			! exit via mirror?
	XROOM1=((MLOC-MRA)*2)+MRAE+1-(MDIR/180)	! assume e-w exit.
	IF(MOD(MDIR,180).EQ.0) GO TO 10100	! if n-s, ok.
	XROOM1=MLOC+1				! assume n exit.
	IF(MDIR.GT.180) XROOM1=MLOC-1		! if south.
10100	CXAPPL=XROOM1
	RETURN
C
10200	IF(.NOT.WDOPNF .OR.
	1	((MOD(MDIR+180,360).NE.LDIR).AND.(PRSO.NE.XEXIT)))
	2	RETURN				! exit via open door?
	XROOM1=MLOC+1				! assume n.
	IF(MDIR.EQ.0) XROOM1=MLOC-1		! if s.
	CALL RSPEAK(818)			! close door.
	WDOPNF=.FALSE.
	CXAPPL=XROOM1
	RETURN
C
C C11-	Maybe door.  Normal message is that door is closed.
C	But if LCELL.NE.4, door isn't there.
C
11000	IF(LCELL.NE.4) XSTRNG=678		! set up msg.
	RETURN
C
C C12-	Frobozz flag (Puzzle Room main entrance)
C
12000	FROBZF=.TRUE.				! always enter.
	CPHERE=10				! set substate.
	RETURN
C
C C13-	CPOUTF (Puzzle Room size entrance)
C
13000	CPHERE=52				! set substate.
	RETURN

C CXAPPL, PAGE 5
C
C C14-	Frobozz flag (Puzzle Room transitions)
C
14000	FROBZF=.FALSE.				! asssume lose.
	IF(PRSO.NE.XUP) GO TO 14100		! up?
	IF(CPHERE.NE.10) RETURN			! at exit?
	XSTRNG=881				! assume no ladder.
	IF(CPVEC(CPHERE+1).NE.-2) RETURN	! ladder here?
	CALL RSPEAK(882)			! you win.
	RFLAG(CPUZZ)=RFLAG(CPUZZ).AND..NOT.RSEEN	! reset seen.
	FROBZF=.TRUE.				! let him out.
	RETURN
C
14100	IF((CPHERE.NE.52).OR.(PRSO.NE.XWEST).OR..NOT.CPOUTF)
	1	GO TO 14200			! w exit at door?
	RFLAG(CPUZZ)=RFLAG(CPUZZ).AND..NOT.RSEEN	! reset seen.
	FROBZF=.TRUE.				! yes, let him out.
	RETURN
C
14200	IF((CPHERE.NE.52).OR.(PRSO.NE.XWEST)) GO TO 14250
	XSTRNG=932				! door in way.
	RETURN
C
14250	DO 14300 I=1,16,2			! locate exit.
	  IF(PRSO.EQ.CPDR(I)) GO TO 14400
14300	CONTINUE
	RETURN					! no such exit.
C
14400	J=CPDR(I+1)				! get directional offset.
	NXT=CPHERE+J				! get next state.
	K=8					! get orthogonal dir.
	IF(J.LT.0) K=-8
	IF((((IABS(J).EQ.1).OR.(IABS(J).EQ.8)).OR.
	1   ((CPVEC(CPHERE+K).EQ.0).OR.(CPVEC(NXT-K).EQ.0))).AND.
	2    (CPVEC(NXT).EQ.0)) GO TO 14500	! cant do it?
	RETURN
C
14500	CALL CPGOTO(NXT)			! move to state.
	XROOM1=CPUZZ				! stay in room.
	CXAPPL=XROOM1
	RETURN
C
C C15-	Frobozz flag (slide exit)
C
15000	FROBZF=.TRUE.				! works.
	IF((TTIE.EQ.0).OR.DEADF) RETURN		! if no rope or dead, cellar.
	IF(OROOM(TTIE).NE.HERE) RETURN		! if rope elsewhere, cellar.
	CALL RSPEAK(1014)			! slippery.
	CFLAG(CEVSLI)=.TRUE.			! turn on slide clock.
	CTICK(CEVSLI)=MAX0(2,100/WEIGHT(0,0,WINNER))
	XROOM1=SLID1				! on the ropes.
	CXAPPL=XROOM1
	RETURN
C
	END

C Room processors for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C RAPPLI- Room routines
C
C Declarations
C
	SUBROUTINE RAPPLI(RI)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QOPEN,QON,QHERE,PROB,F
	LOGICAL MOVETO,LIT,RMDESC,QEMPTY
C
C Functions and data
C
	QOPEN(R)=(OFLAG2(R).AND.OPENBT).NE.0
	QON(R)=(OFLAG1(R).AND.ONBT).NE.0
C
	IF(RI.EQ.0) RETURN			! return if naught.
	GO TO (  1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000,
	1 10000,11000,12000,13000,14000,15000,16000,17000,18000,19000,
	2 20000,21000,22000,23000,24000,25000,26000,27000,28000,29000,
	3 30000,31000,32000,33000,34000,35000,36000,37000,38000,39000,
	4 40000,41000,42000,43000,44000,45000,46000,47000,48000,49000,
	5 50000,51000,52000,53000,54000,55000,56000,57000,58000,59000,
	7 60000,61000,62000,63000),RI
	CALL BUG(1,RI)

C RAPPLI, PAGE 2
C
C R1--	East of house
C
1000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=13					! assume closed.
	IF(QOPEN(WINDO)) I=12			! if open, ajar.
	CALL RSPSUB(11,I)			! describe.
	RETURN
C
C R2--	Kitchen
C
2000	IF(PRSA.NE.LOOKW) GO TO 2100		! look?
	I=13					! assume closed.
	IF(QOPEN(WINDO)) I=12			! if open, ajar.
	CALL RSPSUB(14,I)			! describe.
	RETURN
C
2100	IF((PRSA.NE.WALKIW).OR.DEADF.OR..NOT.BROC1F.OR.BROC2F) RETURN
	CFLAG(CEVBRO)=.TRUE.			! send for brochure.
	CTICK(CEVBRO)=3
	RETURN
C
C R3--	Living Room
C
3000	IF(PRSA.NE.LOOKW) GO TO 3500		! look?
	I=15					! assume no hole.
	IF(MAGICF) I=16				! if magicf, cyclops hole.
	CALL RSPEAK(I)				! describe.
	I=17+ORRUG				! assume initial state.
	IF(QOPEN(DOOR)) I=I+2			! door open?
	CALL RSPEAK(I)				! describe.
	RETURN
C
C Not a look word, reevaluate trophy case.
C
3500	IF((PRSA.NE.TAKEW).AND.((PRSA.NE.PUTW).OR.(PRSI.NE.TCASE)))
	1	RETURN				! if not take or put.
	ASCORE(WINNER)=RWSCOR			! score trophy case.
	DO 3600 I=1,OLNT			! retain raw score as well.
	  J=I					! find out if in case.
3550	  J=OCAN(J)				! trace ownership.
	  IF(J.EQ.0) GO TO 3600
	  IF(J.NE.TCASE) GO TO 3550		! do all levels.
	  ASCORE(WINNER)=ASCORE(WINNER)+OTVAL(I)
3600	CONTINUE
	CALL SCRUPD(0)				! see if endgame trig.
	RETURN

C RAPPLI, PAGE 3
C
C R4--	Cellar
C
4000	IF(PRSA.NE.LOOKW) GO TO 4500		! look?
	CALL RSPEAK(21)				! describe cellar.
	IF(QOPEN(DOOR)) CALL RSPEAK(623)	! describe trap door if open.
	RETURN
C
4500	IF(PRSA.NE.WALKIW) RETURN		! walkin?
	IF((OFLAG2(DOOR).AND.(OPENBT+TCHBT)).NE.OPENBT) RETURN
	OFLAG2(DOOR)=(OFLAG2(DOOR).OR.TCHBT).AND. .NOT.OPENBT
	CALL RSPEAK(22)				! slam and bolt door.
	RETURN
C
C R5--	Grating Room
C
5000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(23)				! describe.
	I=24					! assume locked.
	IF(GRUNLF) I=26				! unlocked?
	IF(QOPEN(GRATE)) I=25			! open?
	CALL RSPEAK(I)				! describe grate.
	RETURN
C
C R6--	Clearing
C
6000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(27)				! describe.
	I=0					! assume no grating.
	IF(RVCLR.NE.0) I=28			! leaves moved?
	IF(QOPEN(GRATE)) I=29			! grate open?
	CALL RSPEAK(I)				! describe grate.
	RETURN

C RAPPLI, PAGE 4
C
C R7--	Reservoir south
C
7000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=31					! assume full.
	IF(LWTIDF) I=32				! if low tide, empty.
	CALL RSPEAK(I)				! describe.
	CALL RSPEAK(33)				! describe exits.
	RETURN
C
C R8--	Reservoir
C
8000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=34					! assume full.
	IF(LWTIDF) I=35				! if low tide, emtpy.
	CALL RSPEAK(I)				! describe.
	RETURN
C
C R9--	Reservoir north
C
9000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=36					! you get the idea.
	IF(LWTIDF) I=37
	CALL RSPEAK(I)
	CALL RSPEAK(38)
	RETURN
C
C R10--	Glacier Room
C
10000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(39)				! basic description.
	I=0					! assume no changes.
	IF(GLACMF) I=40				! partial melt?
	IF(GLACRF) I=41				! complete melt?
	CALL RSPEAK(I)				! describe.
	RETURN
C
C R11--	Forest Room
C
11000	IF(PRSA.NE.WALKIW) RETURN
	CFLAG(CEVFOR)=.TRUE.			! if walk in, birdie.
	CTICK(CEVFOR)=-1
	RETURN
C
C R12--	Mirror Room
C
12000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(42)				! describe.
	IF(MIRRMF) CALL RSPEAK(43)		! if broken, nasty remark.
	RETURN

C RAPPLI, PAGE 5
C
C R13--	Cave2
C
13000	IF(PRSA.NE.WALKIW) RETURN		! walkin?
	IF(PROB(50,50).OR.(OADV(CANDL).NE.WINNER).OR.
	1	.NOT.QON(CANDL)) RETURN		! blow em out?
	OFLAG1(CANDL)=OFLAG1(CANDL).AND. .NOT. ONBT	! yes.
	CALL RSPEAK(47)				! tell of winds.
	CFLAG(CEVCND)=.FALSE.			! halt candle countdown.
	IF(.NOT.LIT(HERE)) CALL RSPEAK(406)	! now pitch black.
	RETURN
C
C R14--	Boom Room
C
14000	J=ODESC2(CANDL)				! assume candle.
	IF((OADV(CANDL).EQ.WINNER).AND.QON(CANDL)) GO TO 14100
	J=ODESC2(TORCH)				! assume torch.
	IF((OADV(TORCH).EQ.WINNER).AND.QON(TORCH)) GO TO 14100
	J=ODESC2(MATCH)
	IF((OADV(MATCH).EQ.WINNER).AND.QON(MATCH)) GO TO 14100
	RETURN					! safe
C
14100	IF((PRSA.NE.TRNONW).AND.(PRSA.NE.BURNW))
	1	GO TO 14200			! turn on or burn?
	CALL RSPSUB(294,J)			! boom!
	CALL JIGSUP(44)
	RETURN
C
14200	IF(PRSA.NE.WALKIW) RETURN		! walkin?
	CALL RSPSUB(295,J)			! boom!
	CALL JIGSUP(44)
	RETURN
C
C R15--	No-objs
C
15000	EMPTHF=.TRUE.				! assume true.
	DO 15100 I=1,OLNT			! see if carrying.
	  IF(OADV(I).EQ.WINNER) EMPTHF=.FALSE.
15100	CONTINUE
C
	IF((HERE.NE.BSHAF).OR.(.NOT.LIT(HERE))) RETURN
	CALL SCRUPD(LTSHFT)			! score light shaft.
	LTSHFT=0				! never again.
	RETURN

C RAPPLI, PAGE 6
C
C R16--	Machine Room
C
16000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=46					! assume lid closed.
	IF(QOPEN(MACHI)) I=12			! if open, open.
	CALL RSPSUB(45,I)			! describe.
	RETURN
C
C R17--	Bat Room
C
17000	IF(PRSA.NE.LOOKW) GO TO 17500		! look?
	CALL RSPEAK(48)				! describe room.
	IF(OADV(GARLI).EQ.WINNER) CALL RSPEAK(49) ! bat holds nose.
	RETURN
C
17500	IF((PRSA.NE.WALKIW).OR.(OADV(GARLI).EQ.WINNER)
	1	.OR.DEADF) RETURN		! garlic or dead?
	CALL RSPEAK(50)				! time to fly, jack.
	F=MOVETO(BATDRP(RND(9)+1),WINNER)	! select random dest.
	F=RMDESC(0)				! new room description.
	RETURN
C
C R18--	Dome Room
C
18000	IF(PRSA.NE.LOOKW) GO TO 18500		! look?
	CALL RSPEAK(51)				! describe.
	IF(DOMEF) CALL RSPEAK(52)		! if rope, describe.
	RETURN
C
18500	IF(PRSA.EQ.LEAPW) CALL JIGSUP(53)	! did he jump???
	RETURN
C
C R19--	Torch Room
C
19000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(54)				! describe.
	IF(DOMEF) CALL RSPEAK(55)		! if rope, describe.
	RETURN
C
C R20--	Carousel Room
C
20000	IF(PRSA.NE.LOOKW) GO TO 20500		! look?
	CALL RSPEAK(56)				! describe.
	IF(.NOT.(CAROFF.OR.DEADF)) CALL RSPEAK(57) ! if not flipped, spin.
	RETURN
C
20500	IF((PRSA.EQ.WALKIW).AND.CAROZF.AND..NOT.DEADF)
	1	CALL JIGSUP(58)			! walked in, zoom, not dead.
	RETURN

C RAPPLI, PAGE 7
C
C R21--	Land of the Living Dead
C
21000	IF(PRSA.NE.LOOKW) GO TO 21100		! look?
	CALL RSPEAK(59)				! describe.
	IF(.NOT.LLDF) CALL RSPEAK(60)		! if not vanished, ghosts.
	RETURN
C
21100	IF(LLDF.OR.(PRSA.NE.RINGW).OR.(PRSO.NE.BELL))
	1	GO TO 21200			! ring bell?
	EXORBF=.TRUE.				! set exorcism bell flag.
	CALL NEWSTA(BELL,0,0,0,0)		! vanish bell.
	CALL NEWSTA(HBELL,967,HERE,0,0)		! insert hot bell.
	LASTIT=HBELL				! update parser.
	IF(.NOT.QON(CANDL).OR.(OADV(CANDL).NE.WINNER))
	1	GO TO 21150			! carrying lit candles?
	CALL NEWSTA(CANDL,968,HERE,0,0)		! drop and go out.
	OFLAG1(CANDL)=OFLAG1(CANDL).AND..NOT.ONBT
	CFLAG(CEVCND)=.FALSE.			! disable candle timer.
21150	CFLAG(CEVXB)=.TRUE.			! start bell timer.
	CTICK(CEVXB)=6
	CFLAG(CEVXBH)=.TRUE.			! start cooling timer.
	CTICK(CEVXBH)=20
	RETURN
C
21200	IF(.NOT.EXORBF.OR.EXORCF.OR.(OADV(CANDL).NE.WINNER).OR.
	1	((OFLAG1(CANDL).AND.ONBT).EQ.0)) GO TO 21300
	EXORCF=.TRUE.				! set exorcism candle flag.
	CALL RSPEAK(969)
	CFLAG(CEVXB)=.FALSE.			! turn off bell timer.
	CFLAG(CEVXC)=.TRUE.			! turn on candle timer.
	CTICK(CEVXC)=3
	RETURN
C
21300	IF(.NOT.EXORCF.OR.(PRSA.NE.READW).OR.(PRSO.NE.BOOK))
	1	GO TO 21400			! read book?
	CALL NEWSTA(GHOST,63,0,0,0)		! exorcism complete.
	LLDF=.TRUE.				! set flag.
	CFLAG(CEVXC)=.FALSE.			! turn off candle timer.
	RETURN
C
21400	IF(PRSA.NE.EXORCW) RETURN		! trying exorcism?
	IF((OADV(BELL).EQ.WINNER).AND.(OADV(BOOK).EQ.WINNER).AND.
	1	(OADV(CANDL).EQ.WINNER).AND.QON(CANDL)) GO TO 21500
	CALL RSPEAK(62)				! not equipped.
	RETURN
C
21500	IF(LLDF) GO TO 21600			! trying again?
	CALL RSPEAK(1044)			! must do it the hard way.
	RETURN
C
21600	CALL JIGSUP(61)				! twice, exorcise you.
	RETURN

C RAPPLI, PAGE 7A
C
C R22--	Land of the Living Dead interior
C
22000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(64)				! describe.
	IF(ONPOLF) CALL RSPEAK(65)		! on pole?
	RETURN
C
C R23--	Dam Room
C
23000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(66)				! describe.
	I=67
	IF(LWTIDF) I=68
	CALL RSPEAK(I)				! describe reservoir.
	CALL RSPEAK(69)				! describe panel.
	IF(GATEF) CALL RSPEAK(70)		! bubble is glowing.
	RETURN
C
C R24--	Tree Room
C
24000	IF(PRSA.NE.LOOKW) GO TO 24300		! look?
	CALL RSPEAK(660)			! describe.
	I=661					! set flag for below.
	DO 24200 J=1,OLNT			! describe obj in fore3.
	  IF(.NOT.QHERE(J,FORE3).OR.(J.EQ.FTREE)) GO TO 24200
	  CALL RSPEAK(I)			! set stage,
	  I=0
	  CALL RSPSUB(502,ODESC2(J))		! describe.
24200	CONTINUE
	RETURN
C
24300	IF(PRSA.NE.WALKIW) GO TO 24400		! walk in?
	CFLAG(CEVFOR)=.TRUE.			! start forest noise timer.
	CTICK(CEVFOR)=-1
	RETURN
C
24400	IF(PRSA.NE.DROPW) RETURN		! drop?
	DO 24600 I=1,OLNT			! loop through objects
	  IF((I.EQ.TTREE).OR.(I.EQ.NEST).OR.
	1	.NOT.QHERE(I,HERE)) GO TO 24600 !  is it here?
	  IF(I.EQ.EGG) GO TO 24500		! egg?
	  CALL NEWSTA(I,0,FORE3,0,0)		! no, drop to forest floor.
	  CALL RSPSUB(659,ODESC2(I))
	  GO TO 24600
C
24500	  CALL NEWSTA(EGG,0,0,0,0)		! vanish egg.
	  CALL NEWSTA(BEGG,658,FORE3,0,0)	! insert broken egg.
	  OTVAL(BEGG)=2
	  IF(OCAN(CANAR).NE.EGG) GO TO 24550	! canary inside?
	  OTVAL(BCANA)=1
	  GO TO 24600
24550	  CALL NEWSTA(BCANA,0,0,0,0)		! no, vanish broken canary.
24600	CONTINUE
	RETURN

C RAPPLI, PAGE 8
C
C R25--	Cyclops Room
C
25000	IF(PRSA.NE.LOOKW) GO TO 25100		! look?
	CALL RSPEAK(606)			! describe.
	I=607					! assume basic state.
	IF(RVCYC.GT.0) I=608			! >0?  hungry.
	IF(RVCYC.LT.0) I=609			! <0?  thirsty.
	IF(CYCLOF) I=610			! asleep?
	IF(MAGICF) I=611			! gone?
	CALL RSPEAK(I)				! describe.
	RETURN
C
25100	IF((PRSA.NE.WALKIW).OR.(RVCYC.EQ.0).OR.DEADF) RETURN
	CFLAG(CEVCYC)=.TRUE.			! walked in, restart timer.
	CTICK(CEVCYC)=-1
	RETURN
C
C R26--	Bank Box Room
C
26000	IF(PRSA.NE.WALKIW) RETURN		! surprise him.
	DO 26100 I=1,8,2			! scolrm depends on
	  IF(FROMDR.EQ.SCOLDR(I)) SCOLRM=SCOLDR(I+1)
26100	CONTINUE				! entry direction.
	RETURN
C
C R27--	Treasure Room
C
27000	IF((PRSA.NE.WALKIW).OR.DEADF.OR..NOT.THFACT)
	1	RETURN				! walkin, thief active?
	IF(OROOM(THIEF).NE.HERE)
	1	CALL NEWSTA(THIEF,82,HERE,0,0)	! no, materialize him.
	THFPOS=HERE				! reset search pattern.
	OFLAG2(THIEF)=OFLAG2(THIEF).OR.FITEBT	! he's angry.
C
C Vanish everything in room.
C
	J=0					! assume nothing to vanish.
	DO 27200 I=1,OLNT
	  IF((I.EQ.CHALI).OR.(I.EQ.THIEF).OR..NOT.QHERE(I,HERE))
	1	GO TO 27200			! here?
	  J=83					! flag byebye.
	  OFLAG1(I)=OFLAG1(I).AND..NOT.VISIBT	! away it goes.
27200	CONTINUE
	CALL RSPEAK(J)				! describe.
	RETURN
C
C R28--	Cliff Room
C
28000	DEFLAF=OADV(RBOAT).NE.WINNER		! true if not carrying.
	RETURN

C RAPPLI, PAGE 9
C
C R29--	Rivr4 Room
C
29000	IF(BUOYF.OR.(OADV(BUOY).NE.WINNER)) RETURN
	CALL RSPEAK(84)				! give hint,
	BUOYF=.TRUE.				! then disable.
	RETURN
C
C R30--	Overfalls
C
30000	IF(PRSA.NE.LOOKW) CALL JIGSUP(85)	! over you go.
	RETURN
C
C R31--	Slide Ledge
C
31000	IF(PRSA.NE.WALKIW) RETURN		! walk in?
	CFLAG(CEVSLI)=.FALSE.			! disable slippery rope.
	RETURN
C
C R32--	Slide
C
32000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(1012)			! describe.
	IF(TTIE.EQ.0) RETURN			! timber tied?
	IF(OROOM(TTIE).EQ.HERE) CALL RSPSUB(1013,ODESC2(TTIE))
	RETURN
C
C R33--	Aragain Falls
C
33000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(96)				! describe.
	I=97					! assume no rainbow.
	IF(RAINBF) I=98				! got one?
	CALL RSPEAK(I)				! describe.
	RETURN

C RAPPLI, PAGE 10
C
C R34--	Ledge Room
C
34000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(100)			! describe.
	I=102					! assume safe room ok.
	IF((RFLAG(MSAFE).AND.RMUNG).NE.0) I=101	! if munged, room gone.
	CALL RSPEAK(I)				! describe.
	RETURN
C
C R35--	Safe Room
C
35000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(104)			! describe.
	I=105					! assume ok.
	IF(SAFEF) I=106				! blown?
	CALL RSPEAK(I)				! describe.
	RETURN
C
C R36--	Magnet Room
C
36000	IF(PRSA.NE.LOOKW) GO TO 36500		! look?
	CALL RSPEAK(107)			! describe.
	RETURN
C
36500	IF((PRSA.NE.WALKIW).OR.DEADF.OR..NOT.CAROFF) RETURN	! walkin?
	IF(CAROZF) GO TO 36600			! zoom?
	CALL RSPEAK(108)			! no, spin his compass.
	RETURN
C
36600	I=58					! spin his insides.
	IF(WINNER.NE.PLAYER) I=99		! spin robot.
	CALL JIGSUP(I)				! dead.
	RETURN
C
C R37--	Cage Room
C
37000	IF(CAGESF) F=MOVETO(CAGER,WINNER)	! if solved, move.
	RETURN

C RAPPLI, PAGE 11
C
C R38--	Mirror D Room
C
38000	IF(PRSA.EQ.LOOKW) CALL LOOKTO(FDOOR,MRG,0,682,681)
	RETURN
C
C R39--	Mirror G Room
C
39000	IF(PRSA.EQ.WALKIW) CALL JIGSUP(685)
	RETURN
C
C R40--	Mirror C Room
C
40000	IF(PRSA.EQ.LOOKW) CALL LOOKTO(MRG,MRB,683,0,681)
	RETURN
C
C R41--	Mirror B Room
C
41000	IF(PRSA.EQ.LOOKW) CALL LOOKTO(MRC,MRA,0,0,681)
	RETURN
C
C R42--	Mirror A Room
C
42000	IF(PRSA.EQ.LOOKW) CALL LOOKTO(MRB,0,0,684,681)
	RETURN

C RAPPLI, PAGE 12
C
C R43--	Mirror C East/West
C
43000	IF(PRSA.EQ.LOOKW) CALL EWTELL(HERE,683)
	RETURN
C
C R44--	Mirror B East/West
C
44000	IF(PRSA.EQ.LOOKW) CALL EWTELL(HERE,686)
	RETURN
C
C R45--	Mirror A East/West
C
45000	IF(PRSA.EQ.LOOKW) CALL EWTELL(HERE,687)
	RETURN
C
C R46--	Inside Mirror
C
46000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(688)			! describe
C
C Now describe pole state.
C
C Cases 1,2--	MDIR=270 & MLOC=MRB, pole is up or in hole
C Cases 3,4--	MDIR=0 V MDIR=180, pole is up or in channel
C Case 5--	Pole is up
C
	I=689					! assume case 5.
	IF((MDIR.EQ.270).AND.(MLOC.EQ.MRB))
	1	I=690+MIN0(POLEUF,1)		! cases 1,2.
	IF(MOD(MDIR,180).EQ.0)
	1	I=692+MIN0(POLEUF,1)		! cases 3,4.
	CALL RSPEAK(I)				! describe pole.
	CALL RSPSUB(694,695+(MDIR/45))		! describe arrow.
	RETURN

C RAPPLI, PAGE 13
C
C R47--	Mirror Eye Room
C
47000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=704					! assume beam stop.
	DO 47100 J=1,OLNT
	  IF(QHERE(J,HERE).AND.(J.NE.RBEAM)) GO TO 47200
47100	CONTINUE
	I=703
47200	CALL RSPSUB(I,ODESC2(J))		! describe beam.
	CALL LOOKTO(MRA,0,0,0,0)		! look north.
	RETURN
C
C R48--	Inside Crypt
C
48000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=46					! crypt is open/closed.
	IF(QOPEN(TOMB)) I=12
	CALL RSPSUB(705,I)
	RETURN
C
C R49--	South Corridor
C
49000	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL RSPEAK(706)			! describe.
	I=46					! odoor is open/closed.
	IF(QOPEN(ODOOR)) I=12
	IF(LCELL.EQ.4) CALL RSPSUB(707,I)	! describe odoor if there.
	RETURN
C
C R50--	Behind Door
C
50000	IF(PRSA.NE.WALKIW) GO TO 50100		! walk in?
	CFLAG(CEVFOL)=.TRUE.			! master follows.
	CTICK(CEVFOL)=-1
	RETURN
C
50100	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=46					! qdoor is open/closed.
	IF(QOPEN(QDOOR)) I=12
	CALL RSPSUB(708,I)
	RETURN

C RAPPLI, PAGE 14
C
C R51--	Front Door
C
51000	IF(PRSA.EQ.WALKIW) CTICK(CEVFOL)=0	! if exits, kill follow.
	IF(PRSA.NE.LOOKW) RETURN		! look?
	CALL LOOKTO(0,MRD,709,0,0)		! describe south.
	I=46					! panel is open/closed.
	IF(CFLAG(CEVINQ).AND.(CTICK(CEVINQ).NE.0)) I=12	! open if inq in prog.
	J=46					! qdoor is open/closed.
	IF(QOPEN(QDOOR)) J=12
	CALL RSPSB2(710,I,J)
	RETURN
C
C R52--	North Corridor
C
52000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=46
	IF(QOPEN(CDOOR)) I=12			! cdoor is open/closed.
	CALL RSPSUB(711,I)
	RETURN
C
C R53--	Parapet
C
53000	IF(PRSA.EQ.LOOKW) CALL RSPSUB(712,712+PNUMB)
	RETURN
C
C R54--	Cell
C
54000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=721					! cdoor is open/closed.
	IF(QOPEN(CDOOR)) I=722
	CALL RSPEAK(I)
	I=46					! odoor is open/closed.
	IF(QOPEN(ODOOR)) I=12
	IF(LCELL.EQ.4) CALL RSPSUB(723,I)	! describe.
	RETURN
C
C R55--	Prison Cell
C
55000	IF(PRSA.EQ.LOOKW) CALL RSPEAK(724)	! look?
	RETURN
C
C R56--	Nirvana Cell
C
56000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=46					! odoor is open/closed.
	IF(QOPEN(ODOOR)) I=12
	CALL RSPSUB(725,I)
	RETURN

C RAPPLI, PAGE 15
C
C R57--	Nirvana and end of game
C
57000	IF(PRSA.NE.WALKIW) RETURN		! walkin?
	CALL RSPEAK(726)
	CALL SCORE(.FALSE.)
	CLOSE(UNIT=DBCH)
	CALL EXIT
C
C R58--	Tomb Room
C
58000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=46					! tomb is open/closed.
	IF(QOPEN(TOMB)) I=12
	CALL RSPSUB(792,I)
	RETURN
C
C R59--	Puzzle Side Room
C
59000	IF(PRSA.NE.LOOKW) RETURN		! look?
	I=861					! assume door closed.
	IF(CPOUTF) I=862			! open?
	CALL RSPEAK(I)				! describe.
	RETURN
C
C R60--	Puzzle Room
C
60000	IF(PRSA.NE.LOOKW) RETURN		! look?
	IF(CPUSHF) GO TO 60100			! started puzzle?
	CALL RSPEAK(868)			! no, describe.
	IF((OFLAG2(WARNI).AND.TCHBT).NE.0) CALL RSPEAK(869)
	RETURN
C
60100	CALL CPINFO(880,CPHERE)			! describe room.
	RETURN

C RAPPLI, PAGE 16
C
C R61--	Palantir Room
C
61000	IF(PRSA.NE.LOOKW) GO TO 62400		! look?
	CALL RSPEAK(1015)
	I=699					! string is south.
	GO TO 62100				! join common code.
C
C R62--	Prm Room
C
62000	IF(PRSA.NE.LOOKW) GO TO 62400		! look?
	CALL RSPEAK(1016)			! string is north.
	I=695
C
62100	IF(PLOOKF) GO TO 62400			! thru window? skip door.
	CALL RSPSUB(1017,I)
	I=1018					! assume lid open.
	IF(.NOT.QOPEN(HERE-PRM+PLID1)) I=1019	! closed.
	CALL RSPEAK(I)				! describe lock.
	DO 62200 I=1,OLNT			! loop through objects.
	  IF(OCAN(I).NE.(HERE-PRM+PKH1)) GO TO 62200
	  CALL RSPSUB(1020,ODESC2(I))		! object in keyhole.
	  GO TO 62300
62200	CONTINUE
C
62300	IF(QOPEN(PDOOR)) CALL RSPEAK(1042)	! door open?
	IF(.NOT.MATF) GO TO 62400		! mat under door?
	CALL RSPEAK(1021)
	IF((MATOBJ.NE.0).AND.((HERE.EQ.PALRM).OR.QOPEN(PDOOR)))
	1	CALL RSPSUB(1022,ODESC2(MATOBJ))	! obj on mat?
	GO TO 62400
C
62400	PLOOKF=.FALSE.				! clear window flag.
	IF(PRSO.EQ.0) RETURN			! any object?
	IF((PRSA.NE.TAKEW).OR..NOT.QEMPTY(HERE-PRM+PKH1).OR.
	1  ((PRSO.NE.SCREW).AND.(PRSO.NE.STICK).AND.
	2   (PRSO.NE.PKEY).AND.(PRSO.NE.KEYS))) GO TO 62500
	IF(.NOT.PTOUCF) GO TO 62450		! touched?
	IF(QOPEN(HERE-PRM+PLID1)) CALL RSPEAK(1043)   	! lid closes.
	OFLAG2(HERE-PRM+PLID1)=OFLAG2(HERE-PRM+PLID1).AND..NOT.OPENBT
62450	PTOUCF=.TRUE.				! touched now.
C
62500	OFLAG1(SCREW)=OFLAG1(SCREW).AND..NOT.NDSCBT
	IF((OCAN(SCREW).EQ.PKH1).OR.(OCAN(SCREW).EQ.PKH2))
	1	OFLAG1(SCREW)=OFLAG1(SCREW).OR.NDSCBT
	OFLAG1(STICK)=OFLAG1(STICK).AND..NOT.NDSCBT
	IF((OCAN(STICK).EQ.PKH1).OR.(OCAN(STICK).EQ.PKH2))
	1	OFLAG1(STICK)=OFLAG1(STICK).OR.NDSCBT
	OFLAG1(PKEY)=OFLAG1(PKEY).AND..NOT.NDSCBT
	IF((OCAN(PKEY).EQ.PKH1).OR.(OCAN(PKEY).EQ.PKH2))
	1	OFLAG1(PKEY)=OFLAG1(PKEY).OR.NDSCBT
	OFLAG1(KEYS)=OFLAG1(KEYS).AND..NOT.NDSCBT
	IF((OCAN(KEYS).EQ.PKH1).OR.(OCAN(KEYS).EQ.PKH2))
	1	OFLAG1(KEYS)=OFLAG1(KEYS).OR.NDSCBT
	IF((OROOM(MAT).NE.PRM).AND.(OROOM(MAT).NE.PALRM)) MATF=.FALSE.
	OFLAG1(MAT)=OFLAG1(MAT).AND..NOT.NDSCBT
	IF(.NOT.MATF) RETURN
	OFLAG1(MAT)=OFLAG1(MAT).OR.NDSCBT
	CALL NEWSTA(MAT,0,HERE,0,0)
	RETURN
C
C R63--	Inslide
C
63000	DO 63100 I=1,OLNT			! loop through objects
	  IF(.NOT.QHERE(I,HERE).OR.
	1	((OFLAG1(I).AND.TAKEBT).EQ.0)) GO TO 63100
	  CALL NEWSTA(I,0,CELLA,0,0)
	  CALL RSPSUB(1011,ODESC2(I))
63100	CONTINUE
	RETURN
C
	END

C LOOKTO--	Describe view in mirror hallway
C
C Declarations
C
	SUBROUTINE LOOKTO(NRM,SRM,NT,ST,HT)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	CALL RSPEAK(HT)				! describe hall.
	CALL RSPEAK(NT)				! describe north view.
	CALL RSPEAK(ST)				! describe south view.
	DIR=0					! assume no direction.
	IF(IABS(MLOC-HERE).NE.1) GO TO 200	! mirror to n or s?
	IF(MLOC.EQ.NRM) DIR=695
	IF(MLOC.EQ.SRM) DIR=699			! dir=n/s.
	IF(MOD(MDIR,180).NE.0) GO TO 100	! mirror n-s?
	CALL RSPSUB(847,DIR)			! yes, he sees panel
	CALL RSPSB2(848,DIR,DIR)		! and narrow rooms.
	GO TO 200
C
100	M1=MRHERE(HERE)				! which mirror?
	MRBF=0					! assume intact.
	IF(((M1.EQ.1).AND..NOT.MR1F).OR.
	1  ((M1.EQ.2).AND..NOT.MR2F)) MRBF=1	! broken?
	CALL RSPSUB(849+MRBF,DIR)		! describe.
	IF((M1.EQ.1).AND.MROPNF) CALL RSPEAK(823+MRBF)
	IF(MRBF.NE.0) CALL RSPEAK(851)
C
200	I=0					! assume no more to do.
	IF((NT.EQ.0).AND.((DIR.EQ.0).OR.(DIR.EQ.699))) I=852
	IF((ST.EQ.0).AND.((DIR.EQ.0).OR.(DIR.EQ.695))) I=853
	IF((NT+ST+DIR).EQ.0) I=854
	IF(HT.NE.0) CALL RSPEAK(I)		! describe halls.
	RETURN
C
	END

C EWTELL--	Describe e/w narrow rooms
C
C Declarations
C
	SUBROUTINE EWTELL(RM,ST)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL M1
C
C Note that we are east or west of mirror, and
C mirror must be n-s.
C
	M1=(MDIR+(MOD(RM-MRAE,2)*180)).EQ.180
	I=MOD(RM-MRAE,2)			! get basic e/w flag.
	IF((M1.AND..NOT.MR1F).OR.(.NOT.M1.AND..NOT.MR2F))
	1	I=I+2				! mirror broken?
	CALL RSPEAK(819+I)
	IF(M1.AND.MROPNF) CALL RSPEAK(823+(I/2))
	CALL RSPEAK(825)
	CALL RSPEAK(ST)
	RETURN
C
	END

C Clock events, demons, actors for DUNGEON.
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C CLOCKD- Intermove clock events demon
C
C Declarations
C
	LOGICAL FUNCTION CLOCKD(X)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	CLOCKD=.FALSE.				! assume no action.
	DO 100 I=1,CLNT
	  IF(.NOT.CFLAG(I) .OR.(CTICK(I).EQ.0)) GO TO 100
	  IF(CTICK(I).LT.0) GO TO 50		! permanent entry?
	  CTICK(I)=CTICK(I)-1
	  IF(CTICK(I).NE.0) GO TO 100		! timer expired?
50	  CLOCKD=.TRUE.
	  CALL CEVAPP(CACTIO(I))		! do action.
100	CONTINUE
	RETURN
C
	END

C CEVAPP- Clock event applicables
C
C Declarations
C
	SUBROUTINE CEVAPP(RI)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	INTEGER CNDTCK(10),LMPTCK(12)
	LOGICAL FINDXT,LIT,RMDESC,QOPEN,MOVETO
	LOGICAL F,QLEDGE,QVAIR,QHERE,PROB,WASLIT
C
C Functions and data
C
	QOPEN(R)=(OFLAG2(R).AND.OPENBT).NE.0
	QLEDGE(R)=(R.EQ.LEDG2).OR.(R.EQ.LEDG3).OR.(R.EQ.LEDG4).OR.
	1	(R.EQ.VLBOT)
	QVAIR(R)=(R.EQ.VAIR1).OR.(R.EQ.VAIR2).OR.(R.EQ.VAIR3).OR.
	1	 (R.EQ.VAIR4)
	DATA CNDTCK/50,20,10,5,0,156,156,156,157,0/
	DATA LMPTCK/50,30,20,10,4,0,154,154,154,154,155,0/
C
	IF(RI.EQ.0) RETURN			! ignore disabled.
	WASLIT=LIT(HERE)
	GO TO (1000,2000,3000,4000,5000,6000,7000,8000,9000,10000,
	1 11000,12000,13000,14000,15000,16000,17000,18000,19000,
	2 20000,21000,22000,23000,24000,25000,26000,27000,28000,
	3 29000,30000),RI
	CALL BUG(3,RI)
C
C Return here to test for change in light.
C
50	IF(WASLIT.AND..NOT.LIT(HERE)) CALL RSPEAK(406)
	RETURN

C CEVAPP, PAGE 2
C
C CEV1--	Cure clock.  Let player slowly recover.
C
1000	ASTREN(PLAYER)=MIN0(0,ASTREN(PLAYER)+1)	! recover.
	IF(ASTREN(PLAYER).GE.0) RETURN		! fully recovered?
	CFLAG(CEVCUR)=.TRUE.
	CTICK(CEVCUR)=30			! no, wait some more.
	RETURN
C
C CEV2--	Maint-room with leak.  Raise the water level.
C
2000	IF(HERE.EQ.MAINT) CALL RSPEAK(71+(RVMNT/2)) ! describe.
	RVMNT=RVMNT+1				! raise water level.
	IF(RVMNT.LE.16) RETURN			! if not full, exit.
	CTICK(CEVMNT)=0				! full, disable clock.
	RFLAG(MAINT)=RFLAG(MAINT).OR.RMUNG	! mung room.
	RDESC1(MAINT)=80			! say it is full of water.
	IF(HERE.EQ.MAINT) CALL JIGSUP(81)	! drown him if present.
	RETURN
C
C CEV3--	Lantern.  Describe growing dimness.
C
3000	CALL LITINT(LAMP,ORLAMP,CEVLNT,LMPTCK,12) ! do light interrupt.
	GO TO 50				! go see if now dark.
C
C CEV4--	Match.  Out it goes.
C
4000	CALL RSPEAK(153)			! match is out.
	OFLAG1(MATCH)=OFLAG1(MATCH).AND. .NOT.(ONBT+FLAMBT+LITEBT)
	GO TO 50				! go see if now dark.
C
C CEV5--	Candle.  Describe growing dimness.
C
5000	CALL LITINT(CANDL,ORCAND,CEVCND,CNDTCK,10) ! do candle interrupt.
	GO TO 50				! go see if now dark.

C CEVAPP, PAGE 3
C
C CEV6--	Balloon.
C
6000	CFLAG(CEVBAL)=.TRUE.
	CTICK(CEVBAL)=3				! reschedule interrupt.
	F=AVEHIC(WINNER).EQ.BALLO		! see if in balloon.
	IF(BLOC.EQ.VLBOT) GO TO 6800		! at bottom?
	IF(QLEDGE(BLOC)) GO TO 6700		! on ledge?
	IF(QOPEN(RECEP).AND.(BINFF.NE.0))
	1	GO TO 6500			! inflated and recep open?
C
C Balloon is in midair and is deflated (or has receptacle closed).
C Fall to next room.
C
	IF(BLOC.NE.VAIR1) GO TO 6300		! in vair1?
	BLOC=VLBOT				! yes, now at vlbot.
	CALL NEWSTA(BALLO,0,BLOC,0,0)
	IF(F) GO TO 6200			! in balloon?
	IF(QLEDGE(HERE).OR.(HERE.EQ.VLBOT))
	1	CALL RSPEAK(530)		! on ledge, describe.
	RETURN
C
6200	F=MOVETO(BLOC,WINNER)			! move him.
	IF(BINFF.EQ.0) GO TO 6250		! in balloon.  inflated?
	CALL RSPEAK(531)			! yes, landed.
	F=RMDESC(0)				! describe.
	RETURN
C
6250	CALL NEWSTA(BALLO,532,0,0,0)		! no, balloon & contents die.
	CALL NEWSTA(DBALL,0,BLOC,0,0)		! insert dead balloon.
	AVEHIC(WINNER)=0			! not in vehicle.
	CFLAG(CEVBAL)=.FALSE.			! disable interrupts.
	CFLAG(CEVBRN)=.FALSE.
	BINFF=0
	BTIEF=0
	RETURN
C
6300	BLOC=BLOC-1				! not in vair1, descend.
	CALL NEWSTA(BALLO,0,BLOC,0,0)
	IF(F) GO TO 6400			! is he in balloon?
	IF(QLEDGE(HERE).OR.(HERE.EQ.VLBOT))
	1	CALL RSPEAK(533)		! if on ledge, describe.
	RETURN
C
6400	F=MOVETO(BLOC,WINNER)			! in balloon, move him.
	CALL RSPEAK(534)			! describe.
	F=RMDESC(0)
	RETURN
C
C Balloon is in midair and is inflated, up-up-and-away! 
c
6500	IF(BLOC.NE.VAIR4) GO TO 6600		! at vair4?
	CFLAG(CEVBRN)=.FALSE.			! disable interrupts.
	CFLAG(CEVBAL)=.FALSE.
	BINFF=0
	BTIEF=0
	BLOC=VLBOT				! fall to bottom.
	CALL NEWSTA(BALLO,0,0,0,0)		! balloon & contents die.
	CALL NEWSTA(DBALL,0,BLOC,0,0)		! substitute dead balloon.
	IF(F) GO TO 6550			! was he in it?
	IF(QLEDGE(HERE)) CALL RSPEAK(535)	! if he can see, describe.
	IF(HERE.EQ.VLBOT) CALL RSPEAK(925)	! if at bottom, describe
	RETURN
C
6550	CALL JIGSUP(536)			! in balloon at crash, die.
	RETURN
C
6600	BLOC=BLOC+1				! not at vair4, go up.
	CALL NEWSTA(BALLO,0,BLOC,0,0)
	IF(F) GO TO 6650			! in balloon?
	IF(QLEDGE(HERE).OR.(HERE.EQ.VLBOT))
	1	CALL RSPEAK(537)		! can he see it?
	RETURN
C
6650	F=MOVETO(BLOC,WINNER)			! move player.
	CALL RSPEAK(538)			! describe.
	F=RMDESC(0)
	RETURN
C
C On ledge, goes to midair room whether inflated or not.
C
6700	BLOC=BLOC+(VAIR2-LEDG2)			! move to midair.
	CALL NEWSTA(BALLO,0,BLOC,0,0)
	IF(F) GO TO 6750			! in balloon?
	IF(QLEDGE(HERE).OR.(HERE.EQ.VLBOT))
	1	CALL RSPEAK(539)		! no, stranded.
	CFLAG(CEVVLG)=.TRUE.
	CTICK(CEVVLG)=10			! materialize gnome.
	RETURN
C
6750	F=MOVETO(BLOC,WINNER)			! move to new room.
	CALL RSPEAK(540)			! describe.
	F=RMDESC(0)
	RETURN
C
C At bottom, go up if inflated, do nothing if deflated.
C
6800	IF((BINFF.EQ.0).OR..NOT.QOPEN(RECEP)) RETURN
	BLOC=VAIR1				! inflated and open,
	CALL NEWSTA(BALLO,0,BLOC,0,0)		! go up to vair1.
	IF(F) GO TO 6850			! in balloon?
	IF(QLEDGE(HERE).OR.(HERE.EQ.VLBOT))
	1	CALL RSPEAK(541)		! if can see, describe.
	RETURN
C
6850	F=MOVETO(BLOC,WINNER)			! move player.
	CALL RSPEAK(542)
	F=RMDESC(0)
	RETURN

C CEVAPP, PAGE 4
C
C CEV7--	Balloon burnup.
C
7000	DO 7100 I=1,OLNT			! find burning object
	  IF((RECEP.EQ.OCAN(I)).AND.((OFLAG1(I).AND.FLAMBT).NE.0))
	1	GO TO 7200			! in receptacle.
7100	CONTINUE
	CALL BUG(4,0)
C
7200	CALL NEWSTA(I,0,0,0,0)			! vanish object.
	BINFF=0					! uninflated.
	IF(HERE.EQ.BLOC) CALL RSPSUB(292,ODESC2(I))	! describe.
	RETURN
C
C CEV8--	Fuse function.
C
8000	IF(OCAN(FUSE).NE.BRICK) GO TO 8500	! ignited brick?
	BR=OROOM(BRICK)				! get brick room.
	BC=OCAN(BRICK)				! get container.
	IF((BR.EQ.0).AND.(BC.NE.0)) BR=OROOM(BC)
	IF(BR.EQ.0) BR=HERE			! it's here...
	CALL NEWSTA(FUSE,0,0,0,0)		! kill fuse.
	CALL NEWSTA(BRICK,0,0,0,0)		! kill brick.
	IF(BR.NE.HERE) GO TO 8100		! brick elsewhere?
C
	RFLAG(HERE)=RFLAG(HERE).OR.RMUNG	! blew self.
	RDESC1(HERE)=114			! mung room.
	CALL JIGSUP(150)			! dead.
	RETURN
C
8100	CALL RSPEAK(151)			! boom.
	MUNGRM=BR				! save room that blew.
	CFLAG(CEVSAF)=.TRUE.
	CTICK(CEVSAF)=5				! set safe interrupt.
	IF(BR.NE.MSAFE) GO TO 8200		! blew safe room?
	IF(BC.NE.SSLOT) RETURN			! was brick in safe?
	CALL NEWSTA(SSLOT,0,0,0,0)		! kill slot.
	OFLAG2(SAFE)=OFLAG2(SAFE).OR.OPENBT	! open safe.
	SAFEF=.TRUE.				! indicate safe blown.
	RETURN
C
8200	DO 8250 I=1,OLNT			! blew wrong room.
	  IF(QHERE(I,BR) .AND. ((OFLAG1(I).AND.TAKEBT).NE.0))
	1	CALL NEWSTA(I,0,0,0,0)		! vanish contents.
8250	CONTINUE
	IF(BR.NE.LROOM) RETURN			! blew living room?
	DO 8300 I=1,OLNT
	  IF(OCAN(I).EQ.TCASE) CALL NEWSTA(I,0,0,0,0) ! kill trophy case.
8300	CONTINUE
	RETURN
C
8500	IF(QHERE(FUSE,HERE).OR.(OADV(FUSE).EQ.WINNER))
	1	CALL RSPEAK(152)
	CALL NEWSTA(FUSE,0,0,0,0)		! kill fuse.
	RETURN

C CEVAPP, PAGE 5
C
C CEV9--	Ledge munge.
C
9000	RFLAG(LEDG4)=RFLAG(LEDG4).OR.RMUNG	! ledge collapses.
	RDESC1(LEDG4)=109
	IF(HERE.EQ.LEDG4) GO TO 9100		! was he there?
	CALL RSPEAK(110)			! no, narrow escape.
	RETURN
C
9100	IF(AVEHIC(WINNER).NE.0) GO TO 9200	! in vehicle?
	CALL JIGSUP(111)			! no, dead.
	RETURN
C
9200	IF(BTIEF.NE.0) GO TO 9300		! tied to ledge?
	CALL RSPEAK(112)			! no, no place to land.
	RETURN
C
9300	BLOC=VLBOT				! yes, crash balloon.
	CALL NEWSTA(BALLO,0,0,0,0)		! balloon & contents die.
	CALL NEWSTA(DBALL,0,BLOC,0,0)		! insert dead balloon.
	BTIEF=0
	BINFF=0
	CFLAG(CEVBAL)=.FALSE.
	CFLAG(CEVBRN)=.FALSE.
	CALL JIGSUP(113)			! dead
	RETURN
C
C CEV10--	Safe munge.
C
10000	RFLAG(MUNGRM)=RFLAG(MUNGRM).OR.RMUNG	! mung target.
	RDESC1(MUNGRM)=114
	IF(HERE.EQ.MUNGRM) GO TO 10100		! is he present?
	CALL RSPEAK(115)			! let him know.
	IF(MUNGRM.NE.MSAFE) RETURN
	CFLAG(CEVLED)=.TRUE.
	CTICK(CEVLED)=8				! start ledge clock.
	RETURN
C
10100	I=116					! he's dead,
	IF((RFLAG(HERE).AND.RHOUSE).NE.0) I=117	! one way or another.
	CALL JIGSUP(I)				! let him know.
	RETURN

C CEVAPP, PAGE 6
C
C CEV11--	Volcano gnome entrance.
C
11000	IF(QLEDGE(HERE)) GO TO 11100		! is he on ledge?
	CFLAG(CEVVLG)=.TRUE.
	CTICK(CEVVLG)=1				! no, wait a while.
	RETURN
C
11100	CALL NEWSTA(GNOME,118,HERE,0,0)		! yes, materialize gnome.
	RETURN
C
C CEV12--	Volcano gnome exit.
C
12000	IF(OROOM(GNOME).EQ.HERE) CALL RSPEAK(149) ! player here to hear?
	CALL NEWSTA(GNOME,0,0,0,0)		! disappear the gnome.
	RETURN
C
C CEV13--	Bucket.
C
13000	IF(OCAN(WATER).EQ.BUCKE)
	1	CALL NEWSTA(WATER,0,0,0,0)	! water leaks out.
	RETURN
C
C CEV14--	Sphere.  If expires, he's trapped.
C
14000	RFLAG(CAGER)=RFLAG(CAGER).OR.RMUNG	! mung room.
	RDESC1(CAGER)=147
	WINNER=PLAYER				! kill player, not robot.
	CALL JIGSUP(148)			! mung player.
	RETURN
C
C CEV15--	END GAME HERALD.
C
15000	ENDGMF=.TRUE.				! we're in endgame.
	CALL RSPEAK(119)			! inform of endgame.
	RETURN

C CEVAPP, PAGE 7
C
C CEV16--	Forest murmurs.
C
16000	CFLAG(CEVFOR)=(HERE.EQ.MTREE).OR.
	1	((HERE.GE.FORE1).AND.(HERE.LT.CLEAR))
	IF(CFLAG(CEVFOR).AND.PROB(10,10)) CALL RSPEAK(635)
	RETURN
C
C CEV17--	Scol alarm.
C
17000	IF(HERE.EQ.BKVAU) CALL JIGSUP(636)	! if in vau, dead.
	IF(ZGNOMF.OR.(HERE.NE.BKTWI)) RETURN	! if not in twi, nothing.
	ZGNOMF=.TRUE.				! gnome only comes once
	CFLAG(CEVZGI)=.TRUE.			! turn on gnome timer
	CTICK(CEVZGI)=5
	RETURN
C
C CEV18--	Gnome of Zurich entrance.
C
18000	IF(HERE.NE.BKTWI) RETURN		! player here?
	CFLAG(CEVZGO)=.TRUE.			! exits, too.
	CTICK(CEVZGO)=12
	CALL NEWSTA(ZGNOM,637,BKTWI,0,0)	! place in twi.
	RETURN
C
C CEV19--	Gnome of Zurich exits.
C
19000	CALL NEWSTA(ZGNOM,0,0,0,0)		! vanish.
	IF(HERE.EQ.BKTWI) CALL RSPEAK(638)	! announce.
	RETURN

C CEVAPP, PAGE 8
C
C CEV20--	Start of endgame.
C
20000	IF(SPELLF) GO TO 20200			! spell his way in?
	IF(HERE.NE.CRYPT) RETURN		! no, still in tomb?
	IF(.NOT.LIT(HERE)) GO TO 20100		! lights off?
	CFLAG(CEVSTE)=.TRUE.
	CTICK(CEVSTE)=3				! reschedule.
	RETURN
C
20100	CALL RSPEAK(727)			! announce.
20200	DO 20300 I=1,OLNT			! strip him of objs.
	  CALL NEWSTA(I,0,OROOM(I),OCAN(I),0)
20300	CONTINUE
	CALL NEWSTA(LAMP,0,0,0,PLAYER)		! give him lamp.
	CALL NEWSTA(SWORD,0,0,0,PLAYER)		! give him sword.
C
	OFLAG1(LAMP)=(OFLAG1(LAMP).OR.LITEBT).AND. .NOT.ONBT
	OFLAG2(LAMP)=OFLAG2(LAMP).OR.TCHBT
	CFLAG(CEVLNT)=.FALSE.			! lamp is good as new.
	CTICK(CEVLNT)=350
	ORLAMP=0
	OFLAG2(SWORD)=OFLAG2(SWORD).OR.TCHBT	! recreate sword.
	SWDACT=.TRUE.
	SWDSTA=0
C
	THFACT=.FALSE.				! thief gone.
	ENDGMF=.TRUE.				! endgame running.
	CFLAG(CEVMAT)=.FALSE.			! matches gone,
	CFLAG(CEVCND)=.FALSE.			! candles gone.
C
	CALL SCRUPD(RVAL(CRYPT))		! score crypt,
	RVAL(CRYPT)=0				! but only once.
	F=MOVETO(TSTRS,WINNER)			! to top of stairs,
	F=RMDESC(3)				! and describe.
	RETURN					! bam!
C
C CEV21--	Mirror closes.
C
21000	MRPSHF=.FALSE.				! button is out.
	MROPNF=.FALSE.				! mirror is closed.
	IF(HERE.EQ.MRANT) CALL RSPEAK(728)	! describe button.
	IF((HERE.EQ.INMIR).OR.(MRHERE(HERE).EQ.1))
	1	CALL RSPEAK(729)		! describe mirror.
	RETURN

C CEVAPP, PAGE 9
C
C CEV22--	Door closes.
C
22000	IF(WDOPNF) CALL RSPEAK(730)		! describe.
	WDOPNF=.FALSE.				! closed.
	RETURN
C
C CEV23--	Inquisitor's question.
C
23000	IF(AROOM(PLAYER).NE.FDOOR) RETURN	! if player left, die.
	CALL RSPEAK(769)
	CALL RSPEAK(770+QUESNO)
	CFLAG(CEVINQ)=.TRUE.
	CTICK(CEVINQ)=2
	RETURN
C
C CEV24--	Master follows.
C
24000	IF(AROOM(AMASTR).EQ.HERE) RETURN	! no movement, done.
	IF((HERE.NE.CELL).AND.(HERE.NE.PCELL)) GO TO 24100
	IF(FOLLWF) CALL RSPEAK(811)		! wont go to cells.
	FOLLWF=.FALSE.
	RETURN
C
24100	FOLLWF=.TRUE.				! following.
	I=812					! assume catches up.
	DO 24200 J=XMIN,XMAX,XMIN
	  IF(FINDXT(J,AROOM(AMASTR)).AND.(XROOM1.EQ.HERE))
	1	I=813				! assume follows.
24200	CONTINUE
	CALL RSPEAK(I)
	CALL NEWSTA(MASTER,0,HERE,0,0)		! move master object.
	AROOM(AMASTR)=HERE			! move master player.
	RETURN
C
C CEV25--	Brochure arrives.
C
25000	CALL NEWSTA(BROCH,948,0,MAILB,0)	! put brochure in mailbox
	BROC2F=.TRUE.				! flag arrival
	RETURN

C CEVAPP, PAGE 10
C
C CEV26--	Cyclops.
C
26000	IF(HERE.NE.MCYCL.OR.MAGICF) GO TO 26500	! player or cyclops gone?
	IF(CYCLOF) RETURN			! if asleep, check later
	IF(IABS(RVCYC).LE.5) GO TO 26200	! cyclops overly annoyed?
	CFLAG(CEVCYC)=.FALSE.			! disable cyclops timer
	CALL JIGSUP(188)			! player munched for lunch
	RETURN
C
26200	IF(RVCYC.LT.0) RVCYC=RVCYC-1		! cyclops gets more annoyed
	IF(RVCYC.GE.0) RVCYC=RVCYC+1
	CALL RSPEAK(193+IABS(RVCYC))		! report cyclops state
	RETURN
C
26500	CFLAG(CEVCYC)=.FALSE.			! disable cyclops timer
	RETURN
C
C CEV27--	Slippery slide.
C
27000	IF((HERE.LT.SLID1).OR.(HERE.GE.SLEDG)) RETURN	! in slide?
	CALL RSPEAK(1034)			! slide to cellar
	F=MOVETO(CELLA,WINNER)			! into cellar
	F=RMDESC(3)				! describe
	RETURN
C
C CEV28--	Exorcism bell.
C
28000	IF(.NOT.EXORCF.AND.(HERE.EQ.LLD1)) CALL RSPEAK(970)
	EXORBF=.FALSE.				! spell broken
	RETURN
C
C CEV29--	Exorcism candles.
C
29000	EXORCF=.FALSE.				! spell broken
	GO TO 28000
C
C CEV30--	Hot bell cools down.
C
30000	CALL NEWSTA(HBELL,0,0,0,0)		! banish hot bell
	CALL NEWSTA(BELL,0,LLD1,0,0)		! get normal bell
	IF(HERE.EQ.LLD1) CALL RSPEAK(971)	! tell player if here
	RETURN
C
	END

C LITINT-	Light interrupt processor
C
C Declarations
C
	SUBROUTINE LITINT(OBJ,CTR,CEV,TICKS,TICKLN)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	INTEGER TICKS(TICKLN)
C
	CTR=CTR+1				! advance state cntr.
	CTICK(CEV)=TICKS(CTR)			! reset interrupt.
	IF(CTICK(CEV).NE.0) GO TO 100		! expired?
	OFLAG1(OBJ)=OFLAG1(OBJ).AND. .NOT.(LITEBT+FLAMBT+ONBT)
	IF((OROOM(OBJ).EQ.HERE).OR.(OADV(OBJ).EQ.WINNER))
	1	CALL RSPSUB(293,ODESC2(OBJ))
	RETURN
C
100	CFLAG(CEV)=.TRUE.
	IF((OROOM(OBJ).EQ.HERE).OR.(OADV(OBJ).EQ.WINNER))
	1	CALL RSPEAK(TICKS(CTR+(TICKLN/2)))
	RETURN
C
	END

C FIGHTD- Intermove fight demon
C
C Declarations
C
	SUBROUTINE FIGHTD
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL PROB,OAPPLI
C
C Functions and data
C
	DATA ROUT/1/

C FIGHTD, PAGE 2
C
	DO 2400 I=1,VLNT			! loop thru villains.
	  VOPPS(I)=0				! clear opponent slot.
	  OBJ=VILLNS(I)				! get object no.
	  RA=OACTIO(OBJ)			! get his action.
	  IF(HERE.NE.OROOM(OBJ)) GO TO 2200	! adventurer still here?
	  IF((OBJ.EQ.THIEF).AND.THFENF) GO TO 2400 ! thief engrossed?
	  IF(OCAPAC(OBJ).GE.0) GO TO 2050	! yes, vill awake?
	  IF((VPROB(I).EQ.0).OR..NOT.PROB(VPROB(I),VPROB(I)))
	1	GO TO 2025			! no, see if wakes up.
	  OCAPAC(OBJ)=IABS(OCAPAC(OBJ))
	  VPROB(I)=0
	  IF(RA.EQ.0) GO TO 2400		! anything to do?
	  PRSA=INXW				! yes, wake him up.
	  F=OAPPLI(RA,0)
	  GO TO 2400				! nothing else happens.
C
2025	  VPROB(I)=VPROB(I)+10			! increase wakeup prob.
	  GO TO 2400				! nothing else.
C
2050	  IF((OFLAG2(OBJ).AND.FITEBT).EQ.0) GO TO 2100
	  VOPPS(I)=OBJ				! fighting, set up opp.
	  GO TO 2400
C
2100	  IF(RA.EQ.0) GO TO 2400		! not fighting,
	  PRSA=FRSTQW				! set up probability
	  IF(.NOT.OAPPLI(RA,0)) GO TO 2400	! of fighting.
	  OFLAG2(OBJ)=OFLAG2(OBJ).OR.FITEBT
	  VOPPS(I)=OBJ				! set up opp.
	  PRSCON=0				! stop cmd stream.
	  GO TO 2400
C
2200	  IF(((OFLAG2(OBJ).AND.FITEBT).EQ.0).OR.(RA.EQ.0))
	1	GO TO 2300			! nothing to do.
	  PRSA=FIGHTW				! have a fight.
	  F=OAPPLI(RA,0)
2300	  IF(OBJ.EQ.THIEF) THFENF=.FALSE.	! turn off engrossed.
	  AFLAG(PLAYER)=AFLAG(PLAYER).AND. .NOT.ASTAG
	  OFLAG2(OBJ)=OFLAG2(OBJ).AND. .NOT.(STAGBT+FITEBT)
	  IF((OCAPAC(OBJ).GE.0).OR.(RA.EQ.0))
	1	GO TO 2400
	  PRSA=INXW				! wake him up.
	  F=OAPPLI(RA,0)
	  OCAPAC(OBJ)=IABS(OCAPAC(OBJ))
2400	CONTINUE

C FIGHTD, PAGE 3
C
C Now do actual counterblows.
C
	OUT=0					! assume hero ok.
2600	DO 2700 I=1,VLNT			! loop thru opps.
	  J=VOPPS(I)
	  IF(J.EQ.0) GO TO 2700			! slot empty?
	  PRSCON=0				! stop cmd stream.
	  RA=OACTIO(J)
	  IF(RA.EQ.0) GO TO 2650		! villain action?
	  PRSA=FIGHTW				! see if
	  IF(OAPPLI(RA,0)) GO TO 2700		! special action.
2650	  RES=BLOW(PLAYER,J,VMELEE(I),.FALSE.,OUT) ! strike blow.
	  IF(RES.LT.0) RETURN			! if hero dead, exit.
	  IF(RES.EQ.ROUT) OUT=2+RND(3)		! if hero out, set flg.
2700	CONTINUE
	OUT=OUT-1				! decrement out count.
	IF(OUT.GT.0) GO TO 2600			! if still out, go again.
	RETURN
C
	END

C BLOW- Strike blow
C
C Declarations
C
	INTEGER FUNCTION BLOW(H,V,RMK,HFLG,OUT)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL HFLG,OAPPLI,PROB
	INTEGER DEF1R(3),DEF2R(4),DEF3R(5)
	INTEGER RVECTR(66),RSTATE(45)
C
C Functions and data
C
	DATA RMISS/0/,ROUT/1/,RKILL/2/,RXXX/3/
	DATA RSER/4/,RSTAG/5/,RLOSE/6/,RHES/7/,RSIT/8/
	DATA DEF1R/1,2,3/
	DATA DEF2R/13,23,24,25/
	DATA DEF3R/35,36,46,47,57/
C
	DATA RVECTR/0,0,0,0,5,5,1,1,2,2,2,2,
	1	0,0,0,0,0,5,5,3,3,1,
	2	0,0,0,5,5,3,3,3,1,2,2,2,
	3	0,0,0,0,0,5,5,3,3,4,4,
	4	0,0,0,5,5,3,3,3,4,4,4,
	5	0,5,5,3,3,3,3,4,4,4/
	DATA RSTATE/5000,3005,3008,4011,3015,3018,1021,0,0,
	1	5022,3027,3030,4033,3037,3040,1043,0,0,
	2	4044,2048,4050,4054,5058,4063,4067,3071,1074,
	3	4075,1079,4080,4084,4088,4092,4096,4100,1104,
	4	4105,2109,4111,4115,4119,4123,4127,3131,3134/

C BLOW, PAGE 2
C
	RA=OACTIO(V)				! get villain action,
	DV=ODESC2(V)				! description.
	BLOW=RMISS				! assume no result.
D	TYPE 10,H,V,RMK,HFLG,OUT
D10	FORMAT(' BLOW 10-- ',3I7,L7,I7)
	IF(.NOT.HFLG) GO TO 1000		! hero striking blow?
C
C Hero is attacker, villain is defender.
C
	PBLOSE=10				! bad lk prob.
	OFLAG2(V)=OFLAG2(V).OR.FITEBT		! yes, villain gets mad.
	IF((AFLAG(H).AND.ASTAG).EQ.0) GO TO 100	! hero stag?
	CALL RSPEAK(591)			! yes, cant fight.
	AFLAG(H)=AFLAG(H).AND. .NOT.ASTAG
	RETURN
C
100	ATT=MAX0(1,FIGHTS(H,.TRUE.))		! get his strength.
	OA=ATT
	DEF=VILSTR(V)				! get vill strength.
	OD=DEF
	DWEAP=0					! assume no weapon.
	DO 200 I=1,OLNT				! search villain.
	  IF((OCAN(I).EQ.V).AND.((OFLAG2(I).AND.WEAPBT).NE.0))
	1	DWEAP=I
200	CONTINUE
	IF(V.EQ.AOBJ(PLAYER)) GO TO 300		! killing self?
	IF(DEF.NE.0) GO TO 2000			! defender alive?
	CALL RSPSUB(592,DV)			! villain dead.
	RETURN
C
300	CALL JIGSUP(593)			! killing self.
	RETURN
C
C Villain is attacker, hero is defender.
C
1000	PRSCON=0				! stop cmd stream.
	PBLOSE=50				! bad lk prob.
	AFLAG(H)=AFLAG(H).AND..NOT.ASTAG	! vill striking.
	IF((OFLAG2(V).AND.STAGBT).EQ.0) GO TO 1200 ! vill staggered?
	OFLAG2(V)=OFLAG2(V).AND. .NOT.STAGBT	! make him ok.
	CALL RSPSUB(594,DV)			! describe.
	RETURN
C
1200	ATT=VILSTR(V)				! set up att, def.
	OA=ATT
	DEF=FIGHTS(H,.TRUE.)
	IF(DEF.LE.0) RETURN			! dont allow dead def.
	OD=FIGHTS(H,.FALSE.)
	DWEAP=IABS(FWIM(0,WEAPBT,0,0,H,.TRUE.))	! find a weapon.

C BLOW, PAGE 3
C
C Parties are now equipped.  DEF cannot be zero.
C ATT must be > 0.
C
2000	CONTINUE
D	TYPE 2050,ATT,OA,DEF,OD,DWEAP
D2050	FORMAT(' BLOW 2050-- ',5I7)
	IF(DEF.GT.0) GO TO 2100			! def alive?
	RES=RKILL
	IF(HFLG) CALL RSPSUB(595,DV)		! deader.
	GO TO 3000
C
2100	IF(DEF-2) 2200,2300,2400		! def <2,=2,>2
2200	ATT=MIN0(ATT,3)				! scale att.
	TBL=DEF1R(ATT)				! choose table.
	GO TO 2500
C
2300	ATT=MIN0(ATT,4)				! scale att.
	TBL=DEF2R(ATT)				! choose table.
	GO TO 2500
C
2400	ATT=ATT-DEF				! scale att.
	ATT=MIN0(2,MAX0(-2,ATT))+3
	TBL=DEF3R(ATT)
C
2500	RES=RVECTR(TBL+RND(10))			! get result.
	IF(OUT.EQ.0) GO TO 2600			! was he out?
	IF(RES.EQ.RSTAG) GO TO 2550		! yes, stag--> hes.
	RES=RSIT				! otherwise, sitting.
	GO TO 2600
2550	RES=RHES
2600	IF((RES.EQ.RSTAG).AND.(DWEAP.NE.0).AND.PROB(25,PBLOSE))
	1	RES=RLOSE			! lose weapon.
C
	MI=RSTATE(((RMK-1)*9)+RES+1)		! choose table entry.
	IF(MI.EQ.0) GO TO 3000
	I=(MOD(MI,1000)+RND(MI/1000))+MBASE+1
	J=DV
	IF(.NOT.HFLG .AND.(DWEAP.NE.0)) J=ODESC2(DWEAP)
D	TYPE 2650,RES,MI,I,J,MBASE
D2650	FORMAT(' BLOW 2650-- ',5I7)
	CALL RSPSUB(I,J)			! present result.

C BLOW, PAGE 4
C
C Now apply result.
C
3000	GO TO (4000,3100,3200,3300,3400,3500,3600,4000,3200),RES+1
C
3100	IF(HFLG) DEF=-DEF			! unconscious.
	GO TO 4000
C
3200	DEF=0					! killed or sitting duck.
	GO TO 4000
C
3300	DEF=MAX0(0,DEF-1)			! light wound.
	GO TO 4000
C
3400	DEF=MAX0(0,DEF-2)			! serious wound.
	GO TO 4000
C
3500	IF(HFLG) GO TO 3550			! staggered.
	AFLAG(H)=AFLAG(H).OR.ASTAG
	GO TO 4000
C
3550	OFLAG2(V)=OFLAG2(V).OR.STAGBT
	GO TO 4000
C
3600	CALL NEWSTA(DWEAP,0,HERE,0,0)		! lose weapon.
	DWEAP=0
	IF(HFLG) GO TO 4000			! if hero, done.
	DWEAP=IABS(FWIM(0,WEAPBT,0,0,H,.TRUE.)) ! get new.
	IF(DWEAP.NE.0) CALL RSPSUB(605,ODESC2(DWEAP))

C BLOW, PAGE 5
C
4000	BLOW=RES				! return result.
	IF(.NOT.HFLG) GO TO 4500		! hero?
	OCAPAC(V)=DEF				! store new capacity.
	IF(DEF.NE.0) GO TO 4100			! dead?
	OFLAG2(V)=OFLAG2(V).AND. .NOT.FITEBT	! yes, not fighting.
	CALL RSPSUB(572,DV)			! he dies.
	CALL NEWSTA(V,0,0,0,0)			! make him disappear.
	IF(RA.EQ.0) RETURN			! if nx to do, exit.
	PRSA=DEADXW				! let him know.
	F=OAPPLI(RA,0)
	RETURN
C
4100	IF((RES.NE.ROUT).OR.(RA.EQ.0)) RETURN
	PRSA=OUTXW				! let him be out.
	F=OAPPLI(RA,0)
	RETURN
C
4500	ASTREN(H)=-10000			! assume dead.
	IF(DEF.NE.0) ASTREN(H)=DEF-OD
	IF(DEF.GE.OD) GO TO 4600
	CTICK(CEVCUR)=30
	CFLAG(CEVCUR)=.TRUE.
4600	IF(FIGHTS(H,.TRUE.).GT.0) RETURN
	ASTREN(H)=1-FIGHTS(H,.FALSE.)		! he's dead.
	CALL JIGSUP(596)
	BLOW=-1
	RETURN
C
	END

C SWORDD- Intermove sword demon
C
C Declarations
C
	SUBROUTINE SWORDD
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL INFEST,FINDXT
C
	IF(OADV(SWORD).NE.PLAYER) GO TO 500	! holding sword?
	NG=2					! assume vill close.
	IF(INFEST(HERE)) GO TO 300		! vill here?
	NG=1
	DO 200 I=XMIN,XMAX,XMIN			! no, search rooms.
	  IF(.NOT.FINDXT(I,HERE)) GO TO 200	! room that way?
	  GO TO (50,200,50,50),XTYPE		! see if room at all.
50	  IF(INFEST(XROOM1)) GO TO 300		! check room.
200	CONTINUE
	NG=0					! no glow.
C
300	IF(NG.EQ.SWDSTA) RETURN			! any state change?
	CALL RSPEAK(NG+495)			! yes, tell new state.
	SWDSTA=NG
	RETURN
C
500	SWDACT=.FALSE.				! dropped sword,
	RETURN					! disable demon.
	END

C INFEST-	Subroutine to test for infested room
C
C Declarations
C
	LOGICAL FUNCTION INFEST(R)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	IF(.NOT.ENDGMF) INFEST=(OROOM(CYCLO).EQ.R).OR.
	1	(OROOM(TROLL).EQ.R).OR.
	2	((OROOM(THIEF).EQ.R).AND.THFACT)
	IF(ENDGMF) INFEST=(R.EQ.MRG).OR.(R.EQ.MRGE).OR.
	1	(R.EQ.MRGW).OR.
	2	((R.EQ.INMIR).AND.(MLOC.EQ.MRG))
	RETURN
	END

C AAPPLI- Applicables for adventurers
C
C Declarations
C
	LOGICAL FUNCTION AAPPLI(RI)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL F,MOVETO,QHERE
C
	IF(RI.EQ.0) GO TO 10			! if zero, no app.
	AAPPLI=.TRUE.				! assume wins.
	GO TO (1000,2000,3000),RI		! branch on adv.
	CALL BUG(11,RI)
C
C Common false return.
C
10	AAPPLI=.FALSE.
	RETURN

C AAPPLI, PAGE 2
C
C A1--	Dead player.
C
1000	IF((PRSA.NE.ATTACW).AND.(PRSA.NE.MUNGW).AND.
	1  (PRSA.NE.KILLW).AND.(PRSA.NE.SWINGW).AND.
	2  (PRSA.NE.KICKW).AND.(PRSA.NE.BLASTW)) GO TO 1050
	CALL RSPEAK(949)			! dead can't attack.
	RETURN
C
1050	IF((PRSA.NE.OPENW).AND.(PRSA.NE.CLOSEW).AND.
	1  (PRSA.NE.EATW).AND.(PRSA.NE.DRINKW).AND.
	2  (PRSA.NE.INFLAW).AND.(PRSA.NE.DEFLAW).AND.
	3  (PRSA.NE.TURNW).AND.(PRSA.NE.TIEW).AND.
	4  (PRSA.NE.BURNW).AND.(PRSA.NE.UNTIEW)) GO TO 1100
	CALL RSPEAK(950)			! dead can't do simple acts.
	RETURN
C
1100	IF(PRSA.NE.TRNONW) GO TO 1150
	CALL RSPEAK(951)			! dead don't need lights.
	RETURN
C
1150	IF(PRSA.NE.SCOREW) GO TO 1200
	CALL RSPEAK(952)			! dead can't score.
	RETURN
C
1200	IF(PRSA.NE.TELLW) GO TO 1250
	CALL RSPEAK(953)			! dead can't give orders.
	RETURN
C
1250	IF(PRSA.NE.TAKEW) GO TO 1300
	CALL RSPEAK(954)			! dead can't take.
	RETURN
C
1300	IF((PRSA.NE.DROPW).AND.(PRSA.NE.THROWW).AND.
	1  (PRSA.NE.INVENW)) GO TO 1350
	CALL RSPEAK(955)			! dead have no possesions
	RETURN
C
1350	IF(PRSA.NE.DIAGNW) GO TO 1400
	CALL RSPEAK(956)			! dead as a doornail
	RETURN
C
1400	IF(PRSA.NE.LOOKW) GO TO 1500
	I=957					! assume nothing here
	DO 1450 J=1,OLNT			! loop through objects
	  IF(QHERE(J,HERE)) I=958		! found something
1450	CONTINUE
	CALL RSPEAK(I)				! describe objects
	IF((RFLAG(HERE).AND.RLIGHT).NE.0) CALL RSPEAK(959)
	GO TO 10				! don't handle
C
1500	IF(PRSA.NE.PRAYW) GO TO 1600
	IF(HERE.EQ.TEMP2) GO TO 1550		! praying in temple?
	CALL RSPEAK(960)			! prayers are not answered
	RETURN
C
1550	OFLAG1(LAMP)=OFLAG1(LAMP).OR.VISIBT	! back to life, restore lamp
	OACTIO(PLAYER)=0			! disable dead player
	DEADF=.FALSE.				! clear dead flag
	F=MOVETO(FORE1,WINNER)			! move to forest
	CALL RSPEAK(9)				! describe
	RETURN
C
1600	IF(PRSA.NE.WALKW) GO TO 1700
	IF(.NOT.FINDXT(PRSO,HERE)) GO TO 10	! if no exits, don't handle
	IF(XROOM1.NE.BSHAF) GO TO 10		! if not bshaft, don't handle
	CALL RSPEAK(962)			! can't go and score points
	RETURN
C
1700	IF(PRSA.EQ.QUITW) GO TO 10		! if quit, don't handle
	CALL RSPEAK(963)			! can't do it
	RETURN

C
C A2--	Robot.  Process most commands given to robot.
C
2000	IF((PRSA.NE.RAISEW).OR.(PRSO.NE.RCAGE)) GO TO 2200
	CFLAG(CEVSPH)=.FALSE.			! robot raised cage.
	WINNER=PLAYER				! reset for player.
	F=MOVETO(CAGER,WINNER)			! move to new room.
	CALL NEWSTA(CAGE,567,CAGER,0,0)		! install cage in room.
	CALL NEWSTA(ROBOT,0,CAGER,0,0)		! install robot in room.
	AROOM(AROBOT)=CAGER			! also move robot/adv.
	CAGESF=.TRUE.				! cage solved.
	OFLAG1(ROBOT)=OFLAG1(ROBOT).AND..NOT.NDSCBT
	OFLAG1(SPHER)=OFLAG1(SPHER).OR.TAKEBT	! reset flags.
	PRSCON=0				! stop cmd stream.
	RETURN
C
2200	IF((PRSA.NE.DRINKW).AND.(PRSA.NE.EATW)) GO TO 2300
	CALL RSPEAK(568)			! eat or drink, joke.
	RETURN
C
2300	IF(PRSA.NE.READW) GO TO 2400		! read,
	CALL RSPEAK(569)			! joke.
	RETURN
C
2400	IF((PRSA.EQ.WALKW).OR.(PRSA.EQ.TAKEW).OR.(PRSA.EQ.DROPW)
	1 .OR.(PRSA.EQ.PUTW).OR.(PRSA.EQ.PUSHW).OR.(PRSA.EQ.THROWW)
	2 .OR.(PRSA.EQ.TURNW).OR.(PRSA.EQ.LEAPW)) GO TO 2500
	CALL RSPEAK(570)			! joke.
	RETURN
C
2500	CALL RSPEAK(930)			! buzz, whirr, click!
	GO TO 10				! don't handle

C AAPPLI, PAGE 3
C
C A3--	Master.  Process most commands given to master.
C
3000	IF((OFLAG2(QDOOR).AND.OPENBT).NE.0) GO TO 3100
	CALL RSPEAK(783)			! no master yet.
	RETURN
C
3100	IF(PRSA.NE.WALKW) GO TO 3200		! walk?
	I=784					! assume wont.
	IF(((HERE.EQ.SCORR).AND.
	1	((PRSO.EQ.XNORTH).OR.(PRSO.EQ.XENTER))).OR.
	2  ((HERE.EQ.NCORR).AND.
	3	((PRSO.EQ.XSOUTH).OR.(PRSO.EQ.XENTER))))
	4	I=785				! if prison, cant.
	CALL RSPEAK(I)
	RETURN
C
3200	IF((PRSA.EQ.TAKEW).OR.(PRSA.EQ.DROPW).OR.(PRSA.EQ.PUTW).OR.
	1  (PRSA.EQ.THROWW).OR.(PRSA.EQ.PUSHW).OR.(PRSA.EQ.TURNW).OR.
	2  (PRSA.EQ.SPINW).OR.(PRSA.EQ.TRNTOW).OR.(PRSA.EQ.FOLLOW).OR.
	3  (PRSA.EQ.STAYW).OR.(PRSA.EQ.OPENW).OR.(PRSA.EQ.CLOSEW).OR.
	4  (PRSA.EQ.KILLW)) GO TO 10		! master can do.
	CALL RSPEAK(786)			! master cant do it.
	RETURN
C
	END

C THIEFD-	Intermove thief demon
C
C Declarations
C
	SUBROUTINE THIEFD
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL DFLAG,ONCE,PROB,QHERE,QSTILL,LIT,WINNIN,WASLIT
C
C Functions AND DATA
C
	QSTILL(R)=(QHERE(STILL,R).OR.(OADV(STILL).EQ.-THIEF))

C THIEFD, PAGE 2
C
	DFLAG=(PRSFLG.AND.32).NE.0		! set up detail flag.
	ONCE=.FALSE.				! init flag.
1025	WASLIT=LIT(HERE)			! record if lit.
	RHERE=OROOM(THIEF)			! visible pos.
	IF(RHERE.NE.0) THFPOS=RHERE
C
	IF((THFPOS.EQ.HERE).AND..NOT.DEADF) GO TO 1100	! thief in live win rm?
	IF(THFPOS.NE.TREAS) GO TO 1400		! thief not in treas?
C
C Thief is in treasure room, and winner is not.
C
	IF(DFLAG) TYPE 10
10	FORMAT(' THIEFD-- IN TREASURE ROOM')
	IF(RHERE.EQ.0) GO TO 1050		! visible?
	CALL NEWSTA(THIEF,0,0,0,0)		! yes, vanish.
	RHERE=0
	IF(QSTILL(TREAS)) CALL NEWSTA(STILL,0,0,THIEF,0)
	DO 1040 I=1,OLNT			! loop through objects.
	  IF(QHERE(I,THFPOS))
	1	OFLAG1(I)=OFLAG1(I).OR.VISIBT	! make objects visible
1040	CONTINUE
1050	I=ROBADV(-THIEF,THFPOS,0,0)		! drop valuables.
	IF(QHERE(EGG,THFPOS)) OFLAG2(EGG)=OFLAG2(EGG).OR.OPENBT
	GO TO 1700
C
C Thief and (live) winner in same room.
C
1100	IF(THFPOS.EQ.TREAS) GO TO 1700		! if treas room, nothing.
	IF((RFLAG(THFPOS).AND.RLIGHT).NE.0) GO TO 1400 ! not if light.
	IF(DFLAG) TYPE 20
20	FORMAT(' THIEFD-- IN ADV ROOM')
	IF(THFFLG) GO TO 1300			! thief announced?
	IF((RHERE.NE.0).OR.PROB(70,70))	GO TO 1150	! if invis and 30%.
	IF(OCAN(STILL).NE.THIEF) GO TO 1700	! abort if no stilletto.
	CALL NEWSTA(THIEF,583,THFPOS,0,0)	! insert thief into room.
	THFFLG=.TRUE.				! thief is announced.
	RETURN
C
1150	IF((RHERE.EQ.0).OR.((OFLAG2(THIEF).AND.FITEBT).EQ.0))
	1	GO TO 1200			! if visible and fight.
	IF(WINNIN(THIEF,PLAYER)) GO TO 1175	! winning?
	CALL NEWSTA(THIEF,584,0,0,0)		! no, vanish thief.
	OFLAG2(THIEF)=OFLAG2(THIEF).AND. .NOT.FITEBT
	IF(QSTILL(THFPOS)) CALL NEWSTA(STILL,0,0,THIEF,0)
	RETURN
C
1175	IF(PROB(90,90)) GO TO 1700		! 90% chance to stay.
C
1200	IF((RHERE.EQ.0).OR.PROB(70,70)) GO TO 1250 ! if visible and 30%
	CALL NEWSTA(THIEF,585,0,0,0)		! vanish thief.
	IF(QSTILL(THFPOS)) CALL NEWSTA(STILL,0,0,THIEF,0)
	RETURN
C
1300	IF(RHERE.EQ.0) GO TO 1700		! announced.  visible?
1250	IF(PROB(70,70)) RETURN			! 70% chance to do nothing.
	THFFLG=.TRUE.
	NR=ROBRM(THFPOS,100,0,0,-THIEF)+ROBADV(PLAYER,0,0,-THIEF)
	I=586					! robbed em.
	IF(RHERE.NE.0) I=588			! was he visible?
	CALL NEWSTA(THIEF,I+MIN0(1,NR),0,0,0)	! vanish thief, give result.
	IF(QSTILL(THFPOS))
	1	CALL NEWSTA(STILL,0,0,THIEF,0)	! reclaim stilletto.
	IF(WASLIT.AND..NOT.LIT(HERE).AND.(HERE.EQ.AROOM(PLAYER)))
	1	CALL RSPEAK(915)		! leave player in dark?
	RHERE=0
	GO TO 1700				! onward.
C
C Not in adventurers room, or adventurer dead, or room lit.
C
1400	CALL NEWSTA(THIEF,0,0,0,0)		! vanish.
	RHERE=0
	IF(DFLAG) TYPE 30,THFPOS
30	FORMAT(' THIEFD-- IN ROOM ',I4)
	IF(QSTILL(THFPOS))
	1	CALL NEWSTA(STILL,0,0,THIEF,0)
	IF((RFLAG(THFPOS).AND.RSEEN).EQ.0) GO TO 1700	! cant rob unseen.
	I=ROBRM(THFPOS,75,0,0,-THIEF)		! rob room 75%.
	IF((THFPOS.LT.MAZE1).OR.(THFPOS.GT.MAZ15).OR.
	1	(HERE.LT.MAZE1).OR.(HERE.GT.MAZ15)) GO TO 1500
	DO 1450 I=1,OLNT			! both in maze.
	  IF(.NOT.QHERE(I,THFPOS).OR.PROB(60,60).OR.
	1	((OFLAG1(I).AND.(VISIBT+TAKEBT)).NE.(VISIBT+TAKEBT)))
	2	GO TO 1450
	  CALL RSPSUB(590,ODESC2(I))		! thief's remarks.
	  IF(PROB(40,20)) GO TO 1700
	  CALL NEWSTA(I,0,0,0,-THIEF)		! steal it.
	  OFLAG2(I)=OFLAG2(I).OR.TCHBT
	  GO TO 1700
1450	CONTINUE
	GO TO 1700
C
1500	DO 1550 I=1,OLNT			! not in maze.
	  IF(.NOT.QHERE(I,THFPOS).OR.(OTVAL(I).NE.0).OR.PROB(80,60).OR.
	1	((OFLAG1(I).AND.(VISIBT+TAKEBT)).NE.(VISIBT+TAKEBT)))
	2	GO TO 1550
	  CALL NEWSTA(I,0,0,0,-THIEF)
	  OFLAG2(I)=OFLAG2(I).OR.TCHBT
	  IF((THFPOS.EQ.HERE).AND..NOT.DEADF)
	1	CALL RSPSUB(1045,ODESC2(I))	! vanishes before you.
	  GO TO 1700
1550	CONTINUE
C
C Now move to new room.
C
1700	IF(OADV(ROPE).NE.-THIEF) GO TO 1725	! did he steal rope?
	DOMEF=.FALSE.
	TTIE=0
1725	IF(ONCE) GO TO 1800
	ONCE=.NOT.ONCE
1750	THFPOS=THFPOS-1				! next room.
	IF(THFPOS.LE.0) THFPOS=RLNT
	IF((RFLAG(THFPOS).AND.(RLAND+RSACRD+REND)).NE.RLAND)
	1	GO TO 1750			! must be land, profane.
	THFFLG=.FALSE.				! not announced.
	GO TO 1025				! once more.
C
C All done.
C
1800	IF(THFPOS.EQ.TREAS) RETURN		! in treasure room?
	J=591					! no, drop stuff.
	IF(THFPOS.NE.HERE) J=0
	DO 1850 I=1,OLNT
	  IF((OADV(I).NE.-THIEF).OR.PROB(70,30).OR.
	1	(OTVAL(I).GT.0)) GO TO 1850
	  CALL NEWSTA(I,J,THFPOS,0,0)
	  J=0
1850	CONTINUE
	RETURN
C
	END

C Command loop, initialization for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C GAME- Main command loop
C
C Declarations
C
	SUBROUTINE GAME
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR'
	LOGICAL RMDESC,VAPPLI,AAPPLI
	LOGICAL F,PARSE,FINDXT,XVEHIC,LIT,PRVLIT

C GAME, PAGE 2
C
C Start up, describe current location.
C
	CALL RSPEAK(1)				! welcome aboard.
	F=RMDESC(3)				! start game.
C
C Now loop, reading and executing commands.
C
100	WINNER=PLAYER				! player moving.
	TELFLG=.FALSE.				! assume nothing told.
	IF(PRSCON.LE.1) CALL RDLINE(INBUF,INLNT,1) ! read command.
C
	IF(INBUF(PRSCON:INLNT).NE.'GDT') GO TO 200	! call on gdt?
	CALL GDT				! yes, invoke.
	PRSCON=1				! force restart.
	GO TO 100				! onward.
C
200	MOVES=MOVES+1
	SUBLNT=0				! no substrings.
	PRVHER=HERE				! save current location.
	PRVLIT=LIT(HERE)			! save current lighting.
	PRSWON=PARSE(INBUF,INLNT,.TRUE.)	! parse input, normal mode.
	IF(.NOT.PRSWON) GO TO 400		! parse lose?
	IF(AAPPLI(AACTIO(WINNER))) GO TO 400	! player handle?
	IF(XVEHIC(1)) GO TO 400			! vehicle handle?
C
	IF(PRSA.EQ.TELLW) GO TO 2000		! tell?
300	IF((PRSO.EQ.VALUA).OR.(PRSO.EQ.EVERY).OR.(PRSO.EQ.POSSE)
	1	.OR.(PRSO.EQ.BUNOBJ)) GO TO 900	! collective object?
	IF(.NOT.VAPPLI(PRSA)) GO TO 400		! verb ok?
	IF(.NOT.PRVLIT.AND.(HERE.EQ.PRVHER)
	1	.AND.LIT(HERE)) F=RMDESC(0)	! now lit
350	IF(.NOT.(ECHOF.OR.DEADF).AND.(HERE.EQ.ECHOR)) GO TO 1000
	CALL RAPPLI(RACTIO(HERE))		! room action?
C
400	CALL XENDMV(TELFLG)			! do end of move.
	IF(.NOT.LIT(HERE)) PRSCON=1		! if not lit, restart.
	GO TO 100
C
900	CALL VALUAC(PRSO)			! collective object.
	GO TO 350

C GAME, PAGE 3
C
C Special case-- Echo Room.
C If input is not 'ECHO' or a direction, just echo.
C
1000	CALL RDLINE(INBUF,INLNT,0)		! read line.
	MOVES=MOVES+1				! charge for moves.
	IF(INBUF.NE.'ECHO') GO TO 1100		! input = echo?
C
	CALL RSPEAK(571)			! kill the echo.
	ECHOF=.TRUE.
	OFLAG2(BAR)=OFLAG2(BAR).AND. .NOT.SCRDBT ! let thief steal bar.
	PRSWON=.TRUE.				! fake out parser.
	PRSCON=1				! force new input.
	GO TO 400
C
1100	IF(INBUF.NE.'BUG') GO TO 1200		! bug request?
	CALL RSPEAK(913)			! wrong, jack.
	GO TO 1000				! try again.
C
1200	IF(INBUF.NE.'FEATURE') GO TO 1300	! feature request?
	CALL RSPEAK(914)			! right, jack.
	GO TO 1000				! try again
C
1300	PRSWON=PARSE(INBUF,INLNT,.FALSE.)	! parse input, echo mode.
	IF(.NOT.PRSWON .OR. (PRSA.NE.WALKW))
	1	GO TO 1400			! walk?
	IF(FINDXT(PRSO,HERE)) GO TO 300		! valid exit?
C
1400	WRITE(OUTCH,1410) INBUF(1:INLNT)	! echo input.
1410	FORMAT(1X,A)
	TELFLG=.TRUE.				! indicate output.
	GO TO 1000				! more echo room.

C GAME, PAGE 4
C
C Special case-- TELL <ACTOR> "NEW COMMAND".
C Note that we cannot be in the Echo Room.
C
2000	IF(SUBLNT.NE.0) GO TO 2050		! any substring?
	CALL RSPSUB(946,ODESC2(PRSO))		! no, joke.
	GO TO 2150				! done.
C
2050	IF(PRSO.NE.OPLAY) GO TO 2100		! to self?
	WRITE(OUTCH,2060) SUBBUF(1:SUBLNT)	! ok, tell it.
2060	FORMAT(' Ok:  "',A,'".')
	TELFLG=.TRUE.
	GO TO 2150
C
2100	IF(OBJACT(X)) GO TO 350			! object handle?
	IF((OFLAG2(PRSO).AND.ACTRBT).NE.0) GO TO 2200 ! actor?
	I=602
	IF((OFLAG1(PRSO).AND.VICTBT).NE.0) I=888
	CALL RSPSUB(I,ODESC2(PRSO))		! no, joke.
2150	PRSCON=0				! disable cmd stream.
	GO TO 350
C
2200	SVPRSC=PRSCON				! save prscon.
	SVPRSO=PRSO				! save prso.
	PRSCON=1				! start of substring.
2300	WINNER=OACTOR(SVPRSO)			! new player.
	HERE=AROOM(WINNER)			! new location.
	PRSWON=PARSE(SUBBUF,SUBLNT,.TRUE.)	! parse command.
	IF(.NOT.PRSWON) GO TO 2600		! parse succeed?
C
	IF(AAPPLI(AACTIO(WINNER))) GO TO 2400	! actor handle?
	IF(XVEHIC(1)) GO TO 2400		! vehicle handle?
	IF((PRSO.EQ.VALUA).OR.(PRSO.EQ.EVERY).OR.(PRSO.EQ.POSSE)
	1	.OR.(PRSO.EQ.BUNOBJ)) GO TO 2900 ! collective object?
	IF(.NOT.VAPPLI(PRSA)) GO TO 2400	! verb handle?
2350	CALL RAPPLI(RACTIO(HERE))		! room action?
2400	IF(PRSCON-1) 2700,2550,2500		! parser reset?
2500	CALL XENDMV(TELFLG)			! more to do, end of move.
	GO TO 2300				! do next command.
C
2550	PRSCON=SVPRSC				! substring exhausted.
	GO TO 2700				! restore state.
C
2600	I=341					! parse fails.
	IF(TELFLG) I=604			! give response.
	CALL RSPEAK(I)
2700	WINNER=PLAYER				! restore state.
	HERE=AROOM(WINNER)
	GO TO 400				! rejoin main loop.
C
2900	CALL VALUAC(PRSO)			! collective object.
	GO TO 2350
C
	END

C XENDMV-	Execute end of move functions.
C
C Declarations
C
	SUBROUTINE XENDMV(FLAG)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL F,CLOCKD,FLAG,XVEHIC
C
	IF(.NOT.FLAG) CALL RSPEAK(341)		! default remark.
	IF(THFACT) CALL THIEFD			! thief demon.
	IF(PRSWON.AND..NOT.DEADF) CALL FIGHTD	! fight demon.
	IF(SWDACT) CALL SWORDD			! sword demon.
	IF(PRSWON) F=CLOCKD(X)			! clock demon.
	IF(PRSWON) F=XVEHIC(2)			! vehicle readout.
	RETURN
	END

C XVEHIC- Execute vehicle function
C
C Declarations
C
	LOGICAL FUNCTION XVEHIC(N)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL OAPPLI
C
	XVEHIC=.FALSE.				! assume loses.
	AV=AVEHIC(WINNER)			! get vehicle.
	IF(AV.NE.0) XVEHIC=OAPPLI(OACTIO(AV),N)
	RETURN
	END

C INITFL-- DUNGEON file initialization subroutine
C
C Declarations
C
	LOGICAL FUNCTION INITFL(X)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL PROTCT
	CHARACTER*1 KEDIT

C INITFL, PAGE 2
C
C First check for protection violation.
C
	INITFL=.FALSE.				! assume init fails.
	IF(PROTCT(X)) GO TO 10000		! protection violation?
	TYPE 10100				! yes, throw him off.
10100	FORMAT(' There appears before you a threatening figure clad
	1 all over'/' in heavy black armor.  His legs seem like the
	2 massive trunk'/' of the oak tree.  His broad shoulders and
	3 helmeted head loom'/' high over your own puny frame, and
	4 you realize that his powerful'/' arms could easily crush the
	5 very life from your body.  There'/' hangs from his belt a
	6 veritable arsenal of deadly weapons:'/' sword, mace, ball
	7 and chain, dagger, lance, and trident.'/' He speaks with a
	8 commanding voice:'//20X,'"You shall not pass."'//' As
	9 he grabs you by the neck all grows dim about you.')
	RETURN
C
C Now restore from existing index file.
C
10000	OPEN(UNIT=1,NAME='DINDX',TYPE='OLD',READONLY,
	1	FORM='FORMATTED',ACCESS='SEQUENTIAL',ERR=1900)
	READ(1,130) I,J				! get version.
	READ(1,125) KEDIT			! get minor edit.
	IF((I.NE.VMAJ).OR.(J.NE.VMIN))
	1	GO TO 1925			! match to ours?
C
	OPEN(UNIT=DBCH,NAME='DTEXT',TYPE='OLD',READONLY,
	1	FORM='UNFORMATTED',ACCESS='DIRECT',
	2	RECORDSIZE=RECLNT,DISPOSE='SAVE',ERR=1950)
C
	READ(1,130) MXSCOR,STRBIT,EGMXSC
	READ(1,130) RLNT,RDESC2,RDESC1,REXIT,RACTIO,RVAL,RFLAG
	READ(1,130) XLNT,TRAVEL
	READ(1,130) OLNT,ODESC1,ODESC2,ODESCO,OACTIO,OFLAG1,OFLAG2,
	1	OFVAL,OTVAL,OSIZE,OCAPAC,OROOM,OADV,OCAN,OREAD
	READ(1,130) R2LNT,O2,R2
	READ(1,130) CLNT,CTICK,CACTIO
	READ(1,135) CFLAG,CCNCEL
	READ(1,130) VLNT,VILLNS,VPROB,VOPPS,VBEST,VMELEE
	READ(1,130) ALNT,AROOM,ASCORE,AVEHIC,AOBJ,AACTIO,ASTREN,AFLAG
	READ(1,130) MBASE,MLNT,RTEXT
C
	CLOSE(UNIT=1)
	GO TO 1025				! init done.
C
125	FORMAT(A)
130	FORMAT(I8)
135	FORMAT(L4)

C INITFL, PAGE 3
C
C The internal data base is now established.
C Set up to play the game-- INITFL succeeds.
C
1025	CALL ITIME(SHOUR,SMIN,SSEC)		! get time and date.
	CALL IDATE(I,J,K)
	CALL INIRND(I.OR.J.OR.K,SHOUR.OR.SMIN.OR.SSEC)
C
	WINNER=PLAYER
	THFPOS=OROOM(THIEF)
	BLOC=OROOM(BALLO)
	HERE=AROOM(WINNER)
	LASTIT=AOBJ(PLAYER)
C
	INITFL=.TRUE.
	RETURN
C
C Errors-- INITFL fails.
C
1900	TYPE 910				! dindx.dat open err
	TYPE 980
	RETURN
1925	TYPE 920,I,J,KEDIT,VMAJ,VMIN,VEDIT	! wrong dindx.dat ver
	TYPE 980
	RETURN
1950	TYPE 960				! dtext.dat open err
	TYPE 980
	RETURN
910	FORMAT(' I can''t open "DINDX.DAT".')
920	FORMAT(' "DINDX.DAT" is version ',I1,'.',I1,A,'.'/
	1	' I require version ',I1,'.',I1,A,'.')
960	FORMAT(' I can''t open "DTEXT.DAT".')
980	FORMAT(' Suddenly a sinister, wraithlike figure appears before
	1 you'/' seeming to float in the air.  In a low, sorrowful voice
	2 he says,'/' "Alas, the very nature of the world has changed,
	3 and the dungeon'/' cannot be found.  All must now pass away."
	4  Raising his oaken staff'/' in farewell, he fades into the
	5 spreading darkness.  In his place'/' appears a tastefully
	6 lettered sign reading:'//23X,'INITIALIZATION FAILURE'//
	7' The darkness becomes all encompassing, and your vision fails.')
C
	END

C PROTCT-- Check for user violation
C
C This routine should be modified if you wish to add system
c dependant protection against abuse.
C
C At the moment, play is permitted under all circumstances.
C
	LOGICAL FUNCTION PROTCT(X)
	IMPLICIT INTEGER(A-Z)
C
	PROTCT=.TRUE.
	RETURN
	END

C Game debugging tool for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C Declarations
C
	SUBROUTINE GDT
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	PARAMETER (DBGMAX=38)			! number of debug commands
	CHARACTER*2 CMD,DBGCMD(DBGMAX),DBGSML(DBGMAX)
	INTEGER ARGTYP(DBGMAX)
	LOGICAL VALID1,VALID2,VALID3
C
C Equivalanced array definitions
C
	INTEGER EQR(RMAX,5)
	EQUIVALENCE (EQR(1,1),RDESC1(1))
	INTEGER EQO(OMAX,14)
	EQUIVALENCE (EQO(1,1),ODESC1(1))
	INTEGER EQC(CMAX,2)
	EQUIVALENCE (EQC(1,1),CTICK(1))
	INTEGER EQV(VMAX,5)
	EQUIVALENCE (EQV(1,1),VILLNS(1))
	INTEGER EQA(AMAX,7)
	EQUIVALENCE (EQA(1,1),AROOM(1))
C
C Functions and data
C
	VALID1(A1,L1)=(A1.GT.0).AND.(A1.LE.L1)
	VALID2(A1,A2,L1)=VALID1(A1,L1).AND.VALID1(A2,L1).AND.
	1	(A1.LE.A2)
	VALID3(A1,L1,A2,L2)=VALID1(A1,L1).AND.VALID1(A2,L2)
	DATA DBGCMD/'DR','DO','DA','DC','DX','DH','DL','DV','DF','DS',
	1	'AF','HE','NR','NT','NC','ND','RR','RT','RC','RD',
	2	'TK','EX','AR','AO','AA','AC','AX','AV','D2','DN',
	3	'AN','DM','DT','AH','DP','PD','DZ','AZ'/
	DATA DBGSML/'dr','do','da','dc','dx','dh','dl','dv','df','ds',
	1	'af','he','nr','nt','nc','nd','rr','rt','rc','rd',
	2	'tk','ex','ar','ao','aa','ac','ax','av','d2','dn',
	3	'an','dm','dt','ah','dp','pd','dz','az'/
	DATA ARGTYP/  2 ,  2 ,  2 ,  2 ,  2 ,  0 ,  0 ,  2 ,  2 ,  0 ,
	1	  1 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,
	2	  1 ,  0 ,  3 ,  3 ,  3 ,  3 ,  1 ,  3 ,  2 ,  2 ,
	3	  1 ,  2 ,  1 ,  0 ,  0 ,  0 ,  0 ,  1 /

C GDT, PAGE 2
C
C First, validate that the caller is an implementer.
C
	IF(GDTFLG.NE.0) GO TO 2000		! if ok, skip.
	WRITE(OUTCH,100)			! not an implementer.
	RETURN					! boot him off
C
100	FORMAT(' You are not an authorized user.')

c GDT, PAGE 2A
C
C Here to get next command.
C
2000	WRITE(OUTCH,200)			! output prompt.
	READ(INPCH,210,ERR=2200,END=31000) CMD	! get command.
	IF(CMD.EQ.'  ') GO TO 2000		! ignore blanks.
	DO 2100 I=1,DBGMAX			! look it up.
	  IF((CMD.EQ.DBGCMD(I)).OR.(CMD.EQ.DBGSML(I))) GO TO 2300
2100	CONTINUE				! found?
2200	WRITE(OUTCH,220)			! no, lose.
	GO TO 2000
C
200	FORMAT(' GDT> ',$)
210	FORMAT(A2)
220	FORMAT(' ?')
230	FORMAT(2I6)
240	FORMAT(I6)
225	FORMAT(' Limits:   ',$)
235	FORMAT(' Entry:    ',$)
245	FORMAT(' Idx,Ary:  ',$)
c
2300	GO TO (2400,2500,2600,2700),ARGTYP(I)+1	! branch on arg type.
	GO TO 2200				! illegal type.
C
2700	WRITE(OUTCH,245)			! type 3, request array coords.
	READ(INPCH,230,ERR=2200,END=2000) J,K
	GO TO 2400
C
2600	WRITE(OUTCH,225)			! type 2, read bounds.
	READ(INPCH,230,ERR=2200,END=2000) J,K
	IF(K.EQ.0) K=J
	GO TO 2400
C
2500	WRITE(OUTCH,235)			! type 1, read entry no.
	READ(INPCH,240,ERR=2200,END=2000) J
2400	GO TO (10000,11000,12000,13000,14000,15000,16000,17000,18000,
	1 19000,20000,21000,22000,23000,24000,25000,26000,27000,28000,
	2 29000,30000,31000,32000,33000,34000,35000,36000,37000,38000,
	3 39000,40000,41000,42000,43000,44000,45000,46000,47000),I
	GO TO 2200				! what???

C GDT, PAGE 3
C
C DR-- Display Rooms
C
10000	IF(.NOT.VALID2(J,K,RLNT)) GO TO 2200	! args valid?
	WRITE(OUTCH,300)			! col hdrs.
	DO 10100 I=J,K
	  WRITE(OUTCH,310) I,(EQR(I,L),L=1,5)
10100	CONTINUE
	GO TO 2000
C
300	FORMAT(' RM#  DESC1  EXITS ACTION  VALUE  FLAGS')
310	FORMAT(1X,I3,4(1X,I6),1X,O6)
C
C DO-- Display Objects
C
11000	IF(.NOT.VALID2(J,K,OLNT)) GO TO 2200	! args valid?
	WRITE(OUTCH,320)			! col hdrs
	DO 11100 I=J,K
	  WRITE(OUTCH,330) I,(EQO(I,L),L=1,14)
11100	CONTINUE
	GO TO 2000
C
320	FORMAT(' OB# DESC1 DESC2 DESCO ACT FLAGS1 FLAGS2 FV TV
	1  SIZE CAPAC  ROOM ADV CON  READ')
330	FORMAT(1X,I3,3I6,I4,2O7,2I3,2I6,I6,2I4,I6)
C
C DA-- Display Adventurers
C
12000	IF(.NOT.VALID2(J,K,ALNT)) GO TO 2200	! args valid?
	WRITE(OUTCH,340)
	DO 12100 I=J,K
	  WRITE(OUTCH,350) I,(EQA(I,L),L=1,7)
12100	CONTINUE
	GO TO 2000
C
340	FORMAT(' AD#   ROOM  SCORE  VEHIC OBJECT ACTION  STREN  FLAGS')
350	FORMAT(1X,I3,6(1X,I6),1X,O6)
C
C DC-- Display Clock Events
C
13000	IF(.NOT.VALID2(J,K,CLNT)) GO TO 2200	! args valid?
	WRITE(OUTCH,360)
	DO 13100 I=J,K
	  WRITE(OUTCH,370) I,(EQC(I,L),L=1,2),CFLAG(I),CCNCEL(I)
13100	CONTINUE
	GO TO 2000
C
360	FORMAT(' CL#   TICK ACTION  FLAG  CANCEL')
370	FORMAT(1X,I3,1X,I6,1X,I6,5X,L1,5X,L1)
C
C DX-- Display Exits
C
14000	IF(.NOT.VALID2(J,K,XLNT)) GO TO 2200	! args valid?
	WRITE(OUTCH,380)			! col hdrs.
	DO 14100 I=J,K,10			! ten per line.
	  L=MIN0(I+9,K)				! compute end of line.
	  WRITE(OUTCH,390) I,L
	  DO 14050 L1=I,L			! loop through data
	    IF(TRAVEL(L1).GE.0) WRITE(OUTCH,391) TRAVEL(L1)
	    IF(TRAVEL(L1).LT.0) WRITE(OUTCH,392) TRAVEL(L1)
14050	  CONTINUE
	WRITE(OUTCH,393)
14100	CONTINUE
	GO TO 2000
C
380	FORMAT('     RANGE CONTENTS')
390	FORMAT(1X,I4,'-',I4,1X,$)
391	FORMAT('+',O7,$)
392	FORMAT('+',I7,$)
393	FORMAT('+')
C
C DH-- Display Hacks
C
15000	WRITE(OUTCH,400) THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
	GO TO 2000
C
400	FORMAT(' THFPOS=',I6,', THFFLG=',L2,', THFACT=',L2/
	1' SWDACT=',L2,', SWDSTA=',I2)
C
C DL-- Display Lengths
C
16000	WRITE(OUTCH,410) RLNT,XLNT,OLNT,CLNT,VLNT,ALNT,MLNT,R2LNT,
	1	MBASE,STRBIT
	GO TO 2000
C
410	FORMAT(' R=',I6,', X=',I6,', O=',I6,', C=',I6/
	1' V=',I6,', A=',I6,', M=',I6,', R2=',I5/
	2' MBASE=',I6,', STRBIT=',I6)
C
C DV-- Display Villains
C
17000	IF(.NOT.VALID2(J,K,VLNT)) GO TO 2200	! args valid?
	WRITE(OUTCH,420)			! col hdrs
	DO 17100 I=J,K
	  WRITE(OUTCH,430) I,(EQV(I,L),L=1,5)
17100	CONTINUE
	GO TO 2000
C
420	FORMAT(' VL# OBJECT   PROB   OPPS   BEST  MELEE')
430	FORMAT(1X,I3,5(1X,I6))
C
C DF-- Display Flags
C
18000	IF(.NOT.VALID2(J,K,FMAX)) GO TO 2200	! args valid?
	DO 18100 I=J,K
	  WRITE(OUTCH,440) I,FLAGS(I)
18100	CONTINUE
	GO TO 2000
C
440	FORMAT(' Flag #',I2,' = ',L1)
C
C DS-- Display State
C
19000	WRITE(OUTCH,450) PRSA,PRSO,PRSI,PRSWON,PRSCON
	WRITE(OUTCH,460) WINNER,HERE,TELFLG
	WRITE(OUTCH,470) MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,LTSHFT,BLOC,
	1	MUNGRM,HS,EGSCOR,EGMXSC
	WRITE(OUTCH,475) FROMDR,SCOLRM,SCOLAC
	GO TO 2000
C
450	FORMAT(' Parse vector=',3(1X,I6),1X,L6,1X,I6)
460	FORMAT(' Play vector= ',2(1X,I6),1X,L6)
470	FORMAT(' State vector=',7(1X,I6)/14X,4(1X,I6))
475	FORMAT(' Scol vector= ',1X,O6,2(1X,I6))

C GDT, PAGE 4
C
C AF-- Alter Flags
C
20000	IF(.NOT.VALID1(J,FMAX)) GO TO 2200	! entry no valid?
	WRITE(OUTCH,480) FLAGS(J)		! type old, get new.
	READ(INPCH,490,ERR=2200,END=2000) FLAGS(J)
	GO TO 2000
C
480	FORMAT(' Old=',L2,6X,'New= ',$)
490	FORMAT(L1)
C
C 21000-- Help
C
21000	WRITE(OUTCH,900)
	GO TO 2000
C
900	FORMAT(' Valid commands are:'/' AA- Alter ADVS'/
	1' AC- Alter CEVENT'/' AF- Alter FINDEX'/' AH- Alter HERE'/
	2' AN- Alter switches'/' AO- Alter OBJCTS'/' AR- Alter ROOMS'/
	3' AV- Alter VILLS'/' AX- Alter EXITS'/
	3' AZ- Alter PUZZLE'/' DA- Display ADVS'/
	4' DC- Display CEVENT'/' DF- Display FINDEX'/' DH- Display HACKS'/
	5' DL- Display lengths'/' DM- Display RTEXT'/
	6' DN- Display switches'/
	6' DO- Display OBJCTS'/' DP- Display parser'/
	6' DR- Display ROOMS'/' DS- Display state'/' DT- Display text'/
	7' DV- Display VILLS'/' DX- Display EXITS'/' DZ- Display PUZZLE'/
	8' D2- Display ROOM2'/' EX- Exit'/' HE- Type this message'/
	9' NC- No cyclops'/' ND- No deaths'/' NR- No robber'/
	1' NT- No troll'/' PD- Program detail'/
	1' RC- Restore cyclops'/' RD- Restore deaths'/
	2' RR- Restore robber'/' RT- Restore troll'/' TK- Take.')
C
C NR-- No Robber
C
22000	THFFLG=.FALSE.				! disable robber.
	THFACT=.FALSE.
	CALL NEWSTA(THIEF,0,0,0,0)		! vanish thief.
	WRITE(OUTCH,500)
	GO TO 2000
C
500	FORMAT(' No robber.')
C
C NT-- No Troll
C
23000	TROLLF=.TRUE.
	CALL NEWSTA(TROLL,0,0,0,0)
	WRITE(OUTCH,510)
	GO TO 2000
C
510	FORMAT(' No troll.')
C
C NC-- No Cyclops
C
24000	CYCLOF=.TRUE.
	CALL NEWSTA(CYCLO,0,0,0,0)
	WRITE(OUTCH,520)
	GO TO 2000
C
520	FORMAT(' No cyclops.')
C
C ND-- Immortality Mode
C
25000	DBGFLG=1
	WRITE(OUTCH,530)
	GO TO 2000
C
530	FORMAT(' No deaths.')
C
C RR-- Restore Robber
C
26000	THFACT=.TRUE.
	WRITE(OUTCH,540)
	GO TO 2000
C
540	FORMAT(' Restored robber.')
C
C RT-- Restore Troll
C
27000	TROLLF=.FALSE.
	CALL NEWSTA(TROLL,0,MTROL,0,0)
	WRITE(OUTCH,550)
	GO TO 2000
C
550	FORMAT(' Restored troll.')
C
C RC-- Restore Cyclops
C
28000	CYCLOF=.FALSE.
	MAGICF=.FALSE.
	CALL NEWSTA(CYCLO,0,MCYCL,0,0)
	WRITE(OUTCH,560)
	GO TO 2000
C
560	FORMAT(' Restored cyclops.')
C
C RD-- Mortal Mode
C
29000	DBGFLG=0
	WRITE(OUTCH,570)
	GO TO 2000
C
570	FORMAT(' Restored deaths.')

C GDT, PAGE 5
C
C TK-- Take
C
30000	IF(.NOT.VALID1(J,OLNT)) GO TO 2200	! valid object?
	CALL NEWSTA(J,0,0,0,WINNER)		! yes, take object.
	WRITE(OUTCH,580)			! tell.
	GO TO 2000
C
580	FORMAT(' Taken.')
C
C EX-- Goodbye
C
31000	RETURN
C
C AR-- Alter Room Entry
C
32000	IF(.NOT.VALID3(J,RLNT,K,5)) GO TO 2200	! indices valid?
	WRITE(OUTCH,590) EQR(J,K)		! type old, get new.
	READ(INPCH,600,ERR=2200,END=2000) EQR(J,K)
	GO TO 2000
C
590	FORMAT(' Old= ',I6,6X,'New= ',$)
600	FORMAT(I6)
C
C AO-- Alter Object Entry
C
33000	IF(.NOT.VALID3(J,OLNT,K,14)) GO TO 2200	! indices valid?
	WRITE(OUTCH,590) EQO(J,K)
	READ(INPCH,600,ERR=2200,END=2000) EQO(J,K)
	GO TO 2000
C
C AA-- Alter Advs Entry
C
34000	IF(.NOT.VALID3(J,ALNT,K,7)) GO TO 2200	! indices valid?
	WRITE(OUTCH,590) EQA(J,K)
	READ(INPCH,600,ERR=2200,END=2000) EQA(J,K)
	GO TO 2000
C
C AC-- Alter Clock Events
C
35000	IF(.NOT.VALID3(J,CLNT,K,4)) GO TO 2200	! indices valid?
	IF(K.EQ.3) GO TO 35500			! flags entry?
	IF(K.EQ.4) GO TO 35600			! cancel entry?
	WRITE(OUTCH,590) EQC(J,K)
	READ(INPCH,600,ERR=2200,END=2000) EQC(J,K)
	GO TO 2000
C
35500	WRITE(OUTCH,480) CFLAG(J)
	READ(INPCH,490,ERR=2200,END=2000) CFLAG(J)
	GO TO 2000
C
35600	WRITE(OUTCH,480) CCNCEL(J)
	READ(INPCH,490,ERR=2200,END=2000) CCNCEL(J)
	GO TO 2000

C GDT, PAGE 6
C
C AX-- Alter Exits
C
36000	IF(.NOT.VALID1(J,XLNT)) GO TO 2200	! entry no valid?
	IF(TRAVEL(J).LT.0) GO TO 36100		! string entry?
	WRITE(OUTCH,610) TRAVEL(J)
	READ(INPCH,620,ERR=2200,END=2000) TRAVEL(J)
	GO TO 2000
C
36100	WRITE(OUTCH,590) TRAVEL(J)
	READ(INPCH,600,ERR=2200,END=2000) TRAVEL(J)
	GO TO 2000
C
610	FORMAT(' Old= ',O6,6X,'New= ',$)
620	FORMAT(O6)
C
C AV-- Alter Villains
C
37000	IF(.NOT.VALID3(J,VLNT,K,5)) GO TO 2200	! indices valid?
	WRITE(OUTCH,590) EQV(J,K)
	READ(INPCH,600,ERR=2200,END=2000) EQV(J,K)
	GO TO 2000
C
C D2-- Display Room2 List
C
38000	IF(.NOT.VALID2(J,K,R2LNT)) GO TO 2200
	DO 38100 I=J,K
	  WRITE(OUTCH,630) I,R2(I),O2(I)
38100	CONTINUE
	GO TO 2000
C
630	FORMAT(' #',I2,'   Room=',I6,'   Obj=',I6)
C
C DN-- Display Switches
C
39000	IF(.NOT.VALID2(J,K,SMAX)) GO TO 2200	! valid?
	DO 39100 I=J,K
	  WRITE(OUTCH,640) I,SWITCH(I)
39100	CONTINUE
	GO TO 2000
C
640	FORMAT(' Switch #',I2,' = ',I6)
C
C AN-- Alter Switches
C
40000	IF(.NOT.VALID1(J,SMAX)) GO TO 2200	! valid entry?
	WRITE(OUTCH,590) SWITCH(J)
	READ(INPCH,600,ERR=2200,END=2000) SWITCH(J)
	GO TO 2000
C
C DM-- Display Messages
C
41000	IF(.NOT.VALID2(J,K,MLNT)) GO TO 2200	! valid limits?
	WRITE(OUTCH,380)
	DO 41100 I=J,K,10
	  L=MIN0(I+9,K)
	  WRITE(OUTCH,650) I,L,(RTEXT(L1),L1=I,L)
41100	CONTINUE
	GO TO 2000
C
650	FORMAT(1X,I4,'-',I4,10(1X,I6))
C
C DT-- Display Text
C
42000	CALL RSPEAK(J)
	GO TO 2000
C
C AH-- Alter Here
C
43000	WRITE(OUTCH,590) HERE
	READ(INPCH,600,ERR=2200,END=2000) HERE
	AROOM(PLAYER)=HERE
	GO TO 2000
C
C DP-- Display Parser State
C
44000	WRITE(OUTCH,660)
	1	OFLAG,OACT,OPREP1,OOBJ1,OPREP,ONAME,OPREP2,OOBJ2,
	2	LASTIT,ACT,OBJ1,OBJ2,PREP1,PREP2,SYN,
	3	BUNLNT,BUNSUB,BUNVEC
	GO TO 2000
C
660	FORMAT(' ORPHS= ',5I7,' "',A,'" ',2I7/' IT=    ',I7/
	1' PV=    ',5I7/' SYN=   ',2O7,4I7/15X,O7,4I7/
	2' BUNCH= ',7I7/22X,5I7)
C
C PD-- Program Detail
C
45000	WRITE(OUTCH,610) PRSFLG			! type old, get new.
	READ(INPCH,620,ERR=2200,END=2000) PRSFLG
	GO TO 2000
C
C DZ-- Display Puzzle Room
C
46000	DO 46100 I=1,64,8			! display puzzle
	  WRITE(OUTCH,670) (CPVEC(J),J=I,I+7)
46100	CONTINUE
	GO TO 2000
C
670	FORMAT(2X,8I3)
C
C AZ-- Alter Puzzle Room
C
47000	IF(.NOT.VALID1(J,64)) GO TO 2200	! valid entry?
	WRITE(OUTCH,590) CPVEC(J)		! output old,
	READ(OUTCH,600) CPVEC(J)		! get new.
	GO TO 2000
C
	END

C Operating system dependent subroutines.
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C ITIME - Return system time in component form
C
	SUBROUTINE ITIME (H, M, S)
	IMPLICIT INTEGER (A-Z)
	INTEGER*2 TIME (7)

	CALL SYS$NUMTIM (TIME, %VAL(0))
	H = TIME(4)
	M = TIME(5)
	S = TIME(6)
	RETURN

	END
C
C RND - Return a random integer mod n
C
	INTEGER FUNCTION RND (N)
	IMPLICIT INTEGER (A-Z)
	REAL RAN
	COMMON /SEED/ RNSEED

	RND = RAN(RNSEED)*FLOAT(N)
	RETURN

	END
C
C INIRND - Initialize random number seed
C
	SUBROUTINE INIRND (LOW, HIGH)
	IMPLICIT INTEGER (A-Z)
	COMMON /SEED/ RNSEED

	RNSEED = (ISHFT(HIGH,16)+LOW).OR.1
	RETURN

	END
	

C Object processors for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C OAPPLI- Object action routines
C
C Declarations
C
	LOGICAL FUNCTION OAPPLI(RI,ARG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL SOBJS,NOBJS
	LOGICAL QOPEN,QON,LIT,WASLIT
	LOGICAL MOVETO,RMDESC,CLOCKD
	LOGICAL THIEFP,CYCLOP,TROLLP,BALLOP
	LOGICAL QEMPTY,QHERE,F,OPNCLS
	PARAMETER (MXSMP=99)
C
C Functions and data
C
	QOPEN(R)=(OFLAG2(R).AND.OPENBT).NE.0
	QON(R)=(OFLAG1(R).AND.ONBT).NE.0
C
	IF(RI.EQ.0) GO TO 10			! zero is false app.
	IF(RI.LE.MXSMP) GO TO 100		! simple object?
	IF(PRSO.NE.0) ODO2=ODESC2(PRSO)
	IF(PRSI.NE.0) ODI2=ODESC2(PRSI)
	AV=AVEHIC(WINNER)
	FLOBTS=FLAMBT+LITEBT+ONBT
	OAPPLI=.TRUE.
	WASLIT=LIT(HERE)
C
	GO TO (2000,5000,10000,11000,12000,15000,18000,
	1 19000,20000,22000,25000,26000,32000,35000,39000,40000,
	2 45000,47000,48000,49000,50000,51000,52000,54000,55000,
	3 56000,57000,58000,59000,60000,61000,62000),
	3	(RI-MXSMP)
	CALL BUG(6,RI)
C
C Return here to declare false result.
C
10	OAPPLI=.FALSE.
	RETURN
C
C Return here to test for light source change.
C
50	IF(WASLIT.AND..NOT.LIT(HERE)) CALL RSPEAK(406)
	RETURN
C
C Simple objects, processed externally.
C
100	IF(RI.LT.32) OAPPLI=SOBJS(RI,ARG)
	IF(RI.GE.32) OAPPLI=NOBJS(RI,ARG)
	RETURN

C OAPPLI, PAGE 3
C
C O100--	Machine
C
2000	IF(HERE.NE.MMACH) GO TO 10		! not here? f
	OAPPLI=OPNCLS(MACHI,123,124)		! handle opn/cls.
	RETURN
C
C O101--	Water
C
5000	IF(PRSA.NE.GTHROW) GO TO 5025		! go through?
	CALL RSPEAK(331+RND(3))			! joke.
	RETURN
C
5025	IF(PRSA.NE.FILLW) GO TO 5050		! fill x with y is
	PRSA=PUTW				! made into
	I=PRSI
	PRSI=PRSO
	PRSO=I					! put y in x.
	I=ODI2
	ODI2=ODO2
	ODO2=I
5050	IF((PRSO.EQ.WATER).OR.(PRSO.EQ.GWATE)) GO TO 5100
	CALL RSPEAK(561)			! water is ind obj,
	RETURN					! punt.
C
5100	IF(PRSA.NE.TAKEW) GO TO 5400		! take water?
	IF(PRSI.NE.0) GO TO 5200		! from x?
	IF((OADV(BOTTL).EQ.WINNER).AND.(OCAN(PRSO).NE.BOTTL))
	1	GO TO 5500			! take, have bottle -> put.
	IF(OCAN(PRSO).NE.BOTTL) GO TO 5150	! water in bottle?
	IF(OADV(BOTTL).NE.WINNER) GO TO 5125	! already have bottle?
	CALL RSPEAK(103)			! yes, already have water.
	RETURN
C
5125	PRSO=BOTTL				! take bottle.
	GO TO 10				! do normal take.
C
5150	IF(OCAN(PRSO).EQ.0) GO TO 5300		! if not inside, take.
	PRSI=OCAN(PRSO)				! make into take from.
	GO TO 5250				! check for open.
C
5200	IF(OCAN(PRSO).NE.PRSI) GO TO 5250	! is it inside?
	CALL RSPEAK(1038)			! not in that.
	RETURN
C
5250	IF(QOPEN(PRSI)) GO TO 5300		! is it open?
	CALL RSPSUB(525,ODI2)			! no, not oopen.
	RETURN
C
5300	IF(AV.NE.0) GO TO 5800			! if in vehicle, put there.
	CALL NEWSTA(PRSO,615,0,0,0)		! slips through fingers
	RETURN
C
C
5400	IF(PRSA.NE.PUTW) GO TO 5700		! put water in x?
	IF(PRSI.EQ.BOTTL) GO TO 5500		! in bottle?
	IF(((OFLAG2(PRSI).AND.VEHBT).NE.0).OR.
	1  ((AV.NE.0).AND.(PRSI.EQ.AV))) GO TO 5450	! in veh?
	CALL RSPSUB(297,ODI2)			! wont go elsewhere.
	CALL NEWSTA(PRSO,0,0,0,0)		! vanish water.
	RETURN
C
5450	CALL NEWSTA(WATER,0,0,PRSI,0)		! water into vehicle.
	CALL RSPSUB(296,ODESC2(PRSI))		! describe.
	RETURN
C
5500	IF(QOPEN(BOTTL)) GO TO 5550		! bottle open?
	CALL RSPEAK(612)			! no, lose.
	RETURN
C
5550	IF(QEMPTY(BOTTL)) GO TO 5600		! open, empty?
	CALL RSPEAK(613)			! no, already full.
	RETURN
C
5600	CALL NEWSTA(WATER,614,0,BOTTL,0)	! take water to bottle.
	RETURN
C
5700	IF((PRSA.NE.DROPW).AND.(PRSA.NE.POURW).AND.
	1	(PRSA.NE.GIVEW)) GO TO 5900	! drop, pour, give?
	IF(AV.NE.0) GO TO 5800			! into vehicle?
	CALL NEWSTA(PRSO,133,0,0,0)		! no, vanishes.
	RETURN
C
5800	CALL NEWSTA(WATER,0,0,AV,0)		! water into his vehicle.
	CALL RSPSUB(296,ODESC2(AV))		! describe.
	RETURN
C
5900	IF(PRSA.NE.THROWW) GO TO 10		! last chance, throw?
	CALL NEWSTA(PRSO,132,0,0,0)		! vanishes.
	RETURN

C OAPPLI, PAGE 4
C
C O102--	Leaf pile
C
10000	IF(PRSA.NE.BURNW) GO TO 10500		! burn?
	IF(QOPEN(GRATE).OR.(RVCLR.NE.0)) GO TO 10050
	RVCLR=1					! leaves moved.
	CALL NEWSTA(GRATE,30,HERE,0,0)		! grating appears.
10050	IF(OADV(PRSO).EQ.PLAYER) GO TO 10100	! was he carrying?
	CALL NEWSTA(PRSO,158,0,0,0)		! no, burn leaves.
	RETURN
C
10100	CALL NEWSTA(PRSO,0,HERE,0,0)		! drop leaves.
	CALL JIGSUP(159)			! burn him.
	RETURN
C
10500	IF(PRSA.NE.MOVEW) GO TO 10600		! move?
	CALL RSPEAK(2)				! done.
10550	IF(QOPEN(GRATE).OR.(RVCLR.NE.0)) RETURN	! done before?
	RVCLR=1					! leaves moved.
	CALL NEWSTA(GRATE,30,HERE,0,0)		! grating appears.
	RETURN
C
10600	IF(PRSA.NE.TAKEW) GO TO 10700		! take?
	OAPPLI=.FALSE.				! don't handle here.
	GO TO 10550				! make grate visible.
C
10700	IF((PRSA.NE.LOOKUW).OR.QOPEN(GRATE).OR.(RVCLR.NE.0)) GO TO 10
	CALL RSPEAK(344)			! look under?
	RETURN
C
C O103--	Troll, done externally.
C
11000	OAPPLI=TROLLP(ARG)			! troll processor.
	GO TO 50				! go see if now dark.
C
C O104--	Rusty knife.
C
12000	IF(PRSA.NE.TAKEW) GO TO 12100		! take?
	IF(OADV(SWORD).EQ.WINNER) CALL RSPEAK(160) ! pulse sword.
	GO TO 10
C
12100	IF((((PRSA.NE.ATTACW).AND.(PRSA.NE.KILLW)).OR.
	1	(PRSI.NE.RKNIF)).AND.
	2  (((PRSA.NE.SWINGW).AND.(PRSA.NE.THROWW)).OR.
	3	(PRSO.NE.RKNIF))) GO TO 10
	CALL NEWSTA(RKNIF,0,0,0,0)		! kill knife.
	CALL JIGSUP(161)			! kill him.
	RETURN

C OAPPLI, PAGE 5
C
C O105--	Glacier
C
15000	IF(PRSA.NE.THROWW) GO TO 15500		! throw?
	IF(PRSO.NE.TORCH) GO TO 15400		! torch?
	CALL NEWSTA(ICE,169,0,0,0)		! melt ice.
	ODESC1(TORCH)=174			! mung torch.
	ODESC2(TORCH)=173
	OFLAG1(TORCH)=OFLAG1(TORCH).AND. .NOT.FLOBTS
	CALL NEWSTA(TORCH,0,STREA,0,0)		! move torch.
	GLACRF=.TRUE.				! glacier gone.
	IF(.NOT.LIT(HERE)) CALL RSPEAK(170)	! in dark?
	RETURN
C
15400	CALL RSPEAK(171)			! joke if not torch.
	GO TO 10				! don't handle.
C
15500	IF((PRSA.NE.MELTW).OR.(PRSO.NE.ICE)) GO TO 10
	IF((OFLAG1(PRSI).AND.FLOBTS).EQ.FLOBTS) GO TO 15600
	CALL RSPSUB(298,ODI2)			! cant melt with that.
	RETURN
C
15600	GLACMF=.TRUE.				! partial melt.
	IF(PRSI.NE.TORCH) GO TO 15700		! melt with torch?
	ODESC1(TORCH)=174			! mung torch.
	ODESC2(TORCH)=173
	OFLAG1(TORCH)=OFLAG1(TORCH).AND. .NOT.FLOBTS
15700	CALL JIGSUP(172)			! drown.
	RETURN
C
C O106--	Black book
C
18000	IF(PRSA.NE.OPENW) GO TO 18100		! open?
	CALL RSPEAK(180)			! joke.
	RETURN
C
18100	IF(PRSA.NE.CLOSEW) GO TO 18200		! close?
	CALL RSPEAK(181)
	RETURN
C
18200	IF(PRSA.NE.BURNW) GO TO 10		! burn?
	CALL NEWSTA(PRSO,0,0,0,0)		! fatal joke.
	CALL JIGSUP(182)
	RETURN

C OAPPLI, PAGE 6
C
C O107--	Candles
C
19000	IF(ORCAND.NE.0) GO TO 19100		! first ref?
	ORCAND=1				! yes, candles are
	CFLAG(CEVCND)=.TRUE.
	CTICK(CEVCND)=50			! burning when seen.
C
19100	IF(PRSI.EQ.CANDL) GO TO 10		! ignore ind refs.
	IF(PRSA.NE.TRNOFW) GO TO 19200		! turn off?
	I=513					! assume off.
	IF(QON(CANDL)) I=514			! if on, different.
	CFLAG(CEVCND)=.FALSE.			! disable countdown.
	OFLAG1(CANDL)=OFLAG1(CANDL).AND. .NOT.ONBT
	CALL RSPEAK(I)
	GO TO 50				! go see if now dark.
C
19200	IF((PRSA.NE.BURNW).AND.(PRSA.NE.TRNONW)) GO TO 10
	IF((OFLAG1(CANDL).AND.LITEBT).NE.0) GO TO 19300
	CALL RSPEAK(515)			! candles too short.
	RETURN
C
19300	IF(PRSI.NE.0) GO TO 19400		! any flame?
	CALL RSPEAK(516)			! no, lose.
	CALL ORPHAN(-1,ACT,PREP1,CANDL,2,' ',0,0) ! orphan "light candle with"
	PRSWON=.FALSE.
	PRSCON=0
	RETURN
C
19400	IF((PRSI.NE.MATCH).OR. .NOT.QON(MATCH)) GO TO 19500
	I=517					! assume off.
	IF(QON(CANDL)) I=518			! if on, joke.
	OFLAG1(CANDL)=OFLAG1(CANDL).OR.ONBT	! lite candles.
	CFLAG(CEVCND)=.TRUE.			! resume countdown.
	CALL RSPEAK(I)
	RETURN
C
19500	IF((PRSI.NE.TORCH).OR. .NOT.QON(TORCH)) GO TO 19600
	IF(QON(CANDL)) GO TO 19700		! already on?
	CALL NEWSTA(CANDL,521,0,0,0)		! no, vaporize.
	RETURN
C
19600	CALL RSPEAK(519)			! cant light with that.
	RETURN
C
19700	CALL RSPEAK(520)			! already on.
	RETURN
C
C O108--	Matches
C
20000	IF((PRSA.NE.TRNONW).OR.(PRSO.NE.MATCH)) GO TO 20500
	IF(ORMTCH.NE.0) GO TO 20100		! any matches left?
	CALL RSPEAK(183)			! no, lose.
	RETURN
C
20100	ORMTCH=ORMTCH-1				! decrement no matches.
	OFLAG1(MATCH)=OFLAG1(MATCH).OR.FLOBTS
	CFLAG(CEVMAT)=.TRUE.
	CTICK(CEVMAT)=2				! countdown.
	CALL RSPEAK(184)
	RETURN
C
20500	IF((PRSA.NE.TRNOFW).OR.((OFLAG1(MATCH).AND.ONBT).EQ.0))
	1	GO TO 10			! extinguish?
	OFLAG1(MATCH)=OFLAG1(MATCH).AND. .NOT.FLOBTS
	CTICK(CEVMAT)=0
	CALL RSPEAK(185)
	GO TO 50				! go see if now dark.
C
C O109--	Cyclops, processed externally.
C
22000	OAPPLI=CYCLOP(ARG)			! cyclops
	GO TO 50				! go see if now dark.
C
C O110--	Thief, processed externally.
C
25000	OAPPLI=THIEFP(ARG)
	GO TO 50				! go see if now dark.
C
C O111--	Window
C
26000	OAPPLI=OPNCLS(WINDO,208,209)		! open/cls window.
	RETURN
C
C O112--	Pile of bodies
C
32000	IF(PRSA.NE.TAKEW) GO TO 32500		! take?
	CALL RSPEAK(228)			! cant.
	RETURN
C
32500	IF((PRSA.NE.BURNW).AND.(PRSA.NE.MUNGW)) GO TO 10
	IF(ONPOLF) RETURN			! burn or mung?
	ONPOLF=.TRUE.				! set head on pole.
	CALL NEWSTA(HPOLE,0,LLD2,0,0)
	CALL JIGSUP(229)			! beheaded.
	RETURN
C
C O113--	Vampire bat
C
35000	CALL RSPEAK(50)				! time to fly, jack.
	F=MOVETO(BATDRP(RND(9)+1),WINNER)	! select random dest.
	F=RMDESC(0)
	RETURN

C OAPPLI, PAGE 7
C
C O114--	Stick
C
39000	IF(PRSA.NE.WAVEW) GO TO 10		! wave?
	IF(HERE.EQ.MRAIN) GO TO 39500		! on rainbow?
	IF((HERE.EQ.POG).OR.(HERE.EQ.FALLS)) GO TO 39200
	CALL RSPEAK(244)			! nothing happens.
	RETURN
C
39200	OFLAG1(POT)=OFLAG1(POT).OR.VISIBT	! make gold visible.
	RAINBF=.NOT. RAINBF			! complement rainbow.
	I=245					! assume off.
	IF(RAINBF) I=246			! if on, solid.
	CALL RSPEAK(I)				! describe.
	RETURN
C
39500	RAINBF=.FALSE.				! on rainbow,
	CALL JIGSUP(247)			! take a fall.
	RETURN
C
C O115--	Balloon, handled externally.
C
40000	OAPPLI=BALLOP(ARG)
	RETURN
C
C O116--	Heads
C
45000	IF(PRSA.NE.HELLOW) GO TO 45100		! hello heads?
	CALL RSPEAK(633)			! truly bizarre.
	RETURN
C
45100	IF((PRSA.NE.KILLW).AND.(PRSA.NE.MUNGW).AND.
	1  (PRSA.NE.ATTACW).AND.(PRSA.NE.KICKW)) GO TO 10
	CALL RSPEAK(260)			! bad news for player
	I=ROBADV(WINNER,0,LCASE,0)+ROBRM(HERE,100,0,LCASE,0)
	IF(I.NE.0) CALL NEWSTA(LCASE,0,LROOM,0,0) ! if robbed, make large case.
	CALL JIGSUP(261)			! kill him.
	RETURN

C OAPPLI, PAGE 8
C
C O117--	Sphere
C
47000	IF(CAGESF.OR.(PRSA.NE.TAKEW)) GO TO 47600 ! take?
	IF(WINNER.NE.PLAYER) GO TO 47500	! robot take?
	CALL RSPEAK(263)			! no, drop cage.
	IF(OROOM(ROBOT).NE.HERE) GO TO 47200	! robot here?
	F=MOVETO(CAGED,WINNER)			! yes, move into cage.
	CALL NEWSTA(ROBOT,0,CAGED,0,0)		! move robot.
	AROOM(AROBOT)=CAGED
	OFLAG1(ROBOT)=OFLAG1(ROBOT).OR.NDSCBT	! dont describe robot.
	CFLAG(CEVSPH)=.TRUE.
	CTICK(CEVSPH)=10			! get out in 10 or else.
	RETURN
C
47200	CALL NEWSTA(SPHER,0,0,0,0)		! youre dead.
	RFLAG(CAGER)=RFLAG(CAGER).OR.RMUNG	! mung cage room.
	RDESC1(CAGER)=147
	CALL JIGSUP(148)			! mung player.
	RETURN
C
47500	CALL NEWSTA(SPHER,0,0,0,0)		! robot tried,
	CALL NEWSTA(ROBOT,264,0,0,0)		! kill him.
	CALL NEWSTA(CAGE,0,HERE,0,0)		! insert mangled cage.
	GO TO 50				! go see if now dark.
C
47600	IF(PRSA.NE.LOOKIW) GO TO 10		! look in?
	OAPPLI=NOBJS(OACTIO(PALAN))		! do palantir function.
	RETURN
C
C O118--	Geometrical buttons
C
48000	IF(PRSA.NE.PUSHW) GO TO 10		! push?
	I=PRSO-SQBUT+1				! get button index.
	IF((I.LE.0).OR.(I.GE.4)) GO TO 10	! a button?
	IF(WINNER.NE.PLAYER) GO TO (48100,48200,48300),I
	CALL JIGSUP(265)			! you pushed, you die.
	RETURN
C
48100	I=267
	IF(CAROZF) I=266			! speed up?
	CAROZF=.TRUE.
	CALL RSPEAK(I)
	RETURN
C
48200	I=266					! assume no change.
	IF(CAROZF) I=268
	CAROZF=.FALSE.
	CALL RSPEAK(I)
	RETURN
C
48300	CAROFF=.NOT.CAROFF			! flip carousel.
	IF(.NOT.QHERE(IRBOX,CAROU)) GO TO 48400	! iron box in carousel?
	CALL RSPEAK(269)			! yes, thump.
	OFLAG1(IRBOX)=OFLAG1(IRBOX).XOR.VISIBT	! complement visibility.
	IF(CAROFF) RFLAG(CAROU)=RFLAG(CAROU).AND. .NOT.RSEEN
	RETURN
C
48400	CALL RSPEAK(232)			! click.
	RETURN
C
C O119--	Flask function
C
49000	IF(PRSA.EQ.OPENW) GO TO 49100		! open?
	IF((PRSA.NE.MUNGW).AND.(PRSA.NE.THROWW)) GO TO 10
	CALL NEWSTA(FLASK,270,0,0,0)		! kill flask.
49100	RFLAG(HERE)=RFLAG(HERE).OR.RMUNG	! mung room.
	RDESC1(HERE)=271
	CALL JIGSUP(272)			! poisoned.
	RETURN
C
C O120--	Bucket function
C
50000	IF((ARG.NE.0).OR.(PRSA.NE.BURNW)) GO TO 50100
	CALL RSPEAK(928)			! can't burn.
	RETURN
C
50100	IF(ARG.NE.2) GO TO 10			! readout?
	IF((OCAN(WATER).NE.BUCKE).OR.BUCKTF) GO TO 50500
	BUCKTF=.TRUE.				! bucket at top.
	CFLAG(CEVBUC)=.TRUE.
	CTICK(CEVBUC)=100			! start countdown.
	CALL NEWSTA(BUCKE,290,TWELL,0,0)	! reposition bucket.
	GO TO 50900				! finish up.
C
50500	IF((OCAN(WATER).EQ.BUCKE).OR..NOT.BUCKTF) GO TO 10
	BUCKTF=.FALSE.
	CALL NEWSTA(BUCKE,291,BWELL,0,0)	! bucket at bottom.
50900	IF(AV.NE.BUCKE) RETURN			! not in bucket?
	F=MOVETO(OROOM(BUCKE),WINNER)		! move adventurer.
	F=RMDESC(0)				! describe room.
	RETURN

C OAPPLI, PAGE 9
C
C O121--	Eatme cake
C
51000	IF((PRSA.NE.EATW).OR.(PRSO.NE.ECAKE).OR.
	1	(HERE.NE.ALICE)) GO TO 10	! eat cake in aliceroom?
	CALL NEWSTA(ECAKE,273,0,0,0)		! vanish cake.
	OFLAG1(ROBOT)=OFLAG1(ROBOT).AND. .NOT.VISIBT	! vanish robot.
	DO 51100 I=1,OLNT			! make objects big.
	  IF((OROOM(I).NE.ALICE).OR.(OSIZE(I).EQ.10000))
	1	GO TO 51100
	  OSIZE(I)=OSIZE(I)*64
	  OROOM(I)=ALISM
51100	CONTINUE
	OAPPLI=MOVETO(ALISM,WINNER)		! move to alice small.
	RETURN
C
C O122--	Icings
C
52000	IF(PRSA.NE.READW) GO TO 52200		! read?
	I=274					! cant read.
	IF(PRSI.NE.0) I=275			! through something?
	IF(PRSI.EQ.BOTTL) I=276			! through bottle?
	IF(PRSI.EQ.FLASK) I=277+(PRSO-ORICE)	! through flask?
	CALL RSPEAK(I)				! read flask.
	RETURN
C
52200	IF((PRSA.NE.THROWW).OR.(PRSO.NE.RDICE).OR.(PRSI.NE.POOL))
	1	GO TO 52300			! throw rdice at pool?
	CALL NEWSTA(POOL,280,0,0,0)		! vanish pool.
	OFLAG1(SAFFR)=OFLAG1(SAFFR).OR.VISIBT	! materialize spices.
	RETURN
C
52300	IF((HERE.NE.ALICE).AND.(HERE.NE.ALISM).AND.(HERE.NE.ALITR))
	1	GO TO 10			! in wonderland?
	IF(((PRSA.NE.EATW).AND.(PRSA.NE.THROWW)).OR.
	1	(PRSO.NE.ORICE)) GO TO 52400	! throw orange ice?
	CALL NEWSTA(ORICE,0,0,0,0)		! vanish orange ice.
	RFLAG(HERE)=RFLAG(HERE).OR.RMUNG	! vanish room.
	RDESC1(HERE)=281
	CALL JIGSUP(282)			! vanish adventurer.
	RETURN
C
52400	IF((PRSA.NE.EATW).OR.(PRSO.NE.BLICE))
	1	GO TO 10			! eat blue ice?
	CALL NEWSTA(BLICE,283,0,0,0)		! vanish blue ice.
	IF(HERE.NE.ALISM) GO TO 52500		! in reduced room?
	OFLAG1(ROBOT)=OFLAG1(ROBOT).OR.VISIBT	! materialize robot.
	DO 52450 I=1,OLNT			! enlarge world.
	  IF((OROOM(I).NE.HERE).OR.(OSIZE(I).EQ.10000))
	1	GO TO 52450
	  OROOM(I)=ALICE
	  OSIZE(I)=OSIZE(I)/64
52450	CONTINUE
	OAPPLI=MOVETO(ALICE,WINNER)		! return
	RETURN
C
52500	CALL JIGSUP(284)			! enlarged in wrong room.
	RETURN
C
C O123--	Brick
C
54000	IF(PRSA.NE.BURNW) GO TO 10		! burn?
	CALL NEWSTA(BRICK,0,0,0,0)		! vanish brick.
	CALL JIGSUP(150)			! boom!
	RETURN
C
C O124--	Myself
C
55000	IF((PRSA.NE.GIVEW).OR.
	1 ((OFLAG2(PRSO).AND.NOCHBT).NE.0)) GO TO 55100	! give?
	CALL NEWSTA(PRSO,2,0,0,PLAYER)		! done.
	RETURN
C
55100	IF(PRSA.NE.TAKEW) GO TO 55200		! take?
	CALL RSPEAK(286)			! joke.
	RETURN
C
55200	IF((PRSA.NE.KILLW).AND.(PRSA.NE.MUNGW)) GO TO 10
	WINNER=PLAYER				! can't kill someone else.
	CALL JIGSUP(287)			! kill, no joke.
	RETURN

C OAPPLI, PAGE 10
C
C O125--	Panels inside mirror
C
56000	IF(PRSA.NE.PUSHW) GO TO 10		! push?
	IF(POLEUF.NE.0) GO TO 56100		! short pole up?
	I=731					! no, wont budge.
	IF(MOD(MDIR,180).EQ.0) I=732		! diff msg if n-s.
	CALL RSPEAK(I)				! tell wont move.
	RETURN
C
56100	IF(MLOC.NE.MRG) GO TO 56200		! in gdn room?
	CALL RSPEAK(733)			! you lose.
	CALL JIGSUP(685)
	RETURN
C
56200	I=831					! rotate l or r.
	IF((PRSO.EQ.RDWAL).OR.(PRSO.EQ.YLWAL)) I=830
	CALL RSPEAK(I)				! tell direction.
	MDIR=MOD(MDIR+45+(270*(I-830)),360)	! calculate new dir.
	CALL RSPSUB(734,695+(MDIR/45))		! tell new dir.
	IF(WDOPNF) CALL RSPEAK(730)		! if panel open, close.
	WDOPNF=.FALSE.
	RETURN					! done.
C
C O126--	Ends inside mirror
C
57000	IF(PRSA.NE.PUSHW) GO TO 10		! push?
	IF(MOD(MDIR,180).EQ.0) GO TO 57100	! mirror n-s?
	CALL RSPEAK(735)			! no, wont budge.
	RETURN
C
57100	IF(PRSO.NE.PINDR) GO TO 57300		! push pine wall?
	IF(((MLOC.EQ.MRC).AND.(MDIR.EQ.180)).OR.
	1  ((MLOC.EQ.MRD).AND.(MDIR.EQ.0)).OR.
	2   (MLOC.EQ.MRG)) GO TO 57200		! in view of gdn?
	CALL RSPEAK(736)			! no, opens.
	WDOPNF=.TRUE.				! indicate open.
	CFLAG(CEVPIN)=.TRUE.			! time opening.
	CTICK(CEVPIN)=5
	RETURN
C
57200	CALL RSPEAK(737)			! gdn sees you, die.
	CALL JIGSUP(685)
	RETURN
C
57300	NLOC=MLOC-1				! new loc if south.
	IF(MDIR.EQ.0) NLOC=MLOC+1		! new loc if north.
	IF((NLOC.GE.MRA).AND.(NLOC.LE.MRD)) GO TO 57400
	CALL RSPEAK(738)			! have reached end.
	RETURN
C
57400	I=699					! assume south.
	IF(MDIR.EQ.0) I=695			! north.
	J=739					! assume smooth.
	IF(POLEUF.NE.0) J=740			! pole up, wobbles.
	CALL RSPSUB(J,I)			! describe.
	MLOC=NLOC
	IF(MLOC.NE.MRG) RETURN			! now in gdn room?
C
	IF(POLEUF.NE.0) GO TO 57500		! pole up, gdn sees.
	IF(MROPNF.OR.WDOPNF) GO TO 57600	! door open, gdn sees.
	IF(MR1F.AND.MR2F) RETURN		! mirrors intact, ok.
	CALL RSPEAK(742)			! mirrors broken, die.
	CALL JIGSUP(743)
	RETURN
C
57500	CALL RSPEAK(741)			! pole up, die.
	CALL JIGSUP(743)
	RETURN
C
57600	CALL RSPEAK(744)			! door open, die.
	CALL JIGSUP(743)
	RETURN

C OAPPLI, PAGE 11
C
C O127--	Global guardians
C
58000	IF((PRSA.NE.ATTACW).AND.(PRSA.NE.KILLW).AND.
	1  (PRSA.NE.MUNGW)) GO TO 58100		! aggressive?
	CALL JIGSUP(745)			! lose.
	RETURN
C
58100	IF(PRSA.NE.HELLOW) GO TO 10		! hello?
	CALL RSPEAK(746)			! no reply.
	RETURN
C
C O128--	Global master
C
59000	IF((PRSA.NE.ATTACW).AND.(PRSA.NE.KILLW).AND.
	1  (PRSA.NE.MUNGW)) GO TO 59100		! aggressive?
	CALL JIGSUP(747)			! bad idea.
	RETURN
C
59100	IF(PRSA.NE.TAKEW) GO TO 10		! take?
	CALL RSPEAK(748)			! joke.
	RETURN
C
C O129--	Numeral five
C
60000	IF(PRSA.NE.TAKEW) GO TO 10		! take five?
	CALL RSPEAK(419)			! time passes.
	DO 60100 I=1,3				! wait a while.
	  IF(CLOCKD(X)) RETURN
60100	CONTINUE
	RETURN
C
C O130--	Crypt function
C
61000	IF(.NOT.ENDGMF) GO TO 45000		! if not eg, die.
	IF(PRSA.NE.OPENW) GO TO 61100		! open?
	I=793
	IF(QOPEN(TOMB)) I=794
	CALL RSPEAK(I)
	OFLAG2(TOMB)=OFLAG2(TOMB).OR.OPENBT	! now tomb with view.
	RETURN
C
61100	IF(PRSA.NE.CLOSEW) GO TO 45000		! close?
	I=795
	IF(QOPEN(TOMB)) I=796
	CALL RSPEAK(I)
	OFLAG2(TOMB)=OFLAG2(TOMB).AND..NOT.OPENBT
	IF(HERE.NE.CRYPT) RETURN
	CFLAG(CEVSTE)=.TRUE.
	CTICK(CEVSTE)=3				! if in crypt, start eg.
	RETURN

C OAPPLI, PAGE 12
C
C O131--	Global ladder
C
62000	IF((CPVEC(CPHERE+1).EQ.-2).OR.(CPVEC(CPHERE-1).EQ.-3))
	1	GO TO 62100			! ladder here?
	CALL RSPEAK(865)			! no, lose.
	RETURN
C
62100	IF((PRSA.EQ.CLMBW).OR.(PRSA.EQ.CLMBUW)) GO TO 62200
	CALL RSPEAK(866)			! climb it?
	RETURN
C
62200	IF((CPHERE.EQ.10).AND.(CPVEC(CPHERE+1).EQ.-2))
	1	GO TO 62300			! at exit?
	CALL RSPEAK(867)			! no, hit your head.
	RETURN
C
62300	F=MOVETO(CPANT,WINNER)			! to anteroom.
	F=RMDESC(3)				! describe.
	RETURN
C
	END

C SOBJS-	Simple objects processor
C
C Declarations
C
	LOGICAL FUNCTION SOBJS(RI,ARG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL MOVETO,OPNCLS,LIT,WASLIT
	LOGICAL QHERE,F,QOPEN
C
C Functions and data
C
	QOPEN(R)=(OFLAG2(R).AND.OPENBT).NE.0
C
	IF(PRSO.NE.0) ODO2=ODESC2(PRSO)
	IF(PRSI.NE.0) ODI2=ODESC2(PRSI)
	AV=AVEHIC(WINNER)
	SOBJS=.TRUE.
	WASLIT=LIT(HERE)
C
	GO TO (1000,3000,4000,6000,7000,8000,9000,
	1 13000,14000,16000,17000,
	2 21000,23000,24000,27000,28000,29000,30000,
	3 31000,33000,34000,36000,37000,38000,
	4 41000,42000,43000,44000,46000,
	5 53000,56000)
	6	RI
	CALL BUG(6,RI)
C
C Return here to declare false result.
C
10	SOBJS=.FALSE.
	RETURN
C
C Return here to test for light source change.
C
50	IF(WASLIT.AND..NOT.LIT(HERE)) CALL RSPEAK(406)
	RETURN

C SOBJS, PAGE 3
C
C O1--	Gunk
C
1000	IF(OCAN(GUNK).EQ.0) GO TO 10		! not inside? f
	CALL NEWSTA(GUNK,122,0,0,0)		! falls apart.
	RETURN
C
C O2--	Trophy case
C
3000	IF(PRSA.NE.TAKEW) GO TO 10		! take?
	CALL RSPEAK(128)			! cant.
	RETURN
C
C O3--	Bottle
C
4000	IF(PRSA.NE.THROWW) GO TO 4100		! throw?
	CALL NEWSTA(PRSO,129,0,0,0)		! breaks.
	RETURN
C
4100	IF(PRSA.NE.MUNGW) GO TO 10		! mung?
	CALL NEWSTA(PRSO,131,0,0,0)		! breaks.
	RETURN

C SOBJS, PAGE 4
C
C O4--	Rope
C
6000	IF((HERE.EQ.DOME).OR.(HERE.EQ.SLIDE).OR.(PRSI.EQ.0).OR.
	1  (PRSI.EQ.TIMBE).OR.(PRSI.EQ.COFFI)) GO TO 6100
	IF(PRSA.EQ.TIEW) CALL RSPEAK(135)	! tie, cant do it.
6050	DOMEF=.FALSE.				! not tied in dome.
	TTIE=0					! not tied to timber.
	OFLAG1(TIMBE)=OFLAG1(TIMBE).AND..NOT.NDSCBT
	OFLAG1(COFFI)=OFLAG1(COFFI).AND..NOT.NDSCBT
	ODESC1(TIMBE)=1032			! restore timber, coffin
	ODESC1(COFFI)=1033
	OFLAG1(ROPE)=OFLAG1(ROPE).AND..NOT.NDSCBT
	OFLAG2(ROPE)=OFLAG2(ROPE).AND..NOT.CLMBBT
	RETURN					! rope not climbable
C
6100	IF((PRSA.NE.CLMBDW).OR.(HERE.NE.CPANT)) GO TO 6200
	IF(TTIE.EQ.0) GO TO 6150		! climb down, tied?
	IF(OROOM(TTIE).NE.HERE) GO TO 6150	! tied here?
	CALL RSPSUB(1028,ODESC2(TTIE))		! yes, tumbles after you.
	CALL NEWSTA(PRSO,0,CPUZZ,0,0)		! now in puzzle room.
	CALL NEWSTA(TTIE,0,CPUZZ,0,0)
	GO TO 10				! not handled here.
C
6150	CALL RSPEAK(1029)			! not tied.
	GO TO 10				! not handled here.
C
6200	IF(PRSA.NE.TIEW) GO TO 6400		! tie rope?
	IF(PRSI.NE.RAILI) GO TO 6300		! to railing?
	IF(DOMEF) GO TO 6250			! already done?
	DOMEF=.TRUE.				! no, now tied.
	CALL NEWSTA(ROPE,137,DOME,0,0)		! put in dome room.
6225	OFLAG1(ROPE)=OFLAG1(ROPE).OR.NDSCBT
	OFLAG2(ROPE)=OFLAG2(ROPE).OR.CLMBBT	! now climbable
	RETURN
C
6250	CALL RSPEAK(136)			! already tied.
	RETURN
C
6300	IF((PRSI.NE.TIMBE).AND.(PRSI.NE.COFFI)) GO TO 10
	IF(TTIE.NE.0) GO TO 6250		! already done?
	IF(OROOM(PRSI).NE.0) GO TO 6350		! target on ground?
	CALL RSPEAK(960)			! can't do it.
	RETURN
C
6350	CALL RSPSUB(961,ODI2)			! now tied to object.
	TTIE=PRSI
	IF(PRSI.EQ.TIMBE) ODESC1(TIMBE)=1030	! change description
	IF(PRSI.EQ.COFFI) ODESC1(COFFI)=1031	! of target.
	IF((HERE.EQ.CPANT).OR.(HERE.EQ.SLIDE)) CALL RSPEAK(339)
	IF(HERE.EQ.SLIDE) OFLAG1(PRSI)=OFLAG1(PRSI).OR.NDSCBT
	CALL NEWSTA(ROPE,0,HERE,0,0)		! put rope in room.
	GO TO 6225				! rope now climbable.
C
6400	IF(PRSA.NE.UNTIEW) GO TO 6600		! untie rope?
	IF(.NOT.DOMEF.AND.(TTIE.EQ.0)) GO TO 6500 ! tied to obj or railing?
	CALL RSPEAK(139)			! report and then
	GO TO 6050				! clean up all status.
C
6500	CALL RSPEAK(134)			! not tied to anything.
	RETURN
C
6600	IF(DOMEF.OR.(PRSA.NE.DROPW).OR.
	1	(HERE.NE.DOME)) GO TO 6700	! drop & untied from dome?
	CALL NEWSTA(ROPE,140,MTORC,0,0)		! yes, drop.
	RETURN
C
6700	IF((PRSA.NE.TAKEW).OR..NOT.DOMEF) GO TO 6800
	CALL RSPEAK(141)			! take & tied.
	RETURN
C
6800	IF((PRSA.NE.TAKEW).OR.(TTIE.EQ.0)) GO TO 10
	CALL RSPEAK(926,ODESC2(TTIE))		! take & tied.
	RETURN
C
C O5--	Sword
C
7000	IF((PRSA.EQ.TAKEW).AND.(WINNER.EQ.PLAYER))
	1	SWDACT=.TRUE.			! turn on demon.
	GO TO 10
C
C O6--	Lantern
C
8000	IF(PRSA.NE.THROWW) GO TO 8100		! throw?
	CALL NEWSTA(LAMP,0,0,0,0)		! kill lamp,
	CALL NEWSTA(BLAMP,142,HERE,0,0)		! replace with broken.
	CFLAG(CEVLNT)=.FALSE.			! turn off timer.
	GO TO 50				! go see if now dark.
C
8100	IF(PRSA.EQ.TRNONW) CFLAG(CEVLNT)=.TRUE.
	IF(PRSA.EQ.TRNOFW) CFLAG(CEVLNT)=.FALSE.
	GO TO 10
C
C O7--	Rug
C
9000	IF(PRSA.NE.RAISEW) GO TO 9100		! raise?
	CALL RSPEAK(143)			! cant
	RETURN
C
9100	IF(PRSA.NE.TAKEW) GO TO 9200		! take?
	CALL RSPEAK(144)			! cant
	RETURN
C
9200	IF(PRSA.NE.MOVEW) GO TO 9300		! move?
	CALL RSPEAK(145+ORRUG)
	ORRUG=1
	OFLAG1(DOOR)=OFLAG1(DOOR).OR.VISIBT	! reveal door.
	RETURN
C
9300	IF((PRSA.NE.LOOKUW).OR.(ORRUG.NE.0).OR.
	1	QOPEN(DOOR)) GO TO 10		! look under rug?
	CALL RSPEAK(345)
	RETURN

C SOBJS, PAGE 5
C
C O8--	Skeleton
C
13000	I=ROBRM(HERE,100,LLD2,0,0)+ROBADV(WINNER,LLD2,0,0)
	CALL RSPEAK(162)			! curses.
	RETURN
C
C O9--	Mirror
C
14000	IF(MIRRMF.OR.(PRSA.NE.RUBW)) GO TO 14500
	MROOM=HERE.XOR.1			! calculate new rm.
	DO 14100 I=1,OLNT			! interchange objs.
	  IF(OROOM(I).EQ.HERE) OROOM(I)=-1
	  IF(OROOM(I).EQ.MROOM) OROOM(I)=HERE
	  IF(OROOM(I).EQ.-1) OROOM(I)=MROOM
14100	CONTINUE
	F=MOVETO(MROOM,WINNER)
	CALL RSPEAK(163)			! shake world.
	RETURN
C
14500	IF((PRSA.NE.LOOKW).AND.(PRSA.NE.LOOKIW).AND.
	1	(PRSA.NE.EXAMIW)) GO TO 14600
	I=164					! mirror ok.
	IF(MIRRMF) I=165			! mirror dead.
	CALL RSPEAK(I)
	RETURN
C
14600	IF(PRSA.NE.TAKEW) GO TO 14700		! take?
	CALL RSPEAK(166)			! joke.
	RETURN
C
14700	IF((PRSA.NE.MUNGW).AND.(PRSA.NE.THROWW)) GO TO 10
	I=167					! mirror breaks.
	IF(MIRRMF) I=168			! mirror already broken.
	MIRRMF=.TRUE.
	BADLKF=.TRUE.
	CALL RSPEAK(I)
	RETURN

C SOBJS, PAGE 6
C
C O10--	Dumbwaiter
C
16000	IF(PRSA.NE.RAISEW) GO TO 16100		! raise?
	IF(CAGETF) GO TO 16400			! already at top?
	CALL NEWSTA(TBASK,175,TSHAF,0,0)	! no, raise basket.
	CALL NEWSTA(FBASK,0,BSHAF,0,0)
	CAGETF=.TRUE.				! at top.
	RETURN
C
16100	IF(PRSA.NE.LOWERW) GO TO 16200		! lower?
	IF(.NOT.CAGETF) GO TO 16400		! already at bottom?
	CALL NEWSTA(TBASK,176,BSHAF,0,0)	! no, lower basket.
	CALL NEWSTA(FBASK,0,TSHAF,0,0)
	CAGETF=.FALSE.
	GO TO 50				! go see if now dark.
C
16200	IF((PRSO.NE.FBASK).AND.(PRSI.NE.FBASK)) GO TO 16300
	CALL RSPEAK(130)			! wrong basket.
	RETURN
C
16300	IF(PRSA.NE.TAKEW) GO TO 10		! take?
	CALL RSPEAK(177)			! joke.
	RETURN
C
16400	CALL RSPEAK(125+RND(3))			! dummy.
	RETURN
C
C O11--	Ghost
C
17000	IF(PRSO.NE.GHOST) GO TO 17100		! direct object?
	CALL RSPEAK(178)			! joke.
	RETURN
C
17100	CALL RSPEAK(179)			! joke.
	GO TO 10				! don't handle.

C SOBJS, PAGE 7
C
C O12--	Tube
C
21000	IF((PRSA.NE.PUTW).OR.(PRSI.NE.TUBE)) GO TO 21100
	CALL RSPEAK(186)			! cant put back in.
	RETURN
C
21100	IF(PRSA.NE.SQUEEW) GO TO 10		! squeeze?
	IF(QOPEN(PRSO)) GO TO 21200		! tube open?
	CALL RSPEAK(909)			! no, can't do it.
	RETURN
C
21200	IF(OCAN(PUTTY).EQ.PRSO) GO TO 21300	! putty inside?
	CALL RSPEAK(910)			! no, doesn't work.
	RETURN
C
21300	CALL NEWSTA(PUTTY,911,0,0,WINNER)	! putty now in hand.
	RETURN
C
C O13--	Chalice
C
23000	IF((PRSA.NE.TAKEW).OR.(OCAN(PRSO).NE.0).OR.
	1	(OROOM(PRSO).NE.TREAS).OR.(OROOM(THIEF).NE.TREAS).OR.
	2	((OFLAG2(THIEF).AND.FITEBT).EQ.0).OR.
	3	.NOT. THFACT) GO TO 10
	CALL RSPEAK(204)			! cant take.
	RETURN
C
C O14--	Painting
C
24000	IF(PRSA.NE.MUNGW) GO TO 10		! mung?
	CALL RSPEAK(205)			! destroy painting.
	OFVAL(PRSO)=0
	OTVAL(PRSO)=0
	ODESC1(PRSO)=207
	ODESC2(PRSO)=206
	RETURN

C SOBJS, PAGE 8
C
C O15--	Bolt
C
27000	IF(PRSA.NE.TURNW) GO TO 27600		! turn bolt?
	IF(PRSI.NE.WRENC) GO TO 27500		! with wrench?
	IF(GATEF) GO TO 27100			! proper button pushed?
	CALL RSPEAK(210)			! no, lose.
	RETURN
C
27100	IF(LWTIDF) GO TO 27200			! low tide now?
	LWTIDF=.TRUE.				! no, empty dam.
	CALL RSPEAK(211)
	OFLAG2(COFFI)=OFLAG2(COFFI).AND. .NOT.SCRDBT
	OFLAG1(TRUNK)=OFLAG1(TRUNK).OR.VISIBT	! materialize trunk.
	RFLAG(RESER)=(RFLAG(RESER).OR.RLAND)
	1	.AND..NOT.(RWATER+RSEEN)	! keep thief away.
	RETURN
C
27200	LWTIDF=.FALSE.				! yes, fill dam.
	CALL RSPEAK(212)
	IF(QHERE(TRUNK,RESER)) OFLAG1(TRUNK)=OFLAG1(TRUNK)
	1	.AND. .NOT.VISIBT
	RFLAG(RESER)=(RFLAG(RESER).OR.RWATER) .AND..NOT.RLAND
	RETURN
C
27500	CALL RSPSUB(299,ODI2)			! not with that.
	RETURN
C
27600	IF(PRSA.NE.OILW) GO TO 10		! oil?
	CALL RSPEAK(906)			! trouble.
	RETURN
C
C O16--	Grating
C
28000	IF((PRSA.NE.OPENW).AND.(PRSA.NE.CLOSEW)) GO TO 10
	IF(GRUNLF) GO TO 28100			! unlocked?
	CALL RSPEAK(214)			! no, locked.
	RETURN
C
28100	I=215					! unlocked, view frm below.
	IF(HERE.EQ.CLEAR) I=216			! view from clearing
	SOBJS=OPNCLS(GRATE,I,885)		! open/close.
	RFLAG(MGRAT)=RFLAG(MGRAT).AND. .NOT.RLIGHT	! set light/dark.
	IF(.NOT.QOPEN(GRATE)) GO TO 50		! if not open, done.
	RFLAG(MGRAT)=RFLAG(MGRAT).OR.RLIGHT	! now lit.
	RVCLR=1					! leaves shoved aside.
	CALL NEWSTA(GRATE,0,CLEAR,0,0)		! grating in clearing.
	RETURN
C
C O17--	Trap door
C
29000	IF(HERE.NE.LROOM) GO TO 29100		! from living room?
	SOBJS=OPNCLS(DOOR,218,219)		! open/close.
	RETURN
C
29100	IF(HERE.NE.CELLA) GO TO 10		! from cellar?
	IF((PRSA.NE.OPENW).OR.QOPEN(DOOR)) GO TO 29200
	CALL RSPEAK(220)			! cant open closed door.
	RETURN
C
29200	SOBJS=OPNCLS(DOOR,0,22)			! normal open/close.
	RETURN
C
C O18--	Durable door
C
30000	I=0					! assume no appl.
	IF(PRSA.EQ.OPENW) I=221			! open?
	IF(PRSA.EQ.BURNW) I=222			! burn?
	IF(PRSA.EQ.MUNGW) I=223+RND(3)		! mung?
	IF(I.EQ.0) GO TO 10
	CALL RSPEAK(I)
	RETURN
C
C O19--	Master switch
C
31000	IF(PRSA.NE.TURNW) GO TO 10		! turn?
	IF(PRSI.NE.SCREW) GO TO 31500		! with screwdriver?
	IF(QOPEN(MACHI)) GO TO 31600		! lid up?
	CALL RSPEAK(226)			! no, activate.
	IF(OCAN(COAL).NE.MACHI) GO TO 31400	! coal inside?
	CALL NEWSTA(COAL,0,0,0,0)		! kill coal,
	CALL NEWSTA(DIAMO,0,0,MACHI,0)		! replace with diamond.
	RETURN
C
31400	DO 31450 I=1,OLNT			! kill noncoal objects.
	  IF(OCAN(I).NE.MACHI) GO TO 31450	! inside machine?
	  CALL NEWSTA(I,0,0,0,0)		! kill object and contents.
	  CALL NEWSTA(GUNK,0,0,MACHI,0)		! reduce to gunk.
31450	CONTINUE
	RETURN
C
31500	CALL RSPSUB(300,ODI2)			! cant turn with that.
	RETURN
C
31600	CALL RSPEAK(227)			! lid is up.
	RETURN

C SOBJS, PAGE 9
C
C O20--	Leak
C
33000	IF((PRSO.NE.LEAK).OR.(PRSA.NE.PLUGW).OR.(RVMNT.LE.0))
	1	GO TO 10			! plug active leak?
	IF(PRSI.NE.PUTTY) GO TO 33100		! with putty?
	RVMNT=-1				! disable leak.
	CTICK(CEVMNT)=0
	CALL RSPEAK(577)
	RETURN
C
33100	CALL RSPSUB(301,ODI2)			! cant with that.
	RETURN
C
C O21--	Drowning buttons
C
34000	IF(PRSA.NE.PUSHW) GO TO 10		! push?
	GO TO (34100,34200,34300,34400),(PRSO-RBUTT+1)
	GO TO 10				! not a button.
C
34100	RFLAG(HERE)=RFLAG(HERE).XOR.RLIGHT	! red, zap lights.
	I=230
	IF((RFLAG(HERE).AND.RLIGHT).NE.0) I=231
	CALL RSPEAK(I)
	GO TO 50				! go see if now dark.
C
34200	GATEF=.TRUE.				! release gate.
	CALL RSPEAK(232)
	RETURN
C
34300	GATEF=.FALSE.				! interlock gate.
	CALL RSPEAK(232)
	RETURN
C
34400	IF(RVMNT.NE.0) GO TO 34500		! leak already started?
	CALL RSPEAK(233)			! no, start leak.
	RVMNT=1
	CFLAG(CEVMNT)=.TRUE.
	CTICK(CEVMNT)=-1
	RFLAG(HERE)=RFLAG(HERE).OR.RFILL	! water present.
	OFLAG1(LEAK)=OFLAG1(LEAK).OR.VISIBT	! bring on the leak.
	RETURN
C
34500	CALL RSPEAK(234)			! button jammed.
	RETURN
C
C O22--	Inflatable boat
C
36000	IF(PRSA.NE.INFLAW) GO TO 10		! inflate?
	IF(OROOM(IBOAT).NE.0) GO TO 36100	! in room?
	CALL RSPEAK(235)			! no, joke.
	RETURN
C
36100	IF(PRSI.NE.PUMP) GO TO 36200		! with pump?
	CALL NEWSTA(IBOAT,0,0,0,0)		! kill defl boat,
	CALL NEWSTA(RBOAT,236,HERE,0,0)		! repl with inf.
	DEFLAF=.FALSE.
	RETURN
C
36200	I=237					! jokes.
	IF(PRSI.NE.LUNGS) I=303
	CALL RSPSUB(I,ODI2)
	RETURN
C
C O23--	Deflated boat
C
37000	IF(PRSA.NE.INFLAW) GO TO 37100		! inflate?
	CALL RSPEAK(238)			! joke.
	RETURN
C
37100	IF(PRSA.NE.PLUGW) GO TO 10		! plug?
	IF(PRSI.NE.PUTTY) GO TO 33100		! with putty?
	CALL NEWSTA(IBOAT,239,OROOM(DBOAT),OCAN(DBOAT),OADV(DBOAT))
	CALL NEWSTA(DBOAT,0,0,0,0)		! kill defl boat, repl.
	RETURN

C SOBJS, PAGE 10
C
C O24--	Rubber boat
C
38000	IF(ARG.NE.0) GO TO 10			! dismiss readin, out.
	IF((PRSA.NE.BOARDW).OR.(OADV(STICK).NE.WINNER)) GO TO 38100
	CALL NEWSTA(RBOAT,0,0,0,0)		! kill infl boat,
	CALL NEWSTA(DBOAT,240,HERE,0,0)		! repl with dead.
	DEFLAF=.TRUE.
	GO TO 50				! go see if now dark.
C
38100	IF(PRSA.NE.INFLAW) GO TO 38200		! inflate?
	CALL RSPEAK(367)			! yes, joke.
	RETURN
C
38200	IF(PRSA.NE.DEFLAW) GO TO 10		! deflate?
	IF(AV.EQ.RBOAT) GO TO 38300		! in boat?
	IF(OROOM(RBOAT).EQ.0) GO TO 38400	! on ground?
	CALL NEWSTA(RBOAT,0,0,0,0)		! kill infl boat,
	CALL NEWSTA(IBOAT,241,HERE,0,0)		! repl with defl.
	DEFLAF=.TRUE.
	GO TO 50				! go see if now dark.
C
38300	CALL RSPEAK(242)			! in boat.
	RETURN
C
38400	CALL RSPEAK(243)			! not on ground.
	RETURN
C
C O25--	Braided rope
C
41000	IF((PRSA.NE.TIEW).OR.(PRSO.NE.BROPE).OR.
	1	((PRSI.NE.HOOK1).AND.(PRSI.NE.HOOK2)))
	2	GO TO 41500			! tie to hook?
	BTIEF=PRSI				! record location.
	CFLAG(CEVBAL)=.FALSE.			! stall ascent.
	CALL RSPEAK(248)
	RETURN
C
41500	IF((PRSA.NE.UNTIEW).OR.(PRSO.NE.BROPE)) GO TO 10
	IF(BTIEF.NE.0) GO TO 41600		! tied up?
	CALL RSPEAK(249)			! no, joke.
	RETURN
C
41600	CALL RSPEAK(250)
	BTIEF=0					! untie.
	CFLAG(CEVBAL)=.TRUE.
	CTICK(CEVBAL)=3				! restart clock.
	RETURN
C
C O26--	Safe
C
42000	I=0					! assume unprocessed.
	IF(PRSA.EQ.TAKEW) I=251			! take?
	IF((PRSA.EQ.OPENW).AND.SAFEF) I=253	! open after blast?
	IF((PRSA.EQ.OPENW).AND..NOT.SAFEF) I=254 ! open before blast?
	IF((PRSA.EQ.CLOSEW).AND.SAFEF) I=253	! close after?
	IF((PRSA.EQ.CLOSEW).AND..NOT.SAFEF) I=255
	IF(I.EQ.0) GO TO 10
	CALL RSPEAK(I)
	RETURN
C
C O27--	Fuse
C
43000	IF(PRSA.NE.BURNW) GO TO 10		! burn?
	CALL RSPEAK(256)
	CFLAG(CEVFUS)=.TRUE.
	CTICK(CEVFUS)=2				! start countdown.
	RETURN
C
C O28--	Gnome
C
44000	IF((PRSA.NE.GIVEW).AND.(PRSA.NE.THROWW)) GO TO 44500
	IF(OTVAL(PRSO).EQ.0) GO TO 44100	! treasure?
	CALL RSPSUB(257,ODO2)			! yes, get door.
	CALL NEWSTA(PRSO,0,0,0,0)
	CALL NEWSTA(GNOME,0,0,0,0)		! vanish gnome.
	GNODRF=.TRUE.
	GO TO 50				! go see if now dark.
C
44100	IF((PRSO.NE.BRICK).OR.(OCAN(FUSE).NE.BRICK).OR.
	1	(CTICK(CEVFUS).EQ.0)) GO TO 44200 ! a bomb?
	CALL NEWSTA(GNOME,927,0,0,0)		! gnome leaves.
	CALL NEWSTA(BRICK,0,HERE,0,0)		! brick on floor.
	CFLAG(CEVVLG)=.FALSE.			! turn off gnome clocks.
	CFLAG(CEVGNO)=.FALSE.
	RETURN
C
44200	CALL RSPSUB(258,ODO2)			! no, lose object.
	CALL NEWSTA(PRSO,0,0,0,0)
	GO TO 50				! go see if now dark.
C
44500	CALL RSPEAK(259)			! nervous gnome.
	IF(GNOMEF) RETURN
	CFLAG(CEVGNO)=.TRUE.
	CTICK(CEVGNO)=5				! schedule byebye.
	GNOMEF=.TRUE.
	RETURN
C
C O29--	Coke bottles
C
46000	IF((PRSA.NE.THROWW).AND.(PRSA.NE.MUNGW)) GO TO 10
	CALL NEWSTA(PRSO,262,0,0,0)		! mung bottles.
	RETURN

C SOBJS, PAGE 11
C
C O30--	Robot
C
53000	IF(PRSA.NE.GIVEW) GO TO 53200		! give?
	CALL NEWSTA(PRSO,0,0,0,AROBOT)		! put on robot.
	CALL RSPSUB(302,ODO2)
	RETURN
C
53200	IF(((PRSA.NE.MUNGW).AND.(PRSA.NE.THROWW)).OR.
	1  ((PRSO.NE.ROBOT).AND.(PRSI.NE.ROBOT))) GO TO 10
	CALL NEWSTA(ROBOT,285,0,0,0)		! kill robot.
	GO TO 50				! go see if now dark.
C
C O31--	Grue
C
56000	IF(PRSA.NE.EXAMIW) GO TO 56100		! examine?
	CALL RSPEAK(288)
	RETURN
C
56100	IF(PRSA.NE.FINDW) GO TO 10		! find?
	CALL RSPEAK(289)
	RETURN
C
	END

C NOBJS-	New objects processor
C
C Declarations
C
	LOGICAL FUNCTION NOBJS(RI,ARG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QOPEN,MOVETO,F,RMDESC
	LOGICAL QHERE,OPNCLS,MIRPAN
	LOGICAL LIT,WASLIT,QEMPTY
C
C Functions and data
C
	QOPEN(R)=(OFLAG2(R).AND.OPENBT).NE.0
C
	IF(PRSO.NE.0) ODO2=ODESC2(PRSO)
	IF(PRSI.NE.0) ODI2=ODESC2(PRSI)
	AV=AVEHIC(WINNER)
	NOBJS=.TRUE.
	WASLIT=LIT(HERE)
C
	GO TO (1000,2000,3000,4000,5000,6000,7000,8000,9000,
	1 10000,11000,12000,13000,14000,15000,16000,17000,
	2 18000,19000,20000,21000,22000,23000,24000,25000,
	3 26000,27000,28000,29000,30000,31000,32000,33000,
	4 34000,35000,36000,37000,38000,39000,40000,41000,
	5 42000,43000,44000,45000,46000),
	6	(RI-31)
	CALL BUG(6,RI)
C
C Return here to declare false result.
C
10	NOBJS=.FALSE.
	RETURN
C
C Return here to test for light source change.
C
50	IF(WASLIT.AND..NOT.LIT(HERE)) CALL RSPEAK(406)
	RETURN

C NOBJS, PAGE 3
C
C O32--	Bills
C
1000	IF(PRSA.NE.EATW) GO TO 1100		! eat?
	CALL RSPEAK(639)			! joke.
	RETURN
C
1100	IF(PRSA.EQ.BURNW) CALL RSPEAK(640)	! burn?  joke.
	GO TO 10				! let it be handled.
C
C O33--	Screen of light
C
2000	TARGET=SCOL				! target is scol.
2100	IF(PRSO.NE.TARGET) GO TO 2400		! prso eq target?
	IF((PRSA.NE.PUSHW).AND.(PRSA.NE.MOVEW).AND.
	1	(PRSA.NE.TAKEW).AND.(PRSA.NE.RUBW)) GO TO 2200
	CALL RSPEAK(673)			! hand passes thru.
	RETURN
C
2200	IF((PRSA.NE.KILLW).AND.(PRSA.NE.ATTACW).AND.
	1	(PRSA.NE.MUNGW)) GO TO 2400	! aggressive?
	CALL RSPSUB(674,ODI2)			! passes thru.
	RETURN
C
2400	IF((PRSA.NE.THROWW).OR.(PRSI.NE.TARGET)) GO TO 10
	IF(HERE.EQ.BKBOX) GO TO 2600		! thru scol?
	CALL NEWSTA(PRSO,0,BKBOX,0,0)		! no, thru wall.
	CALL RSPSUB(675,ODO2)			! ends up in box room.
	CTICK(CEVSCL)=0				! cancel alarm.
	SCOLRM=0				! reset scol room.
	GO TO 50				! go see if now dark.
C
2600	IF(SCOLRM.EQ.0) GO TO 2900		! tried to go thru?
	CALL NEWSTA(PRSO,0,SCOLRM,0,0)		! success.
	CALL RSPSUB(676,ODO2)			! ends up somewhere.
	CTICK(CEVSCL)=0				! cancel alarm.
	SCOLRM=0				! reset scol room.
	GO TO 50				! go see if now dark.
C
2900	CALL RSPEAK(213)			! cant do it.
	RETURN

C NOBJS, PAGE 4
C
C O34--	Gnome of Zurich
C
3000	IF((PRSA.NE.GIVEW).AND.(PRSA.NE.THROWW)) GO TO 3200
	IF(OTVAL(PRSO).NE.0) GO TO 3100		! throw a treasure?
	IF((PRSO.NE.BRICK).OR.(OCAN(FUSE).NE.BRICK).OR.
	1	(CTICK(CEVFUS).EQ.0)) GO TO 3050 ! a bomb?
	CALL NEWSTA(ZGNOM,931,0,0,0)		! gnome leaves.
	CALL NEWSTA(BRICK,0,HERE,0,0)		! brick on floor.
	CFLAG(CEVZGO)=.FALSE.			! stop gnome timers.
	CFLAG(CEVZGI)=.FALSE.
	RETURN
C
3050	CALL NEWSTA(PRSO,641,0,0,0)		! no, go pop.
	RETURN
C
3100	CALL NEWSTA(PRSO,0,0,0,0)		! yes, bye bye treasure.
	CALL RSPSUB(642,ODO2)
	CALL NEWSTA(ZGNOM,0,0,0,0)		! bye bye gnome.
	CFLAG(CEVZGO)=.FALSE.			! cancel exit.
	F=MOVETO(BKENT,WINNER)			! now in bank entrance.
	RETURN
C
3200	IF((PRSA.NE.ATTACW).AND.(PRSA.NE.KILLW).AND.
	1	(PRSA.NE.MUNGW)) GO TO 3300	! aggressive?
	CALL NEWSTA(ZGNOM,643,0,0,0)		! vanish gnome.
	CFLAG(CEVZGO)=.FALSE.			! cancel exit.
	RETURN
C
3300	CALL RSPEAK(644)			! gnome is impatient.
	RETURN
C
C O35--	Egg
C
4000	IF((PRSA.NE.OPENW).OR.(PRSO.NE.EGG)) GO TO 4500
	IF(.NOT.QOPEN(EGG)) GO TO 4100		! open already?
	CALL RSPEAK(649)			! yes.
	RETURN
C
4100	IF(PRSI.NE.0) GO TO 4200		! with something?
	CALL RSPEAK(650)			! no, cant.
	RETURN
C
4200	IF(PRSI.NE.HANDS) GO TO 4300		! with hands?
	CALL RSPEAK(651)			! not recommended.
	RETURN
C
4300	I=652					! mung message.
	IF(((OFLAG1(PRSI).AND.TOOLBT).NE.0).OR.
	1	((OFLAG2(PRSI).AND.WEAPBT).NE.0)) GO TO 4600
	I=653					! novelty 1.
	IF((OFLAG2(PRSO).AND.FITEBT).NE.0) I=654 ! novelty 2.
	OFLAG2(PRSO)=OFLAG2(PRSO).OR.FITEBT
	CALL RSPSUB(I,ODI2)
	RETURN
C
4500	IF(PRSA.NE.MUNGW) GO TO 10		! mung?
	I=655					! you blew it.
4600	CALL NEWSTA(BEGG,I,OROOM(EGG),OCAN(EGG),OADV(EGG))
	CALL NEWSTA(EGG,0,0,0,0)		! vanish egg.
	OTVAL(BEGG)=2				! bad egg has value.
	IF(OCAN(CANAR).NE.EGG) GO TO 4700	! was canary inside?
	CALL RSPEAK(ODESCO(BCANA))		! yes, describe result.
	OTVAL(BCANA)=1
	RETURN
C
4700	CALL NEWSTA(BCANA,0,0,0,0)		! no, vanish it.
	RETURN

C NOBJS, PAGE 5
C
C O36--	Canaries, good and bad
C
5000	IF(PRSA.NE.WINDW) GO TO 10		! wind em up?
	IF(PRSO.EQ.CANAR) GO TO 5100		! right one?
	CALL RSPEAK(645)			! no, bad news.
	RETURN
C
5100	IF(.NOT.SINGSF.AND.((HERE.EQ.MTREE).OR.
	1	((HERE.GE.FORE1).AND.(HERE.LT.CLEAR))))
	2	GO TO 5200			! first song in for?
	CALL RSPEAK(646)			! no, mediocre news.
	RETURN
C
5200	SINGSF=.TRUE.				! sang song.
	I=HERE
	IF(I.EQ.MTREE) I=FORE3			! place bauble.
	CALL NEWSTA(BAUBL,647,I,0,0)
	RETURN
C
C O37--	White cliffs
C
6000	IF((PRSA.NE.CLMBW).AND.(PRSA.NE.CLMBUW).AND.
	1	(PRSA.NE.CLMBDW)) GO TO 10	! climb?
	CALL RSPEAK(648)			! oh yeah?
	RETURN
C
C O38--	Wall 
C
7000	IF((IABS(HERE-MLOC).NE.1).OR.(MRHERE(HERE).NE.0).OR.
	1	.NOT.ENDGMF) GO TO 7100		! mirror wall in endgame?
	IF(PRSA.NE.PUSHW) GO TO 10		! pushed?
	CALL RSPEAK(860)			! pushed mirror wall.
	RETURN
C
7100	IF((RFLAG(HERE).AND.RNWALL).EQ.0) GO TO 10
	CALL RSPEAK(662)			! no wall.
	RETURN

C NOBJS, PAGE 6
C
C O39--	Global bird
C
8000	IF(PRSA.NE.FINDW) GO TO 8100		! find?
	CALL RSPEAK(666)
	RETURN
C
8100	IF(PRSA.NE.EXAMIW) GO TO 10		! examine?
	CALL RSPEAK(667)
	RETURN
C
C O40--	Puzzle/Scol walls
C
9000	IF(HERE.NE.CPUZZ) GO TO 9500		! puzzle walls?
	IF(PRSA.NE.PUSHW) GO TO 10		! push?
	DO 9100 I=1,8,2				! locate wall.
	  IF(PRSO.EQ.CPWL(I)) GO TO 9200
9100	CONTINUE
	CALL BUG(80,PRSO)			! what?
C
9200	J=CPWL(I+1)				! get directional offset.
	NXT=CPHERE+J				! get next state.
	WL=CPVEC(NXT)				! get c(next state).
	GO TO (9300,9300,9300,9250,9350),(WL+4)	! process.
C
9250	CALL RSPEAK(876)			! clear corridor.
	RETURN
C
9300	IF(CPVEC(NXT+J).EQ.0) GO TO 9400	! movable, room to move?
9350	CALL RSPEAK(877)			! immovable, no room.
	RETURN
C
9400	I=878					! assume first push.
	IF(CPUSHF) I=879			! not?
	CPUSHF=.TRUE.
	CPVEC(NXT+J)=WL				! move wall.
	CPVEC(NXT)=0				! vacate next state.
	CALL CPGOTO(NXT)			! onward.
	CALL CPINFO(I,NXT)			! describe.
	CALL PRINCR(.TRUE.,HERE)		! print rooms contents.
	RETURN
C
9500	IF(HERE.NE.SCOLAC) GO TO 9700		! in scol active room?
	DO 9600 I=1,12,3
	  TARGET=SCOLWL(I+1)			! assume target.
	  IF(SCOLWL(I).EQ.HERE) GO TO 2100	! treat if found.
9600	CONTINUE
C
9700	IF(HERE.NE.BKBOX) GO TO 10		! in box room?
	TARGET=WNORT
	GO TO 2100

C NOBJS, PAGE 7
C
C O41--	Short pole
C
10000	IF(PRSA.NE.RAISEW) GO TO 10100		! lift?
	I=749					! assume up.
	IF(POLEUF.EQ.2) I=750			! already up?
	CALL RSPEAK(I)
	POLEUF=2				! pole is raised.
	RETURN
C
10100	IF((PRSA.NE.LOWERW).AND.(PRSA.NE.PUSHW)) GO TO 10
	IF(POLEUF.NE.0) GO TO 10200		! already lowered?
	CALL RSPEAK(751)			! cant do it.
	RETURN
C
10200	IF(MOD(MDIR,180).NE.0) GO TO 10300	! mirror n-s?
	POLEUF=0				! yes, lower into
	CALL RSPEAK(752)			! channel.
	RETURN
C
10300	IF((MDIR.NE.270).OR.(MLOC.NE.MRB)) GO TO 10400
	POLEUF=0				! lower into hole.
	CALL RSPEAK(753)
	RETURN
C
10400	CALL RSPEAK(753+POLEUF)			! poleuf = 1 or 2.
	POLEUF=1				! now on floor.
	RETURN
C
C O42--	Mirror switch
C
11000	IF(PRSA.NE.PUSHW) GO TO 10		! push?
	IF(MRPSHF) GO TO 11300			! already pushed?
	CALL RSPEAK(756)			! button goes in.
	DO 11100 I=1,OLNT			! blocked?
	  IF(QHERE(I,MREYE).AND.(I.NE.RBEAM)) GO TO 11200
11100	CONTINUE
	CALL RSPEAK(757)			! nothing in beam.
	RETURN
C
11200	CFLAG(CEVMRS)=.TRUE.			! mirror opens.
	CTICK(CEVMRS)=7
	MRPSHF=.TRUE.
	MROPNF=.TRUE.
	RETURN
C
11300	CALL RSPEAK(758)			! mirror alreadyopen.
	RETURN

C NOBJS, PAGE 8
C
C O43--	Beam function
C
12000	IF((PRSA.NE.TAKEW).OR.(PRSO.NE.RBEAM)) GO TO 12100
	CALL RSPEAK(759)			! take beam, joke.
	RETURN
C
12100	I=PRSO					! assume blk with dirobj.
	IF((PRSA.EQ.PUTW).AND.(PRSI.EQ.RBEAM)) GO TO 12200
	IF((PRSA.NE.MUNGW).OR.(PRSO.NE.RBEAM).OR.
	1	(PRSI.EQ.0)) GO TO 10		! break beam with x?
	I=PRSI
12200	IF(OADV(I).NE.WINNER) GO TO 12300	! carrying?
	CALL NEWSTA(I,0,HERE,0,0)		! drop obj.
	CALL RSPSUB(760,ODESC2(I))
	RETURN
C
12300	J=761					! assume not in room.
	IF(QHERE(J,HERE)) I=762			! in room?
	CALL RSPSUB(J,ODESC2(I))		! describe.
	RETURN
C
C O44--	Bronze door
C
13000	IF((HERE.EQ.NCELL).OR.((LCELL.EQ.4).AND.
	1	((HERE.EQ.CELL).OR.(HERE.EQ.SCORR))))
	2	GO TO 13100
	CALL RSPEAK(763)			! door not there.
	RETURN
C
13100	IF(.NOT.OPNCLS(ODOOR,764,765)) GO TO 10	! open/close?
	IF((HERE.EQ.NCELL).AND.QOPEN(ODOOR))
	1	CALL RSPEAK(766)		! descr view.
	RETURN
C
C O45--	Quiz door
C
14000	IF((PRSA.NE.OPENW).AND.(PRSA.NE.CLOSEW)) GO TO 14100
	CALL RSPEAK(767)			! door wont move.
	RETURN
C
14100	IF(PRSA.NE.KNOCKW) GO TO 10		! knock?
	IF(INQSTF) GO TO 14200			! tried it already?
	INQSTF=.TRUE.				! start inquisition.
	CFLAG(CEVINQ)=.TRUE.
	CTICK(CEVINQ)=2
	QUESNO=RND(8)				! select question.
	NQATT=0
	CORRCT=0
	CALL RSPEAK(768)			! announce rules.
	CALL RSPEAK(769)
	CALL RSPEAK(770+QUESNO)			! ask question.
	RETURN
C
14200	CALL RSPEAK(798)			! no reply.
	RETURN
C
C O46--	Locked door
C
15000	IF(PRSA.NE.OPENW) GO TO 10		! open?
	CALL RSPEAK(778)			! cant.
	RETURN
C
C O47--	Cell door
C
16000	NOBJS=OPNCLS(CDOOR,779,780)		! open/close?
	RETURN

C NOBJS, PAGE 9
C
C O48--	Dialbutton
C
17000	IF(PRSA.NE.PUSHW) GO TO 10		! push?
	CALL RSPEAK(809)			! click.
	IF(QOPEN(CDOOR)) CALL RSPEAK(810)	! close cell door.
	IF(LCELL.EQ.PNUMB) RETURN		! any change?
C
	DO 17100 I=1,OLNT			! relocate old to hyper.
	  IF((OROOM(I).EQ.CELL).AND.((OFLAG1(I).AND.DOORBT).EQ.0))
	1	CALL NEWSTA(I,0,LCELL*HFACTR,0,0)
	  IF(OROOM(I).EQ.(PNUMB*HFACTR))
	1	CALL NEWSTA(I,0,CELL,0,0)	! move in new hyper.
17100	CONTINUE
C
	OFLAG2(ODOOR)=OFLAG2(ODOOR).AND. .NOT.OPENBT
	OFLAG2(CDOOR)=OFLAG2(CDOOR).AND. .NOT.OPENBT
	OFLAG1(ODOOR)=OFLAG1(ODOOR).AND. .NOT.VISIBT
	IF(PNUMB.EQ.4) OFLAG1(ODOOR)=OFLAG1(ODOOR).OR.VISIBT
C
	IF(AROOM(PLAYER).NE.CELL) GO TO 17400	! player in cell?
	IF(LCELL.NE.4) GO TO 17200		! in right cell?
	OFLAG1(ODOOR)=OFLAG1(ODOOR).OR. VISIBT
	F=MOVETO(NCELL,PLAYER)			! yes, moveto ncell.
	GO TO 17400
17200	F=MOVETO(PCELL,PLAYER)			! no, moveto pcell.
C
17400	LCELL=PNUMB
	RETURN

C NOBJS, PAGE 10
C
C O49--	Dial indicator
C
18000	IF(PRSA.NE.SPINW) GO TO 18100		! spin?
	PNUMB=RND(8)+1				! whee!
	CALL RSPSUB(797,712+PNUMB)
	RETURN
C
18100	IF((PRSA.NE.MOVEW).AND.(PRSA.NE.PUTW).AND.
	1	(PRSA.NE.TRNTOW)) GO TO 10
	IF(PRSI.NE.0) GO TO 18200		! turn dial to x?
	CALL RSPEAK(806)			! must specify.
	RETURN
C
18200	IF((PRSI.GE.NUM1).AND.(PRSI.LE.NUM8)) GO TO 18300
	CALL RSPEAK(807)			! must be digit.
	RETURN
C
18300	PNUMB=PRSI-NUM1+1			! set up new.
	CALL RSPSUB(808,712+PNUMB)
	RETURN
C
C O50--	Global mirror
C
19000	NOBJS=MIRPAN(832,.FALSE.)
	RETURN
C
C O51--	Global panel
C
20000	IF(HERE.NE.FDOOR) GO TO 20100		! at front door?
	IF((PRSA.NE.OPENW).AND.(PRSA.NE.CLOSEW)) GO TO 10
	CALL RSPEAK(843)			! panel in door, nogo.
	RETURN
C
20100	NOBJS=MIRPAN(838,.TRUE.)
	RETURN
C
C O52--	Puzzle Room slit
C
21000	IF((PRSA.NE.PUTW).OR.(PRSI.NE.CSLIT)) GO TO 10
	IF(PRSO.NE.GCARD) GO TO 21100		! put card in slit?
	CALL NEWSTA(PRSO,863,0,0,0)		! kill card.
	CPOUTF=.TRUE.				! open door.
	RETURN
C
21100	IF(((OFLAG1(PRSO).AND.VICTBT).EQ.0).AND.
	1  ((OFLAG2(PRSO).AND.VILLBT).EQ.0)) GO TO 21200
	CALL RSPEAK(552+RND(6))			! joke for vill, vict.
	RETURN
C
21200	CALL NEWSTA(PRSO,0,0,0,0)		! kill object.
	CALL RSPSUB(864,ODO2)			! describe.
	RETURN

C NOBJS, PAGE 11
C
C O53--	Global brochure or stamp
C
22000	IF(PRSO.NE.STAMP) GO TO 22100		! stamp?
	IF(PRSA.EQ.TAKEW) OFLAG1(BROCH)=OFLAG1(BROCH).AND..NOT.CONTBT
	GO TO 10				! do normal take.
C
22100	IF((PRSO.NE.BROCH).OR.
	1  ((PRSA.NE.EXAMIW).AND.(PRSA.NE.READW)))
	2  GO TO 22200				! examine brochure?
	CALL RSPEAK(942)			! describe.
	IF(OCAN(STAMP).EQ.BROCH) CALL RSPEAK(943)
	RETURN
C
22200	IF((PRSA.NE.FINDW).OR..NOT.BROC1F) GO TO 22300
	CALL RSPEAK(944)			! on the way.
	RETURN
C
22300	IF(PRSA.NE.SENDW) GO TO 10		! send?
	IF(BROC2F) CALL RSPEAK(945)		! already got it.
	IF(BROC1F.AND..NOT.BROC2F) CALL RSPEAK(944)	! on the way.
	IF(.NOT.BROC1F) CALL RSPEAK(947)	! postal service.
	BROC1F=.TRUE.				! send for brochure.
	RETURN
C
C O54--	Global ground
C
23000	IF(PRSA.NE.DIGW) GO TO 10		! dig?
	CALL RSPEAK(924)			! can't do it.
	RETURN
C
C O55--	Global granite wall
C
24000	I=916					! default.
	IF(PRSA.NE.FINDW) GO TO 24100		! find?
	I=917					! none here.
	IF((HERE.EQ.TEMP1).OR.(HERE.EQ.TREAS)) I=918	! unless special.
24100	CALL RSPEAK(I)				! tell all.
	RETURN

C NOBJS, PAGE 12
C
C O56--	Global house
C
25000	IF((HERE.GE.WHOUS).AND.(HERE.LE.EHOUS)) GO TO 25200
	IF(PRSA.NE.FINDW) GO TO 25100		! find, not at house?
	I=892					! joke 1.
	IF(HERE.EQ.CLEAR) I=893			! joke 2 for clearing.
	CALL RSPEAK(I)
	RETURN
C
25100	CALL RSPEAK(894)			! not there.
	RETURN
C
25200	IF(PRSA.NE.FINDW) GO TO 25300		! find, at house?
	CALL RSPEAK(895)			! right there.
	RETURN
C
25300	IF(PRSA.NE.EXAMIW) GO TO 25400		! look at?
	CALL RSPEAK(896)			! a nice house.
	RETURN
C
25400	IF(PRSA.NE.BURNW) GO TO 25500		! burn?
	CALL RSPEAK(897)			! bad boy.
	RETURN
C
25500	IF(PRSA.NE.GTHROW) GO TO 10		! go through?
	IF(HERE.EQ.EHOUS) GO TO 25600		! at east side?
	CALL RSPEAK(898)			! can't do it
	RETURN
C
25600	IF(QOPEN(WINDO)) GO TO 25700		! window open?
	CALL RSPEAK(899)			! no, shut
	RETURN
C
25700	F=MOVETO(KITCH,WINNER)			! move into kitchen.
	F=RMDESC(0)				! describe room
	RETURN
C
C O57--	Barred window in white house
C
26000	IF((PRSA.NE.OPENW).AND.(PRSA.NE.LOOKIW).AND.
	1  (PRSA.NE.GTHROW)) GO TO 26100	! open, look in, enter?
	CALL RSPEAK(1039)			! window barred.
	RETURN
C
26100	IF(PRSA.NE.CLOSEW) GO TO 10		! close?
	CALL RSPEAK(1040)			! already closed and locked.
	RETURN

C NOBJS, PAGE 13
C
C O58--	Global well
C
27000	IF(((OFLAG1(PRSO).AND.TAKEBT).EQ.0).OR.
	1  ((PRSA.NE.TAKEW).AND.(PRSA.NE.PUTW).AND.(PRSA.NE.DROPW)))
	2  GO TO 10				! take, put, drop x in well?
	CALL RSPSUB(939,ODO2)
	CALL NEWSTA(PRSO,0,BWELL,0,0)		! put in well bottom.
	GO TO 50				! go see if now dark.
C
C O59--	Global rope
C
28000	IF(PRSA.NE.TAKEW) GO TO 28100		! take?
	CALL RSPEAK(1006)			! not a good idea.
	RETURN
C
28100	IF(PRSA.NE.DROPW) GO TO 28300		! drop?
	CALL RSPEAK(1007)			! you lose.
28200	F=MOVETO(CELLA,WINNER)			! drop into cellar.
	F=RMDESC(3)				! describe.
	RETURN
C
28300	IF((PRSA.EQ.CLMBW).OR.(PRSA.EQ.CLMBUW).OR.
	1  (PRSA.EQ.CLMBDW)) GO TO 10		! normal climb.
	CALL RSPEAK(1008)			! not a good idea.
	RETURN
C
C O60--	Global slide
C
29000	IF((PRSA.NE.GTHROW).AND.
	1 ((PRSA.NE.PUTW).OR.(PRSO.NE.AOBJ(PLAYER)))) GO TO 29100
	CALL RSPEAK(1010)			! down the slide.
	GO TO 28200
C
29100	IF(PRSA.NE.PUTW) GO TO 10		! put in slide?
	IF((OFLAG1(PRSO).AND.TAKEBT).NE.0) GO TO 29200
	CALL RSPEAK(552+RND(6))			! can't take it.
	RETURN
C
29200	IF(PRSO.NE.TTIE) GO TO 29300		! tied object?
	OFLAG1(TTIE)=OFLAG1(TTIE).AND..NOT.NDSCBT
	OFLAG1(ROPE)=OFLAG1(ROPE).AND..NOT.NDSCBT
	OFLAG2(ROPE)=OFLAG2(ROPE).AND..NOT.CLMBBT
	ODESC1(TIMBE)=1032			! restored untied desc.
	ODESC1(COFFI)=1033
	TTIE=0					! not tied any more.
	CALL NEWSTA(ROPE,0,CELLA,0,0)		! rope is now here.
29300	CALL RSPSUB(1011,ODO2)
	CALL NEWSTA(PRSO,0,CELLA,0,0)		! put in cellar.
	GO TO 50				! go see if now dark.

C NOBJS, PAGE 14
C
C O61--	Barrel
C
30000	IF(ARG.NE.1) GO TO 10			! read in?
	I=0					! default.
	IF(PRSA.EQ.WALKW) I=920			! walk?
	IF(PRSA.EQ.LOOKW) I=921			! look?
	IF(PRSA.EQ.BURNW) I=922			! burn?
	IF(PRSA.EQ.TAKEW) I=552+RND(6)		! take?
	CALL RSPEAK(I)
	NOBJS=I.NE.0				! handled?
	RETURN
C
C O62--	Hot bell
C
31000	IF(PRSA.NE.TAKEW) GO TO 31100		! take?
	CALL RSPEAK(972)			! too hot.
	RETURN
C
31100	IF(PRSA.NE.RINGW) GO TO 31400		! ring?
	IF(PRSI.NE.0) GO TO 31200		! with something?
	CALL RSPEAK(973)			! too hot.
	RETURN
C
31200	IF((OFLAG1(PRSI).AND.BURNBT).EQ.0) GO TO 31300
	CALL RSPSUB(974,ODI2)			! burnable is consumed.
	CALL NEWSTA(PRSI,0,0,0,0)		! vanish it.
	RETURN
C
31300	I=975					! joke 1.
	IF(PRSI.EQ.HANDS) I=973			! joke for hands.
	CALL RSPEAK(I)
	RETURN
C
31400	IF(PRSA.NE.PORONW) GO TO 10		! pour on?
	CALL NEWSTA(HBELL,0,0,0,0)		! vanish bell.
	CALL NEWSTA(BELL,976,LLD1,0,0)		! insert real bell.
	CALL NEWSTA(PRSO,0,0,0,0)		! vanish water.
	RETURN
C
C O63--	Axe
C
32000	IF(PRSA.NE.TAKEW) GO TO 10		! take?
	CALL RSPEAK(891)			! too hot.
	RETURN

C NOBJS, PAGE 15
C
C O64--	Timber
C
33000	IF((PRSA.NE.TAKEW).OR.(PRSO.NE.TTIE)) GO TO 10
	CALL RSPSUB(1009,ODO2)			! take timber.
	OFLAG1(TTIE)=OFLAG1(TTIE).AND..NOT.NDSCBT
	OFLAG1(ROPE)=OFLAG1(ROPE).AND..NOT.NDSCBT
	OFLAG2(ROPE)=OFLAG2(ROPE).AND..NOT.CLMBBT
	ODESC1(TIMBE)=1032			! restored untied desc.
	ODESC1(COFFI)=1033
	TTIE=0					! not tied any more.
	CALL NEWSTA(ROPE,0,HERE,0,0)		! rope is now here.
	GO TO 10				! don't handle.
C
C O65--	Guano
C
34000	IF(PRSA.NE.DIGW) GO TO 10		! dig?
	RVGUA=MIN0(4,RVGUA+1)			! go to next state.	
	CALL RSPEAK(91+RVGUA)			! describe.
	RETURN
C
C O66--	Alice room leak
C
35000	IF(PRSA.NE.TAKEW) GO TO 35100		! take?
	CALL RSPEAK(552+RND(6))			! joke.
	RETURN
C
35100	IF(PRSA.NE.PLUGW) GO TO 10		! plug?
	CALL RSPEAK(929)			! can't reach.
	RETURN

C NOBJS, PAGE 16
C
C O67--	Sand
C
36000	IF(PRSA.NE.DIGW) GO TO 10		! dig?
	RVSND=RVSND+1				! go to next state.
	GO TO (36100,36100,36100,36400,36500),RVSND	! process
	CALL BUG(2,RVSND)
C
36100	CALL RSPEAK(85+RVSND)			! 1..3, describe.
	RETURN
C
36400	IF((OFLAG1(STATU).AND.VISIBT).EQ.0) CALL RSPEAK(89)
	OFLAG1(STATU)=OFLAG1(STATU).OR.VISIBT	! 4, statue appears.
	RETURN
C
36500	RVSND=0					! 5, sand collapses.
	IF(OROOM(STATU).EQ.HERE)
	1	OFLAG1(STATU)=OFLAG1(STATU).AND..NOT.VISIBT
	CALL JIGSUP(90)				! gonzo.
	RETURN
C
C O68--	Torch
C
37000	IF(PRSA.NE.TRNOFW) GO TO 10		! extinguish?
	CALL RSPEAK(900)			! can't do it.
	RETURN
C
C O69--	Tool chests
C
38000	IF(PRSA.NE.EXAMIW) GO TO 38100		! examine?
	CALL RSPEAK(907)			! describe.
	RETURN
C
38100	IF(PRSA.NE.TAKEW) GO TO 10		! take?
	CALL RSPEAK(908)			! can't do it.
	RETURN

C NOBJS, PAGE 17
C
C O70--	Palantir door
C
39000	IF((PRSA.NE.LOOKUW).OR..NOT.MATF) GO TO 39100
	CALL RSPEAK(995)			! mat under door.
	RETURN
C
39100	IF(PRSA.NE.UNLOKW) GO TO 39500		! unlock?
	IF(PRSI.NE.PKEY) GO TO 39400		! with rusty key?
39200	IF((OCAN(PKEY).EQ.(HERE-PRM+PKH1)).OR.
	1	QEMPTY(HERE-PRM+PKH1)) GO TO 39300	! keyhole empty?
39250	CALL RSPEAK(991)			! no
	RETURN
C
39300	CALL RSPEAK(996)			! now unlocked.
	PUNLKF=.TRUE.
	RETURN
C
39400	I=997					! joke 1.
	IF(PRSI.EQ.KEYS) I=998			! joke 2 for keys.
	CALL RSPEAK(I)
	RETURN
C
39500	IF(PRSA.NE.LOCKW) GO TO 39700		! lock?
	IF(PRSI.EQ.PKEY) GO TO 39600		! with rusty key?
	CALL RSPEAK(999)			! no
	RETURN
C
39600	IF((OCAN(PKEY).NE.(HERE-PRM+PKH1)).AND.
	1	.NOT.QEMPTY(HERE-PRM+PKH1)) GO TO 39250
	CALL RSPEAK(1000)			! now locked.
	PUNLKF=.FALSE.
	RETURN
C
39700	IF((PRSA.NE.PUTUNW).OR.((PRSO.NE.BLABE).AND.
	1  (PRSO.NE.LABEL).AND.(PRSO.NE.CARD).AND.
	2  (PRSO.NE.WARNI).AND.(PRSO.NE.RBTLB).AND.
	3  (PRSO.NE.GUIDE))) GO TO 39800	! put small paper?
	CALL NEWSTA(PRSO,1001,HERE.XOR.1,0,0)	! put in other room.
	RETURN
C
39800	IF((PRSA.NE.OPENW).AND.(PRSA.NE.CLOSEW)) GO TO 10
	IF(.NOT.PUNLKF) GO TO 39900		! open or close, unlocked?
	NOBJS=OPNCLS(PRSO,1002,1003)		! open or close.
	RETURN
C
39900	CALL RSPEAK(1000)			! door locked.
	RETURN
C
C O71--	Palantir window
C
40000	IF(PRSA.NE.GTHROW) GO TO 40100		! go through?
	CALL RSPEAK(1004)			! can't do it.
	RETURN
C
40100	IF(PRSA.NE.LOOKIW) GO TO 10		! look in?
	IF(QOPEN(PDOOR)) GO TO 40200		! door open?
	PLOOKF=.TRUE.				! set window flag.
	SVFLAG=RFLAG(HERE.XOR.1)		! save room flags from other.
	F=MOVETO(HERE.XOR.1,WINNER)		! go to other room.
	F=RMDESC(3)				! describe it.
	F=MOVETO(HERE.XOR.1,WINNER)		! come back.
	RFLAG(HERE.XOR.1)=SVFLAG		! restore flags.
	RETURN
C
40200	CALL RSPEAK(1005)			! door open, dummy.
	RETURN

C NOBJS, PAGE 18
C
C O72--	Keyhole lids
C
41000	IF((PRSA.NE.OPENW).AND.(PRSA.NE.RAISEW)) GO TO 41100
	CALL RSPEAK(985)			! open lid.
	OFLAG2(PRSO)=OFLAG2(PRSO).OR.OPENBT
	RETURN
C
41100	IF((PRSA.NE.CLOSEW).AND.(PRSA.NE.LOWERW)) GO TO 10
	IF(QEMPTY(PRSO-PLID1+PKH1)) GO TO 41200		! keyhole empty?
	CALL RSPEAK(986)			! can't do it.
	RETURN
C
41200	CALL RSPEAK(987)			! close lid.
	OFLAG2(PRSO)=OFLAG2(PRSO).AND..NOT.OPENBT
	RETURN
C
C O73--	Keyholes
C
42000	IF(PRSA.NE.LOOKIW) GO TO 42200		! look in?
	I=988					! doesn't work.
	IF(QOPEN(PLID1).AND.QOPEN(PLID2).AND.
	1	QEMPTY(PKH1).AND.QEMPTY(PKH2).AND.
	2	LIT(HERE.XOR.1)) I=989		! does work
	CALL RSPEAK(I)
	RETURN
C
42200	IF(PRSA.NE.PUTW) GO TO 10		! put?
	IF(QOPEN(PRSI-PKH1+PLID1)) GO TO 42300	! lid open?
	CALL RSPEAK(990)			! no.
	RETURN
C
42300	IF(QEMPTY(PRSI)) GO TO 42400		! keyhole empty?
	CALL RSPEAK(991)			! no.
	RETURN
C
42400	IF((PRSO.NE.SCREW).AND.(PRSO.NE.KEYS).AND.
	1  (PRSO.NE.STICK).AND.(PRSO.NE.PKEY)) GO TO 42700
	IF(QEMPTY(PRSI.XOR.1)) GO TO 10		! nothing to shove.
	DO 42500 I=1,OLNT
	  IF(OCAN(I).EQ.(PRSI.XOR.1)) GO TO 42600	! find obj in keyhole.
42500	CONTINUE
	CALL BUG(67,PRSI.XOR.1)
C
42600	CALL NEWSTA(I,992,HERE.XOR.1,0,0)	! obj falls to floor.
	IF(MATF) MATOBJ=I			! if mat, falls on that.
	GO TO 10				! finish put.
C
42700	CALL RSPSUB(993,ODO2)			! doesn't fit.
	RETURN

C NOBJS, PAGE 19
C
C O74--	Rusty key
C
43000	IF(PRSA.NE.TURNW) GO TO 10		! turn?
	IF(PUNLKF) GO TO 39600			! unlock?
	GO TO 39200				! otherwise lock.
C
C O75--	Palantirs
C
44000	IF(PRSA.NE.LOOKIW) GO TO 10		! look in?
	OBJ=PALAN				! assume dest = palan.
	IF(PRSO.EQ.PALAN) OBJ=PAL3		! if palan, then pal3.
	IF(PRSO.EQ.PAL3) OBJ=SPHER		! if pal3, then sphere.
	J=HERE					! save here.
	K=OCAN(OBJ)				! get dest container.
	IF(OROOM(OBJ).NE.0) J=OROOM(OBJ)	! if dest in room, use.
	IF(K.NE.0) J=OROOM(K)			! if cont, use cont room.
	IF((J.EQ.0).OR.(OADV(OBJ).EQ.-THIEF)) GO TO 44200
	IF(.NOT.LIT(J)) GO TO 44200		! see destination?
	IF(K.EQ.0) GO TO 44100			! contained?
	IF(((OFLAG1(K).AND.TRANBT).EQ.0).AND..NOT.QOPEN(K))
	1	GO TO 44200			! see out of it?
44100	CALL RSPEAK(1024)			! start vision.
	OFLAG1(OBJ)=OFLAG1(OBJ).AND..NOT.VISIBT	! object not visible.
	SVHERE=HERE				! save state.
	SVFLAG=RFLAG(J)
	F=MOVETO(J,WINNER)			! move to new room.
	F=RMDESC(3)				! describe.
	IF(J.EQ.SVHERE) CALL RSPEAK(1025)	! was it here?
	F=MOVETO(SVHERE,WINNER)			! come back.
	RFLAG(J)=SVFLAG				! restore flags.
	OFLAG1(OBJ)=OFLAG1(OBJ).OR.VISIBT	! restore object.
	RETURN
C
44200	CALL RSPEAK(1023)			! nothing to see.
	RETURN
C
C O76--	Mat
C
45000	IF((PRSA.NE.PUTUNW).OR.(PRSI.NE.PDOOR)) GO TO 45100
	MATF=.TRUE.				! put under right door.
	CALL NEWSTA(PRSO,983,HERE,0,0)
	RETURN
C
45100	IF(((PRSA.NE.TAKEW).AND.(PRSA.NE.MOVEW)).OR.(MATOBJ.EQ.0)) 
	1	GO TO 10			! take or move?
	CALL NEWSTA(MATOBJ,0,HERE,0,0)		! materialize mat object.
	CALL RSPSUB(984,ODESC2(MATOBJ))
	MATOBJ=0
	MATF=.FALSE.
	IF(PRSA.EQ.TAKEW) GO TO 10		! do normal take.
	RETURN					! move is done.
C
C O77--	Stove
C
46000	CALL RSPEAK(994)			! too hot.
	RETURN
C
	END

C MIRPAN--	Processor for global mirror/panel
C
C Declarations
C
	LOGICAL FUNCTION MIRPAN(ST,PNF)
	IMPLICIT INTEGER(A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL PNF
C
	MIRPAN=.TRUE.
	NUM=MRHERE(HERE)			! get mirror num.
	IF(NUM.NE.0) GO TO 100			! any here?
	CALL RSPEAK(ST)				! no, lose.
	RETURN
C
100	IF((PRSA.NE.MOVEW).AND.(PRSA.NE.OPENW)) GO TO 200
	CALL RSPEAK(ST+1)			! cant open or move.
	RETURN
C
200	MRBF=0					! assume mirror ok.
	IF(((NUM.EQ.1).AND..NOT.MR1F).OR.
	1  ((NUM.EQ.2).AND..NOT.MR2F)) MRBF=1
	IF(PNF.OR.((PRSA.NE.LOOKIW).AND.(PRSA.NE.EXAMIW).AND.
	1	(PRSA.NE.LOOKW))) GO TO 300
	CALL RSPEAK(844+MRBF)			! look in mirror.
	RETURN
C
300	IF(PRSA.NE.MUNGW) GO TO 400		! break?
	CALL RSPEAK(ST+2+MRBF)			! do it.
	IF((NUM.EQ.1).AND..NOT.PNF) MR1F=.FALSE.
	IF((NUM.EQ.2).AND..NOT.PNF) MR2F=.FALSE.
	RETURN
C
400	IF(PNF.OR.(MRBF.EQ.0)) GO TO 500	! broken mirror?
	CALL RSPEAK(846)
	RETURN
C
500	IF(PRSA.NE.PUSHW) GO TO 600		! push?
	CALL RSPEAK(ST+3+NUM)
	RETURN
C
600	MIRPAN=.FALSE.				! cant handle it.
	RETURN
C
	END

C BALLOP-	Balloon function
C
C Declarations
C
	LOGICAL FUNCTION BALLOP(ARG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL FINDXT,QEMPTY
C
	BALLOP=.TRUE.				! assume wins.
	IF(ARG.NE.2) GO TO 200			! readout?
	IF(PRSA.NE.LOOKW) GO TO 10		! only process look.
	IF(BINFF.NE.0) GO TO 50			! inflated?
	CALL RSPEAK(543)			! no.
	GO TO 100
50	CALL RSPSUB(544,ODESC2(BINFF))		! yes.
100	IF(BTIEF.NE.0) CALL RSPEAK(545)		! hooked?
	GO TO 10
C
200	IF(ARG.NE.1) GO TO 500			! readin?
	IF(PRSA.NE.WALKW) GO TO 300		! walk?
	IF(FINDXT(PRSO,HERE)) GO TO 250		! valid exit?
	CALL RSPEAK(546)			! no, joke.
	RETURN
C
250	IF(BTIEF.EQ.0) GO TO 275		! tied up?
	CALL RSPEAK(547)			! yes, joke.
	RETURN
C
275	IF(XTYPE.NE.XNORM) GO TO 10		! normal exit?
	IF((RFLAG(XROOM1).AND.RMUNG).NE.0) GO TO 10
	BLOC=XROOM1
	CFLAG(CEVBAL)=.TRUE.
	CTICK(CEVBAL)=3
10	BALLOP=.FALSE.
	RETURN
C
300	IF((PRSA.NE.TAKEW).OR.(PRSO.NE.BINFF)) GO TO 350
	CALL RSPSUB(548,ODESC2(BINFF))		! recep cont too hot.
	RETURN
C
350	IF((PRSA.NE.PUTW).OR.(PRSI.NE.RECEP).OR.QEMPTY(RECEP))
	1	GO TO 10			! recep already full.
	CALL RSPEAK(549)
	RETURN
C
500	IF((PRSA.NE.BURNW).OR.(OCAN(PRSO).NE.RECEP)) GO TO 10
	CALL RSPSUB(550,ODESC2(PRSO))		! light fire in recep.
	CFLAG(CEVBRN)=.TRUE.
	CTICK(CEVBRN)=OSIZE(PRSO)*20
	OFLAG1(PRSO)=(OFLAG1(PRSO).OR.(ONBT+FLAMBT+LITEBT)).AND.
	1	.NOT.(TAKEBT+READBT)		! burn it.
	IF(BINFF.NE.0) RETURN			! already inflated?
	IF(.NOT.BLABF) CALL NEWSTA(BLABE,0,0,BALLO,0)	! insert label.
	BLABF=.TRUE.				! only once.
	BINFF=PRSO
	CFLAG(CEVBAL)=.TRUE.
	CTICK(CEVBAL)=3				! start countdown.
	CALL RSPEAK(551)
	RETURN
C
	END

C TROLLP-	Troll function
C
C Declarations
C
	LOGICAL FUNCTION TROLLP(ARG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QHERE,PROB
C
	TROLLP=.TRUE.				! assume wins.
	IF(PRSA.NE.FIGHTW) GO TO 1100		! fight?
	IF(OCAN(AXE).EQ.TROLL) GO TO 10		! got axe?  nothing.
	I=433					! assume cant get.
	IF(.NOT.QHERE(AXE,HERE).OR.PROB(25,10)) GO TO 1050	! here?
	I=434					! yes, recover.
	CALL NEWSTA(AXE,0,0,TROLL,0)
1050	IF(QHERE(TROLL,HERE)) CALL RSPEAK(I)	! if player here.
	RETURN
C
1100	IF(PRSA.NE.DEADXW) GO TO 1200		! dead?
	TROLLF=.TRUE.				! permit exits.
	RETURN
C
1200	IF(PRSA.NE.OUTXW) GO TO 1300		! out?
	TROLLF=.TRUE.				! permit exits.
	OFLAG1(AXE)=OFLAG1(AXE).AND. .NOT.VISIBT
	ODESC1(TROLL)=435			! troll out.
	RETURN
C
1300	IF(PRSA.NE.INXW) GO TO 1400		! wake up?
	TROLLF=.FALSE.				! forbid exits.
	OFLAG1(AXE)=OFLAG1(AXE).OR.VISIBT
	ODESC1(TROLL)=436			! troll in.
	IF(QHERE(TROLL,HERE)) CALL RSPEAK(437)
	RETURN
C
1400	IF(PRSA.NE.FRSTQW) GO TO 1500		! first encounter?
	TROLLP=PROB(33,66)			! 33% true unless badlk.
	RETURN
C
1500	IF((PRSA.NE.MOVEW).AND.(PRSA.NE.TAKEW).AND.(PRSA.NE.MUNGW)
	1	.AND.(PRSA.NE.THROWW).AND.(PRSA.NE.GIVEW)) GO TO 2000
	IF(OCAPAC(TROLL).GE.0) GO TO 1550	! troll out?
	OCAPAC(TROLL)=-OCAPAC(TROLL)		! yes, wake him.
	OFLAG1(AXE)=OFLAG1(AXE).OR.VISIBT
	TROLLF=.FALSE.
	ODESC1(TROLL)=436
	CALL RSPEAK(437)
C
1550	IF((PRSA.NE.TAKEW).AND.(PRSA.NE.MOVEW)) GO TO 1600
	CALL RSPEAK(438)			! joke.
	RETURN
C
1600	IF(PRSA.NE.MUNGW) GO TO 1700		! mung?
	CALL RSPEAK(439)			! joke.
	RETURN
C
1700	IF(PRSO.EQ.0) GO TO 10			! no object?
	I=440					! assume throw.
	IF(PRSA.EQ.GIVEW) I=441			! give?
	CALL RSPSUB(I,ODESC2(PRSO))		! troll takes.
	IF(PRSO.EQ.KNIFE) GO TO 1900		! obj knife?
	CALL NEWSTA(PRSO,442,0,0,0)		! no, eats it.
	RETURN
C
1900	CALL RSPEAK(443)			! knife, throws it back
	OFLAG2(TROLL)=OFLAG2(TROLL).OR.FITEBT	! and gets mad.
	RETURN
C
2000	IF(.NOT.TROLLF.OR.(PRSA.NE.HELLOW)) GO TO 10
	CALL RSPEAK(366)			! troll out.
	RETURN
C
10	TROLLP=.FALSE.				! couldnt handle it.
	RETURN
C
	END

C CYCLOP-	Cyclops function
C
C Declarations
C
	LOGICAL FUNCTION CYCLOP(ARG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
C
	CYCLOP=.TRUE.				! assume wins.
	IF(.NOT.CYCLOF) GO TO 100		! asleep?
	IF((PRSA.NE.ALARMW).AND.(PRSA.NE.MUNGW).AND.(PRSA.NE.KICKW).AND.
	1	(PRSA.NE.BURNW).AND.(PRSA.NE.KILLW).AND.(PRSA.NE.ATTACW))
	2	 GO TO 10
	CYCLOF=.FALSE.				! wake cyclops.
	CALL RSPEAK(187)			! describe.
	RVCYC=IABS(RVCYC)
	OFLAG2(CYCLO)=(OFLAG2(CYCLO).OR.FITEBT).AND..NOT.SLEPBT
	RETURN
C
100	IF(PRSA.NE.GIVEW) GO TO 500		! give?
	IF(PRSO.NE.FOOD) GO TO 300 		! food?
	IF(RVCYC.LT.0) GO TO 200		! already eaten?
	CALL NEWSTA(FOOD,189,0,0,0)		! eats peppers.
	RVCYC=MIN0(-1,-RVCYC)			! gets thirsty.
200	CFLAG(CEVCYC)=.TRUE.			! turn on cyclops timer.
	CTICK(CEVCYC)=-1
	RETURN
C
300	IF(PRSO.NE.WATER) GO TO 400		! drink when thirsty?
	IF(RVCYC.GE.0) GO TO 350
	CALL NEWSTA(PRSO,190,0,0,0)		! drinks and
	CYCLOF=.TRUE.				! falls asleep.
	OFLAG2(CYCLO)=(OFLAG2(CYCLO).OR.SLEPBT).AND..NOT.FITEBT
	CFLAG(CEVCYC)=.FALSE.			! turn off cyclops timer.
	RETURN
C
350	CALL RSPEAK(191)			! not thirsty.
10	CYCLOP=.FALSE.				! fails.
	RETURN
C
400	I=192					! assume inedible.
	IF(PRSO.EQ.GARLI) I=193			! garlic is joke.
450	CALL RSPEAK(I)				! disdain it.
	RETURN
C
500	IF((PRSA.NE.KILLW).AND.(PRSA.NE.ATTACW).AND.
	1  (PRSA.NE.MUNGW).AND.(PRSA.NE.THROWW)) GO TO 600
	CFLAG(CEVCYC)=.TRUE.			! turn on cyclops timer.
	CTICK(CEVCYC)=-1
	I=201					! assume not poke.
	IF(PRSA.EQ.MUNGW) I=912			! poke joke.
	GO TO 450				! go remark and return.
C
600	I=202					! assume take.
	IF(PRSA.EQ.TAKEW) GO TO 450
	I=203					! assume tie.
	IF(PRSA.EQ.TIEW) GO TO 450
	CYCLOP=.FALSE.
	RETURN
C
	END

C THIEFP-	Thief function
C
C Declarations
C
	LOGICAL FUNCTION THIEFP(ARG)
	IMPLICIT INTEGER (A-Z)
	INCLUDE 'DPARAM.FOR/NOLIST'
	LOGICAL QHERE,PROB,QEMPTY
C
	THIEFP=.TRUE.				! assume wins.
	IF(PRSA.NE.FIGHTW) GO TO 100		! fight?
	IF(OCAN(STILL).EQ.THIEF) GO TO 10	! got stilletto?  f.
	IF(QHERE(STILL,THFPOS)) GO TO 50	! can he recover it?
	CALL NEWSTA(THIEF,0,0,0,0)		! no, vanish.
	IF(QHERE(THIEF,HERE)) CALL RSPEAK(498)	! if hero, tell.
	RETURN
C
50	CALL NEWSTA(STILL,0,0,THIEF,0)		! yes, recover.
	IF(QHERE(THIEF,HERE)) CALL RSPEAK(499)	! if hero, tell.
	RETURN
C
100	IF(PRSA.NE.DEADXW) GO TO 200		! dead?
	THFACT=.FALSE.				! disable demon.
	IF(HERE.NE.TREAS) GO TO 150		! in treasure room?
	J=501
	DO 125 I=1,OLNT				! loop.
	  IF((I.EQ.CHALI).OR.(I.EQ.THIEF).OR..NOT.QHERE(I,HERE))
	1	GO TO 125			! is it here?
	  OFLAG1(I)=OFLAG1(I).OR.VISIBT		! rematerialize objects.
	  CALL RSPSUB(J,ODESC2(I))		! describe.
	  J=502
	  IF(.NOT.QEMPTY(I).AND.
	1   (((OFLAG1(I).AND.TRANBT).NE.0).OR.
	2    ((OFLAG2(I).AND.OPENBT).NE.0))) CALL PRINCO(I,573,.TRUE.)
125	CONTINUE
C
150	J=500
	DO 175 I=1,OLNT				! carrying anything?
	  IF(OADV(I).NE.-THIEF) GO TO 175
	  CALL NEWSTA(I,0,HERE,0,0)		! drop in room.
	  CALL RSPSUB(J,ODESC2(I))		! describe.
	  J=502
	  IF(.NOT.QEMPTY(I).AND.
	1   (((OFLAG1(I).AND.TRANBT).NE.0).OR.
	2    ((OFLAG2(I).AND.OPENBT).NE.0))) CALL PRINCO(I,573,.TRUE.)
175	CONTINUE
	RETURN
C
200	IF(PRSA.NE.FRSTQW) GO TO 250		! first encounter?
	THIEFP=PROB(20,75)
	RETURN
C
250	IF((PRSA.NE.HELLOW).OR.(ODESC1(THIEF).NE.504))
	1	GO TO 300			! hello to out thief?
	CALL RSPEAK(626)
	RETURN
C
300	IF(PRSA.NE.OUTXW) GO TO 400		! out?
	THFACT=.FALSE.				! disable demon.
	ODESC1(THIEF)=504			! change description.
	OFLAG1(STILL)=OFLAG1(STILL).AND..NOT.VISIBT
	RETURN
C
400	IF(PRSA.NE.INXW) GO TO 500		! in?
	IF(QHERE(THIEF,HERE)) CALL RSPEAK(505)	! can hero see?
	THFACT=.TRUE.				! enable demon.
	ODESC1(THIEF)=503			! change description.
	OFLAG1(STILL)=OFLAG1(STILL).OR.VISIBT
	RETURN
C
500	IF(PRSA.NE.TAKEW) GO TO 600		! take?
	CALL RSPEAK(506)			! joke.
	RETURN
C
600	IF((PRSA.NE.THROWW).OR.(PRSO.NE.KNIFE).OR.
	1	((OFLAG2(THIEF).AND.FITEBT).NE.0)) GO TO 700
	IF(PROB(10)) GO TO 650			! threw knife, 10%?
	CALL RSPEAK(507)			! no, just makes
	OFLAG2(THIEF)=OFLAG2(THIEF).OR.FITEBT	! thief mad.
	RETURN
C
650	J=508					! thief drops stuff.
	DO 675 I=1,OLNT
	  IF(OADV(I).NE.-THIEF) GO TO 675	! thief carrying?
	  J=509
	  CALL NEWSTA(I,0,HERE,0,0)
675	CONTINUE
	CALL NEWSTA(THIEF,J,0,0,0)		! thief vanishes.
	RETURN
C
700	IF(((PRSA.NE.THROWW).AND.(PRSA.NE.GIVEW)).OR.(PRSO.EQ.0).OR.
	1	(PRSO.EQ.THIEF)) GO TO 10	! thro/give to thief?
	IF(OCAPAC(THIEF).GE.0) GO TO 750	! wake him up.
	OCAPAC(THIEF)=-OCAPAC(THIEF)
	THFACT=.TRUE.
	OFLAG1(STILL)=OFLAG1(STILL).OR.VISIBT
	ODESC1(THIEF)=503
	CALL RSPEAK(510)
C
750	IF((PRSO.NE.BRICK).OR.(OCAN(FUSE).NE.BRICK).OR.
	1	(CTICK(CEVFUS).EQ.0)) GO TO 800
	CALL RSPEAK(511)			! thief refuses bomb.
	RETURN
C
800	CALL NEWSTA(PRSO,0,0,0,-THIEF)		! thief takes gift.
	IF(OTVAL(PRSO).GT.0) GO TO 900		! a treasure?
	CALL RSPSUB(512,ODESC2(PRSO))
	RETURN
C
900	CALL RSPSUB(627,ODESC2(PRSO))		! thief engrossed.
	THFENF=.TRUE.
	RETURN
C
10	THIEFP=.FALSE.
	RETURN
	END

C Declarations for DUNGEON
C
C COPYRIGHT 1980, 1990, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA.
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C This file should be included in *all* modules to supply consistent
C data structure definitions.

C
C Array size parameters
C
	PARAMETER (MMAX=1500)			! messages
	PARAMETER (RMAX=200)			! rooms
	PARAMETER (XXMAX=1000)			! exits
	PARAMETER (OMAX=300)			! objects
	PARAMETER (R2MAX=20)			! multiroom objects
	PARAMETER (CMAX=30)			! clock events
	PARAMETER (VMAX=4)			! villains
	PARAMETER (AMAX=4)			! actors
	PARAMETER (FMAX=56)			! flags
	PARAMETER (SMAX=24)			! switches
	PARAMETER (BWMAX=10)			! buzzword vocabulary
	PARAMETER (DWMAX=25)			! direction vocabulary
	PARAMETER (PWMAX=20)			! preposition vocabulary
	PARAMETER (AWMAX=160)			! adjective vocabularly
	PARAMETER (AVMAX=300)			! string to obj index
	PARAMETER (OWMAX=360)			! object vocabularly
	PARAMETER (OVMAX=550)			! string to obj index
	PARAMETER (VWMAX=240)			! verb vocabularly
	PARAMETER (VVMAX=750)			! verb syntaxes
C
C Other parameters
C
	PARAMETER (RECLNT=20)			! DTEXT.DAT record size, lw
	PARAMETER (TEXLNT=76)			! text buffer size, char
	PARAMETER (WRDLNT=8)			! word length size, char
	PARAMETER (BUNMAX=10)			! bunched objects
	PARAMETER (LEXMAX=20)			! lexical tokens
C
C Syntax definitions
C 
	PARAMETER (SDIR='40000'O)		! direct object present
	PARAMETER (SIND='20000'O)		! indirect object present
	PARAMETER (SSTD='10000'O)		! direct object std format
	PARAMETER (SFLIP='4000'O)		! flip direct, indirect obj
	PARAMETER (SDRIV='2000'O)		! default (driver) syntax
	PARAMETER (SVMASK='777'O)		! mask for verb number
	PARAMETER (VABIT='40000'O)		! search adv for object
	PARAMETER (VRBIT='20000'O)		! search room for object
	PARAMETER (VTBIT='10000'O)		! take object if possible
	PARAMETER (VCBIT='4000'O)		! must have object
	PARAMETER (VEBIT='2000'O)		! qualifier flags = fwim flags
	PARAMETER (VFBIT='1000'O)		! must reach object
	PARAMETER (VPMASK='777'O)		! mask for prep number
C
C Clock event indices
C
	PARAMETER (CEVCUR=1)			! wound cure timer
	PARAMETER (CEVMNT=2)			! maintenance room timer
	PARAMETER (CEVLNT=3)			! lantern timer
	PARAMETER (CEVMAT=4)			! match timer
	PARAMETER (CEVCND=5)			! candle timer
	PARAMETER (CEVBAL=6)			! balloon inflation
	PARAMETER (CEVBRN=7)			! balloon burnup
	PARAMETER (CEVFUS=8)			! fuse burn
	PARAMETER (CEVLED=9)			! ledge collapse timer
	PARAMETER (CEVSAF=10)			! safe timer
	PARAMETER (CEVVLG=11)			! volcano gnome appearance
	PARAMETER (CEVGNO=12)			! volcano gnome exit
	PARAMETER (CEVBUC=13)			! bucket timer
	PARAMETER (CEVSPH=14)			! sphere timer
	PARAMETER (CEVEGH=15)			! end game herald
	PARAMETER (CEVFOR=16)			! forest noises
	PARAMETER (CEVSCL=17)			! screen of light
	PARAMETER (CEVZGI=18)			! Zurich gnome appearance
	PARAMETER (CEVZGO=19)			! Zurich gnome exit
	PARAMETER (CEVSTE=20)			! end game start
	PARAMETER (CEVMRS=21)			! mirror timer
	PARAMETER (CEVPIN=22)			! panel timer
	PARAMETER (CEVINQ=23)			! inquisition timer
	PARAMETER (CEVFOL=24)			! master follows
	PARAMETER (CEVBRO=25)			! brochure timer
	PARAMETER (CEVCYC=26)			! cyclops demon
	PARAMETER (CEVSLI=27)			! slide timer
	PARAMETER (CEVXB=28)			! exorcism bell timer
	PARAMETER (CEVXC=29)			! exorcism candle timer
	PARAMETER (CEVXBH=30)			! exorcism bell cooling
C
C Exit definitions
C
	PARAMETER (XLFLAG='100000'O)		! last entry flag
	PARAMETER (XDMASK='76000'O)		! direction mask
	PARAMETER (XRMASK='377'O)		! room mask
	PARAMETER (XFMASK=3)			! type mask
	PARAMETER (XFSHFT=256)
	PARAMETER (XASHFT=256)
	PARAMETER (XNORM=1)			! normal exit
	PARAMETER (XNO=2)			! no exit
	PARAMETER (XCOND=3)			! conditional exit
	PARAMETER (XDOOR=4)			! door
	PARAMETER (XMIN='2000'O)		! minimum direction
	PARAMETER (XMAX='40000'O)		! maximum direction
	PARAMETER (XNORTH='2000'O)
	PARAMETER (XNE='4000'O)
	PARAMETER (XEAST='6000'O)
	PARAMETER (XSE='10000'O)
	PARAMETER (XSOUTH='12000'O)
	PARAMETER (XSW='14000'O)
	PARAMETER (XWEST='16000'O)
	PARAMETER (XNW='20000'O)
	PARAMETER (XUP='22000'O)
	PARAMETER (XDOWN='24000'O)
	PARAMETER (XLAUN='26000'O)
	PARAMETER (XLAND='30000'O)
	PARAMETER (XENTER='32000'O)
	PARAMETER (XEXIT='34000'O)
	PARAMETER (XCROSS='36000'O)
C
C Actor indices
C
	PARAMETER (PLAYER=1)			! player
	PARAMETER (AROBOT=2)			! robot
	PARAMETER (AMASTR=3)			! dungeon master
C
C Actor flags
C
	PARAMETER (ASTAG='100000'O)		! staggered
C
C Room flags
C
	PARAMETER (RSEEN='100000'O)		! seen
	PARAMETER (RLIGHT='40000'O)		! lighted
	PARAMETER (RLAND='20000'O)		! land
	PARAMETER (RWATER='10000'O)		! water
	PARAMETER (RAIR='4000'O)		! air
	PARAMETER (RSACRD='2000'O)		! sacred (thief cant visit)
	PARAMETER (RFILL='1000'O)		! contains water
	PARAMETER (RMUNG='400'O)		! destroyed
	PARAMETER (RBUCK='200'O)		! part of bucket
	PARAMETER (RHOUSE='100'O)		! part of house
	PARAMETER (RNWALL='40'O)		! no walls
	PARAMETER (REND='20'O)			! part of endgame
C
C Room indices
C
	PARAMETER (WHOUS=2)			! west of house
	PARAMETER (EHOUS=5)			! east of house
	PARAMETER (KITCH=6)			! kitchen
	PARAMETER (LROOM=8)			! living room
	PARAMETER (CELLA=9)			! cellar
	PARAMETER (MTROL=10)			! troll room
	PARAMETER (MAZE1=11)			! start of maze
	PARAMETER (MGRAT=25)			! grating room
	PARAMETER (MAZ15=30)			! end of maze
	PARAMETER (FORE1=31)			! forest 1
	PARAMETER (FORE3=33)			! forest 3
	PARAMETER (CLEAR=36)			! clearing
	PARAMETER (RESER=40)			! reservoir
	PARAMETER (STREA=42)			! stream
	PARAMETER (EGYPT=44)			! egypt room
	PARAMETER (ECHOR=49)			! echo room
	PARAMETER (SLIDE=58)			! slide room
	PARAMETER (TSHAF=61)			! top of shaft
	PARAMETER (BSHAF=76)			! bottom of shaft
	PARAMETER (MMACH=77)			! machine room
	PARAMETER (DOME=79)			! dome room
	PARAMETER (MTORC=80)			! torch room
	PARAMETER (CAROU=83)			! carousel room
	PARAMETER (RIDDL=91)			! riddle room
	PARAMETER (LLD1=93)			! entrance to hades
	PARAMETER (LLD2=94)			! land of the living dead
	PARAMETER (TEMP1=96)			! temple
	PARAMETER (TEMP2=97)			! altar
	PARAMETER (MAINT=100)			! maintenance room
	PARAMETER (MCYCL=101)			! cyclops room
	PARAMETER (BLROO=102)			! back of living room
	PARAMETER (TREAS=103)			! thief's treasury
	PARAMETER (RIVR1=107)			! river 1
	PARAMETER (RIVR2=108)			! river 2
	PARAMETER (RIVR3=109)			! river 3
	PARAMETER (RIVR4=112)			! river 4
	PARAMETER (RIVR5=113)			! river 5
	PARAMETER (FCHMP=114)			! over falls
	PARAMETER (FALLS=120)			! top of falls
	PARAMETER (MRAIN=121)			! rainbow room
	PARAMETER (POG=122)			! pot of gold room
	PARAMETER (VLBOT=126)			! volcano bottom
	PARAMETER (VAIR1=127)			! mid air 1
	PARAMETER (VAIR2=128)			! mid air 2
	PARAMETER (VAIR3=129)			! mid air 3
	PARAMETER (VAIR4=130)			! mid air 4
	PARAMETER (LEDG2=131)			! ledge 2
	PARAMETER (LEDG3=132)			! ledge 3
	PARAMETER (LEDG4=133)			! ledge 4
	PARAMETER (MSAFE=135)			! safe room
	PARAMETER (CAGER=140)			! cage room
	PARAMETER (CAGED=141)			! in cage
	PARAMETER (TWELL=142)			! top of well
	PARAMETER (BWELL=143)			! bottom of well
	PARAMETER (ALICE=144)			! alice room
	PARAMETER (ALISM=145)			! alice small room
	PARAMETER (ALITR=146)			! alice trap room
	PARAMETER (MTREE=147)			! up a tree
	PARAMETER (BKENT=148)			! bank entrance
	PARAMETER (BKVW=151)			! bank view west
	PARAMETER (BKVE=152)			! bank view east
	PARAMETER (BKTWI=153)			! bank
	PARAMETER (BKVAU=154)			! bank vault
	PARAMETER (BKBOX=155)			! bank box
	PARAMETER (CRYPT=157)			! crypt
	PARAMETER (TSTRS=158)			! top of stairs
	PARAMETER (MRANT=159)			! mirror anteroom
	PARAMETER (MREYE=160)			! mirror eye
	PARAMETER (MRA=161)			! mirror A
	PARAMETER (MRB=162)			! mirror B
	PARAMETER (MRC=163)			! mirror C
	PARAMETER (MRG=164)			! mirror G
	PARAMETER (MRD=165)			! mirror D
	PARAMETER (FDOOR=166)			! front door
	PARAMETER (MRAE=167)			! mirror A east
	PARAMETER (MRCE=171)			! mirror C east
	PARAMETER (MRCW=172)			! mirror C west
	PARAMETER (MRGE=173)			! mirror G east
	PARAMETER (MRGW=174)			! mirror G west
	PARAMETER (MRDW=176)			! mirror D west
	PARAMETER (INMIR=177)			! in mirror
	PARAMETER (SCORR=179)			! south corridor
	PARAMETER (NCORR=182)			! north corridor
	PARAMETER (PARAP=183)			! parapet
	PARAMETER (CELL=184)			! cell
	PARAMETER (PCELL=185)			! prison cell
	PARAMETER (NCELL=186)			! nirvana cell
	PARAMETER (CPANT=188)			! puzzle anteroom
	PARAMETER (CPOUT=189)			! puzzle exit
	PARAMETER (CPUZZ=190)			! puzzle room
	PARAMETER (PRM=192)			! palantir anteroom
	PARAMETER (PALRM=193)			! palantir room
	PARAMETER (SLID1=194)			! slide 1
	PARAMETER (SLEDG=197)			! slide ledge
C
C Verb indices
C
	PARAMETER (CINTW=1)			! clock interrupt
	PARAMETER (DEADXW=2)			! villain dead
	PARAMETER (FRSTQW=3)			! villain first encounter
	PARAMETER (INXW=4)			! villain wakes up
	PARAMETER (OUTXW=5)			! villain out cold
	PARAMETER (WALKIW=6)			! player walks in
	PARAMETER (FIGHTW=7)			! fighting starts
	PARAMETER (FOOW=8)			! nop
	PARAMETER (SQUEEW=68)			! squeeze
	PARAMETER (STAYW=73)			! stay
	PARAMETER (PRAYW=79)			! pray
	PARAMETER (BLASTW=82)			! blast
	PARAMETER (SCOREW=83)			! score
	PARAMETER (QUITW=84)			! quit
	PARAMETER (FOLLOW=85)			! follow
	PARAMETER (GTHROW=86)			! go through
	PARAMETER (RINGW=87)			! ring
	PARAMETER (DIGW=89)			! dig
	PARAMETER (LEAPW=91)			! leap
	PARAMETER (LOCKW=92)			! lock
	PARAMETER (UNLOKW=93)			! unlock
	PARAMETER (DIAGNW=94)			! diagnose
	PARAMETER (READW=100)			! read
	PARAMETER (MELTW=101)			! melt
	PARAMETER (INFLAW=102)			! inflate
	PARAMETER (DEFLAW=103)			! deflate
	PARAMETER (ALARMW=104)			! alarm
	PARAMETER (EXORCW=105)			! exorcise
	PARAMETER (PLUGW=106)			! plug
	PARAMETER (KICKW=107)			! kick
	PARAMETER (WAVEW=108)			! wave
	PARAMETER (RAISEW=109)			! raise
	PARAMETER (LOWERW=110)			! lower
	PARAMETER (RUBW=111)			! rub
	PARAMETER (PUSHW=112)			! push
	PARAMETER (UNTIEW=113)			! untie
	PARAMETER (TIEW=114)			! tie
	PARAMETER (TIEUPW=115)			! tie up
	PARAMETER (TURNW=116)			! turn
	PARAMETER (BREATW=117)			! breathe
	PARAMETER (KNOCKW=118)			! knock
	PARAMETER (LOOKW=119)			! look
	PARAMETER (EXAMIW=120)			! examine
	PARAMETER (SHAKEW=121)			! shake
	PARAMETER (MOVEW=122)			! move
	PARAMETER (TRNONW=123)			! turn on
	PARAMETER (TRNOFW=124)			! turn off
	PARAMETER (OPENW=125)			! open
	PARAMETER (CLOSEW=126)			! close
	PARAMETER (FINDW=127)			! find
	PARAMETER (WAITW=128)			! wait
	PARAMETER (SPINW=129)			! spin
	PARAMETER (BOARDW=130)			! board
	PARAMETER (UNBOAW=131)			! disembark
	PARAMETER (TAKEW=132)			! take
	PARAMETER (INVENW=133)			! inventory
	PARAMETER (FILLW=134)			! fill
	PARAMETER (EATW=135)			! eat
	PARAMETER (DRINKW=136)			! drink
	PARAMETER (BURNW=137)			! burn
	PARAMETER (MUNGW=138)			! destroy
	PARAMETER (KILLW=139)			! kill
	PARAMETER (SWINGW=140)			! swing
	PARAMETER (ATTACW=141)			! attack
	PARAMETER (WALKW=142)			! walk
	PARAMETER (TELLW=143)			! tell
	PARAMETER (PUTW=144)			! put
	PARAMETER (DROPW=145)			! drop
	PARAMETER (GIVEW=146)			! give
	PARAMETER (POURW=147)			! pour
	PARAMETER (THROWW=148)			! throw
	PARAMETER (HELLOW=151)			! hello
	PARAMETER (LOOKIW=152)			! look in
	PARAMETER (LOOKUW=153)			! look under
	PARAMETER (PUMPW=154)			! pump
	PARAMETER (WINDW=155)			! wind
	PARAMETER (CLMBW=156)			! climb
	PARAMETER (CLMBUW=157)			! climb up
	PARAMETER (CLMBDW=158)			! climb down
	PARAMETER (TRNTOW=159)			! turn to
	PARAMETER (PORONW=160)			! pour on
	PARAMETER (PUTUNW=161)			! put under
	PARAMETER (UTFRMW=162)			! untie from
	PARAMETER (MAKEW=163)			! make
	PARAMETER (OILW=164)			! oil
	PARAMETER (PLAYW=165)			! play
	PARAMETER (SENDW=166)			! send
C
C Object flags
C
	PARAMETER (VISIBT='100000'O)		! visible
	PARAMETER (READBT='40000'O)		! readable
	PARAMETER (TAKEBT='20000'O)		! takeable
	PARAMETER (DOORBT='10000'O)		! door
	PARAMETER (TRANBT='4000'O)		! transparent
	PARAMETER (FOODBT='2000'O)		! edible
	PARAMETER (NDSCBT='1000'O)		! don't describe
	PARAMETER (DRNKBT='400'O)		! drinkable
	PARAMETER (CONTBT='200'O)		! container
	PARAMETER (LITEBT='100'O)		! provides light
	PARAMETER (VICTBT='40'O)		! victim
	PARAMETER (BURNBT='20'O)		! burnable
	PARAMETER (FLAMBT='10'O)		! flaming
	PARAMETER (TOOLBT='4'O)			! tool
	PARAMETER (TURNBT='2'O)			! turnable
	PARAMETER (ONBT='1'O)			! turned on
	PARAMETER (FINDBT='100000'O)		! find
	PARAMETER (SLEPBT='40000'O)		! sleeping
	PARAMETER (SCRDBT='20000'O)		! sacred (thief wont steal)
	PARAMETER (TIEBT='10000'O)		! tieable
	PARAMETER (CLMBBT='4000'O)		! climbable
	PARAMETER (ACTRBT='2000'O)		! actor
	PARAMETER (WEAPBT='1000'O)		! weapon
	PARAMETER (FITEBT='400'O)		! fighting
	PARAMETER (VILLBT='200'O)		! villain
	PARAMETER (STAGBT='100'O)		! staggered
	PARAMETER (TRYBT='40'O)			! try to take
	PARAMETER (NOCHBT='20'O)		! don't check
	PARAMETER (OPENBT='10'O)		! open
	PARAMETER (TCHBT='4'O)			! touched
	PARAMETER (VEHBT='2'O)			! vehicle
	PARAMETER (SCHBT='1'O)			! searchable
C
C Object indices
C
	PARAMETER (GARLI=2)			! garlic
	PARAMETER (FOOD=3)			! hot peppers
	PARAMETER (GUNK=4)			! gunk
	PARAMETER (COAL=5)			! piece of coal
	PARAMETER (MACHI=7)			! machine
	PARAMETER (DIAMO=8)			! diamond
	PARAMETER (TCASE=9)			! trophy case
	PARAMETER (BOTTL=10)			! bottle
	PARAMETER (WATER=11)			! water
	PARAMETER (ROPE=12)			! rope
	PARAMETER (KNIFE=13)			! knife
	PARAMETER (SWORD=14)			! sword
	PARAMETER (LAMP=15)			! lamp
	PARAMETER (BLAMP=16)			! broken lamp
	PARAMETER (RUG=17)			! rug
	PARAMETER (LEAVE=18)			! pile of leaves
	PARAMETER (TROLL=19)			! troll
	PARAMETER (AXE=20)			! axe
	PARAMETER (KEYS=23)			! keys
	PARAMETER (RKNIF=24)			! rusty knife
	PARAMETER (BAGCO=25)			! bag of coins
	PARAMETER (BAR=26)			! platinum bar
	PARAMETER (ICE=30)			! glacier
	PARAMETER (COFFI=33)			! coffin
	PARAMETER (TORCH=34)			! torch
	PARAMETER (TBASK=35)			! true basket
	PARAMETER (FBASK=36)			! false basket
	PARAMETER (TIMBE=38)			! timber
	PARAMETER (IRBOX=39)			! iron box
	PARAMETER (STRAD=40)			! violin
	PARAMETER (GHOST=42)			! spirits
	PARAMETER (TRUNK=45)			! trunk
	PARAMETER (BELL=46)			! bell
	PARAMETER (BOOK=47)			! book
	PARAMETER (CANDL=48)			! candles
	PARAMETER (GUIDE=49)			! guidebook
	PARAMETER (MATCH=51)			! matches
	PARAMETER (MAILB=53)			! mailbox
	PARAMETER (TUBE=54)			! tube of putty
	PARAMETER (PUTTY=55)			! putty
	PARAMETER (WRENC=56)			! wrench
	PARAMETER (SCREW=57)			! screwdriver
	PARAMETER (CYCLO=58)			! cyclops
	PARAMETER (CHALI=59)			! chalice
	PARAMETER (THIEF=61)			! thief
	PARAMETER (STILL=62)			! stiletto
	PARAMETER (WINDO=63)			! window
	PARAMETER (GRATE=65)			! grating
	PARAMETER (DOOR=66)			! door
	PARAMETER (HPOLE=71)			! head on pole
	PARAMETER (RBUTT=79)			! red button
	PARAMETER (LEAK=78)			! leak
	PARAMETER (RAILI=75)			! railing
	PARAMETER (POT=85)			! pot of gold
	PARAMETER (STATU=86)			! statue
	PARAMETER (IBOAT=87)			! inflatable boat
	PARAMETER (DBOAT=88)			! dead boat
	PARAMETER (PUMP=89)			! pump
	PARAMETER (RBOAT=90)			! inflated boat
	PARAMETER (LABEL=91)			! boat label
	PARAMETER (STICK=92)			! stick
	PARAMETER (BARRE=93)			! barrel
	PARAMETER (BUOY=94)			! buoy
	PARAMETER (SHOVE=96)			! shovel
	PARAMETER (GUANO=97)			! pile of guano
	PARAMETER (BALLO=98)			! balloon
	PARAMETER (RECEP=99)			! receptacle
	PARAMETER (BROPE=101)			! braided rope
	PARAMETER (HOOK1=102)			! hook 1
	PARAMETER (HOOK2=103)			! hook 2
	PARAMETER (ZORKM=104)			! zorkmid coin
	PARAMETER (SAFE=105)			! safe
	PARAMETER (CARD=106)			! card
	PARAMETER (SSLOT=107)			! safe slot
	PARAMETER (BRICK=109)			! brick (bomb)
	PARAMETER (FUSE=110)			! fuse
	PARAMETER (GNOME=111)			! volcano gnome
	PARAMETER (BLABE=112)			! balloon label
	PARAMETER (DBALL=113)			! dead balloon
	PARAMETER (TOMB=119)			! tomb
	PARAMETER (LCASE=123)			! large case
	PARAMETER (CAGE=124)			! cage
	PARAMETER (RCAGE=125)			! real cage
	PARAMETER (SPHER=126)			! white crystal sphere
	PARAMETER (SQBUT=127)			! square button
	PARAMETER (FLASK=132)			! flask
	PARAMETER (POOL=133)			! pool of sewage
	PARAMETER (SAFFR=134)			! spices
	PARAMETER (BUCKE=137)			! bucket
	PARAMETER (ECAKE=138)			! eatme cake
	PARAMETER (ORICE=139)			! orange icing
	PARAMETER (RDICE=140)			! red icing
	PARAMETER (BLICE=141)			! blue icing
	PARAMETER (ROBOT=142)			! robot
	PARAMETER (RBTLB=143)			! robot label
	PARAMETER (TTREE=144)			! foot of tree
	PARAMETER (FTREE=145)			! foot of tree
	PARAMETER (BILLS=148)			! pile of bills
	PARAMETER (PORTR=149)			! portrait
	PARAMETER (SCOL=151)			! screen of light
	PARAMETER (ZGNOM=152)			! gnome of Zurich
	PARAMETER (NEST=153)			! nest
	PARAMETER (EGG=154)			! egg
	PARAMETER (BEGG=155)			! broken egg
	PARAMETER (BAUBL=156)			! bauble
	PARAMETER (CANAR=157)			! canary
	PARAMETER (BCANA=158)			! broken canary
	PARAMETER (YLWAL=159)			! yellow wall
	PARAMETER (RDWAL=161)			! red wall
	PARAMETER (PINDR=164)			! pine door
	PARAMETER (RBEAM=171)			! red beam
	PARAMETER (ODOOR=172)			! endgame door
	PARAMETER (QDOOR=173)			! endgame door
	PARAMETER (CDOOR=175)			! endgame door
	PARAMETER (NUM1=178)			! numeral 1
	PARAMETER (NUM8=185)			! numeral 8
	PARAMETER (WARNI=186)			! warning
	PARAMETER (CSLIT=187)			! card slit
	PARAMETER (GCARD=188)			! gold card
	PARAMETER (STLDR=189)			! steel door
	PARAMETER (HBELL=190)			! hot bell
	PARAMETER (BROCH=195)			! brochure
	PARAMETER (STAMP=196)			! stamp on brochure
	PARAMETER (PDOOR=197)			! palantir door
	PARAMETER (PLID1=200)			! lid 1
	PARAMETER (PLID2=201)			! lid 2
	PARAMETER (PKH1=202)			! keyhole 1
	PARAMETER (PKH2=203)			! keyhole 2
	PARAMETER (PKEY=205)			! rusty key
	PARAMETER (PALAN=206)			! blue crystal sphere
	PARAMETER (MAT=207)			! welcome mat
	PARAMETER (PAL3=209)			! red crystal sphere
C
	PARAMETER (ITOBJ=250)			! global it
	PARAMETER (OPLAY=251)			! global me
	PARAMETER (EVERY=252)			! global everything
	PARAMETER (VALUA=253)			! global valuables
	PARAMETER (POSSE=254)			! global possessions
	PARAMETER (SAILO=255)			! global sailor
	PARAMETER (TEETH=256)			! global teeth
	PARAMETER (WALL=257)			! global wall
	PARAMETER (HANDS=259)			! global hands
	PARAMETER (LUNGS=260)			! global lungs
	PARAMETER (AVIAT=261)			! global flyer
	PARAMETER (GWISH=263)			! global wish
	PARAMETER (GRWAL=265)			! global granite wall
	PARAMETER (GLOBAL=265)			! end of universals
	PARAMETER (WNORT=269)			! global north wall
	PARAMETER (GWATE=273)			! global water
	PARAMETER (MASTER=279)			! global dungeon master
	PARAMETER (BUNOBJ=284)			! bunch pseudo object
C
C Misc definitions
C
	PARAMETER (HFACTR=500)
C
C Parser output
C
	LOGICAL PRSWON
	COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C Parser state
C
	CHARACTER*(WRDLNT) ONAME
	COMMON /PRSSTA/
	1	OFLAG,OACT,OPREP1,OOBJ1,OPREP,ONAME,OPREP2,OOBJ2,
	2	LASTIT,ACT,OBJ1,OBJ2,PREP1,PREP2,
	3	VFLAG,DOBJ,DFL1,DFL2,DFW1,DFW2,
	4	IOBJ,IFL1,IFL2,IFW1,IFW2,
	5	BUNLNT,BUNSUB,BUNVEC(BUNMAX)
	INTEGER SYN(11)
	EQUIVALENCE (SYN(1),VFLAG)
C
C Parser vocabularies
C
	CHARACTER*(WRDLNT) BWORD,PWORD,DWORD,AWORD,OWORD,VWORD
	COMMON /VOCAB/ BWORD(BWMAX),PWORD(PWMAX),PVOC(PWMAX),
	1	DWORD(DWMAX),DVOC(DWMAX),AWORD(AWMAX),AVOC(AVMAX),
	2	OWORD(OWMAX),OVOC(OVMAX),VWORD(VWMAX),VVOC(VVMAX)
C
C Game state
C
	LOGICAL TELFLG
	COMMON /PLAY/ WINNER,HERE,TELFLG,
	1	MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
	2	LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C Screen of light state
C
	COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC,
	1	SCOLDR(8),SCOLWL(12)
C
C Puzzle room state
C
	COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C Message index
C
	COMMON /RMSG/ MLNT,RTEXT(MMAX)
C
C Miscellaneous variables
C
	CHARACTER*(TEXLNT) INBUF,SUBBUF
	CHARACTER*1 VEDIT
	COMMON /INPUT/ INLNT,INBUF,SUBLNT,SUBBUF
	COMMON /MISC/ MBASE,STRBIT,
	1	PLTIME,SHOUR,SMIN,SSEC,
	2	BATDRP(9),
	3	INPCH,OUTCH,DBCH,
	4	DBGFLG,PRSFLG,GDTFLG,
	5	VMAJ,VMIN,VEDIT
C
C Rooms
C
	COMMON /ROOMS/ RLNT,RDESC2,RDESC1(RMAX),REXIT(RMAX),
	1	RACTIO(RMAX),RVAL(RMAX),RFLAG(RMAX)
C
C Exits
C
	COMMON /EXITS/ XLNT,TRAVEL(XXMAX)
C
	COMMON /CURXT/ XELNT(4),XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
	EQUIVALENCE (XFLAG,XOBJ)
C
C Objects
C
	COMMON /OBJCTS/ OLNT,ODESC1(OMAX),ODESC2(OMAX),ODESCO(OMAX),
	1	OACTIO(OMAX),OFLAG1(OMAX),OFLAG2(OMAX),OFVAL(OMAX),
	2	OTVAL(OMAX),OSIZE(OMAX),OCAPAC(OMAX),OROOM(OMAX),
	3	OADV(OMAX),OCAN(OMAX),OREAD(OMAX)
C
	COMMON /OROOM2/ R2LNT,O2(R2MAX),R2(R2MAX)
C
C Clock interrupts
C
	LOGICAL CFLAG,CCNCEL
	COMMON /CEVENT/ CLNT,CTICK(CMAX),CACTIO(CMAX),
	1	CFLAG(CMAX),CCNCEL(CMAX)
C
C Villains and demons
C
	LOGICAL THFFLG,SWDACT,THFACT
	COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
	COMMON /VILL/ VLNT,VILLNS(VMAX),VPROB(VMAX),VOPPS(VMAX),
	1	VBEST(VMAX),VMELEE(VMAX)
C
C Adventurers
C
	COMMON /ADVS/ ALNT,AROOM(AMAX),ASCORE(AMAX),AVEHIC(AMAX),
	1	AOBJ(AMAX),AACTIO(AMAX),ASTREN(AMAX),AFLAG(AMAX)
C
C Flags
C
	LOGICAL FLAGS(FMAX)
	EQUIVALENCE (FLAGS(1),TROLLF)
	INTEGER SWITCH(SMAX)
	EQUIVALENCE (SWITCH(1),BTIEF)
	LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
	LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
	LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
	LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
	LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
	LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
	LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
	LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
	LOGICAL DEADF,ZGNOMF,MATF,PLOOKF,PTOUCF
	LOGICAL BROC1F,BROC2F,EXORBF,EXORCF,PUNLKF
	COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
	1	DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
	2	MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
	3	EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
	4	GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
	5	GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
	6	MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
	7	FOLLWF,SPELLF,CPOUTF,CPUSHF,
	8	DEADF,ZGNOMF,MATF,PLOOKF,PTOUCF,
	9	BROC1F,BROC2F,EXORBF,EXORCF,PUNLKF
	COMMON /FINDEX/ BTIEF,BINFF
	COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
	COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
	COMMON /FINDEX/ MDIR,MLOC,POLEUF
	COMMON /FINDEX/ QUESNO,NQATT,CORRCT
	COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
	COMMON /FINDEX/ TTIE,MATOBJ
